Search.additionalData = [
["history.html","Revision History",
"Revision History\n",0]
,["history.html","Version 1.0 (2014-09-04)",
"Version 1.0 (2014-09-04)\n",0]
,["history.html","Additions and Changes",
"Additions and Changes\n \tInitial version.\nCONFIDENTIAL\n",0]
,["title.html","3DS Programming Manual",
"3DS Programming Manual: Font Library\nVersion 1.0\n\tNintendo Confidential\n\tThe content of this document is highly confidential and should be handled accordingly.\nThe content of this document cannot be duplicated, copied, reprinted, transferred, distributed, or loaned in whole or in part without the prior approval of Nintendo.\nThis document contains confidential and proprietary information of Nintendo and is also protected under the copyright laws of the United States and foreign countries.No part of this document may be released, distributed, transmitted or reproduced in any form or by any electronic or mechanical means, including information storage and retrieval systems, without permission in writing from Nintendo.\n© 2014 Nintendo. All rights reserved.\nCTR-06-0147-002-A\nAll company and product names in this document are the trademarks or registered trademarks of their respective companies.\n",0]
,["Pages/Page_53970596.html","1. Introduction",
"1. Introduction\nThis document describes how to use the Font library, which is provided with the CTR-SDK, in programming procedures and other processes that render text characters in applications.\n2. Terminology describes terminology specific to the Font library. Read it to learn about the terminology used in this document.\n3. Font Management describes the classes used to manage font resources. Read it to learn about how font resources are managed in the Font library.\n4. Displaying Characters describes methods of displaying text. Read it to learn about using the Font library to implement the displaying of text.\n5. Creating Fonts describes methods of creating font resources using ctr_FontConverter. Read it if you want to create font resources to use in an application.\nCONFIDENTIAL\n",0]
,["Pages/Page_53970597.html","2. Terminology",
"2. Terminology\nThis section defines terminology used with the Font library. The definitions used here are specific to this library and may differ from the ordinary meaning of the terms.\n",0]
,["Pages/Page_53970597.html#PageId_53970598","2.1. Terms Related to Characters and Text",
"2.1. Terms Related to Characters and Text\nThe following table presents a summary of character-related and text-related terms.\n Table 2-1. Character-Related and Text-Related Terms\n \tTerm \tDescription\n \tLetters \tThe graphical shape to render. It includes both the visually recognizable graphic image and the white space surrounding it.\n \tEncoding \tA numerical value assigned to each character to facilitate handling by computer systems.\n \tCharacter Sets \tA set of characters and their associated character codes.\n \tText Encoding \tA method of converting or arranging character codes so that a string is represented as a byte array.\n \tISO 8859-1 \t A character set formed by adding some extended Latin characters and symbols to the ASCII character set; also called Latin-1.\n The range of character codes used is from 0x00 to 0xFF, but 0x00 to 0x1F and 0x80 to 0x9F are allocated to control characters that cannot be displayed.\n \tCP1252 (Code Page 1252) \tAn extended Latin character set defined by Microsoft for Windows. In this set, the characters in the range 0x80 to 0x9F, which are allocated to control characters in ISO 8859-1, are replaced with displayable characters, so all of the displayable characters in ISO 8859-1 can also be displayed by CP1252.\n \tJIS X 0201 \tA Japanese character set defined in the JIS standards. It includes Japanese hiragana, katakana, and kanji as full-width characters.\n \tJIS X 0208 \tA Japanese character set defined in the JIS standards. It includes ASCII and half-width katakana as half-width characters.\n \tShift JIS \tThe standard character encoding in Japanese environments. The characters included in JIS X 0201 and JIS X 0208 can be used in this encoding.\n \tUnicode \tA character system intended to represent all characters used in the world in a single character set. It includes definitions for both character sets and character encodings.\n \tUTF-16 \t A character encoding defined under Unicode. In this encoding all characters are represented with two bytes, so it includes almost all other character encodings, but is not compatible with ASCII.\n Depending on the endianness, it may use the notation UTF16-BE or UTF16-LE.\n \tUTF-8 \tA character encoding defined under Unicode. In this encoding the number of bytes corresponding to one character depends on the character. ASCII characters are represented with one byte, so this encoding is compatible with ASCII, in contrast to UTF-16.\n",0]
,["Pages/Page_53970597.html#PageId_53970599","2.2. Terms Related to Glyphs",
"2.2. Terms Related to Glyphs\nA glyph is defined to be a visually recognizable shape of a character. This section describes terms related to glyphs.\nFigure 2-1. below illustrates parameters involved in the display of glyphs. The yellow regions are the glyphs, while the characters include both the glyphs and the surrounding green regions. Parameters of the glyphs that are supplied by the Font library are indicated in black, parameters of the fonts that are supplied by the Font library are indicated in blue, and parameters that are set by the application when displaying the glyphs as strings are indicated in red.\n Figure 2-1. Glyphs\n Table 2-2. Glyph-Related Terms\n \tTerm \tDescription\n \tGlyph Images \tA term referring to a glyph that emphasizes its aspect of being a graphic image. It may also be called a cell.\n \tCell height \tThe height of a glyph image. This is common to the entire font.\n \tGlyph width \tThe width of a rectangle circumscribing the glyph. In the figure, the width of the yellow region.\n \tLeft space width \tThe width of the space between the glyph and the immediately previous character.\n \tRight space width \tThe width of the space between the glyph and the immediately subsequent character.\n \tCharacter width \tThe width of the character. The sum of the glyph width and the left and right space widths.\n \tCharacter width information \tInformation indicating the width of a character. Consists of the following four pieces of information: the left space width, the right space width, the glyph width and the character width.\n \tBaseline \tThe position serving as the base in the vertical direction for all glyphs when lining up characters horizontally (that is, when rendering characters).\n \tAscender line \tA line along the upper edge of the region to be occupied by the string.\n \tDescender line \tA line along the lower edge of the region to be occupied by the string.\n \tAscent \tThe distance from the baseline to the ascender line.\n \tDescent \tThe distance from the baseline to the descender line.\n \tFont height \tThe distance from the ascender line to the descender line.\n \tFont width \tThe character width shared by all characters in a font. This width serves as the basis for the tab width.\n",0]
,["Pages/Page_53970597.html#PageId_53970600","2.3. Terms Related to Font Resources",
"2.3. Terms Related to Font Resources\nThe following table presents terms related to font data and other font resources.\n Table 2-3. Terms Related to Font Resources\n \tTerm \tDescription\n \tBCFNT (Binary Ctr FoNT) \tOrdinary font data used in the Font library. Also, the extension for files that contain this font data.\n \tBCFNA (Binary Ctr FoNt Archived) \t Compressed font data used in the Font library. Also, the extension for files that contain this font data.\n You can extract and decompress individual glyph sets as needed from these archives. . These archives are used when the fonts to be displayed are grouped by language, or when you want to switch only some fonts to a different typeface.\n \tFont resource \tOrdinary font data used in the Font library. Synonymous with BCFNT.\n \tArchived font \tCompressed font data used in the Font library. Synonymous with BCFNTA.\n \tctr_FontConverter \tA Windows tool used to create BCFNT and BCFNA data. Both a GUI version and command-line version are provided.\n \tAlternate character \tA substitute character used when information for the requested character is not contained within a font.\n ",0]
,["Pages/Page_53970597.html#PageId_53970601","2.3.1. Glyph Groups",
"2.3.1. Glyph Groups\nA glyph group is defined as a glyph set that is subdivided into groups. In addition, a set of glyph groups is called a group set.\nThe Font library provides a feature for constructing a font by freely selecting and combining any of the groups within a group set. For example, from a group set comprising the four groups “ascii,” “latin,” “greek,” and “cyrillic,” it is possible to construct a font containing only the glyphs required to display text for languages that use the Latin alphabet by combining “ascii” and “latin,” or a font for languages that use the Cyrillic alphabet by combining “ascii” and “cyrillic.”\n Figure 2-2. Examples of Glyph Group\n",0]
,["Pages/Page_53970597.html#PageId_53970602","2.3.2. Sheets",
"2.3.2. Sheets\nA sheet is defined as a texture object upon which glyph images are drawn. One texture object corresponds to one sheet. Multiple glyph images can be arranged on a single sheet.\n Figure 2-3. Examples of Sheets\n",0]
,["Pages/Page_53970597.html#PageId_53970603","2.4. Other Terms",
"2.4. Other Terms\nThe following table presents other terms related to the Font library.\n Table 2-4. Other Terms\n \tTerm \tDescription\n \tTagged strings \t Strings that contain instructions related to rendering text.\n The Font library provides a framework for processing tagged strings. The actual processing of tags embedded in strings must be handled by the application.\nCONFIDENTIAL\n",0]
,["Pages/Page_53970604.html","3. Font Management",
"3. Font Management\nThis chapter describes the management of fonts. The rendering of characters by applications is described in subsequent chapters.\nThe Font library provides the Font class as a base class, the ResFont class for manipulating font resources loaded into memory, the ArchiveFont class and PackedFont class for manipulating archived font resources and the PairFont class for handling two fonts as a single font. Note that we recommend using UTF16-LE as the encoding for font resources, because this is the encoding used by other CTR-SDK libraries to handle strings.\nThe figure below illustrates the hierarchy of the Font library classes (with derived classes on the right). In your application, select from among the classes along the right edge of the figure and create instances of these classes as necessary depending on how you use font resources.\n Figure 3-1. Hierarchy of Classes (for Font Management)\n",0]
,["Pages/Page_53970604.html#PageId_53970605","3.1. Font Class",
"3.1. Font Class\nThis is the base class for handling font resources, but this class itself is never instantiated. When the Font library classes are used to render characters, textures (sheets upon which glyph images are drawn) are loaded by directly referencing main memory, so the application must prepare a buffer in device memory for the font (the images). The restrictions placed on the location of this memory are described in the individual classes that inherit from this class.\nTable 3-1 below is a list of the member functions defined in the Font class. Note that as a general rule, when these functions get parameters they return values in pixels.\n Table 3-1. List of Member Functions of the Font Class\n \tCategory \tFunction \tDescription\n \tGet font information\n \t GetWidth \tReturns the font width. Used to determine the tab width and perform similar tasks.\n \t GetHeight \tReturns the font height.\n \t GetAscent \tReturns the ascent. Used to align the upper edges of characters.\n \t GetDescent \tReturns the descent. Used to align the lower edges of characters.\n \t GetMaxCharWidth \tReturns the maximum character width of all of the characters contained in the font.\n \t GetType \tReturns the font type.\n \t GetTextureFormat \tReturns the format of the sheet (the texture).\n \t GetLineFeed \tReturns the linefeed width.\n \t GetDefaultCharWidths \tReturns the default character width information. Used as the character width for characters not contained in the font and for other anomalous widths.\n \tSet font information\n \t SetLineFeed \tResets the linefeed width.\n \t SetDefaultCharWidths \tResets the default character width information.\n \t SetAlternateChar \tSets alternate characters.\n \tGet character information\n \t GetCharWidth \tReturns the character width of a character.\n \t GetCharWidths \tReturns the character width information of a character.\n \t GetGlyph \tGlyph information. Returns the glyph of an alternate character if the glyph of the specified character is not contained in the font.\n \t HasGlyph \tReturns whether the glyph of the specified character is contained in the font.\n \t String\n Encoding\n \t GetCharacterCode \tReturns the character encoding.\n \t GetCharStrmReader \tThe CharWriter class is used when drawing characters with the Font library.\n \tGets sheet information.\n \t GetBaselinePos \tReturns the baseline position.\n \t GetCellHeight \tReturns the cell height.\n \t GetCellWidth \tReturns the cell width.\n \tTexture interpolation\n \t EnableLinearFilter \tWhen rendering characters with the Font library, sets whether to use linear interpolation when scaling characters.\n \t IsLinearFilterEnableAtSmall \tWhen rendering characters with the Font library, returns whether linear interpolation is used when scaling down characters.\n \t IsLinearFilterEnableAtLarge \tWhen rendering characters with the Font library, returns whether linear interpolation is used when scaling up characters.\n \t GetTextureWrapFilterValue \tWhen rendering characters with the Font library, returns the wrapping mode and filter settings.\n",0]
,["Pages/Page_53970604.html#PageId_53970606","3.2. ResFont Class",
"3.2. ResFont Class\nThis is a class for manipulating font resources. It is not compatible with grouping, so when using this class all sheets are loaded in memory. For this reason, the entire font resource must be loaded in memory.\nFont resources (BCFNT files) loaded in memory are bound to the ResFont class by the SetResource function. When the Font library classes are used to render characters, the glGenTextures function is used to create one texture object for each sheet contained in the font resource. These created texture objects are configured so that the GPU directly accesses their texture images. Accordingly, the font resource must be loaded into device memory using 128-byte alignment (defined by nn::font::GlyphDataAlignment). Unbind the resource using the RemoveResource function. Do not release the buffer into which the font resource was loaded until the resource is unbound.\nWhen the Font library classes are used to render characters, a render buffer (requiring 4-byte alignment) having the size returned by the GetDrawBufferSize function must be set using the SetDrawBuffer function, but there is no need to allocate the render buffer in device memory.\n",0]
,["Pages/Page_53970604.html#PageId_53970607","3.2.1. System Fonts",
"3.2.1. System Fonts\nWith 3DS, font resources called internal fonts are stored in system memory. The application can use the PL library to use these internal fonts as shared font resources.\n Calling the nn::pl::InitializeSharedFont function starts the loading of the internal fonts corresponding to the 3DS system region, and the loading is complete when the nn::pl::GetSharedFontLoadState function returns nn::pl::SHARED_FONT_LOAD_STATE_LOADED. Font resources loaded by this procedure are loaded to fixed addresses (physical addresses outside of application jurisdiction), so they do not consume any application memory.\nThe nn::pl::GetSharedFontType function gets the type of the internal fonts, which are loaded based on the 3DS system’s region. To use an internal font of a type not returned by this function, you must use the nn::pl::MountSharedFont function to mount the internal font archive and then have the application load the font resource file. The files are compressed in LZ77 format, so they must be uncompressed using the CX Library. Also note that each type of internal font must be mounted separately, and that the uncompressed font resources must be placed in device memory to render characters with the Font library. When the loading of font resources is complete, unmount the archive with the nn::pl::UnmountSharedFont function.\n Note:\n For more information about loading internal fonts, see the 3DS Programming Manual: System.\n",0]
,["Pages/Page_53970604.html#PageId_53970608","3.3. ArchiveFont Class",
"3.3. ArchiveFont Class\nThis is a class for manipulating archived fonts. The glyphs within the font files are organized into groups, so you can uncompress and load into memory sheets containing just the specified groups. (Multiple groups can be specified.) To specify groups, either use LOAD_GLYPH_ALL, which loads all glyphs, or use a string containing the names of the groups to load delimited by commas (“,”).\nThere are two ways to construct fonts: (1) you can construct fonts from archived font data that is already loaded in memory, or (2) you can load the data into memory as a stream to reduce the amount of memory required for loading. Use the Construct function for the former method and the InitStreamingConstruct and StreamingConstruct functions for the latter. Font data is compressed, but the font images are decompressed and loaded into memory. Use the GetRequireBufferSize function to get the size of the buffer required to construct the font. (The data is decompressed into this buffer.) When the Font library classes are used to render characters, the buffer must be allocated in device memory using 128-byte alignment.\nAfter the font is constructed, the memory used to load archived fonts can be released, but the buffer used to construct the font cannot be released until the font is destroyed. Destroy the font using the Destroy function. When this function destroys a font, it returns a pointer to the buffer for you to then release.\n",0]
,["Pages/Page_53970604.html#PageId_53970609","3.4. PackedFont Class",
"3.4. PackedFont Class\nLike the ArchiveFont class, the PackedFont class is a class for manipulating archived fonts. However, using this class font resources can be maintained in memory in compressed form and decompressed and used as needed. Although decompressing the sheet corresponding to a particular character entails a processing load, this class implements a cache so that the load is reduced somewhat. By managing the proportion of data left in the cache and locking the sheets, you can prevent cache misses.\nThe PackedFont class uses the same font construction methods as the ArchiveFont class. When calculating the size of the buffer, specify the number or proportion of the sheets to be left in the cache. The following functions are provided for managing the cache: GetNumCache which gets the number of cacheable sheets, PreloadSheet which preloads the cache with sheets, LockSheet which locks sheets, UnlockSheet which unlocks individual sheets and UnlockSheetAll which unlocks all sheets.\nAfter the font is constructed, the memory used to load archived fonts can be released, but the buffer used to construct the font cannot be released until the font is destroyed. Destroy the font using the Destroy function. When this function destroys a font, it returns a pointer to the buffer for you to then release.\n",0]
,["Pages/Page_53970604.html#PageId_53970610","3.5. PairFont Class",
"3.5. PairFont Class\nThis class is derived from the Font class and is a class for using two fonts that have the same character encoding and same texture format as a single font. Note that problems with the display positions of characters might occur when combining fonts that have different baseline positions.\nWhen an instance of the PairFont class is constructed, the font specified first is called the primary font and the font specified next is the secondary font. When you get parameters using this class, the class returns parameters for either the primary font or secondary font in accordance with the conditions in the following table.\n Table 3-2. Parameters of the PairFont Class\n \tParameter \tParameter Returned\n \tFont width \tGreatest value among the two fonts.\n \tFont height\n \tMaximum character width\n \tAscent \t The value for the font that has the largest font height.\n If both fonts have the same height, the value for the primary font is returned.\n \tDescent\n \tBaseline\n \tCell height\n \tLine feed width\n \tCell width \t The value for the font that has the largest font width.\n If both fonts have the same width, the value for the primary font is returned.\n \tDefault character width\n \tGetting glyphs \t The primary font takes priority.\n The glyph from the secondary font is returned if the specified character is not present in the primary font. The alternate character from the primary font is returned if the specified character is not in either font. However, if an alternate character is set after the instance was constructed, and that alternate character is not present in the primary font but is present in the secondary font, the alternate character from the secondary font is returned.\n \tAlternate character \t The primary font takes priority.\n However, if an alternate character is set after the instance was constructed, and that alternate character is not present in the primary font but is present in the secondary font, the alternate character from the secondary font is returned.\nCONFIDENTIAL\n",0]
,["Pages/Page_53970611.html","4. Displaying Characters",
"4. Displaying Characters\nThere are two ways to display characters: by using glyph information obtained from the font resources, or by using the character rendering classes provided by the Font library.\n",0]
,["Pages/Page_53970611.html#PageId_53970612","4.1. Displaying Characters Based on Glyph Information",
"4.1. Displaying Characters Based on Glyph Information\nThe GetGlyph function of the Font class returns glyph information in a Glyph structure. This structure contains the information required to display glyphs as characters and is defined as follows.\n Code 4-1. Glyph Structure\n struct Glyph\n{\n const void* pTexture;\n struct CharWidths\n {\n s8 left;\n u8 glyphWidth;\n s8 charWidth;\n } widths;\n u8 height;\n u16 texWidth;\n u16 texHeight;\n u16 cellX;\n u16 cellY;\n u8 isSheetUpdated;\n TexFmt texFormat;\n const TextureObject* pTextureObject;\n};\nThe values stored in the various members are as follows. The values of the widths and heights are stored in pixel units.\n Table 4-1. Members of the Glyph Structure\n \tMember \tDescription\n \t pTexture \tPointer to the sheet (the texture image).\n \t widths.left \tLeft space width.\n \t widths.glyphWidth \tGlyph width.\n \t widths.charWidth \t Character width.\n The right space width can be found by this formula: [character width – glyph width – left space width].\n \t height \tCell (glyph image) height.\n \t texWidth \tSheet width.\n \t texHeight \tSheet height.\n \t cellX \tX-coordinate of the upper-left corner of the cell, taking the upper-left corner of the sheet as the origin.\n \t cellY \tY-coordinate of the upper-left corner of the cell, taking the upper-left corner of the sheet as the origin.\n \t isSheetUpdated \tSheet update flag. Referenced by the Font library.\n \t texFormat \tSheet (texture) format.\n \t pTextureObject \tTexture object information and other information. Referenced by the Font library.\n The sheet format definitions correspond as follows to the argument values specified to the glTexImage2D function.\n Table 4-2. Sheet Format Definitions and Argument Values Specified to the glTexImage2D Function\n \tFormat \tformat \ttype\n \t FONT_SHEET_FORMAT_A4 \t GL_ALPHA_NATIVE_DMP \t GL_UNSIGNED_4BITS_DMP\n \t FONT_SHEET_FORMAT_A8 \t GL_ALPHA_NATIVE_DMP \t GL_UNSIGNED_BYTE\n \t FONT_SHEET_FORMAT_LA4 \t GL_LUMINANCE_ALPHA_NATIVE_DMP \t GL_UNSIGNED_BYTE_4_4_DMP\n \t FONT_SHEET_FORMAT_LA8 \t GL_LUMINANCE_ALPHA_NATIVE_DMP \t GL_UNSIGNED_BYTE\n \t FONT_SHEET_FORMAT_RGBA4 \t GL_RGBA_NATIVE_DMP \t GL_UNSIGNED_SHORT_4_4_4_4\n \t FONT_SHEET_FORMAT_RGB5A1 \t GL_RGBA_NATIVE_DMP \t GL_UNSIGNED_SHORT_5_5_5_1\n \t FONT_SHEET_FORMAT_RGBA8 \t GL_RGBA_NATIVE_DMP \t GL_UNSIGNED_BYTE\n \t FONT_SHEET_FORMAT_RGB565 \t GL_RGB_NATIVE_DMP \t GL_UNSIGNED_SHORT_5_6_5\n \t FONT_SHEET_FORMAT_RGB8 \t GL_RGB_NATIVE_DMP \t GL_UNSIGNED_BYTE\n The following structure members are required in order to identify the location in the sheet of the glyph image to display.\n Figure 4-1. Glyph Structure Members Required to Identify the Location of a Glyph Image\nYou must note that while the 3DS texture coordinates have their origin at the lower left, the origin of the cell (glyph image) coordinates is at the upper left. Because of this, the calculation of texture coordinates is implemented as in the following sample code.\n Code 4-2. Calculation of Texture Coordinates\n Glyph glyph;\nmyFont.GetGlyph(&glyph, character);\nconst f32 texLeft = 1.0f * glyph.cellX / glyph.texWidth;\nconst f32 texRight = 1.0f * (glyph.cellX + glyph.widths.glyphWidth)\n / glyph.texWidth;\n// Be careful about the differences between glyph image coordinates and texture coordinate origins.\nconst f32 texTop = 1.0f * (glyph.texHeight - glyph.cellY) / glyph.texHeight;\nconst f32 texBottom = 1.0f * (glyph.texHeight - (glyph.cellY + glyph.height))\n / glyph.texHeight;\n",0]
,["Pages/Page_53970611.html#PageId_53970613","4.2. Using the Font Library Classes",
"4.2. Using the Font Library Classes\nThe Font library provides classes for rendering characters and strings. In addition to simply rendering single characters, it also has the following features:\n \tChanging the text color \tVertical or horizontal color gradation on the per-character level \tScaling characters \tForced fixed-width (monospaced) font display \tCharacter spacing, line spacing, and tab spacing \tLeft-justification or right-justification \tAutomatic line wrapping (newlines) in text \tRendering using format strings (printf equivalent) \tProcessing of tagged strings (customizable)\nSeveral classes are used to render characters with the Font library, and they cooperate as illustrated below. In this process flow, the classes denoted by orange rectangles in the figure below are classes that configure settings for rendering text, and they are instantiated by the application. Also, blue denotes base classes, while green denotes implicitly-used classes.\n Figure 4-2. Font Library Class Structure (for Text Rendering)\nIf you use Font library classes to render text, we recommend using the RectDrawer class, which directly generates 3D commands (PICA register settings).\n Table 4-3. Processing Performed by Classes Used in Rendering\n \tClass \tProcessing Performed\n \tCharWriter \tRenders individual characters. If you do not use TextWriter, inherit this class and form the characters into strings, along with the other processing involved with rendering strings.\n \tTextWriter \tRenders strings. This class provides the basic features for generating strings.\n \tTagProcessor \tProcesses tag characters (control characters in the range 0x0000 to 0x001F). If you want the tag processor to support characters other than the newline character (0x000A) and the tab character (0x0009), define a custom class that inherits TagProcessor.\n \tRectDrawer \tGenerates 3D commands from the string display information accumulated in a buffer by the TextWriter (or CharWriter) class. Generates 3D commands compatible with dedicated shader programs.\n ",0]
,["Pages/Page_53970611.html#PageId_53970614","4.2.1. Steps for Implementing in an Application",
"4.2.1. Steps for Implementing in an Application\nThis section describes the procedures for using the Font library classes to display strings on the screen, using as an example the source code for the ResFont demo included in the sample demos.\n",0]
,["Pages/Page_53970611.html#PageId_53970615","4.2.1.1. Loading and Constructing Font Resources",
"4.2.1.1. Loading and Constructing Font Resources\nFirst, load and construct the font resources used to render text. In the sample demo, a pointer to an instance of the ResFont class and the font resource filename (that has an extension of bcfnt) are passed to the InitFont function.\n Code 4-3. Loading and Constructing Font Resources\n //---------------------------------------------------------------------------\n//! @brief Constructs ResFont.\n//!\n//! @param[out] pFont: Pointer to the font to construct.\n//! @param[in] filePath: Filename of the font resource to load.\n//!\n//! @return Returns whether ResFont was successfully constructed.\n//---------------------------------------------------------------------------\nbool\nInitFont(\n nn::font::ResFont* pFont,\n const char* filePath)\n{\n // Load font resources.\n nn::fs::FileReader fontReader(filePath);\n s32 fileSize = (s32)fontReader.GetSize();\n if ( fileSize <= 0 )\n {\n return false;\n }\n void* buffer = s_AppHeap.Allocate(fileSize, nn::font::GlyphDataAlignment);\n if (buffer == NULL)\n {\n return false;\n }\n s32 readSize = fontReader.Read(buffer, fileSize);\n if (readSize != fileSize)\n {\n s_AppHeap.Free(buffer);\n return false;\n }\n // Set font resources.\n bool bSuccess = pFont->SetResource(buffer);\n NN_ASSERT(bSuccess);\n //---Fails when resources are already set or already loaded,\n // or when the resources are invalid.\n if (! bSuccess)\n {\n s_AppHeap.Free(buffer);\n }\n // Set the render buffer.\n const u32 drawBufferSize = nn::font::ResFont::GetDrawBufferSize(buffer);\n void* drawBuffer = s_AppHeap.Allocate(drawBufferSize, 4);\n NN_NULL_ASSERT(drawBuffer);\n pFont->SetDrawBuffer(drawBuffer);\n return bSuccess;\n}\nIn the Font library, textures are loaded with settings such that the GPU directly accesses the sheets that contain the drawn glyph images of the loaded font resources. Accordingly, font resources must be loaded into a buffer in device memory that has 128-byte alignment. Note that the only restriction on the render buffer is the requirement of 4-byte alignment, so this buffer does not need to be allocated in device memory.\nFor more information about the restrictions that apply when using font resources other than the ResFont class, see 3.3. The ArchiveFont Class and 3.4. The PackedFont Class.\n",0]
,["Pages/Page_53970611.html#PageId_53970616","4.2.1.2. Initializing Shaders",
"4.2.1.2. Initializing Shaders\nLoad the shader binary that will be used for text display, and allocate a buffer for the RectDrawer class. In the sample demo, a pointer to an instance of the RectDrawer class is passed to the InitShaders function.\n Code 4-4. Initializing the Shaders\n //---------------------------------------------------------------------------\n//! @brief Initializes the shaders.\n//!\n//! @param[in,out] pDrawer Pointer to the instance to initialize.\n//---------------------------------------------------------------------------\nvoid*\nInitShaders(nn::font::RectDrawer* pDrawer)\n{\n nn::fs::FileReader shaderReader(s_ShaderBinaryFilePath);\n const u32 fileSize = (u32)shaderReader.GetSize();\n void* shaderBinary = s_AppHeap.Allocate(fileSize);\n NN_NULL_ASSERT(shaderBinary);\n#ifndef NN_BUILD_RELEASE\n s32 read =\n#endif // NN_BUILD_RELEASE\n shaderReader.Read(shaderBinary, fileSize);\n NN_ASSERT(read == fileSize);\n const u32 vtxBufCmdBufSize =\n nn::font::RectDrawer::GetVertexBufferCommandBufferSize(\n shaderBinary, fileSize);\n void *const vtxBufCmdBuf = s_AppHeap.Allocate(vtxBufCmdBufSize);\n NN_NULL_ASSERT(vtxBufCmdBuf);\n pDrawer->Initialize(vtxBufCmdBuf, shaderBinary, fileSize);\n s_AppHeap.Free(shaderBinary);\n return vtxBufCmdBuf;\n}\nIn the RectDrawer class, two buffers are used: the vertex buffer and the command buffer. The vertex buffer contains vertex coordinates for use in rendering. The command buffer stores render commands, but also contains shader binary loading commands (programs, swizzle patterns, constant registers) and other such commands. These buffers are accessed directly by the GPU, so they must be allocated in device memory. There is no required buffer alignment, but we recommend 4-byte or 16-byte alignment.\nIn the sample demo, the two buffers are allocated in a single region, but functions for getting the required size of each buffer and an initialization function for allocating the buffers separately are also provided. After initialization is successful, you can release the buffer that contains the shader binary.\nThe SDK contains nnfont_RectDrawerShader.shbin as the shader binary used in the RectDrawer class. This shader assumes that an orthogonal projection matrix has been set in which the sizes of the projected screen in screen space and the LCD screen are identical, with the origin of the projection matrix at the upper left of the screen in screen space (although the directions of the y-axis and z-axis are the reverse of the 3DS axes), and also assumes that the modelview matrix is set to a unit matrix. The adjustment of the character display position and size is managed by accumulating transformation matrices in the floating-point constant registers.\n",0]
,["Pages/Page_53970611.html#PageId_53970617","4.2.1.3. Allocating a Display String Buffer",
"4.2.1.3. Allocating a Display String Buffer\nAllocate a buffer that accumulates string display information (the display string buffer). The required size of the display string buffer is calculated based on the maximum number of characters to display. When string rendering is complete, the same buffer can be used to accumulate string display information. If the font and characters to display do not change, the stored string display information can be reused unchanged. If the string has previously been rendered in a single color, you can change just the font color and do not need to accumulate the string display information again.\n Code 4-5. Allocating a Display String Buffer\n //---------------------------------------------------------------------------\n//! @brief Allocates a display string buffer.\n//!\n//! @param[in] charMax: Maximum number of characters in the string to display.\n//!\n//! @return Returns a pointer to the allocated display string buffer.\n//---------------------------------------------------------------------------\nnn::font::DispStringBuffer*\nAllocDispStringBuffer(int charMax)\n{\n const u32 DrawBufferSize =\n nn::font::CharWriter::GetDispStringBufferSize(charMax);\n void *const bufMem = s_AppHeap.Allocate(DrawBufferSize);\n NN_NULL_ASSERT(bufMem);\n return nn::font::CharWriter::InitDispStringBuffer(bufMem, charMax);\n}\nThere is no need to allocate the display string buffer in device memory. There is no required buffer alignment, but we recommend 4-byte alignment.\n",0]
,["Pages/Page_53970611.html#PageId_53970618","4.2.1.4. Rendering Settings",
"4.2.1.4. Rendering Settings\nThe Font library configures the minimum level of settings required for rendering characters, so the application must appropriately set the following render pipeline stages before rendering.\n \tCulling \tScissor test \tPolygon offset \tEarly depth test \tDepth test \tStencil test \tMasking \tFramebuffer object\nIf the application makes culling or depth test settings to display 3D models or the like, the settings in effect immediately before the text is rendered are applied to the text. However, you can change these settings before rendering.\n In the following sample demo, the InitDraw function generates commands that configure the rendering settings.\n Code 4-6. Rendering Settings\n //---------------------------------------------------------------------------\n//! @brief Performs the initial settings for rendering.\n//!\n//! @param[in] width Screen width.\n//! @param[in] height Screen height.\n//---------------------------------------------------------------------------\nvoid\nInitDraw(\n int width,\n int height\n)\n{\n // Color buffer information.\n // Align with the orientation of the LCD, and swap the width with the height.\n const nn::font::ColorBufferInfo colBufInfo =\n { width, height, PICA_DATA_DEPTH24_STENCIL8_EXT };\n const u32 screenSettingCommands[] =\n {\n // Viewport settings.\n NN_FONT_CMD_SET_VIEWPORT( 0, 0, colBufInfo.width, colBufInfo.height ),\n // Disable scissoring.\n NN_FONT_CMD_SET_DISABLE_SCISSOR( colBufInfo ),\n // Disable the w buffer.\n // Depth range settings.\n // Disable polygon offset.\n NN_FONT_CMD_SET_WBUFFER_DEPTHRANGE_POLYGONOFFSET(\n 0.0f, // wScale : 0.0 disables the W buffer.\n 0.0f, // Depth range near.\n 1.0f, // Depth range far.\n 0, // Polygon offset units : 0.0 disables the polygon offset.\n colBufInfo),\n };\n nngxAdd3DCommand(screenSettingCommands, sizeof(screenSettingCommands), true);\n static const u32 s_InitCommands[] =\n {\n // Disable culling.\n NN_FONT_CMD_SET_CULL_FACE( NN_FONT_CMD_CULL_FACE_DISABLE ),\n // Disable stencil test.\n NN_FONT_CMD_SET_DISABLE_STENCIL_TEST(),\n // Disable depth test.\n // Enable writing of all color buffer components.\n NN_FONT_CMD_SET_DEPTH_FUNC_COLOR_MASK(\n false, // isDepthTestEnabled\n 0, // depthFunc\n true, // depthMask\n true, // red\n true, // green\n true, // blue\n true), // alpha\n // Disable early depth test.\n NN_FONT_CMD_SET_ENABLE_EARLY_DEPTH_TEST( false ),\n // Control access to the framebuffer.\n NN_FONT_CMD_SET_FBACCESS(\n true, // colorRead\n true, // colorWrite\n false, // depthRead\n false, // depthWrite\n false, // stencilRead\n false), // stencilWrite\n };\n nngxAdd3DCommand(s_InitCommands, sizeof(s_InitCommands), true);\n}\n",0]
,["Pages/Page_53970611.html#PageId_53970619","4.2.1.5. Processing Each Time Text Is Rendered",
"4.2.1.5. Processing Each Time Text Is Rendered\nThe processing performed until now is just initialization. This section describes the processing performed each time text is rendered.\nThe (Wide)TextWriter classes perform the rendering of strings that have a specified display position and font color. An instance of this class is assumed to be generated each frame, so this class has no explicit initialization function. Classes that process tag characters are also configured by default, so as long as there is no need to process custom tag characters, you can use the generated instance with no changes required. In addition, if you set no buffer to receive the fully uncompressed and formatted string, and then call a formatted Printf function, 256 characters of memory is allocated from the stack. If you do not want to use the stack, or if a buffer with a capacity of more than 256 characters is needed, the application must allocate a buffer and set it using the SetBuffer function. The return value is a pointer to the previously set buffer.\nThe rendered strings are accumulated one character at a time as string display information. Use the SetDispStringBuffer function to set the buffer for accumulating string information. (This buffer was allocated in 4.2.1.3 Allocating a Display String Buffer) for the TextWriter class. Use the SetFont function to set the font resources used in rendering.\nThe SetCursor or MoveCursor functions are used to set the display position (that is, the cursor position). SetCursor sets a new display position with no reference to a previous position. MoveCursor specifies the display position relative to the previous position. The x, y, and z coordinates can be set individually, or they can all be set at the same time. The default is (0.0, 0.0, 0.0).\nThe SetDrawFlag function sets how the string is laid out in relation to the display position. This string layout is set by the bitwise OR of three flags: two flags (one each per vertical and horizontal axes) that specify where to place the origin of the rectangular region in which to render the string, and one flag (horizontal axis only) that specifies which direction to align or justify the string toward. The flags are defined by nn::font::PositionFlag enumerators. The default string layout setting is HORIZONTAL_ALIGN_LEFT | HORIZONTAL_ORIGIN_LEFT | VERTICAL_ORIGIN_TOP. Figure 4-3. illustrates how string layout changes as individual flags are changed from the default settings.\n Figure 4-3. Changes in String Layout With Different Flags\nCharacters are scaled up or scaled down with the SetScale or SetFontSize functions. SetScale sets the width and height of characters as a multiple of the font’s width and height values. SetFontSize sets pixel values for the width and height of the characters to display. Scaling also affects the ascent and descent. For this reason, the GetFontAscent and GetFontDescent functions might return different values than those of the font. The default scaling is 100% (no change).\nThe SetTextColor function sets the character color. In addition, the SetGradationMode function can apply color gradation effects in the horizontal or vertical directions. The SetColorMapping function can set a linear transform for the gradation effect, and the gradation’s change in color can also be reversed depending on its settings. Note that the SetAlpha function can set an additional alpha value separate from the character color. The default settings are: a character color of (255,255,255,255), no gradation effect, no linear transform, and an additional alpha value of 255.\nThe SetLineHeight function sets the height of one line. This setting automatically adjusts the line spacing, not the linefeed width. Use the SetLineSpace function to directly set the line spacing. Additionally, the SetTabWidth and SetCharSpace functions set the tab width and character spacing, respectively. The default settings are: 0 for the line spacing and character spacing, and a tab width of 4 characters wide.\nTo forcibly render strings at a fixed width and ignore the font’s settings, use the SetFixedWidth function to set the rendering width, and use EnableFixedWidth(true) to enable monospaced rendering. Specify false in the EnableFixedWidth function to again disable monospaced rendering. The default setting is false (disabled).\nThe settings discussed until now are related to the display of text, and are set for the TextWriter class. Graphics-related settings for rendering text are set for the RectDrawer class.\n The DrawBegin function performs the initialization required to begin rendering. This function generates rendering commands that initialize the render mode, textures, and other items. This function also initializes internal variables, so if you plan to set the parallax with the SetParallax function, you must do so after this function is called.\nSet the projection matrix and view matrix with the SetProjectionMtx function and SetViewMtxForText function, respectively. The Font library assumes that the projection matrix has its origin at the upper left, with the dimensions of the screen in screen space identical to those of the LCD screen, and the positive directions of the y-axis and z-axis are reversed from their sign conventions in the CTR coordinate system. The view matrix is assumed to be a unit matrix.\nStrings are rendered by the TextWriter class. When characters are rendered, they are temporarily accumulated in the display string buffer as string display information, and the RectDrawer class generates rendering commands from the accumulated information.\n Use the TextWriter::StartPrint function to declare the start of string rendering. When this is done, the display string buffer is cleared.\n Render strings using either the TextWriter::Print or TextWriter::Printf function. The former does not specify a format string, while the latter does specify a format string.\nWhen string rendering is complete, use the TextWriter::EndPrint function to declare the end of string rendering. Thereafter, the RectDrawer::BuildTextCommand function generates rendering commands based on the accumulated information and the TextWriter::UseCommandBuffer function sends the rendering commands to the command buffer.\nFinally, call the RectDrawer::DrawEnd function to kick off the rendering commands and actually render the characters in the render buffer.\nIf there is no change to the content or display position of the string to render, you can get the same rendering results without any need to execute again the sequence of functions from the TextWriter::StartPrint function to the TextWriter::EndPrint and RectDrawer::BuildTextCommand functions. You can also render a string again and change only the character color, as long as the string was previously rendered in a solid color. However, this is possible only if the accumulated string display information has been saved.\nThe following code is the relevant portion of the sample demo.\n Code 4-7. Matrix Settings and Drawing Strings\n //---------------------------------------------------------------------------\n//! @brief Sets the modelview matrix and projection matrix for the display string.\n//!\n//! @param[in] pDrawer Pointer to the RectDrawer object.\n//! @param[in] width Screen width.\n//! @param[in] height Screen height.\n//---------------------------------------------------------------------------\nvoid\nSetupTextCamera(\n nn::font::RectDrawer* pDrawer,\n int width,\n int height\n)\n{\n // Set the projection matrix to orthogonal projection.\n {\n // Set as the top-left origin, with the y-axis and z-axis in the reverse orientation.\n nn::math::MTX44 proj;\n f32 znear = 0.0f;\n f32 zfar = -1.0f;\n f32 t = 0;\n f32 b = static_cast<f32>(width);\n f32 l = 0;\n f32 r = static_cast<f32>(height);\n nn::math::MTX44OrthoPivot(\n &proj, l, r, b, t, znear, zfar, nn::math::PIVOT_UPSIDE_TO_TOP);\n pDrawer->SetProjectionMtx(proj);\n }\n // Set the modelview matrix to an identity matrix.\n {\n nn::math::MTX34 mv;\n nn::math::MTX34Identity(&mv);\n pDrawer->SetViewMtxForText(mv);\n }\n}\n//---------------------------------------------------------------------------\n//! @brief Draw ASCII characters.\n//!\n//! @param[in] pDrawer Pointer to the RectDrawer object.\n//! @param[in] pDrawStringBuf Pointer to the DispStringBuffer object.\n//! @param[in] pFont Pointer to the font.\n//! @param[in] width Screen width.\n//! @param[in] height Screen height.\n//---------------------------------------------------------------------------\nvoid\nDrawAscii(\n nn::font::RectDrawer* pDrawer,\n nn::font::DispStringBuffer* pDrawStringBuf,\n nn::font::ResFont* pFont,\n int width,\n int height\n)\n{\n nn::font::TextWriter writer;\n writer.SetDispStringBuffer(pDrawStringBuf);\n writer.SetFont(pFont);\n writer.SetCursor(0, 0);\n // The strings are not changed, so the command for drawing strings is only created once.\n if (! s_InitAsciiString)\n {\n writer.StartPrint();\n (void)writer.Print(\"DEMO: ResFont\\n\");\n (void)writer.Print(\"\\n\");\n // Display ASCII character samples\n (void)writer.Print(\"All ASCII Character listing:\\n\");\n (void)writer.Print(\"\\n\");\n (void)writer.Print(\" !\\\"#$%&'()*+,-./\\n\");\n (void)writer.Print(\"0123456789:;<=>?\\n\");\n (void)writer.Print(\"@ABCDEFGHIJKLMNO\\n\");\n (void)writer.Print(\"PQRSTUVWXYZ[\\\\\\]^_\\n\");\n (void)writer.Print(\"`abcdefghijklmno\\n\");\n (void)writer.Print(\"pqrstuvwxyz{|}~\\n\");\n writer.EndPrint();\n pDrawer->BuildTextCommand(&writer);\n s_InitAsciiString = true;\n }\n // Character color can be changed without regenerating the string rendering commands.\n writer.SetTextColor(nn::util::Color8(s_Color, 255, s_Color, 255));\n s_Color++;\n pDrawer->DrawBegin();\n SetupTextCamera(pDrawer, width, height);\n writer.UseCommandBuffer();\n pDrawer->DrawEnd();\n}\n",0]
,["Pages/Page_53970611.html#PageId_53970620","4.2.1.6. Changing the GPU Settings With the Font Library",
"4.2.1.6. Changing the GPU Settings With the Font Library\nWhen fonts are rendered using the RectDrawer class, various GPU settings are changed including the texture sampler type and the vertex attribute load addresses. For this reason, after rendering fonts, have the application validate all of the GPU states and reset all of the GPU settings, although in some cases this processing might be redundant.\nThis section describes the GPU settings configured when fonts are rendered, as reference material for reducing the cost of resetting the GPU.\n",0]
,["Pages/Page_53970611.html#Anchor_53970620_コンバイナの設定","Combiner Settings",
"Combiner Settings\nCombiners 3 through 5 are used and set as follows. Some settings are different depending on whether the sheet’s texture format has an alpha component. Note also that the character color is expressed using the vertex color settings.\n Table 4-4. Combiner 3 Settings\n \tSetting \tColor \tAlpha\n \tSource 0 \t GL_TEXTURE0 \t GL_TEXTURE0\n \tSource 1 \t GL_CONSTANT \t GL_CONSTANT\n \tSource 2 \t GL_CONSTANT \t GL_CONSTANT\n \tOperand 0 \t (No alpha) GL_SRC_COLOR\n (With alpha) GL_ONE_MINUS_SRC_COLOR\n \t GL_SRC_ALPHA\n \tOperand 1 \t GL_SRC_COLOR \t GL_SRC_ALPHA\n \tOperand 2 \t GL_SRC_COLOR \t GL_SRC_ALPHA\n \tCombine \t GL_MODULATE \t GL_MODULATE\n \tScale \t1.0 \t1.0\n \tConstant color \tWhite (1.0, 1.0, 1.0, 1.0)\n Table 4-5. Combiner 4 Settings\n \tSetting \tColor \tAlpha\n \tSource 0 \t GL_TEXTURE0 \t GL_TEXTURE0\n \tSource 1 \t GL_CONSTANT \t GL_CONSTANT\n \tSource 2 \t GL_PREVIOUS \t GL_PREVIOUS\n \tOperand 0 \t (No alpha) GL_ONE_MINUS_SRC_COLOR\n (With alpha) GL_SRC_COLOR\n \t GL_ONE_MINUS_SRC_ALPHA\n \tOperand 1 \t GL_SRC_COLOR \t GL_SRC_ALPHA\n \tOperand 2 \t GL_SRC_COLOR \t GL_SRC_ALPHA\n \tCombine \t GL_MULT_ADD_DMP \t GL_MULT_ADD_DMP\n \tScale \t1.0 \t1.0\n \tConstant color \tBlack (0.0, 0.0, 0.0, 0.0)\n Table 4-6. Combiner 5 Settings\n \tSetting \tColor \tAlpha\n \tSource 0 \tGL_PRIMARY_COLOR \tGL_PRIMARY_COLOR\n \tSource 1 \tGL_PREVIOUS \tGL_PREVIOUS\n \tSource 2 \tGL_PREVIOUS \tGL_PREVIOUS\n \tOperand 0 \tGL_SRC_COLOR \tGL_SRC_ALPHA\n \tOperand 1 \tGL_SRC_COLOR \tGL_SRC_ALPHA\n \tOperand 2 \tGL_SRC_COLOR \tGL_SRC_ALPHA\n \tCombine \tGL_MODULATE \tGL_MODULATE\n \tScale \t1.0 \t1.0\n \tConstant color \tNot yet set. Undefined.\n ",0]
,["Pages/Page_53970611.html#Anchor_53970620_予約フラグメントシェーダの設定","Reserved Fragment Shader Settings",
"Reserved Fragment Shader Settings\nThe settings of the following reserved fragment shader features are changed.\n Table 4-7. Reserved Fragment Shader Settings\n \tFeature \tSetting\n \tPer-fragment operations mode \tStandard mode (GL_FRAGOP_MODE_GL_DMP)\n \tFragment lighting \tDisabled\n \tShadows (shadow textures) \tDisabled\n \tFog ( and gas) \tDisabled\n \tAlpha test \tDisabled\n \tBlending \tEnabled\n ",0]
,["Pages/Page_53970611.html#Anchor_53970620_テクスチャの設定","Texture Settings",
"Texture Settings\nOnly texture 0 is used, and it is set to GL_TEXTURE_2D. The texture image address and resolution, and filter settings and other settings are changed.\n",0]
,["Pages/Page_53970611.html#Anchor_53970620_シェーダの設定","Shader Settings",
"Shader Settings\nData required for rendering is set in the integer register i0 and the floating-point constant registers c0 through c95.\nThe shader program outputs the vertex coordinates, vertex color, texture coordinate 0, texture coordinate 1, and texture coordinate 2, but geometry shaders cannot be used.\n",0]
,["Pages/Page_53970611.html#PageId_53970621","4.2.2. Customizing the Processing of Tag Characters",
"4.2.2. Customizing the Processing of Tag Characters\nBy customizing classes that inherit the nn::font::TagProcessorBase class, it is possible to implement custom processing of tag characters (0x0000 to 0x001F).\nWhen a tag character appears as a character to render in the middle of rendering a string, the TextWriter class passes the character to the TagProcessor class set in the TextWriter for processing. By default, the TextWriter class is configured to have a TagProcessor class that processes the tab character (0x0009) and the newline character (0x000A), but you can use the SetTagProcessor function to set a customized TagProcessor class.\nWhen you use customized tag character processing, override the Process and CalcRect functions.\n Code 4-8. Functions to Override When Using Customized Tag Character Processing\n virtual Operation Process( u16 code,\n PrintContext<CharType>* pContext);\nvirtual Operation CalcRect(util::Rect* pRect,\n u16 code,\n PrintContext<CharType>* pContext);\nThe TextWriter class adjusts the coordinates at which to render characters based on the values returned from these functions. Implement your application so that the Process and CalcRect functions both return the same value when they process the same tag character.\n Table 4-8. Definitions of Return Values of Tag Character Processing\n \tDefinition \tProcessing Performed by TextWriter\n \t OPERATION_DEFAULT \tInserts no space before the next character if it is the first character in a line, but otherwise always inserts space before the next character.\n \t OPERATION_NO_CHAR_SPACE \tNever inserts a space before the next character.\n \t OPERATION_CHAR_SPACE \tAlways inserts a space before the next character.\n \t OPERATION_NEXT_LINE \tPerforms newline processing. Only adjusts the x-coordinate; the y-coordinate must be adjusted when processing tags.\n \t OPERATION_END_DRAW \tEnds string rendering in the middle of a string.\n A pointer to the TextWriter class is included in the members of the pContext argument, so it is possible to use tag characters for special processing, such as changing the character color.\nCONFIDENTIAL\n",0]
,["Pages/Page_53970622.html","5. Creating Fonts",
"5. Creating Fonts\nFont resources used by the Font library can be created using ctr_FontConverter (or the command-line version ctr_FontConverterConsole) from fonts installed on a PC or from image data.\n Warning:\n CTR-SDK does not include a license to any font.\n The ctr_FontConverter program uses fonts installed on a PC or image data to create font resources for the display of text using the font library. However, a license to use these fonts is needed to sell software that uses these fonts. You must always obtain all the appropriate licenses for each of your software titles.\nNot only can ctr_FontConverter create font resources, but it also can output fonts as image data. The possible image data formats are BMP format and TGA format. Image data in these formats can be used to create font resources. In other words, you can output image data, revise or tweak it, and recreate the font resource from that data, and you can combine image data to create a font resource that contains multiple fonts.\n",0]
,["Pages/Page_53970622.html#PageId_53970623","5.1. Files Used to Create Font Resources",
"5.1. Files Used to Create Font Resources\nThe following files are used when ctr_FontConverter creates font resources.\n \tCharacter filter files \tGlyph group files \tCharacter order files\nThese files are all written in XML (eXtensible Markup Language), and generally share a common structure.\n",0]
,["Pages/Page_53970622.html#PageId_53970624","5.1.1. Common Structures",
"5.1.1. Common Structures\nAlthough the name of the root element is different in the three types of files, each file has a common structure that contains the version attribute, the head element, and the body element. Although the structure of the head element is common among the files, the structure of the body element differs for each of the files.\nTable 5-1 below lists the elements in the common portions. The elements and attributes indicated in bold are required.\n Table 5-1. Elements in the Common Portions of the XML Files\n \tElement \t Elements It May Contain (Top Cell)\n Attributes (Bottom Cell)\n \tDescription\n \t Root element \tHEAD, BODY \t For the root element, the name of the element is different in each file.\n The elements it may contain and its attributes are common to all files.\n \t version\n \tHEAD \tCREATE, TITLE, COMMENT, GENERATOR \t Contains the information describing the file itself (the header).\n This element has a common structure in all files.\n \tNone.\n \tCREATE \tNone. \t Contains information set when the file was created.\n The user attribute contains the user name on the PC where the file was created. The host attribute contains the name of the PC. The date attribute contains the file creation date and time in ISO 8601 extended format.\n The source attribute contains the filename of the source data file if a source data file exists.\n \tuser, host, date, source\n \tTITLE \tNone. \t Contains the title of the file.\n This title is sometimes displayed as a selectable item in the GUI version of ctr_FontConverter.\n \tNone.\n \tCOMMENT \tNone. \tContains comments from the creator of the file.\n \tNone.\n \tGENERATOR \tNone. \t Contains information about the application that created the file.\n The name attribute contains a string that identifies the application.The version attribute contains the application version string.\n \t name, version\n \t body \tDepends on the file \tContains information comprising the body of the file.\n \tNone.\n Figure 5-4 illustrates the hierarchy of elements.\n Figure 5-1. Hierarchy of Elements in the Common Portions of the XML Files\n",0]
,["Pages/Page_53970622.html#PageId_53970625","5.1.2. Character Filter Files",
"5.1.2. Character Filter Files\nThe character filter file (extension .xllt) is used for the creation of a compact font resource that contains only the required characters. When the font resource is converted into a font, it is possible to suppress the output of all characters except those specified in this file. This file is unnecessary when all characters contained in the pre-conversion data are to be included in the font.\nThe root element is LETTER-LIST and 1.0 is stored in the version attribute. The BODY element contains only one element: letter.\n Table 5-2. Elements in the Character Filter File (Excluding the Common Portions)\n \tElement \t Elements It May Contain (Top Cell)\n Attributes (Bottom Cell)\n \tDescription\n \t LETTER-LIST \tHEAD, BODY \t The root element.\n The version attribute contains 1.0.\n \t version\n \t BODY \t LETTER \t Contains information comprising the body of the file.\n The only element it can contain is the single element LETTER.\n \tNone.\n \t LETTER \tNone. \t Defines the characters to output.\n The characters to output are specified by directly coding those characters. However, white-space characters (half-width spaces and tab characters) are ignored, and the half-width space is always included in the conversion results.\n \tNone.\n Figure 5-4 illustrates the hierarchy of elements.\n Figure 5-2. Hierarchy of Elements in the Character Filter File\nThe code below is the content of a sample character filter file (sample.xllt).\n Code 5-1. Sample Character Filter File (sample.xllt)\n <?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<!DOCTYPE letter-list SYSTEM \"letter-list.dtd\">\n<letter-list version=\"1.0\">\n <head>\n <create user=\"sample\" date=\"2005-02-18T10:51:13\" />\n <title>XLLT Sample</title>\n <comment>Sample Character Filter File</comment>\n </head>\n <body>\n <letter>\n FontConverter\n あいうえかきくけ\n 任天堂\n </letter>\n </body>\n</letter-list>\n",0]
,["Pages/Page_53970622.html#PageId_53970626","5.1.3. Glyph Group Files",
"5.1.3. Glyph Group Files\nThe glyph group file (extension .xggp) is used for the creation of archived fonts (compressed fonts). By specifying a group set (or specifying a file using the command argument –op in the command-line version), you can create a font resource containing the group information set in this file.\nThe root element is GLYPH-GROUPS and 1.0 is stored in the version attribute. The BODY element contains only one element: letter.\n Table 5-3. Elements in the Glyph Group File (Excluding the Common Portions)\n \tElement \t Elements It May Contain (Top Cell)\n Attributes (Bottom Cell)\n \tDescription\n \t GLYPH-GROUPS \tHEAD, BODY \t The root element.\n The version attribute contains 1.0.\n \t version\n \t BODY \t GROUP \t Contains information comprising the body of the file.\n The only element it may contain is the single element group.\n \tNone.\n \t GROUP \tSP, GROUP \t Defines the glyph group.\n The enumerated characters are contained in a glyph group having the name specified in the name attribute. Multiple group elements can be nested in a GROUP element.\n The only characters that can be used in the name attribute are the half-width alphanumeric characters (0–9, a–z, A–Z) and the underscore character (_). Within the same file, all GROUP elements must have unique name attributes.\n \t name\n \tSP \tNone. \tHalf-width spaces coded directly within GROUP elements are ignored, so this element is used to specify the half-width space within GROUP elements.\n \tNone.\n Figure 5-4 illustrates the hierarchy of elements.\n Figure 5-3. Hierarchy of Elements in the Glyph Group File\nThe code below is excerpted from a sample glyph group file (sample.xggp).\n Code 5-2. Sample Glyph Group File (sample.xggp)\n <?xml version=\"1.0\" encoding=\"UTF-8\" ?>\n<!DOCTYPE glyph-groups SYSTEM \"glyph-groups.dtd\">\n<glyph-groups version=\"1.0\">\n <head>\n <create user=\"sample\" date=\"2006-09-05T14:50:23\" />\n <title>sample</title>\n </head>\n <body>\n <group name=\"all\">\n <group name=\"ascii\">\n <sp/> ! \" # $ % & ' ( ) * + , - . /\n (omitted)\n p q r s t u v w x y z { | } ~\n </group>\n <group name=\"european\">\n € &sbquo; ƒ &bdquo; ... † ‡\n ˆ ‰ Š &lsaquo; Œ Ž\n (omitted)\n </group>\n (omitted)\n </group>\n </body>\n</glyph-groups>\n",0]
,["Pages/Page_53970622.html#PageId_53970627","5.1.4. Character Order Files",
"5.1.4. Character Order Files\nThe character order file (extension .xlor) is necessary when creating a font resource from image data or when outputting a font as image data. When used for input of image data, the order of the characters rendered in the image data must match the order of characters set in this file. When used for output of image data, the characters are rendered in the order set in this file, so this file also serves as a filter.\nThe root element is LETTER-ORDER and 1.0 or 1.1 is stored in the version attribute. The BODY element contains the AREA and ORDER elements.\n Table 5-4. Elements in the Character Order File (Excluding the Common Portions)\n \tElement \t Elements It May Contain (Top Cell)\n Attributes (Bottom Cell)\n \tDescription\n \t LETTER-ORDER \tHEAD, BODY \t The root element.\n The version attribute contains 1.0.\n If 1.0 is specified as the version attribute, no error results if multiple characters that have the same character code are coded within the ORDER element. However, if multiple glyphs that have the same character code are present, the first-coded glyph among them is used. Accordingly, edits to the other glyph images might not be reflected in the font resource. If 1.1 is specified as the version attribute, an error results if multiple characters that have the same character code are coded within the ORDER element, so we normally recommend that 1.1 be specified.\n \t version\n \t body \tAREA, ORDER \t Contains information comprising the body of the file.\n It can contain the AREA element and the ORDER element.\n \t None.\n \tAREA \tNone. \t Defines the font image contained in the image data using the number of characters in the horizontal and vertical directions.\n The width attribute defines the number of characters in the horizontal direction. If this attribute is omitted, the default is 16.\n The height attribute defines the number of characters in the vertical direction. If this attribute is omitted, the default is a value sufficient to output all the characters specified in the ORDER element.\n \twidth, height\n \t ORDER \tSP, NULL \t Defines the characters to output and their order.\n The characters enumerated in this element are output to the font resource in the order defined within it.\n \tNone.\n \tSP \tNone. \tHalf-width spaces coded directly within the ORDER element are ignored, so this element is used to specify half-width spaces in the ORDER element.\n \tNone.\n \tNULL \tNone. \tThis element causes the output position to skip forward by one character. Use this element if you do not want to output the block in that position to the font resource.\n \tNone.\n Figure 5-4 illustrates the hierarchy of elements.\n Figure 5-4. Hierarchy of Elements in the Character Order File\nThe code below is excerpted from a sample character order file (cp1252.xlor).\n Code 5-3. Sample Character Order File (cp1252.xlor)\n <?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\" ?>\n<!DOCTYPE letter-order SYSTEM \"letter-order.dtd\">\n<letter-order version=\"1.1\">\n <head>\n <create user=\"sample\" date=\"2005-02-18T10:51:13\" />\n <title>European Language (CodePage 1252 / Latin-1)</title>\n <comment>Windows Code Page 1252 character set. It is super set of ISO 8859-1 (Latin-1).</comment>\n </head>\n <body>\n <area width=\"16\" />\n <order>\n <sp/> ! \" # $ % & ' ( ) * + , - . /\n 0 1 2 3 4 5 6 7 8 9 : ; < = > ?\n (omitted)\n € <null/> &sbquo; ƒ &bdquo; ... †\n ‡ ˆ ‰ Š &lsaquo; Œ <null/>\n Ž <null/>\n (omitted)\n </order>\n </body>\n</letter-order>\n",0]
,["Pages/Page_53970622.html#PageId_53970628","5.1.4.1. Notes on Coding",
"5.1.4.1. Notes on Coding\nctr_FontConverter uses Unicode as the character encoding for its internal processing. Accordingly, it uses Unicode to determine whether character codes are identical. For example, in CP1252 and Shift-JIS, the ASCII character codes match, and some extended Latin characters and half-width Japanese katakana characters are assigned to the same character code in these two different encodings. In contrast, in Unicode different character codes are allocated to the extended Latin characters and half-width Japanese katakana characters, so ctr_FontConverter determines them to not be the same character. Yet for the 16 characters listed in Table 5-5, although different character codes are allocated to these characters in CP1252 and Shift-JIS, the same character code is allocated in Unicode, so ctr_FontConverter unfortunately determines them to be identical. To avoid this problem, in the character order files cp1252_JIS_X0201_X0208_012.xlor and cp1252_JIS_X0201_X0208_012_94.xlor provided with the SDK, these 16 characters on the Shift-JIS side are replaced with <null/>.\n Table 5-5. Characters Mapped to the Same Character Code in Unicode\n \tGlyph \tCharacter Code in CP1252 \tCharacter Code in Shift-JIS \tCharacter Code in Unicode\n \t´ \t0xB4 \t0x814C \tU+00B4\n \t¨ \t0xA8 \t0x814E \tU+00A8\n \t… \t0x85 \t0x8163 \tU+2026\n \t' \t0x91 \t0x8165 \tU+2018\n \t' \t0x92 \t0x8166 \tU+2019\n \t\" \t0x93 \t0x8167 \tU+201C\n \t\" \t0x94 \t0x8168 \tU+201D\n \t± \t0xB1 \t0x817D \tU+00B1\n \t× \t0xD7 \t0x817E \tU+00D7\n \t÷ \t0xF7 \t0x8180 \tU+00F7\n \t° \t0xB0 \t0x818B \tU+00B0\n \t§ \t0xA7 \t0x8198 \tU+00A7\n \t‰ \t0x89 \t0x81F1 \tU+2030\n \t† \t0x86 \t0x81F5 \tU+2020\n \t‡ \t0x87 \t0x81F6 \tU+2021\n \t¶ \t0xB6 \t0x81F7 \tU+00B6\n",0]
,["Pages/Page_53970622.html#PageId_53970629","5.2. Creating Font Resources From Fonts Installed on a PC",
"5.2. Creating Font Resources From Fonts Installed on a PC\nctr_FontConverter can create font resources from fonts installed on a PC. To exclude the possibility of using unlicensed fonts in products, the font resources are created using automatic font linking disabled, so that characters not included in the specified font are not included in the font resource.\nWhen text is viewed in an ordinary text editor, automatic font linking enables characters not included in the font to sometimes be supplemented by characters from another font. The Windows application Character Map can be used to confirm exactly what characters are actually contained in a font.\n",0]
,["Pages/Page_53970622.html#PageId_53970630","5.3. Creating Font Resources From Image Data",
"5.3. Creating Font Resources From Image Data\nctr_FontConverter can create font resources from the combination of character order files and image data on which the font images have been rendered. The image data that can be used as input to ctr_FontConverter must be in the following format.\n Table 5-6. Formats of Image Data Supported by ctr_FontConverter\n \tFormat \tScope of Support\n \tIndexed color BMP \tPer pixel: 1, 4, or 8 bits (2, 16, or 256 colors)\n \tDirect color BMP \tPer pixel: 24 bits (RGB8) or 32 bits (RGBA8).\n \tColorMap type TGA \tPer pixel: index is 8 or 16 bits (256 or 65,536 colors), and palette is 24 bits (RGB8) or 32 bits (RGBA8). Run-length encoding compressed data is also supported.\n \tTrueColor type TGA \tPer pixel: 24 bits (RGB8) or 32 bits (RGBA8). Run-length encoding compressed data is also supported.\n ctr_FontConverter performs the following conversions depending on the color format and image data format specified as image data input options. Note that in intensity-format fonts, ctr_FontConverter inverts the luminance values of the image data. In other words, the closer a pixel is to black the higher its luminance value becomes, and the closer a pixel is to white the lower its luminance value becomes.\n Table 5-7. Color Formats and Processing Performed in Conversion\n \tColor \tConversion Processes\n \tA4 \t In the case of indexed color, the index value is converted to 4 bits.\n In the case of direct color, the average of the RGB components is converted to 16-level grayscale.\n \tA8 \t In the case of indexed color, the index value is converted to 8 bits.\n In the case of direct color, the average of the RGB components is converted to 256-level grayscale.\n \tLA4 \t In the case of indexed color, the index value converted to 4 bits is used as the luminance value.\n In the case of direct color, the average of the RGB components converted to 16-level grayscale is used as the luminance value.\n Regardless of the color format of the image data, the per-pixel alpha component converted to 4 bits is used as the alpha value.\n \tLA8 \t In the case of indexed color, the index value converted to 8 bits is used as the luminance value.\n In the case of direct color, the average of the RGB components converted to 256-level grayscale is used as the luminance value.\n Regardless of the color format of the image data, the per-pixel alpha component converted to 8 bits is used as the alpha value.\n \tRGB565 \tThe RGB components are converted to 5, 6, and 5 bits, respectively, and the alpha component is not used.\n \tRGB5A1 \tThe RGB components are converted to 5 bits each, and only the most significant bit of the alpha component is used.\n \tRGBA4 \tThe RGBA components are converted to 4 bits each.\n \tRGB8 \tThe RGB components are converted to 8 bits each, and the alpha component is not used.\n \tRGBA8 \tThe RGBA components are converted to 8 bits each.\n ",0]
,["Pages/Page_53970622.html#Anchor_53970630_線形補間対策処理","Linear Interpolation Correction",
"Linear Interpolation Correction\nWhen the Font library renders characters, glyphs are displayed as textures applied to polygons. This enables hardware-based texture linear interpolation to be used to scale up characters. However, if the font format has an alpha channel and the pixel’s alpha value is 0, texture linear interpolation looks up the pixel color instead, which sometimes causes unintended display results.\nWith ctr_FontConverter, you can apply linear interpolation correction when you convert image data into a font resource. In linear interpolation correction, the color of pixels that are completely transparent (have an alpha value of 0) is overwritten with the average pixel color of all pixels that are not completely transparent (have a nonzero alpha value) among the eight adjacent pixels. The alpha value is not overwritten. Correcting glyphs in this manner resolves the unintended display problems caused by linear interpolation.\n",0]
,["Pages/Page_53970622.html#PageId_53970632","5.3.1. Blocks",
"5.3.1. Blocks\nA block is a subsection of the image data that contains a cell in which a glyph image has been rendered and a width-line region that indicates the character width. Each character coded in the character order file corresponds to one block, and the image data used for input to ctr_FontConverter must have these blocks packed one after another with no gaps in between.\nThe following limitations apply to the image data used for input.\nwidth of one block × number of blocks in the horizontal direction = width of the image\nheight of one block × number of blocks in the vertical direction = height of the image\nIn other words, the blocks in the image are aligned with no gaps in between, and there must be no empty space or spacing between blocks.\nIn fact, the number of blocks in the horizontal (or vertical) directions are defined in the character order file. The tool compares these numbers to the dimensions of the image as determined from the image data, and calculates the dimensions of the individual blocks. These calculated block dimensions must be integers or the image data cannot be used for input.\nThe figure below is an example of image data.\n Figure 5-5. Example of Image Data (Number of Blocks: 16×6)\nEach block contains a cell, which is the region in which the glyph image has been rendered. Below the cell, there is a one-pixel blank area, and below that there is a width-line region having a height of one pixel. The width-line in this region defines the character width and the relative position of the glyph image within the cell. There is a one-pixel-wide blank frame surrounding the cell and the width-line region, and a one-pixel-wide grid frame surrounding the blank frame. Accordingly, the block boundary is the boundary of that grid frame against the grid frame of the adjacent block. The grid frames are not checked when image data is converted, but the blank frames must contain a solid color or the tool will determine that a glyph image has overlapped the edge of the cell.\nThe height of the width-line region and the number of pixels in the blank frame and grid frame are fixed, so the size of a cell is always determined as follows.\ncell width = block width – 4 pixels\ncell height = block height – 6 pixels\nFigure 5-6 below is a schematic drawing of a block.\n Figure 5-6. Schematic Drawing of a Block\n",0]
,["Pages/Page_53970622.html#PageId_53970633","5.3.2. Cells and Width-Line Regions",
"5.3.2. Cells and Width-Line Regions\nOnly the glyph image is placed within the cell. ctr_FontConverter detects the smallest rectangle present within the cell that contains all pixels with nonzero alpha values and all pixels whose color is not white (255, 255, 255), and handles it as the glyph image. For this reason, even if the cell itself is large, the white transparent spaces surrounding the glyph image are ignored and have no effect on the created font. If the image data does not include an alpha channel, the smallest rectangle containing non-white pixels is handled as the glyph image.\nOnly a single line segment called the width-line is drawn in the width-line region. The width-line defines the character width and the width of the spaces to the left and right of the character. The length of the width-line is taken as exactly equivalent to the character width, and any abnormality in this line (such as being discontinuous and broken into more than one segment) causes an error. The character width can be made smaller than the width of the glyph image, and in this case the character is displayed on 3DS overlapping with the previous character. You can move the glyph image left or right within the cell without affecting the output font as long as the width-line is also moved and maintains the same positional relationship with the glyph image.\nIf the size of the glyph image is 0 and the length of the width-line is also 0, or if the interior of the cell is a solid single color and the length of the width-line is 0, that glyph is not output. You can use this fact to control what glyphs are output instead of using a character filter file. Conversely, if a glyph is not passed for output despite being specified for output in the character filter file, the character may have been dropped unintentionally, and a warning is displayed.\n",0]
,["Pages/Page_53970622.html#PageId_53970634","5.3.2.1. Layout Information",
"5.3.2.1. Layout Information\nThe block at the upper-left corner of the image data contains several single-pixel points that specify parameters for string layout when strings are rendered. These single-pixel dots are the layout information. The four values serving as the parameters for layout are the baseline, the ascender line, the descender line, and the font width. These four values are specified with five points. These values are common to the entire font and cannot be specified for individual characters.\nAll of the dots are located in the grid frame and are white (255, 255, 255) if a grid has been rendered, or are rendered in the grid color if no grid has been rendered. Although the pixel that indicates the baseline position must always be present, the remaining four pixels may be omitted.\nThe single pixel at the extreme upper-left corner of the image is reserved for future use and must always be white (255, 255, 255). In addition, this single pixel can also be used as a color key for transparent color. If an alpha value is entered for this pixel, the transparent color is determined to be the color containing the alpha value.\n Figure 5-7. Block Layout Information\n",0]
,["Pages/Page_53970622.html#Anchor_53970634_ベースライン","Baseline",
"Baseline\nThe point indicating the baseline position is rendered in the left edge of the grid frame. The upper edge of this pixel indicates the baseline position. In other words, the baseline lies on the boundary between pixels. The baseline serves as the vertical reference position when different fonts are used together or when characters are scaled.\n",0]
,["Pages/Page_53970622.html#Anchor_53970634_アセンダライン、ディセンダライン","Ascender Line and Descender Line",
"Ascender Line and Descender Line\nThe points indicating the ascender line and descender line positions are also rendered on the left edge of the grid frame. Like the baseline, the ascender line and descender line lie on the boundary between pixels, with the lower edge of the ascender line’s pixel indicating the position of the ascender line, and the upper edge of the descender line’s pixel indicating the position of the descender line. The ascender line is treated as the upper edge of the string, while the descender line is treated as the lower edge of the string. The distance between the ascender line and descender line is called the font height, which is the reference size when scaling characters in the vertical direction.\nThe ascender line must always be positioned above the baseline, and the descender line must always be positioned below the baseline. However, it is possible for the baseline and the descender line to be specified by the same pixel, and in this case the descent is 0.\nThe two points indicating the ascender line position and the descender line position are optional and may be omitted, with the remaining points being interpreted as illustrated in Table 5-8. If no ascender line position or descender line position is specified, the upper edge of the cell is treated as the ascender line and the lower edge of the cell is treated as the descender line.\nWhen ctr_FontConverter is used to output image data, the pixels indicating the ascender line position and the descender line position are sometimes rendered and sometimes not rendered. They are never rendered in conversions where Windows fonts are used as input. If image data is used as input, they are rendered if the input image contains pixels indicating the ascender line position and the descender line position, but are not rendered if not. When conditions are right to render the pixels indicating the ascender line position and descender line position, but the cell is too small to represent these pixels, the cell is automatically enlarged.\n Table 5-8. Number of Points and Their Interpretation\n \tNumber of Points \tFirst Point from Top \tSecond Point from Top \tThird Point from Top\n \t0 \tError\n \t1 \tBaseline \t–\n \t2 \tAscender line \tBaseline and descender line \t–\n \t3 \tAscender line \tBaseline \tDescender line\n \t4 or more \tError\n ",0]
,["Pages/Page_53970622.html#Anchor_53970634_フォント幅","Font Width",
"Font Width\nThe two points indicating the font width are rendered in the top edge of the grid frame. The two points represent the left edge and right edge of the width, respectively, so the number of pixels between these two pixels is the font width. These two points can be moved left or right with no effect on output as long as there is no change in the number of pixels between them. If the points indicating the font width are omitted, the width of the cell is taken as the font width. If used, both points must always be present (that is, you cannot omit just one of these points). The font width serves as the reference size for the tab width and for scaling characters in the horizontal direction.\nWhen ctr_FontConverter is used to output image data, the pixels indicating the font width are sometimes rendered and sometimes not rendered. They are never rendered in conversions where Windows fonts are used as input. They are always rendered in conversions where font resources are used as input. If image data is used as input, they are rendered if the input image contains pixels indicating the font width, but are not rendered if not. When conditions are right to render the pixels indicating the font width but the cell is too small to represent these pixels, the cell is automatically enlarged.\n",0]
,["Pages/Page_53970622.html#PageId_53970635","5.4. Creating Font Resources From Existing Font Resources",
"5.4. Creating Font Resources From Existing Font Resources\nFont resources can also be created and image data can also be output from BCFNT or BCFNA files. This capability can be used for filtering or investigating the characters contained in the font resources, or for checking or editing their glyph images.\n Warning:\n Be sure to obtain licenses to the fonts contained in the source font resources.\nCONFIDENTIAL\n",0]
];
for (var x = 0; x < Search.additionalData.length; x++) Search.indexData.push(Search.additionalData[x]);
