(function(){
var additionalData = [
["history.html","Revision History ",
"Revision History\n",0]
,["history.html","Version 1.2 (2015-01-15)",
"Version 1.2 (2015-01-15)\n",0]
,["history.html","Additions",
"Additions\n\t12. Applets\tMerged the information about library applets and system applets into a single chapter.\n",0]
,["history.html","Changes",
" \t12.2. System Applets\n \t12.2.2.1. Starting an Application From the Miiverse Post Page\n \t17. Appendix: Testing the Operations of CTR Titles on SNAKE\nChanges\n\t1. Overview\tRevised the link descriptions according to the addition of the Applets page.\n \t4.3.2. Libraries\tRevised the description of the OLV library.\n \t5.7.2. Characteristics and Limitations of the RO Library\tAdded an upper limit to the number of dynamic modules that can be loaded simultaneously.\n \t6.2.7.2. Differences From the Circle Pad Pro\tAdded information about system behavior when waking from Sleep Mode.\n \t12.1. Library Applets\tRemoved redundant parts from the applet description. \tMoved the chapter. \tRemoved unnecessary library information.\n \t12.2.1. Internet Browser Applet\tMoved the chapter. \tChanged the chapter name from WEBBRS Library (Internet Browser Applet). \tAdded the library name.\n \t12.2.2. Miiverse Application and Post App\tChanged the chapter name from \"OLV Library (Miiverse Post App).\" \tRevised the descriptions pertaining to the OLV library. \tMoved the chapter.\n \t13. Supplemental Libraries\tMoved the chapter about system applets.\n",0]
,["history.html","Deletions",
"Deletions\n\t1. Platform Notation\tDeleted this page because the information about platform notation was moved to the Readme file.\n",0]
,["history.html","Version 1.1 (2014-11-10)",
"Version 1.1 (2014-11-10)\n",0]
,["history.html","Additions",
"Additions\n\t5.3.10. Jump to E-manual\n \t12.2.2. Miiverse Application and Post App\nChanges\n\t2.3.1. CPU\tAdded descriptions of the core configuration and use cases.\n \t4.2.6. SNAKE-Only Titles\tAdded a description of SNAKE-only titles.\n \t4.3.2. Libraries\tAdded a description of adding the OLV library.\n \t9.6. Thread-Local Storage\tAdded a description of the feature to call the thread local storage destructor function.\n",0]
,["history.html","Version 1.0 (2014-09-04)",
"Version 1.0 (2014-09-04)\n",0]
,["history.html","Additions and Changes",
"Additions and Changes\n\tInitial version.\nCONFIDENTIAL\n",0]
,["title.html","3DS Programming Manual",
"3DS Programming Manual: System\nVersion 1.2\n\tNintendo Confidential\n\tThe content of this document is highly confidential and should be handled accordingly.\nThe content of this document cannot be duplicated, copied, reprinted, transferred, distributed, or loaned in whole or in part without the prior approval of Nintendo.\nThis document contains confidential and proprietary information of Nintendo and is also protected under the copyright laws of the United States and foreign countries.No part of this document may be released, distributed, transmitted or reproduced in any form or by any electronic or mechanical means, including information storage and retrieval systems, without permission in writing from Nintendo.\n© 2014–2015 Nintendo. All rights reserved.\nCTR-06-0019-002-B\nAll company and product names in this document are the trademarks or registered trademarks of their respective companies.\n",0]
,["Pages/Page_55582437.html","1. Introduction ",
"1. Introduction\nThis document provides 3DS application developers with an overview of CTR features, functions used, and programming procedures.\n2. System provides hardware block diagrams and overviews of the various features. Refer to this chapter for an overall grasp of the whole system.\n3. Memory and Nintendo 3DS Game Cards describes system memory regions and Nintendo 3DS Game Card memory regions. Refer to this chapter to learn about memory maps and proper CTR memory usage.\n4. Software Configuration describes the various types of software and libraries, and how they are organized. Refer to this chapter for information about differences between the hardware and application types, and about the libraries included in the SDK.\n5. Initializing Applications and Handling State Transitions describes the processes required to run an application and to properly transition through system states such as Sleep Mode. Refer to this chapter for explicit initialization and state transitioning procedures, and code examples.\n6. Input From Input Devices describes how to use the various input devices in an application. Refer to this chapter for more information about using key input, accelerometer, touch panel, gyro sensor, microphone, and camera.\n7. File System describes how to access media files and directories. Refer to this chapter for details on accessing files located on a Nintendo 3DS Card and its backup memory, or in SD cards.\n8. Time describes time-related features, such as ticks, timers, alarms, and the real-time clock (RTC). Refer to this chapter for more information about measuring the passage of time or using the RTC.\n9. Threads describes threads and classes used to synchronize multiple threads. Refer to this chapter for more information about how to create threads and how to share resources between multiple threads.\n10. Sound describes how to use the libraries needed for sound playback. Refer to this chapter for more information about playing back sounds in your application.\n11. System Settings describes how to access settings such as the user's name or the sound output mode. Refer to this chapter for more information about retrieving such information in your application.\n12. Applets describes how to use applets from within an application. Refer to this chapter to learn how to use applets provided on the 3DS.\n13. Supplemental Libraries describes how to use the libraries that provide functionality specific to the 3DS family. Refer to this chapter to learn how to access pedometer information and built-in resources.\n14. Infrared Communications Between Systems describes how to use the libraries needed by the infrared communications module. Refer to this chapter to communicate between systems using infrared communications.\n15. Differences Between TWL Mode and Actual TWL System describes the differences in operations of a 3DS system operating in TWL emulation mode and an actual TWL system. Refer to the cautions mentioned in this chapter when developing applications for Nintendo DS-family systems that will also run on 3DS systems.\n Note:\n For more information about the graphics features, see the separate 3DS Programming Manual: Basic Graphics and 3DS Programming Manual: Advanced Graphics.\nCONFIDENTIAL\n",0]
,["Pages/Page_55582438.html","2. System ",
"2. System\n",0]
,["Pages/Page_55582438.html#PageId_55605837","2.1. System Block Diagram (SNAKE)",
"This section describes the system block diagrams and hardware block information for both SNAKE and CTR.\n2.1. System Block Diagram (SNAKE)\nFigure 2-1 shows an overview of the SNAKE system.\nFigure 2-1. System Block Diagram (SNAKE)\nThe 800 pixels for stereoscopic display mode consist of 400 pixels each for the left and right eyes.\nThe items with a red background in the diagram are newly added specifications in SNAKE. Items with an orange background have changed from CTR.\n Note:\n The LCD screen size and other specifications differ depending on the hardware variation. For information about the specification differences, see 3DS Overview – General.\n",0]
,["Pages/Page_55582438.html#PageId_55606026","2.2. System Block Diagram (CTR)",
"\n2.2. System Block Diagram (CTR)\nFigure 2-2 shows an overview of the CTR system.\nFigure 2-2. System Block Diagram (CTR)\nThe 800 pixels for stereoscopic display mode consist of 400 pixels each for the left and right eyes.\n Note:\n FTR (Nintendo 2DS) has different specifications than CTR for the number of speakers and the upper screen. For information about the specification differences, see 3DS Overview – General.\n Application developers do not need to consider the differences between CTR and FTR.\n",0]
,["Pages/Page_55582438.html#PageId_55582439","2.3. SoC",
"\n2.3. SoC\n",0]
,["Pages/Page_55582438.html#PageId_55582440","2.3.1. CPU",
"The system-on-chip (SoC) includes the main components of the CPU, GPU, DSP, and VRAM all on one chip. The specifications of each are as follows.\n2.3.1. CPU\nThis is an ARM11 MPCore processor with multiple cores and their related vector floating-point (VFP) coprocessors.\n \t \tSNAKE \tCTR\n \tProcessor core \tARM11 MPCore\n \tOperating frequency \t268 MHz or 804 MHz \t268 MHz\n \tL1 cache \t4-way set-associative (per core)\n \t Core 0-1:\n 16 KB for instructions, 16 KB for data\n Core 2-3:\n 32 KB for instructions, 32 KB for data\n \t Core 0-1:\n 16 KB for instructions, 16 KB for data\n \tL2 cache \t 16-way set-associative\n (Shared by all cores. 2 MB shared command/data.)\n \tNone\n \tEndianness \tLittle-endian\nCTR has two CPU cores (Core 0 and Core 1). SNAKE has four CPU cores (Core 0 through 3). An application can use CPU Core 0 exclusively, while the remaining cores are used by the system. The core used exclusively by the application is called the application core and the cores used by the system are called the system cores. Each CPU core is used as follows.\n \tCPU Core \tUsage\n \tCore 0 \tApplication\n \tCore 1 \tSystem (but applications can use up to 30%)\n \tCore 2 \tUnused (reserved for system)\n \tCore 3 \tSystem (controls the Super-Stable 3D feature)\n Note:\n Although part of the system core can be used by the application, there are disadvantages such as a negative effect on background processes.\n",0]
,["Pages/Page_55582438.html#PageId_55582441","2.3.2. GPU",
"\n2.3.2. GPU\nThis includes a graphics core developed by Digital Media Professionals Inc. (DMP).\nBecause graphics processing is handled by the framebuffers, the BG or OBJ concepts used for the Nintendo DS do not apply.\n \tGraphics core \tPICA graphics core\n \tOperating frequency \t268 MHz\n \tArchitecture \tFrame buffer architecture\n \tShader \tVertex (programmable), pixel (not programmable)\n \tGraphics features \t OpenGL ES 1.1-based fixed pipeline + independent extensions (partially equivalent to OpenGL ES 2.0)\n Frequently used 3D graphics processes are built into the hardware.\n ",0]
,["Pages/Page_55582438.html#PageId_55582442","2.3.3. VRAM",
"\n2.3.3. VRAM\nThis includes two 3-MB video memory modules, which are read/write accessible only from the GPU. There is no difference in the performance of the two memory modules.\nThis is generally used as the location for the color buffers, depth buffers (Z buffers), and stencil buffers, and for textures and vertex buffers that are frequently used.\nVRAM is independent of the main memory and cannot be written to directly by the CPU.\n",0]
,["Pages/Page_55582438.html#PageId_55582443","2.3.4. Sound DSP",
"\n2.3.4. Sound DSP\nThe CTR system comes equipped with a digital signal processor (DSP). Unlike the DSP in the TWL, the CTR's DSP cannot be used for other processing.\n \tNumber of channels \t24 ch\n \tSampling Rate \tRoughly 32,728 Hz (precisely, Fs = 16756991 * 16 / (32 * 256) = 32,728.49805… Hz)\n \tParameter update interval \tRoughly 4.889 ms (precisely, T = 160 / Fs = 4.888705… ms)\n \tSampling format \tDSP ADPCM / PCM8 / PCM16\n \tResampling \tPolyphase filter / linear interpolation / disabled\n \tNumber of AUX buses \t2\n",0]
,["Pages/Page_55582438.html#PageId_55582444","2.4. Main Memory",
"\n2.4. Main Memory\nEach system has the following memory space available.\n \t \tSNAKE \tCTR\n \tMain Memory \t 124 MB\n (Development hardware has 178 MB.)\n \t 64 MB\n (Development hardware has 96 MB.)\n Texture and vertex buffers may also be located in main memory and referenced directly from the GPU.\nFor more information about the memory map, see 3.1. Memory.\n",0]
,["Pages/Page_55582438.html#PageId_56756383","2.5. Operating Modes",
"\n2.5. Operating Modes\nThe SNAKE hardware has two modes of operation: a standard mode that is equivalent to CTR, and an extended mode that is unique to SNAKE.\nThe performance differences between standard mode and extended mode are listed below.\nTable 2-1. Differences Between Standard Mode and Extended Mode\n \t \tStandard Mode \tExtended Mode\n \tCPU operating frequency \t268 MHz \t804 MHz (3x)\n \tCPU L2 cache \tDisabled \tEnabled (2 MB)\n \tMain memory size \t64 MB \t124 MB\n ",0]
,["Pages/Page_55582438.html#PageId_55582445","2.6. LCD",
"\n2.6. LCD\nThe system has two LCD screens.\n \t \t \tSNAKE \tCTR (SPR) \tFTR\n \tUpper Screen \tScreen size \t 3.88 inches\n XL is 4.88 inches.\n \t 3.5 inches\n SPR is 4.88 inches.\n \t3.5 inches\n \t Resolution\n For stereoscopic display\n \t 400 × 240 pixels\n 800 × 240 pixels (with one pixel for the left eye and one for the right displayed in the same size as a single pixel in normal 2D display)\n \tColor depth \t8-bit RGB for approximately 16.77 million colors\n \tLCD type \tSemi-transmissive (anti-glare)\n \tBacklight \t Built-in active backlight (controlled by turning power saving mode on and off)\n Brightness can be adjusted while the HOME Menu is displayed.\n \t3D display \tBy setting the mode and designing an application to support it, an application can support autostereoscopic display (stereoscopic 3D without glasses). \tNone\n \tLower Screen \tScreen size \t 3.33 inches\n XL is 4.18 inches.\n \t 3.0 inches\n SPR is 4.18 inches.\n \t3.0 inches\n \tResolution \t320 × 240 pixels\n \tColor depth \t8-bit RGB for approximately 16.77 million colors\n \tLCD type \tSemi-transmissive (no anti-glare)\n \tBacklight \t Built-in active backlight (controlled by turning power saving mode on and off)\n Brightness can be adjusted while the HOME Menu is displayed.\n \tTouch panel \tResistive film (No multi-touch. Input coordinates can be obtained in LCD pixels.)\n Warning:\n Stereoscopic display does not work when the system is held vertically (with the longer side of the LCD screens vertical).\n Note:\n For more information about stereoscopic display, see the 3DS Programming Manual: Advanced Graphics.\n",0]
,["Pages/Page_55582438.html#PageId_55582446","2.7. Memory Devices",
"\n2.7. Memory Devices\n",0]
,["Pages/Page_55582438.html#PageId_55582447","2.7.1. Game Card Slot",
"2.7.1. Game Card Slot\nThe Game Card slot accepts the following Game Cards.\n \t \tSNAKE-compatible \t3DS Only \tDS only\nDSi-compatible\nDSi only\n \tSNAKE \t○ \t○ \t○\n \tCTR \t○ \t○ \t○\n Note:\n It does not have a Game Pak (GBA) slot.\n",0]
,["Pages/Page_55582438.html#PageId_55582448","2.7.1.1. Nintendo 3DS Game Cards",
"\n2.7.1.1. Nintendo 3DS Game Cards\nNintendo 3DS Game Cards can be accessed at higher speeds than TWL/NITRO Cards, and security features have been revamped as well.\nTwo types of cards are available: CARD1 and CARD2. Current specifications support a CARD1 ROM capacity of up to 4 GB (32 gigabits). A backup memory capacity of either 128 KB (1 MB) or 512 KB (4 MB) is supported. CARD2 provides a total ROM and backup memory capacity of up to 2 GB (16 gigabits).\nThe system will use some of the capacity of both the ROM and backup memory. For more information, see 3.2. Nintendo 3DS Game Cards and 7.3. Save Data.\n",0]
,["Pages/Page_55582438.html#PageId_55606290","2.7.1.2. SNAKE-Compatible 3DS Game Cards",
"\n2.7.1.2. SNAKE-Compatible 3DS Game Cards\n(TBD)\n",0]
,["Pages/Page_55582438.html#PageId_55582449","2.7.2. System NAND Memory",
"\n2.7.2. System NAND Memory\nEach system has the following amount of internal NAND memory. System NAND memory is used for saving things such as preinstalled application data.\n \t \tSNAKE \tCTR\n \tCapacity \t1.3 GB \t1 GB\n ",0]
,["Pages/Page_55582438.html#PageId_55582450","2.7.3. SD/microSD Card Slot",
"\n2.7.3. SD/microSD Card Slot\nEach system includes a microSD or SD card slot that supports the following media types.\nThe system provides a means of accessing some files using dedicated libraries (for example, SoundDB and ImageDB). Applications (specifically, downloadable applications other than Nintendo DSiWare) can be started directly from an SD card.\n \t \tSNAKE \tCTR\n \tSupported media \t microSD Memory Card\nmicroSDHC Memory Card\n (microSDXC Memory Cards are not supported.)\n \t SD Memory Card\nSDHC Memory Card\n (SDXC Memory Cards are not supported.)\n",0]
,["Pages/Page_55582438.html#PageId_55582451","2.8. Input Devices",
"\n2.8. Input Devices\n",0]
,["Pages/Page_55582438.html#PageId_55582452","2.8.1. Key Input",
"2.8.1. Key Input\n \t \tSNAKE \t CTR\n SPR\n \tFTR \tComments\n \t+Control Pad \tYes \t\n \tA, B, X, and Y Buttons \tYes \t When the X Button on SNAKE is pressed with considerable force, downward movement might be detected on the C Stick. To avoid problems, we recommend the following workarounds in applications that use the C Stick.\n\tDo not assign press-and-hold operations to the X Button. \tDo not read values from the C Stick in scenarios where the X Button is held down. \tAdjust the sensitivity of the C Stick.\nMore force is required to reproduce this issue on the development hardware and the new Nintendo 3DS than on the new Nintendo 3DS XL.\n \tL/R Buttons \tYes \t\n \tZL/ZR Buttons \tYes \tAvailable when Circle Pad Pro is connected \tNone \tThe ZL and ZR Buttons on SNAKE are compatible with the ZL and ZR Buttons on the Nintendo 3DS Circle Pad Pro. Applications can handle them as if SNAKE were a CTR system that is always equipped with the Circle Pad Pro.\n \tCircle Pad \tYes \t\n \t C Stick/\n Right Circle Pad\n \tYes \tAvailable when Circle Pad Pro is connected \tNone \tThe C Stick on SNAKE are compatible with the Right Circle Pad on the Nintendo 3DS Circle Pad Pro. Applications can handle them as if SNAKE were a CTR system that is always equipped with the Circle Pad Pro.\n \tSTART or SELECT \tYes \tSELECT has been kept for backward compatibility with Nintendo DS software, and any SELECT press is interpreted by 3DS applications as identical to a START press.\n \tHOME Button \tYes \t Activates the HOME Menu.\n This input cannot be used by the application for gameplay purposes.\n \tPOWER Button \tYes \t Controls power features. To prevent unintended operation of the button, the button does not react to momentary presses. Holding it down for a set period of time begins forced shutdown.\n On SNAKE hardware, the POWER Button can be pressed while the system is closed.\n This input cannot be used by the application for gameplay purposes.\n \tWireless switch \tNone \tYes \tNone \t On SNAKE and FTR, the wireless switch is turned on and off from the HOME Menu.\n This input cannot be used by the application for gameplay purposes.\n \t Open/Closed detection sensor/\n Sleep Switch\n \tOpen/Closed detection sensor \tSleep Switch \t The open/close detection switch detects whether the system is open or closed. FTR cannot be closed, so it includes a sleep switch \"slider\" instead of an open/close detection switch.\n This input cannot be used by the application for gameplay purposes.\n \tSound volume \tYes \t Equipped with a volume slider.\n This input cannot be used by the application for gameplay purposes.\n \t3D Depth Slider \tYes \tNone \t Adjusts parallax for stereoscopic display.\n This input cannot be used by the application for gameplay purposes.\n ",0]
,["Pages/Page_55582438.html#PageId_55582453","2.8.2. Accelerometer",
"\n2.8.2. Accelerometer\nThe CTR system includes an accelerometer in the base of the system that measures acceleration on each of the three axes. This can be used by applications. The accelerometer range is approximately 1.8 G in both directions on each axis, with noise when stationary of up to ±0.02 G, sensitivity of approximately 0.002 G, and a sampling rate of 100 Hz (theoretical value for the device).\n",0]
,["Pages/Page_55582438.html#PageId_55582454","2.8.3. Touch Panel",
"\n2.8.3. Touch Panel\nThe CTR system has a touch panel over the lower LCD, just like the Nintendo DS/DSi.\nThe touch panel uses resistive film technology for single-point touch functionality similar to the Nintendo DSi. As with previous systems, input coordinates can be obtained in terms of LCD pixels.\n",0]
,["Pages/Page_55582438.html#PageId_55582455","2.8.4. Microphone",
"\n2.8.4. Microphone\nThe monaural microphone is located to the side of the group of buttons at the bottom of the lower screen. Performance is equivalent to the microphone on the Nintendo DSi. As with the Nintendo DSi, the microphone gain can be adjusted from 10.5 dB to 70.0 dB in increments of 0.5 dB.\nSensitivity variations between individual microphones are within 0.5 dB (1.06x).\n",0]
,["Pages/Page_55582438.html#PageId_55582456","2.8.5. Cameras",
"\n2.8.5. Cameras\nThe CTR system has one inner camera and two outer cameras (left and right), with the same specifications as the ones used on the Nintendo DSi system. You can either use both outer cameras at the same time or the left outer camera and the inner camera at the same time, but it is not possible to use all three cameras at the same time.\nThe main specifications of the cameras are listed below.\n \tAperture \tF2.8 (fixed).\n \tAngle of view \tSee the table below (when photographing at maximum resolution).\n \tPhotographable range \t20 cm to infinity. (Pan focus. Not equipped with a macro switch.)\n \tMaximum resolution \tVGA\n \tMaximum frame rate \t30 fps (fps: frames per second)\n \tOutput format \tYCrYCb (can also output to RGBA8888, RGB888, RGB565, and RGBA5551 formats by use of the separate YUV to RGB circuit).\n \t\n \t Minimum\n \t Average\n \t Maximum\n \t Diagonal\n \t 63.0°\n \t 66.0°\n \t 69.0°\n \t Horizontal\n \t 52.2°\n \t 54.9°\n \t 57.6°\n \t Vertical\n \t 40.4°\n \t 42.6°\n \t 44.8°\n ",0]
,["Pages/Page_55582438.html#PageId_55582457","2.8.6. Gyro Sensor",
"\n2.8.6. Gyro Sensor\nThe CTR system is equipped with a triaxial gyroscopic sensor in the bottom half of the system that can detect when the system is tilted and the speed of rotation. The sensor can measure up to ±1800 degrees per second (DPS), with noise when stationary of up to ±2.28 DPS, sensitivity of 0.07 DPS, and a sampling rate of 100 Hz.\n",0]
,["Pages/Page_55582438.html#PageId_55582458","2.9. Output Devices",
"\n2.9. Output Devices\n",0]
,["Pages/Page_55582438.html#PageId_55582459","2.9.1. Speakers",
"2.9.1. Speakers\nCTR and SPR have stereo speakers located to the left and right of the upper screen. FTR has a single monaural speaker located to the upper-left of the upper screen.\nThe following figure shows the frequency response of the CTR, SPR, and FTR speakers.\nFigure 2-3. Frequency Response of the CTR (SPR/FTR) System Speakers\nAcoustic input: -6dBFs [dBspl] [Hz] SPR CTR FTR\n",0]
,["Pages/Page_55582438.html#PageId_55582460","2.9.2. Audio Jack",
"\n2.9.2. Audio Jack\nThe system comes equipped with a stereo output mini-jack. Unlike the Nintendo DS/DSi, there is no microphone jack.\nHeadsets that include a microphone are not supported.\n \t \tSNAKE \tCTR \tSPR \tFTR\n \tAudio Jack location \tFront and center of lower half of system \tFront left of lower half of system\n ",0]
,["Pages/Page_55582438.html#PageId_55582461","2.9.3. LEDs",
"\n2.9.3. LEDs\nThe system comes with LEDs to indicate the camera state, battery level, charging status, wireless status, 3D display, and notification status.\nEach platform has the following LEDs.\n \t \tSNAKE \tCTR \tSPR \tFTR\n \tCamera status \tNone \tYes \tYes \tNone\n \tBattery \tYes \tYes \tYes \tYes\n \tCharging \tYes \tYes \tYes \tYes\n \tWireless \tYes \tYes \tYes \tYes\n \t3D Display \tNone \tYes \tNone \tNone\n \tNotifications \tYes \tYes \tYes \tYes\n",0]
,["Pages/Page_55582438.html#PageId_55582462","2.10. Communication Devices",
"\n2.10. Communication Devices\n",0]
,["Pages/Page_55582438.html#PageId_55582463","2.10.1. Wireless Communication Module",
"2.10.1. Wireless Communication Module\nThe CTR system has a wireless communication module that transmits in the 2.4 GHz band.\nCommunications features can be broadly classified as foreground, such as when an application explicitly uses communications features, and background, such as when the system is engaging in automatic communications.\n",0]
,["Pages/Page_55582438.html#PageId_55582464","2.10.2. Infrared Communication Device",
"For more information about wireless communication, see the 3DS Programming Manual: Wireless Communication.\n\tForeground Communication \tInfrastructure communication \tLocal communication \tDownload Play\n\tBackground communication \tStreetPass \tDownload tasks \tPresence features\n2.10.2. Infrared Communication Device\nThe CTR system comes with an infrared transceiver and an infrared communication device.\n",0]
,["Pages/Page_55582438.html#PageId_56754482","2.10.3. Near Field Communication (NFC)",
"\n2.10.3. Near Field Communication (NFC)\nA contactless near field communication (NFC) antenna is located below the lower screen panel.\n",0]
,["Pages/Page_55582438.html#PageId_55582465","2.11. Other",
"\n2.11. Other\n",0]
,["Pages/Page_55582438.html#PageId_55582466","2.11.1. Real-Time Clock (RTC)",
"2.11.1. Real-Time Clock (RTC)\nThis keeps and measures time.\n",0]
,["Pages/Page_55582438.html#PageId_55582467","2.11.2. Compatibility With the Nintendo DSi",
"\n2.11.2. Compatibility With the Nintendo DSi\nThe CTR system maintains compatibility with the Nintendo DSi and supports DS Download Play.\nCONFIDENTIAL\n",0]
,["Pages/Page_55582468.html","3. Memory and Nintendo 3DS Game Cards ",
"3. Memory and Nintendo 3DS Game Cards\n",0]
,["Pages/Page_55582468.html#PageId_55582469","3.1. Memory",
"This chapter describes memory regions that can be accessed by applications and Nintendo 3DS Game Cards written to by card-based software.\n3.1. Memory\n",0]
,["Pages/Page_55582468.html#PageId_55582470","3.1.1. Memory Map",
"3.1.1. Memory Map\nThe following figure shows a memory map as seen by applications. This memory map is for release versions.\nFigure 3-1 Memory Map (Release Versions)\nReserved Region 0x0000_0000 0x0800_0000 Heap Memory nn::os::GetHeapAddress() nn::os::GetHeapSize() 0x0E00_0000 Reserved Region VRAM nngxGetVramStartAddr(NN_GX_MEM_VRAMA) nngxGetVramEndAddr(NN_GX_MEM_VRAMB) nngxGetVramStartAddr(NN_GX_MEM_VRAMB) nngxGetVramEndAddr(NN_GX_MEM_VRAMA) VRAM-A 3 MB 1.5 MB which cannot be used for display buffers VRAM-B 3 MB 1.5 MB which cannot be used for display buffers 0x2000_0000 0x3000_0000 device memory nn::os::GetDeviceMemoryAddress() nn::os::GetDeviceMemorySize() 0x4000_0000 Can be directly overwritten by the application Cannot be directly overwritten by the application\nMemory access from applications is carried out using virtual addresses.\nFor security reasons, it is not possible to execute data arrays loaded into memory other than the region where the program is loaded (such as heap memory or device memory).\nMemory above address 0x4000_0000 is reserved.\n",0]
,["Pages/Page_55582468.html#PageId_55582471","3.1.2. Device Memory",
"\n3.1.2. Device Memory\nDevice memory is a region in memory for which the OS guarantees address integrity when it is accessed by the GPU or other peripheral device. Some of the buffers accessed by the GPU used for graphics and the DSP used for sound must be allocated from this device memory. Conversely, some buffers cannot be allocated from device memory. Generally, those buffers must be 4096-byte aligned and have sizes that are multiples of 4096 bytes.\nYou can use the nn::os::SetDeviceMemorySize function to specify the size of the memory region to allocate as device memory. Specify the size as a multiple of 4096 bytes. On CTR, you can allocate up to 64 MB for the main program and heap memory (96 MB on development hardware). On SNAKE, you can allocate up to 124 MB (178 MB on development hardware). You can call this function again to change the size of the memory region to allocate, but if you do you must change the size by a multiple of 1 MB (1,048,576 bytes). There is no guarantee that the address of the memory region allocated will be the same for every call. After specifying the size of the region, first use the nn::os::GetDeviceMemoryAddress function to get the starting address of the region, and then access the device memory. Use the nn::os::GetDeviceMemorySize function to get the size of the currently allocated memory.\nTable 3-1. Types and Starting Address Alignment for Buffers Allocated From Device Memory\n \t Device\n \t Buffer Type\n \t Alignment\n \t Comments\n \t GPU\n \t Texture image\n \t 128-byte\n \t\n \t Vertex buffer\n \t 1-byte to 4-byte\n \t Changes depending on vertex attributes.\n \t Display buffer\n \t 16-byte\n \t\n \t DSP\n \t Sound source data\n \t 32-byte\n \t The size of the whole region storing sound source data must be a multiple of 32 bytes.\n \t CAMERA\n \t Receive buffer\n \t 64 bytes (recommended)\n \t If you use a buffer allocated in a space other than device memory, the SDK stops on a panic.\n \t Y2R\n \t Image data receive/send buffer\n \t 64 bytes (recommended)\n \t If you use a buffer allocated in a space other than device memory, the SDK stops on a panic.\n Buffers accessed by the GPU may also be allocated from VRAM.\nTable 3-2. Buffers That Cannot Be Allocated From Device Memory\n \t Buffer\n \t Comments\n \t Buffer storing microphone sampling results\n \t Must be 4096-byte aligned, and its size must be a multiple of 4096 bytes.\n \t UDS library’s receive buffer\n \t Must be 4096-byte aligned, and its size must be a multiple of 4096 bytes.\n \t Socket library’s receive buffer\n \t Must be 4096-byte aligned, and its size must be a multiple of 4096 bytes.\n \t HTTP library’s working buffer\n \t Must be 4096-byte aligned, and its size must be a multiple of 4096 bytes.\n \t DLP library’s working buffer\n \t Must be 4096-byte aligned, and its size must be a multiple of 4096 bytes.\n \t ACT library communication buffer\n \t Must be 4096-byte aligned, and its size must be a multiple of 4096 bytes.\n ",0]
,["Pages/Page_55582468.html#PageId_55582472","3.1.3. VRAM",
"\n3.1.3. VRAM\nVRAM consists of the two regions VRAM-A and VRAM-B, each 3 MB, for a total of 6 MB.\nApplications must manage memory regions used by the GX (graphics) library, such as by allocating color buffers. (Note that when reading VRAM on the CPU, the data is not guaranteed to be accurate.) To allocate memory in VRAM, use the nngxGetVramStartAddr, nngxGetVramEndAddr, and nngxGetVramSize functions to get the start and end addresses and size of VRAM to manage the location of the requested memory regions.\nFor more information about the GX library and how to manage memory used by libraries, see 5.5. Initializing the GX Library (in this manual) and the 3DS Programming Manual: Basic Graphics.\n",0]
,["Pages/Page_55582468.html#PageId_55582473","3.1.4. Heap Memory",
"\n3.1.4. Heap Memory\nThis memory is freely usable by applications, such as for allocating file read and write buffers. Use the nn::os::SetHeapSize function to specify the size of heap memory to allocate. On CTR, the total of main program and device memory must be no greater than 64 MB (96 MB for development units). On SNAKE, the heap can use up to 96 MB and the total of main program, heap memory, and device memory must be no greater than 124 MB (178 MB for development hardware). Call this function again to change the size of the memory region to allocate. There is no guarantee that the address of the memory region allocated will be the same for every call. After specifying the size, use the nn::os::GetHeapAddr function to get the starting address of the region. Use the nn::os::GetHeapSize function to get the size of the currently allocated heap.\n",0]
,["Pages/Page_55582468.html#PageId_55582474","3.2. Nintendo 3DS Game Cards",
"\n3.2. Nintendo 3DS Game Cards\nThere are two types of Nintendo 3DS Game Cards: CARD1 and CARD2. The card most appropriate for use is determined by the game title’s specifications.\n Warning:\n As a rule, use CARD1 for game titles with a backup memory capacity of 512 KB, and use CARD2 for those with a capacity of 1 MB or more.\n",0]
,["Pages/Page_55582468.html#PageId_55582475","3.2.1. CARD1",
"\n3.2.1. CARD1\n",0]
,["Pages/Page_55582468.html#PageId_55582476","3.2.1.1. ROM",
"CARD1 cards come equipped with both read-only memory (ROM) and backup memory (rewritable non-volatile memory).\n3.2.1.1. ROM\nThe CARD1 ROM transfer speed varies depending on the version of the SDK in use and the size of the data being transferred. The actual speed may also vary slightly due to differences in individual cards, so do not design applications that depend on transfer speeds.\nThere are six different ROM capacities, ranging from 128 MB to 4 GB.\nTable 3-3. ROM Capacity (CARD1)\n \t ROM Capacity\n \t Transfer\nSpeed\n \t Usable Space Size by Market\n \t Japan, North America, Korea\n \t Europe\n \t China, Taiwan\n \t 128 MB\n \t (See Note)\n \t 93.5 MB\n(98,041,856 bytes)\n \t 91.5 MB\n(95,944,704 bytes)\n \t 61.5 MB\n(64,487,424 bytes)\n \t 256 MB\n \t 219.0 MB\n(229,638,144 bytes)\n \t 217.0 MB\n(227,540,992 bytes)\n \t 187.0 MB\n(196,083,712 bytes)\n \t 512 MB\n \t 470.0 MB\n (492,830,720 bytes)\n \t 468.0 MB\n(490,733,568 bytes)\n \t 438.0 MB\n(459,276,288 bytes)\n \t 1 GB\n \t 921.5 MB\n(966,262,784 bytes)\n \t 919.5 MB\n(964,165,632 bytes)\n \t 889.5 MB\n(932,708,352 bytes)\n \t 2 GB\n \t 1875.5 MB\n(1,966,604,288 bytes)\n \t 1873.5 MB\n(1,964,507,136 bytes)\n \t 1843.5 MB\n(1,933,049,856 bytes)\n \t 4 GB\n \t 3783.0 MB\n(3,966,763,008 bytes)\n \t 3781.0 MB\n(3,964,665,856 bytes)\n \t 3751.0 MB\n(3,933,208,576 bytes)\n Transfer speeds depend on the version of the SDK and the size of the data. For more information, see 3DS Performance Tips.\n",0]
,["Pages/Page_55582468.html#PageId_55582477","3.2.1.2. Backup Memory",
"\n3.2.1.2. Backup Memory\nThe transfer speed for backup memory in CARD1 cards depends on the version of the SDK in use and the size of the data being transferred. The actual speed may also vary slightly due to differences in individual cards, so do not design applications that depend on transfer speeds. See the CTR Guidelines and follow its standards for the number of write operations.\nThere are two different backup memory capacities, either 128 KB or 512 KB. Use a CARD2 card if you need 1 MB or more of backup memory.\nThe content of backup memory at time of shipment is guaranteed to be padded with 0xFF throughout the entire memory region, so pad all of the backup memory with 0xFF when emulating the memory state at time of shipment.\nYou can enable automatic redundancy of the backup memory region used for save data files. However, when automatic redundancy is enabled, the capacity available for saving files is roughly 40% of the total capacity.\nTable 3-4. Backup Memory Capacity (CARD1)\n \t Backup Memory Capacity\n \t Transfer Speed\n \t Usable Region Size When Automatic Redundancy Is Enabled\n \t 128 KB\n \t (See Note)\n \t 50 KB or less\n \t 512 KB\n \t 239 KB or less\n Transfer speeds depend on the version of the SDK and the size of the data. For more information, see 3DS Performance Tips.\n",0]
,["Pages/Page_55582468.html#PageId_55582478","3.2.2. CARD2",
"\n3.2.2. CARD2\n",0]
,["Pages/Page_55582468.html#PageId_55582479","3.2.2.1. Writable Memory",
"CARD2 cards come equipped with writable memory that has features of both ROM and backup memory.\n3.2.2.1. Writable Memory\nThe transfer speed for writable memory in CARD2 cards depends on the version of the SDK used and the size of the data involved. The actual speed may vary slightly due to differences in individual cards, so do not design applications that depend on transfer speeds. See the CTR Guidelines and follow its standards for the number of write operations.\nWith writable memory, you can change the boundaries of the ROM (read-only) and backup (rewritable) regions in 1-MB increments.\nYou can use the library to enable automatic redundancy for data in backup memory, just as with CARD1 backup memory. Calculate the usable capacity for saving files in a similar manner. The maximum file size that you can specify as backup space is half of the writable memory capacity. There are three sizes of writable memory capacity: 512 MB, 1 GB, and 2 GB.\nTable 3-5. Writable Memory Capacity (CARD2)\n \t Writable Memory Capacity\n \t Transfer\nSpeed\n \t Usable Space Size by Market\n \t Japan, North America, Korea\n \t For Europe\n \t China, Taiwan\n \t 512 MB\n \t (See Note)\n \t 412.5 MB\n(432,537,600 bytes)\n \t 410.5 MB\n(430,440,448 bytes)\n \t 412.5 MB\n(432,537,600 bytes)\n \t 1 GB\n \t 889.5 MB\n(932,708,352 bytes)\n \t 887.5 MB\n(930,61,200 bytes)\n \t 889.5 MB\n(932,708,352 bytes)\n \t 2 GB\n \t 1843.5 MB\n(1,933,049,856 bytes)\n \t 1841.5 MB\n(1,930,952,704 bytes)\n \t 1843.5 MB\n(1,933,049,856 bytes)\n Transfer speeds depend on the version of the SDK and the size of the data. For more information, see 3DS Performance Tips.\nCONFIDENTIAL\n",0]
,["Pages/Page_55582480.html","4. Software Configuration ",
"4. Software Configuration\n",0]
,["Pages/Page_55582480.html#PageId_55582481","4.1. Applications",
"This chapter describes the software configuration of the 3DS system.\n4.1. Applications\nTo switch from one application to another, you must start the second application using the HOME Menu.\nFigure 4-1. Application Switching\nApplication A Push HOME button HOME Menu Start Application Application B\n",0]
,["Pages/Page_55582480.html#PageId_56758514","4.2. Standard and Extended Applications",
"\n4.2. Standard and Extended Applications\nThe SNAKE hardware offers two operating modes with different CPU performance: standard mode and extended mode. For more information, see 2.5. Operating Modes. CTR is handled as a platform that only supports the standard mode.\nConsequently, two application types are available: standard applications that run in standard mode even on SNAKE, and extended applications that run in extended mode on SNAKE.\nTable 4-1. Application Types and Operating Modes on Each Platform\n \tApplication Type \tSNAKE \tCTR \tComments\n \tStandard application \tStandard mode \tStandard mode \tIncludes applications built with previous SDKs.\n \tExtended application \tExtended mode \tStandard mode \t\n ",0]
,["Pages/Page_55582480.html#PageId_56758596","4.2.1. Creating a Standard Application",
"4.2.1. Creating a Standard Application\nIf you are using the CTR-SDK build system, comment out the following line in the OMakefile if it exists: \"DESCRIPTOR = $(CTRSDK_ROOT)/resources/specfiles/ExtApplication.desc\".\nIf you are using VSI-CTR (requires VSI-CTR Platform 3.0.0 or later), in Configuration Properties > General, change Create Extended Application to No.\n",0]
,["Pages/Page_55582480.html#PageId_56758601","4.2.2. Creating an Extended Application",
"\n4.2.2. Creating an Extended Application\nIf you are using the CTR-SDK build system, add the following line to the OMakefile: \"DESCRIPTOR = $(CTRSDK_ROOT)/resources/specfiles/ExtApplication.desc\".\nIf you are using VSI-CTR (requires VSI-CTR Platform 3.0.0 or later), in Configuration Properties > General, change Create Extended Application to Yes.\n",0]
,["Pages/Page_55582480.html#PageId_56759311","4.2.3. Things to Note When Using Extended Mode",
"\n4.2.3. Things to Note When Using Extended Mode\nThe L2 cache is enabled in extended mode. However, the performance of functions such as nngxUpdaterBuffer might decrease due to the large capacity of the L2 cache.\nTo avoid this performance drop, variants of some API functions are provided for specific purposes in extended mode. Be sure to use the right function when handling graphics in your application while running in extended mode.\n",0]
,["Pages/Page_55582480.html#PageId_56759330","4.2.4. When the Operating Mode Changes",
"\n4.2.4. When the Operating Mode Changes\nOn SNAKE, the operating mode changes when nn::applet::Enable is called. Consequently, even standard applications run in extended mode from the time the 3DS logo is displayed until control is passed to the application and nn::applet::Enable is called.\nThe system always runs in extended mode while the HOME Menu is displayed, regardless of whether an application is running. When a standard application is suspended by the HOME Menu, the system changes from standard mode to extended mode, and then back to standard mode when control returns to the application.\nSystem applets such as Game Notes and Internet Browser also suspend the application and switch the operating mode to extended mode in the same manner as the HOME Menu.\nTable 4-2. Application Types and Timing of Operating Mode Change\n \tApplication Type \tLogo Display \tnn::applet::Enable \tApplication \tHOME Menu \tLibrary Applet \tSystem Applets\n \tExtended application \tExtended mode \tExtended mode \tExtended mode \tExtended mode \tExtended mode \tExtended mode\n \tStandard application \tExtended mode \tStandard mode \tStandard mode \tExtended mode \tStandard mode \tExtended mode\n ",0]
,["Pages/Page_55582480.html#PageId_56760643","4.2.5. Changing Application Behavior on SNAKE and CTR",
"\n4.2.5. Changing Application Behavior on SNAKE and CTR\nWith the addition of SNAKE to the 3DS family, in some cases it may be necessary to modify the behavior of an application depending on the type of hardware it is running on.\nAn application can determine whether it is running on SNAKE hardware by calling the nn::os::IsRunOnSnake function. This allows hardware-specific implementations, such as omitting the Circle Pad Pro connection check on SNAKE hardware, which has the equivalent input devices built into the system.\nAn application created as an extended application can determine whether it is running in extended mode on SNAKE by calling the nn::os::IsRunningAsExtApplication function. Note, however, that this function has a high execution cost and cannot be called inside nninitStartUp.\nThe nn::os::IsRunOnSnake and nn::os::IsRunningAsExtApplication functions return the following values for the various combinations of hardware and application type.\nTable 4-3. Return Values for Hardware and Application Combinations\n \tHardware \tApplication \tIsRunOnSnake \tIsRunningAsExtApplication\n \tSNAKE \tExtended application \ttrue \ttrue\n \tStandard application \ttrue \tfalse\n \tCTR \tExtended application \tfalse \tfalse\n \tStandard application \tfalse \tfalse\n Warning:\n Always use the nn::os::IsRunningAsExtApplication function to determine whether the application can use the enhanced features in extended mode (such as additional memory and CPU performance). The cache manipulation functions that are added when the L2 cache is enabled, however, can be used even in standard mode.\n Use the nn::os::IsRunOnSnake function to determine whether any other devices with different specifications on SNAKE and CTR can be used.\n",0]
,["Pages/Page_55582480.html#PageId_68590800","4.2.6. SNAKE-Only Titles",
"\n4.2.6. SNAKE-Only Titles\nFor applications that only operate on SNAKE, set the SNAKEOnly item in the BSF file to True. SNAKE-only titles do not run on CTR, so you do not need to consider operations on CTR.\n Note:\n For more information about BSF files, see the reference manual for the CTR-SDK tool ctr_makebanner.\n",0]
,["Pages/Page_55582480.html#PageId_55582482","4.3. What the SDK Provides",
"\n4.3. What the SDK Provides\n",0]
,["Pages/Page_55582480.html#PageId_55582483","4.3.1. Applets",
"The 3DS SDK includes not only libraries for handling device input such as key presses, but also provides applets and libraries for using features such as the HOME Menu and SpotPass.\n4.3.1. Applets\nMuch like the HOME Menu, applets provide features for specific purposes that applications can use. Using applet features can help reduce the cost of developing applications.\n Warning:\n Only applets provided by Nintendo can be used. Developers cannot create their own applets.\n",0]
,["Pages/Page_55582480.html#PageId_55582484","4.3.2. Libraries",
"\n4.3.2. Libraries\nCTR-SDK includes the libraries needed to use the hardware. Each library has its own namespace derived from the library name and comprises multiple classes and member functions.\nLibraries are written mainly in C++, with wrapper functions written in C. For more information about the C-language wrapper functions, see the CTR-SDK API Reference. The following descriptions all use C++ for function names and other code.\nTable 4-4. Library List\n \t Library Name\n \t Namespace\n \t Description\n \t OS\n \t nn::os\n \t A collection of classes for memory allocation, mutual exclusion, ticks, alarms, threads, and other operating system-related features.\n \t RO\n \t nn::ro\n \t Provides DLL features.\n \t APPLET\n \t nn::applet\n \t Supports starting applets, transitioning the system to sleep when the system is closed, and other functionality.\n \t FS\n \t nn::fs\n \t Used for accessing files on various media.\n \t CX\n \t nn::cx\n \t Handles data compression and decompression.\n \t MATH\n \t nn::math\n \t A collection of mathematical and numeric functions.\n \t CRYPTO\n \t nn::crypto\n \t Handles encryption.\n \t FND\n \t nn::fnd\n \t A collection of heap, time, and other fundamental classes.\n \t FONT\n \t nn::font\n \t Handles character drawing using font data.\n \t HID\n \t nn::hid\n \t Handles input from the digital buttons, Circle Pad, touch panel, accelerometer, gyro sensor, and debug pad.\n \t PTM\n \t nn::ptm\n \t Controls system power and alarms.\n \t GX\n \t nn::gx\n \t Handles GPU and LCD control. Uses the gl and nngx functions for 3D graphics rendering.\n \t GD\n \t nn::gd\n \t A lighter-weight version of the 3D graphics rendering functions in the GX library.\n \t GR\n \t nn::gr\n \t Supports direct generation of 3D graphics commands.\n \t MIC\n \t nn::mic\n \t Handles automatic microphone sampling.\n \t CAMERA\n \t nn::camera\n \t Handles image capture using a camera.\n \t Y2R\n \t nn::y2r\n \t Handles conversion from YUV to RGB format using the YUVtoRGB circuit.\n \t DSP\n \t nn::dsp\n \t Allows use of DSP for sound playback\n \t SND\n \t nn::snd\n \t Handles local sound playback.\n \t NDM\n \t nn::ndm\n \t Controls the daemon carrying out network processes.\n \t UDS\n \t nn::uds\n \t Handles wireless communications using the wireless communications module.\n \t RDT\n \t nn::rdt\n \t Allows secure data communication using the UDS library.\n \t CEC\n \t nn::cec\n \t Handles StreetPass [Chance Encounter Communication (CEC)] settings and other features.\n \t DLP\n \t nn::dlp\n \t Supports Nintendo 3DS Download Play.\n \t AC\n \t nn::ac\n \t Handles automatic connections for infrastructure communication.\n \t BOSS\n \t nn::boss\n \t Handles download task registration.\n \t FRIENDS\n \t nn::friends\n \t Supports access to friend information.\n \t NEWS\n \t nn::news\n \t Posts notifications.\n \t EC\n \t nn::ec\n \t For using the EC features.\n \tIR \tnn::ir \tFor using infrared communication between systems.\n \t ULCD\n \t nn::ulcd\n \t Calculates the left- and right-eye camera matrices used in stereoscopic display.\n \t JPEG\n \t nn::jpeg\n \t Handles encoding to and decoding from JPEG format.\n \t TPL\n \t nn::tpl\n \t Handles texture collection TPL files.\n \t CFG\n \t nn::cfg\n \t Gets information handled by System Settings.\n \t NGC\n \t nn::ngc\n \t Used to check for words that are in the profanity list.\n \t UBL\n \t nn::ubl\n \t Manages the blocked-user list..\n \t PL\n \t nn::pl\n \t Used for features unique to the 3DS (such as the pedometer).\n \t UTIL\n \t nn::util\n \t Utility functions.\n \t ENC\n \t nn::enc\n \t Handles encoding conversions.\n \t ERR\n \t nn::err\n \t Error handling.\n \t ERREULA\n \t nn::erreula\n \t For using the Error/EULA applet.\n \t SWKBD\n \t nn::swkbd\n \t For using the software keyboard applet.\n \t PHTSEL\n \t nn::phtsel\n \t For using the photo selection applet.\n \t VOICESEL\n \t nn::voicesel\n \t For using the sound selection applet.\n \t EXTRAPAD\n \t nn::extrapad\n \t For using the Circle Pad Pro calibration applet.\n \t WEBBRS\n \t nn::webbrs\n \t For using the Internet browser.\n \tOLV \t nn::olv\n \tFor using the Miiverse application and the Post app.\n \t SOCKET\n \t nn::socket\n \t (Debugging Only) Handles socket communication.\n \t SSL\n \t nn::ssl\n \t (Debugging Only) Handles SSL communication.\n \t HTTP\n \t nn::http\n \t (Debugging Only) Handles HTTP communication.\n \t DBG\n \t nn::dbg\n \t Assists in debugging.\n \t HIO\n \t nn::hio\n \t (Debugging Only) For using Host IO.\n \t MIDI\n \t nn::midi\n \t (Debugging Only) For using MIDI.\n Library configurations and names may be changed in the future.\n",0]
,["Pages/Page_55582480.html#PageId_55582485","4.4. Error Handling",
"\n4.4. Error Handling\nWhen the 3DS system is updated, the libraries are also updated. As a result, functions could return values that were not defined at the time the application was developed. To handle such cases, you must use the function nn::Result::IsSuccess or nn::Result::IsFailure to determine whether a process has succeeded.\nNintendo does not recommend error handling that only uses value matching to determine errors rather than using these functions, because doing so could cause the application to erroneously assume success or failure when an unexpected error occurs.\n Note:\n When errors that differ from the symptoms in the reference occur only on a particular device, you should suspect a problem with that hardware.\nCONFIDENTIAL\n",0]
,["Pages/Page_55582486.html","5. Initializing Applications and Handling State Transitions ",
"5. Initializing Applications and Handling State Transitions\n",0]
,["Pages/Page_55582486.html#PageId_55582487","5.1. Initialization Prior to Calling the Entry Function",
"This chapter describes what an application must initialize when it is started, and how to handle state transitions, such as to Sleep Mode.\n5.1. Initialization Prior to Calling the Entry Function\nFor more information about the processes performed prior to calling the application's entry function, see the System Programming Guide included in the SDK.\n",0]
,["Pages/Page_55582486.html#PageId_55582488","5.2. Entry Function",
"\n5.2. Entry Function\nAn application's entry function is defined by the nnMain function.\nThe entry function must first initialize the libraries used by the application. The details of initializing the main libraries are provided later in this document.\nIf there is no entry function, the application quits. Within the entry function, construct a main loop, and ensure that execution does not leave the entry function until the application quits.\n",0]
,["Pages/Page_55582486.html#PageId_55582489","5.3. Initializing the APPLET Library",
"\n5.3. Initializing the APPLET Library\nThe APPLET library is not just for using library applets. It is also required for handling HOME Button and POWER Button events and transitioning to Sleep Mode when the system is closed. Initialization of the APPLET library is performed before execution moves to the entry function. Initialization processing that must be performed by the application calls the nn::applet::Enable function to enable each function of the APPLET library.\nCode 5-1. APPLET Library Initialization\n void nn::applet::Enable(bool isSleepEnabled = true);\nCall this function after setting a sleep-related callback. Use isSleepEnabled when calling this function to specify whether a sleep-related callback is enabled.\nJust before and after calling this function, sleep-related handling must be carefully performed. For information about sleep-related handling, see 5.3.3. Sleep Handling.\n Warning:\n The nn::applet::Enable function must be called before the nngxInitialize, nn::dsp::Initialize, or nn::snd::Initialize functions.\n Primarily, this is because there are times when an application must be closed immediately after it starts due to something that occurred before the Enable function is called, such as the POWER Button being pressed while the application was starting. For this reason, immediately after calling this function, handle with an application close request as described in 5.3.1. Handling Application Close Requests. At this time, do not call nngxInitialize until it is verified that the close request did not arrive.\nThe following sections explain application close requests, the HOME Button, sleep (closing system), and POWER Button handling that the application must implement. These sections also give examples of handling these state changes. The system uses Applet Manager to notify the application about all state changes the application must respond to.\n Warning:\n When there has been no response to an application close request or a POWER Button press, the application is forcibly ended when the POWER Button is held down for longer than a certain period of time. The application must implement responses to these state changes so that they are handled by normal processing.\n",0]
,["Pages/Page_55582486.html#PageId_55582490","5.3.1. Handling Application Close Requests",
"\nFigure 5-1. Notifications Sent From the Applet Manager\nApplication Applet Manager IsExpectedToProcessHomeButton() returns true. IsExpectedToProcessPowerButton() returns true. IsExpectedToCloseApplication() returns true. The sleep query callback is called. The sleep cancel callback is called. The sleep recovery callback is called. Returns\n5.3.1. Handling Application Close Requests\nThe Applet Manager uses the nn::applet::IsExpectedCloseApplication function to send a notification if an application enters a state where it must close. This could occur, for example, when another application is started or Close is selected on the HOME Menu while an application is suspended. Applications must call this function periodically (such as once per frame). If nn::applet::IsExpectedToCloseApplication returns true, the application must quickly be closed. It is also possible for the application to enter a state where it has no rendering rights.\nIn this case, first make the application perform its own shutdown processing (within four seconds), and then call the nn::applet::CloseApplication to close the application. Because graphics-related processes cannot be executed from a state where there are no rendering rights, calls to nngxInitialize or nngxWaitCmdlistDone block processing. Also, command request completion interrupts are not generated in this state. You must implement the shutdown processing without waiting for completion of command requests.\nThe nngxFinalize function can be called even in a state where the application does not have rendering rights, and calling it automatically releases the display buffer allocated by the nngx or gl functions.\nCode 5-2. Functions Used to Close Applications\n bool nn::applet::IsExpectedToCloseApplication(void);\nnn::Result nn::applet::CloseApplication(const u8* pParam=NULL,\n size_t paramSize=0, nn::Handle handle=NN_APPLET_HANDLE_NONE);\n",0]
,["Pages/Page_55582486.html#PageId_55582491","5.3.1.1. Cautions When Shutting Down",
"In addition to periodically calling the IsExpectedToCloseApplication function, also be sure to call this function immediately after returning from the HOME Menu or a library applet to check whether a condition requiring the application to close while waiting for the return has occurred. Also check immediately after initializing the APPLET library in case a close request has arrived while loading an application. If this function returns true, also execute the processes that you want to run when the application closes (for example, autosave).\n5.3.1.1. Cautions When Shutting Down\nAlthough the CTR-SDK is designed to release the allocated resources, even if an application calls nn::applet::CloseApplication at an arbitrary time, this feature has not been sufficiently tested. To safely close an application, implement closing based on the following measures until CloseApplication is called.\n Note:\n Revisions in future releases are expected to make the following measures unnecessary.\n",0]
,["Pages/Page_55582486.html#Anchor_55582491_必須","Required",
"Required\nWhen an nn::os::Alarm object has been created, call the Alarm object member functions Cancel and Finalize in order.\nWhen an nn::os::Timer object has been created, call the Timer object member functions Stop and Finalize in order.\nStop FS and UDS library processes, and then finalize the libraries. In particular, for the FS library, call the Finalize function for each class being used. Even for NW4C and other non-SDK packages, be sure to finalize for classes being used by the FS library.\n",0]
,["Pages/Page_55582486.html#Anchor_55582491_推奨","Recommended",
"Recommended\nFinalize all libraries that have been initialized.\n",0]
,["Pages/Page_55582486.html#PageId_55582492","5.3.2. Handling HOME Button Presses",
"\n5.3.2. Handling HOME Button Presses\nIf the HOME Button is pressed, the Applet Manager uses the nn::applet::IsExpectedToProcessHomeButton function to send notification of whether the application has entered a state that requires the HOME Menu to start. Applications must call this function periodically (such as once per frame). If this function returns true, the application must start the HOME Menu. Have the applications stop the operation of all devices and start the HOME Menu immediately. If, however, operations cannot be stopped due to a process that cannot be halted, you can display a HOME Disabled icon and stop the start of the HOME Menu. Note that the IsExpectedToProcessHomeButton function continues to return true unless you use the nn::applet::ClearHomeButtonState function to invalidate the fact that the HOME Button was pressed.\nCode 5-3. Functions Used to Start the HOME Menu\n bool nn::applet::IsExpectedToProcessHomeButton(void);\nbool nn::applet::ProcessHomeButton(void);\nnn::applet::AppletWakeupState nn::applet::WaitForStarting(\n nn::applet::AppletId* pSenderId=NULL, u8* pParam=NULL,\n size_t paramSize=0, s32* pReadLen=NULL, nn::Handle *pHandle=NULL,\n nn::fnd::TimeSpan timeout=NN_APPLET_WAIT_INFINITE);\nvoid nn::applet::ClearHomeButtonState(void);\nvoid nn::applet::ProcessHomeButtonAndWait();\nProcessing required to start the HOME Menu can be carried out merely by calling the nn::applet::ProcessHomeButton function. If the return value is true, immediately call the nn::applet::WaitForStarting function and wait for the return from the HOME Menu. Upon return, there are restrictions on the use of devices for purposes such as getting key input and rendering. Also, note that only the thread that called the WaitForStarting function stops.\nDo not program an application in a way that would encourage operation that causes threads with priority level 16 or higher (a priority number from 1 to 16) to continue to occupy the CPU even after transitioning to the HOME Menu.If game memory is started up when a thread of this type is present, the system will freeze.When an application thread continues to run while the HOME Menu is being displayed, performance for the HOME Menu and other operations deteriorate. We recommend that you program the system so that all application threads stop when transitioning to the HOME Menu.\nThe nn::applet::ProcessHomeButtonAndWait function is a wrapper function that calls the ProcessHomeButton function and handles waiting and Sleep Mode.\n Warning:\n At some point before the ProcessHomeButton function is called, you must call the nngxWaitCmdlistDone function or perform equivalent processing to ensure that all GPU render commands have finished executing.\n Note:\n The ProcessHomeButton function can only be called during the time that the GX library can be used (from the completion of nngxInitialize until nngxFinalize is called).\n Before you call the ProcessHomeButton function, configure the display buffer, swap buffers, and call the nngxStartLcdDisplay function to start LCD output. If LCD output has not been started, there is a chance that the HOME Menu could start up with black screens. Likewise, if the display buffer has not been configured or the buffers have not been swapped, there is a chance that undefined content could be displayed on the screens.\nTable 5-1. Handling Devices During HOME Menu Display\n \t Device\n \t Application Response During HOME Menu Display\n \t GPU/LCDs\n \t Stop rendering, and do not update the display buffer. Also, by the time the HOME Menu is displayed, the graphics processing must be completed and the GPU must be in a stopped state.\n \t Digital Buttons/Circle Pad\n \t No particular handling is necessary. This input is not reflected in the input values obtained by the application.\n \t Touch Panel\n \t No particular handling is necessary. This input is not reflected in the sampling values obtained by the application; an invalid sampling value (0) is returned.\n \t Accelerometer\n \t No particular handling is necessary. Input values can be obtained.\n \t Gyro Sensor\n \t Input values can be obtained. If the gyro sensor will not be calibrated after returning from the HOME Menu, even during HOME Menu display, the application must obtain and correct these input values.\n \t Sound\n \t Functions in the SND library are designed to be called from the main thread and the sound thread. When calling functions from these threads, the application does not need to keep track of anything when transitioning with the HOME Button. However, if you are calling functions from other threads, you must provide appropriate handling so that calls are not made while the application is in a suspended state.\n Because you cannot control the timing at which sound stops, the application must manage playback status or take other such steps to ensure synchronization of sound and graphics when such synchronization is necessary, such as when playing video.\n \t Camera\n \t No particular handling is necessary. Unless the cameras are finalized before HOME Menu startup, HOME Menu features that use the cameras will not work.\n \t Microphone\n \t No particular handling is necessary.\n \t Wireless Communication\n \t For non-local types of communication, no particular handling is necessary. However, if a browser or other application has been started and it uses wireless communication while the HOME Menu is displaying, that application’s communication will be disconnected when the system returns from the HOME Menu.\n Local communication can continue. However, you must consider the possibility that the system will be closed during HOME Menu display, which would result in a transition to Sleep Mode. If local communications are not ended at that point, the local communications status will transition to an error. Also, unless local communication is finalized before HOME Menu startup, any HOME Menu features that use local communication will not work.\n \tNFC \t(TBD)\n From immediately after returning from the HOME Menu until the application calls the nngxSwapBuffers function to switch the display buffer, an image captured during transition to the HOME Menu is displayed on the screen. Note at this point is that although the content of main memory and VRAM is protected, GPU register settings must be reset by the application. Be sure to reset all register settings including the framebuffer, shader binary, and lookup tables, and not just the vertex load array settings and texture unit settings.\n Note:\n The nngxUpdateState(NN_GX_STATE_ALL) function call can be used to restore register settings as long as they are not directly overwritten.\n",0]
,["Pages/Page_55582486.html#Anchor_55582492_HOMEボタン押下の検知","HOME Button Press Detection",
"HOME Button Press Detection\nAlthough detection of HOME Button presses can also be checked using notifications to a callback function registered using the nn::applet::SetHomeButtonCallback function, implement this check by periodically checking the nn::applet::IsExpectedToProcessHomeButton function.\nCode 5-4 Setting a HOME Button Callback Function\n void nn::applet::SetHomeButtonCallback(\n nn::applet::AppletHomeButtonCallback callback, uptr arg=0);\ntypedef bool (*nn::applet::AppletHomeButtonCallback)(\n uptr arg, bool isActive, nn::applet::CTR::HomeButtonState state);\nSet a callback function by calling the nn::applet::SetHomeButtonCallback function. Calls to the callback function pass the value of the arg parameter that was originally specified when SetHomeButtonCallback was called. The isActive parameter specifies whether an application is currently running, and the state parameter specifies the state of the HOME Button.\nThe status of the HOME Button is defined by the nn::applet::HomeButtonState enumerator type.\nTable 5-2. HOME Button States\n \t Definition\n \t Description\n \t HOME_BUTTON_NONE\n \t HOME Button is not pressed.\n \t HOME_BUTTON_SINGLE_PRESSED\n \t HOME Button is pressed (held for at least 200 ms).\n Use the nn::applet::GetHomeButtonState function to check the state of the HOME Button. After a button press is detected, the HOME Button keeps that state until the next call to the nn::applet::ClearHomeButtonState function. Calls to ClearHomeButtonState return the state of the HOME Button to HOME_BUTTON_NONE.\nCode 5-5. Checking the State of the HOME Button\n nn::applet::AppletHomeButtonState nn::applet::GetHomeButtonState(void);\n",0]
,["Pages/Page_55582486.html#PageId_55582494","5.3.2.1. What an Application Can Do Before Starting the HOME Menu",
"The application can use the return value from the callback function to determine whether to enable or disable detection of HOME Button presses, and to control whether detection is indicated in the state of the HOME Button that is obtained by calling the nn::applet::GetHomeButtonState function. Indicate detection of HOME Button presses for callback return values of true; do not for return values of false. Implement the callback function to return the value in the isActive parameter. Implement the function to only handle lightweight processing such as flag control; do not start the HOME Menu from directly within the callback function.\n5.3.2.1. What an Application Can Do Before Starting the HOME Menu\nAfter an application detects a HOME Button press, it has a maximum of 0.5 seconds until it must start the HOME Menu. Within this time, the application can carry out such operations as pausing the action or auto-saving. When you do not want to have a static image of the game as the HOME Menu background (such as for timed puzzle games), you could use this time to process a different image to hide the game screen. But in general, we recommend using just a static game screen as the background.\n When an application is suspended, the rendering process to create a capture image to display on the upper screen of the HOME Menu is performed after it is confirmed that nn::applet::IsExpectedToProcessHomeButton returns true. However to display the HOME Menu with nn::applet::ProcessHomeButton, the GPU processing must be stopped (graphics processing must be completed). Call nngxWaitCmdlistDone to wait until all graphics commands have completed. After that, call nngxWaitVSync to ensure that the images displayed on the LCDs are updated.\nWhen starting the HOME Menu, consider the possibility that the user will close the application in the HOME Menu and implement it so that there are no problems even if the application is closed in the HOME Menu. Although you can usually perform shutdown processing after control returns to the application, note that shutdown processing becomes impossible if the battery runs down during Sleep Mode while the HOME Menu is being displayed.\n",0]
,["Pages/Page_55582486.html#PageId_55582495","5.3.2.2. Displaying the HOME Menu Disabled Icon",
"\n5.3.2.2. Displaying the HOME Menu Disabled Icon\nWhen an application detects a HOME Button press while in the middle of a process that cannot be interrupted (such as saving), and the HOME Menu cannot be displayed right away, the application can display the HOME Menu Disabled icon in the middle of the lower screen and cancel starting the HOME Menu.\n Implement the HOME Menu Disabled icon according to the following specifications.\n\tIcon: Image file included in the CTR-SDK (HomeNixSign_Targa.tga) \tDisplay position: Center of the lower screen \tFade-in: 0.083 seconds (5 frames at 60 fps) \tDisplay time: 1 second (60 frames at 60 fps) \tFade-out: 0.333 seconds (20 frames at 60 fps)\nIf the user presses the HOME Button while the icon is displayed, simply continue displaying the icon. For example, if the user presses the HOME Button while the icon is fading out, you do not need to fade in again. Just continue with the fade-out. Even if it does become possible to start the HOME Menu while the HOME Menu Disabled icon is still displaying, you must not start the HOME Menu while the icon is displayed.\n",0]
,["Pages/Page_55582486.html#PageId_55582496","5.3.2.3. Prohibiting the Posting of Screenshots",
"\n5.3.2.3. Prohibiting the Posting of Screenshots\nYou can prevent other applications (such as system applets like Miiverse) from posting images created when transitioning to the HOME Menu.\nCode 5-6. Setting and Getting Screen Capture Post Permissions\n nn::Result nn::applet::SetScreenCapturePostPermission(\n const nn::applet::ScreenCapturePostPermission permission);\nnn::Result nn::applet::GetScreenCapturePostPermission(\n nn::applet::ScreenCapturePostPermission* pPermission);\nYou can specify whether posting is allowed with the SetScreenCapturePostPermission function. Two values can be specified for the permission argument: SCREEN_CAPTURE_POST_ENABLE or SCREEN_CAPTURE_POST_DISABLE. Specifying any other values is prohibited. If the application is restarted with the nn::applet::RestartApplication function, the initial values (see Table 5-3) are restored.\nYou can get the current settings with the GetScreenCapturePosetPermission function.\nTable 5-3. Values Used When Setting and Getting Screen Capture Post Permissions\n \t Definition\n \t Description\n \t SCREEN_CAPTURE_POST_NO_SETTING\n \t (Specifying this value is prohibited.) The default value, where posting is allowed.\n \t SCREEN_CAPTURE_POST_NO_SETTING_OLD_SDK\n \t (Specifying this value is prohibited.) The default value obtained by applications released under an old version of the SDK, where posting is allowed.\n Posting screenshots is prohibited when the camera is in use. The camera is in use after nn::camera::Initialize is called to initialize the camera, until nn::camera::Finalize is called to close the camera from the CAMERA library.\n \t SCREEN_CAPTURE_POST_ENABLE\n \t Posting is allowed.\n \t SCREEN_CAPTURE_POST_DISABLE\n \t Posting is prohibited.\n Note:\n Contact Nintendo support when you want to disable screenshot posting to Miiverse from an application using a CTR-SDK version earlier than 7.x.\n",0]
,["Pages/Page_55582486.html#PageId_55582497","5.3.3. Sleep Handling",
"\n5.3.3. Sleep Handling\nAs with the DS, on 3DS an application can determine whether to transition to Sleep Mode when the system is closed while the application is running. However, with 3DS it is possible to transition to Sleep Mode even if the application is suspended, such as when the HOME Menu is being displayed.\n",0]
,["Pages/Page_55582486.html#PageId_55582498","5.3.3.1. Sleep Query Callback",
"The following figure indicates sleep state transitions as the relationship between the related user operations, 3DS state, and callback function association. This section describes how to handle sleep transitions focused on these callback functions and then provides information associated with sleep.\nFigure 5-2 Sleep State Transitions\nSleep Query Sleep Cancel Sleep Recovery System is in Sleep Mode Close system Open system Response is postponed Postpone response to query Accept sleep While response is postponed, user opens the system before the sleep transition has been accepted or rejected Reject sleep User Operation 3DS State Callback Function\n5.3.3.1. Sleep Query Callback\nWhen the system is closed while an application is running, the Applet Manager queries the application about whether to transition to Sleep Mode by system closing. The application sends a notification in reply to this query using the set callback function.\nCode 5-7. Setting a Sleep Query Callback Function\n void nn::applet::SetSleepQueryCallback(\n nn::applet::AppletSleepQueryCallback callback, uptr arg=0);\ntypedef nn::applet::AppletQueryReply\n (*nn::applet::AppletSleepQueryCallback)(uptr arg);\nSet a callback function by calling the nn::applet::SetSleepQueryCallback function. Calls to the callback function pass the value for the arg parameter that was originally specified to SetSleepQueryCallback.\nThe application notifies the Applet Manager whether to transition immediately to Sleep Mode depending on the query response.\nTable 5-4. Values Specifiable as the Return Value of the Sleep Query Callback Function\n \t Definition\n \t Description\n \t REPLY_REJECT\n \t Rejects the transition to sleep.\n \t REPLY_ACCEPT\n \t Accepts transition to sleep.\n \t REPLY_LATER\n \t Postpones the transition to sleep.\n Return REPLY_REJECT when the application continues with wireless communication or sound playback after the system is closed. Return REPLY_ACCEPT to transition directly to Sleep Mode, but note that the system does so immediately and the transition may not necessarily occur at a time that is safe for graphics and other processing that is underway. Return REPLY_LATER to postpone transitioning to Sleep Mode until the application can safely pause other processing. However, when doing so, the application must call nn::applet::ReplySleepQuery and pass REPLY_ACCEPT as an argument as soon as it is safe to transition to sleep, and then use an event class or some other mechanism to wait for the system to wake up again.\nWhen REPLY_LATER is returned, the system is in a state where it is ready to transition to Sleep Mode, such as turning off LCD power. Also, because the Applet Manager is in a semi-stopped state where it cannot perform HOME Button or POWER Button processing, use as little processing time as possible when stopping other processes. However, there is no problem with continuing the postponed state for several tens of seconds as long as the sleep cancel callback (see Section 5.3.3.3 Sleep Cancel Callback) is used to appropriately handle cases where the system is opened while sleep is postponed. If you do not use a sleep cancel callback to handle such cases, system behavior is not considered a violation of the CTR Guidelines as long as sleep is postponed for no longer than four seconds. If you want to prohibit sleep for longer than four seconds, use a combination of REPLY_REJECT and the nn::applet::EnableSleep function (described below), and reissue the sleep query callback.\n Warning:\n Do not accept transitions to Sleep Mode while initializing local communications (while executing the nn::uds::Initialize function). Conflicts with wireless communications state transitions could result in the possibility of Sleep Mode transition not occurring correctly. Also, when you transition to Sleep Mode without finalizing local communications, the UDS library forcibly disconnects local communications and transitions to an error state. Once in this error state, UDS library functions, with some exceptions, will return errors until finalization takes place.\n When calling functions in the SND library from threads other than the main or sound threads, you must apply appropriate controls so that no SND library functions are called between when the transition to sleep is accepted with REPLY_ACCEPT and when the system recovers from the sleep state.\n In some cases, sound thread processes get jammed up during the transition to the sleep state. In these cases, if the time between calls to the nn::snd::WaitForDspSync and nn::snd::SendParameterToDsp functions (which are normally made every five milliseconds) exceeds 100 milliseconds, sometimes the sound thread remains stopped when the system recovers from the sleep state. There have been infrequent reports of threads stopping in this way in Debug builds only.\n If the battery runs out during sleep, the system never recovers from sleep and finalization is impossible. Also, in some cases the game card will be removed during sleep. You must keep both of these cases in mind and implement your code so that there is no problem even if the application terminates on an error during sleep.\nIf a sleep query callback function has not been registered by the application, status is the same as when a callback function that returns REPLY_REJECT has been registered.\n",0]
,["Pages/Page_55582486.html#Anchor_55582498_アプリケーション中断中のコールバック","Callbacks While an Application Is Suspended",
"Callbacks While an Application Is Suspended\nThe sleep query callback function can be called even if the application is not running, such as when the HOME Menu is being displayed. The nn::applet::IsActive function can be used to check whether an application is running. Return REPLY_ACCEPT when it is determined in the sleep query callback function that the application is suspended.\nCode 5-8. Determining Whether an Application Is Running\n bool nn::applet::IsActive(void);\nIf the return value is true, the application is running. If the value is false, it is suspended.\nThe state in which application operations are suspended is called the Inactive state (as opposed to the Active state when the application is running). As when the HOME Menu or library applet is being displayed, threads other than those used by the applications to call functions to display them or to wait for them to complete can continue to run. Also, during the interval until nn::applet::Enable is called while the application is running, no sleep-related callbacks are issued, but the application is in the Inactive state.\nDuring the Inactive state, the VSync callback and other callbacks including the sleep query callback can be issued as usual. However, because it is usual to implement so that the main thread stops in the Inactive state, in some cases an unintentional deadlock state occurs because a sleep query callback cannot be handled properly. For example, when sleep handling is performed by the main thread, if REPLY_LATER is returned while in the Inactive state, there is no opportunity to accept the transition to the sleep state because the main thread is stopped and the application state stagnates.\nExcluding the case when REPLY_REJECT is always returned during communications, we recommend stopping access to the FS library before entering the Inactive state, such as when displaying the HOME Menu, and always returning REPLY_ACCEPT to sleep queries while in the Inactive state. When creating threads to run even during the Inactive state, there is no problem in using the same processing as that in the Active state as long as there is appropriate sleep handling.\n",0]
,["Pages/Page_55582486.html#Anchor_55582498_スリープ対応の制御","Controlling Sleep Responses",
"Controlling Sleep Responses\nYou can control whether the application supports transition to Sleep Mode using the nn::applet::EnableSleep and nn::applet::DisableSleep functions.\nCode 5-9. Controlling Sleep Mode Support\n void nn::applet::EnableSleep(\n bool isSleepCheck=nn::applet::SLEEP_IF_SHELL_CLOSED);\nvoid nn::applet::DisableSleep(\n bool isReplyReject=nn::applet::REPLY_REJECT_IF_LATER);\nThe nn::applet::EnableSleep function validates the return value specified by the sleep query callback function, allowing control to move to the Sleep Mode transition sequence. If SLEEP_IF_SHELL_CLOSED is specified in isSleepCheck, the system status is checked when the function is called. The sleep query callback function is called if the system is closed. If NO_SHELL_CHECK is specified in isSleepCheck, there is no difference in operations except that the system status is not checked and no callback function is called. Incidentally, when sleep-related callbacks are enabled with nn::applet::Enable(true), EnableSleep(NO_SHELL_CHECK) is executed within the callback functions.\nIf SLEEP_IF_SHELL_CLOSED is specified in isSleepCheck, and nn::applet::EnableSleep is called, it is not necessary to consider the case of the system being opened while transitioning to the sleep state because a sleep query callback is issued while the system is closed. If REPLY_REJECT is returned rather than REPLY_LATER in the sleep query callback functions, necessary processing is performed while sleep is being rejected. In other words, if REPLY_REJECT is returned using the sleep query callback, there are no sleep query callbacks issued while the system is closed, but by calling EnableSleep(SLEEP_IF_SHELL_CLOSED) when the current state is ready to transition to sleep state, the sleep query callback can be issued again while the system is still closed. Even if DisableSleep is not called, EnableSleep can be called at any time. However, several milliseconds may pass from when a function is called until it returns depending on the Applet Manager state, so we do not recommend calling in every frame.\n Warning:\n When the system is closed while an application is running, it is the equivalent of returning REPLY_REJECT to the sleep query until nn::applet::Enable is called. For applications that support sleep, call EnableSleep(SLEEP_IF_SHELL_CLOSED) after Enable to be able to reissue sleep query callbacks even if the system is closed during operations.\nThe nn::applet::DisableSleep function disables the return value specified by the sleep query callback function, setting the status to REPLY_REJECT regardless of which return value is specified. If REPLY_REJECT_IF_LATER is specified in isReplyReject, the nn::applet::ReplySleepQuery(REPLY_REJECT) function is executed and the request is rejected if the system has not already attempted to enter Sleep Mode. If NO_REPLY_REJECT is specified in isReplyReject, there is no difference in operations except that the ReplySleepQuery(REPLY_REJECT) function is not executed.\nA sleep query callback can be issued when the system is closed even after DisableSleep has been called, but the callback function return value is ignored and it is considered as if REPLY_REJECT is always returned. However, note that the return values of sleep query callbacks called while the application is suspended (state when nn::applet::IsActive returns false) are valid (can return values other than REPLY_REJECT). Also, DisableSleep does not have an internal counter, so even if it is called multiple times, calling EnableSleep once makes the callback function’s return value valid.\nWhen calling a function that suspends the application, such as displaying the HOME Menu (nn::applet::ProcessHomeButton) or POWER Menu (nn::applet::ProcessPowerButton) or starting a library applet, before you call this function be sure to first reject the sleep query with DisableSleep, and then call EnableSleep after the application recovers.\n Warning:\n If the DisableSleep(REPLY_REJECT_IF_LATER) function is executed before performing application shutdown processing, execution may stop during Sleep Mode if the system is closed during shutdown processing.\n",0]
,["Pages/Page_55582486.html#Anchor_55582498_通知状態の確認と保留への回答","Checking the Notification State and Replying to Postponed Queries",
"Checking the Notification State and Replying to Postponed Queries\nTo determine whether transition to sleep has been postponed in the application, call nn::applet::IsExpectedToReplySleepQuery. If this function returns true, the application must determine whether it is ready to transition to the sleep state and must use the nn::applet::ReplySleepQuery function to reply to the postponed query.\nIn your implementation of handling transitions to sleep state, we recommend that you call the IsExpectedToReplySleepQuery function periodically (such as once per frame) and then transition to sleep state at some predetermined time.\nCode 5-10. Checking Sleep Notification State and Replying to Postponed Queries\n bool nn::applet::IsExpectedToReplySleepQuery(void);\nvoid nn::applet::ReplySleepQuery(nn::applet::AppletQueryReply reply);\n",0]
,["Pages/Page_55582486.html#PageId_55582499","5.3.3.2. Sleep Recovery Callback",
"\n5.3.3.2. Sleep Recovery Callback\nThe application uses a callback function to receive notification that the system has opened and the system has recovered from sleep.\nCode 5-11. Setting a Sleep Recovery Callback Function\n void nn::applet::SetAwakeCallback(nn::applet::AppletAwakeCallback callback,\n uptr arg=0);\ntypedef void (*nn::applet::AppletAwakeCallback)(uptr arg);\nCall nn::applet::SetAwakeCallback to set a sleep recovery callback function. Calls to the callback function pass the value for the arg parameter that was originally specified to SetAwakeCallback.\nHave this callback function only perform simple processing, such as signaling the event class instance that is waiting to resume. This callback function is called immediately if sleep status does not result even though the system is closed for some reason such as REPLY_REJECT being returned by the sleep query callback function. Whether the system has been opened cannot be determined by calling this callback function.\n Warning:\n The LCD displays are turned off when the system transitions to Sleep Mode. Consequently, when the system is ready to display a screen after waking up, the screens do not show anything until the nn::gx::StartLcdDisplay function is called. Note, however, that the screen display may momentarily distort if the nn::gx::StartLcdDisplay function is called while recovering from sleep while library applets are executing. If this happens, make the call after preparations for screen display have been completed and a state allowing normal display has been established.\n",0]
,["Pages/Page_55582486.html#PageId_55582500","5.3.3.3. Sleep Cancel Callback",
"\n5.3.3.3. Sleep Cancel Callback\nYou can use the nn::applet::SetSleepCanceledCallback function to register a callback function to be called in case sleep is canceled. Sleep cancellation occurs when the system has been closed and is opened again before the application can transition to Sleep Mode.\nCode 5-12. Registering a Sleep Cancel Callback Function\n void nn::applet::SetSleepCanceledCallback(\n nn::applet::AppletSleepCanceledCallback callback, uptr arg=0);\ntypedef void (*nn::applet::AppletSleepCanceledCallback)(uptr arg);\nUse this callback function in cases such as when halting the sleep process by detecting if the system has been opened while performing processing that takes time. This can happen in cases such as saving data before entering Sleep Mode after the system is closed.\nIf nothing is done inside this callback function, the transition to Sleep Mode is postponed. In other words, Sleep Mode will not be canceled unless the ReplySleepQuery(REPLY_REJECT) function is called explicitly. Also, note that the sleep recovery callback function will be called even if this callback function is called.\nThis callback function does not need to be registered when transitioning to Sleep Mode immediately or when the time required for other processing to complete is short. In these cases, you may consider not implementing the sleep cancel callback feature.\nNormally, a sleep cancel callback is issued only when REPLY_LATER is returned. However, when the system is quickly opened and closed, a sleep cancel callback may be issued after REPLY_ACCEPT or REPLY_REJECT is returned. Reproducing when the system is opened before a reply is sent to the sleep query callback may be difficult to do during debug because this error can only be reproduced when the cover is opened and closed quickly.\nSleep-related callbacks are not called simultaneously or in parallel. It is guaranteed that the sleep cancel callback will be issued either zero times or one time between the sleep query callback and the sleep recovery callback.\n Note:\n The reference for the nn::applet::SetSleepCanceledCallback function shows a sample implementation.\n",0]
,["Pages/Page_55582486.html#PageId_55582501","5.3.3.4. Prohibited Processes While in Sleep Mode",
"\n5.3.3.4. Prohibited Processes While in Sleep Mode\n Note:\n Currently, no processes are prohibited to applications while the system is in Sleep Mode.\n",0]
,["Pages/Page_55582486.html#PageId_55582502","5.3.3.5. Device State When the System Is Closed",
"\n5.3.3.5. Device State When the System Is Closed\nSome devices work differently when the system is closed depending on whether the argument passed when calling nn::applet::ReplySleepQuery is REPLY_ACCEPT or REPLY_REJECT.\nTable 5-5. Device State When the System Is Closed\n \t Device\n \t REPLY_ACCEPT\n \t REPLY_REJECT\n \t LCD\n \t Display buffer updates and VSyncs are both stopped, and LCD displays are turned off.\n \t Display buffer updates are stopped and LCD backlights are turned off (but screen displays are maintained).\n \t Digital buttons\n \t No input accepted.\n \t CTR only accepts input from the L and R Buttons. SNAKE accepts input from the L, R, ZL, and ZR Buttons.\n \t Touch Panel\n \t Sampling values cannot be obtained.\n \t Returns an invalid sampling value (0).\n \t Accelerometer\n \t Functions as a pedometer. Input values cannot be obtained.\n \t Functions as a pedometer. Input values can be obtained.\n \t Gyro Sensor\n \t Suspended.\n \t Input values can be obtained.\n \t Sound\n \t Suspended.\n \t Normally output is suspended from the speakers and forcibly output from the headphones, but you can make settings so that the output also comes from the speakers.\n \t Camera\n \t Suspended.\n \t Suspended.\n \t Microphone\n \t Suspended.\n \t Suspended.\n \t Wireless Communication\n \t Suspended. Recommend suspending local communication ahead of time.\n \t Not suspended.\n \tInfrared Communication \tSuspended. We recommend running the disconnect process and waiting for it to complete before entering Sleep Mode. \tNot suspended.\n \tNFC \tSuspended. \tSuspended.\n Threads created by an application, including the main thread, are all suspended when the system transitions to Sleep Mode. If the system has not transitioned to Sleep Mode, the threads continue running, but will no longer receive events or other notifications from suspended devices.\n Warning:\n Unlike with the DS/DSi systems, note that sound is not normally output from the speakers when the system is closed. For information about having output come from the speakers, see 10.5.7. Sound Output When the System Is Closed and Sleep Is Rejected.\n",0]
,["Pages/Page_55582486.html#PageId_55582503","5.3.4. Handling the POWER Button",
"\n5.3.4. Handling the POWER Button\nWhen the POWER Button is pressed for 160 ms or longer, the Applet Manager uses the nn::applet::IsExpectedToProcessPowerButton function to send notification whether the application needs to handle the fact that the POWER Button was pressed. Applications must call this function periodically (such as once per frame). If this function returns true, call the nn::applet::ProcessPowerButton function as soon as feasible.\nCode 5-13. Functions Used to Handle POWER Button Presses\n bool nn::applet::IsExpectedToProcessPowerButton(void);\nbool nn::applet::ProcessPowerButton(void);\nvoid nn::applet::ProcessPowerButtonAndWait();\nAfter you call the nn::applet::ProcessPowerButton function, control transfers to the system in order to display the POWER Menu. By displaying the POWER Menu, there is no need for the application to display a special screen when closing. Immediately after calling this function, the application must begin waiting with the nn::applet::WaitForStarting function for permission to begin finalization. After processing returns from WaitForStarting, because nn::applet::IsCloseApplication returns true in this state, perform the application close process while referring to 5.3.1. Handling Application Close Requests.\nThe nn::applet::ProcessPowerButtonAndWait function is a wrapper function that calls the ProcessPowerButton function and handles waiting and Sleep Mode.\n Note:\n The ProcessPowerButton function can only be called while the GX library can be used (from when nngxInitialize completes until nngxFinalize is called).\n Before you call the ProcessPowerButton function, configure the display buffer, swap buffers, and call the nngxStartLcdDisplay function to start LCD output. If LCD output has not been started, there is a chance that the Power Menu could start up with black screens. Likewise, if the display buffer has not been configured or the buffers have not been swapped, there is a chance that undefined content could be displayed on the screens.\n",0]
,["Pages/Page_55582486.html#PageId_55582504","5.3.5. Example of Handling by the Application",
"\n5.3.5. Example of Handling by the Application\nImplement sleep or HOME Button handling based on the following points.\n\tPerform the following determinations in locations where the main loop is called periodically. \tEvaluate the nn::applet::IsExpectedToProcessHomeButton function:\nWhen true is returned, call nn::applet::ProcessHomeButton.\n(When you do not want to or cannot display the HOME Menu, display the HOME Menu Disabled icon according to the guidelines.)\n \t\tEvaluate the nn::applet::IsExpectedToProcessPowerButton function:\nWhen true is returned, call nn::applet::ProcessPowerButton.\n \t\tEvaluate the applet::IsExpectedToCloseApplication function:\nIf true, close the application.\n \tBefore calling the nn::applet::ProcessHomeButton or nn::applet::ProcessPowerButton function, you must ensure that all render commands have finished executing. Use the nngxWaitCmdlistDone function to wait for currently executing render commands to finish. \tAfter you call the nn::applet::ProcessHomeButton or nn::applet::ProcessPowerButton function, you must always call the nn::applet::WaitForStarting function. \tWhen control is returned from nn::applet::Enable or nn::applet::WaitForStarting, be sure to perform nn::applet::IsExpectedToCloseApplication determination.\nThe following sample code shows how to handle sleeping and the HOME Button.\nCode 5-14. Sample Code for Handling Different Situations\n nn::os::LightEvent sAwakeEvent(true);\nnn::os::LightEvent sTransitionEvent(true);\nnn::os::CriticalSection sFileSystemCS(WithInitialize); // Sleep query callback.\n nn::applet::AppletQueryReply mySleepQueryCallback(uptr arg)\n{\n sAwakeEvent.ClearSignal();\n return (nn::applet::IsActive() ? REPLY_LATER : REPLY_ACCEPT);\n} // Sleep recovery callback.\n void myAwakeCallback(uptr arg)\n{\n sAwakeEvent.Signal();\n} // Sleep\n void sleepApplication()\n{ // Lock to prevent access by the FS library during Sleep Mode.\n // If unable to acquire lock, try again next frame.\n if (sFileSystemCS.TryEnter())\n {\n _app_prepareToSleep();\n nn::applet::ReplySleepQuery(REPLY_ACCEPT);\n sAwakeEvent.Wait();\n _app_recoverFormSleep();\n sFileSystemCS.Leave();\n nn::gx::StartLcdDisplay();\n }\n} // Exit application.\n void exitApplication()\n{\n _app_finalize();\n nn::applet::CloseApplication();\n} // Main loop\n void nnMain()\n{ // Run normally when an event is in the signaled state.\n sAwakeEvent.Signal();\n sTransitionEvent.Signal(); // Set callbacks.\n nn::applet::SetSleepQueryCallback(mySleepQueryCallback);\n nn::applet::SetAwakeCallback(myAwakeCallback);\n nn::applet::Enable(true); // Handle close requests while the application is loading.\n if (nn::applet::IsExpectedToCloseApplication())\n {\n exitApplication();\n } // Handle the system being closed while the application is loading.\n nn::applet::EnableSleep(SLEEP_IF_SHELL_CLOSED);\n while (true)\n {\n _app_exec(); // Respond to the sleep query.\n if (nn::applet::IsExpectedToReplySleepQuery())\n {\n if (_app_isRejectSleep())\n { // Notify of rejection if unable to enter Sleep Mode.\n nn::applet::ReplySleepQuery(REPLY_REJECT);\n } else {\n sleepApplication();\n }\n } // Application close request.\n if (nn::applet::IsExpectedToCloseApplication())\n {\n exitApplication();\n } // HOME Button\n if (nn::applet::IsExpectedToProcessHomeButton())\n {\n if (_app_isSuppressedHomeButton())\n {\n _app_drawSuppressedHomeButtonIcon();\n nn::applet::ClearHomeButtonState();\n } else { // During state transitions that stop the main thread,\n // such as starting the HOME Menu or a library applet,\n // set the event to an unsignaled state.\n sTransitionEvent.ClearSignal(); // When the system enters Sleep Mode while the HOME Menu is displayed,\n // lock to prevent access by the FS library.\n // If unable to acquire a lock, try again the next frame.\n if (sFileSystemCS.TryEnter())\n {\n _app_prepareToHomeButton();\n nn::applet::ProcessHomeButtonAndWait();\n sFileSystemCS.Leave();\n if (nn::applet::IsExpectedToCloseApplication())\n {\n exitApplication();\n }\n sTransitionEvent.Signal(); // The GPU register settings must be restored.\n _app_recoverGpuState();\n }\n }\n } // POWER Button\n if (nn::applet::IsExpectedToProcessPowerButton())\n { // Lock to prevent access by the FS library.\n // If unable to acquire a lock, try again the next frame.\n if (sFileSystemCS.TryEnter())\n {\n nn::applet::ProcessPowerButtonAndWait();\n sFileSystemCS.Leave();\n if (nn::applet::IsExpectedToCloseApplication())\n {\n exitApplication();\n } // The GPU register settings must be restored.\n _app_recoverGpuState();\n }\n }\n }\n} // Lock as demonstrated below before accessing via the FS library\n// from outside the main thread.\n { // If in Sleep Mode, stop the thread until the system wakes.\n sAwakeEvent.Wait(); // Stop the thread until control returns to the main thread.\n s_TransitionEvent.Wait();\n {\n os::CriticalSection::ScopedLock lock(sFileSystemCS);\n //\n // Write the process to access FS here.\n //\n }\n}\n",0]
,["Pages/Page_55582486.html#PageId_55582505","5.3.6. Restarting an Application",
"\n5.3.6. Restarting an Application\nYou can call the nn::applet::RestartApplication function to restart an application without returning to the HOME Menu. You can specify the parameters to pass to the application after it is restarted, and you can use the nn::applet::GetStartupArgument function to get these parameters.\nCode 5-15. Functions Used to Restart an Application\n nn::Result nn::applet::RestartApplication(\n const void* pParam = NULL,\n size_t paramSize = NN_APPLET_PARAM_BUF_SIZE);\nbool nn::applet::GetStartupArgument(\n void* pParam,\n size_t paramSize = NN_APPLET_PARAM_BUF_SIZE);\nSpecify a byte array of parameters in pParam and the size, in bytes, of the parameters in paramSize. The array cannot be larger than NN_APPLET_PARAM_BUF_SIZE.\nThe nn::applet::RestartApplication function usually restarts an application without returning. To find out whether this function was used to restart an application, check the return value from the nn::applet::GetStartupArgument function, which returns true when it is able to get the parameters that were passed to the restarted application.\n",0]
,["Pages/Page_55582486.html#PageId_55582506","5.3.7. Jump to System Settings",
"\n5.3.7. Jump to System Settings\nThis function allows a jump directly from an application to System Settings screens for Internet Settings, Parental Controls, or Data Management.\nCode 5-16. Jump to System Settings\n nn::Result nn::applet::JumpToInternetSetting(void);\nnn::Result nn::applet::JumpToParentalControls(\n nn::applet::AppletParentalControlsScene scene =\n nn::applet::CTR::PARENTAL_CONTROLS_TOP);\nnn::Result nn::applet::JumpToDataManagement(\n nn::applet::AppletDataManagementScene scene =\n nn::applet::CTR::DATA_MANAGEMENT_STREETPASS);\nbool nn::applet::IsFromMset(nn::applet::AppletMsetScene* pScene = NULL);\nAn application can jump to the Internet Settings, Parental Control, or Data Management settings screens by calling the nn::applet::JumpToInternetSetting, nn::applet::JumpToParentalControls, or nn::applet::JumpToDataManagement function, respectively. The application shuts down before jumping to System Settings, so perform shutdown processing in advance. Any failure in calls to these functions results in a fatal error. Also, regardless of whether these functions are successful, control does not return to the application. The Parental Control screen contains multiple configuration items.\nA parameter is provided to allow selection of the jump destination.\nTable 5-6. Specifying Jump Destination Screen\n \t Definition\n \t Jump Destination Screen\n \t PARENTAL_CONTROLS_TOP\n \t Parental control main menu\n \t PARENTAL_CONTROLS_COPPACS\n \t Parental control COPPACS authentication processing screen\n \t DATA_MANAGEMENT_STREETPASS\n \t StreetPass setting screen for data management screen\n When the system setting application is exited after one of these jump functions, the application is restarted. During a restart after exiting system settings, a call to the nn::applet::IsFromMset function returns true. To determine which scene was jumped to in the system settings, the pScene parameter specifies the variable that stores the jump target. Call the nn::applet::IsFromMset function after the nn::applet::Enable function is called.\n",0]
,["Pages/Page_55582486.html#PageId_55582507","5.3.8. Jump to Nintendo eShop",
"\n5.3.8. Jump to Nintendo eShop\nYou can also make jumps from applications to pages in the Nintendo eShop.\nCode 5-17. Jump to Nintendo eShop\n nn::Result nn::applet::JumpToEShopTitlePage(bit32 uniqueId);\nbool nn::applet::IsEShopAvailable();\nThe page shown after the jump is the details page for the title with the unique ID specified by the uniqueId parameter. If the title specified is not one that can be publicly searched (because its name is not shown in searches), the page is not shown. Also, if the uniqueId parameter is set to a unique ID for a title that has not been registered in Nintendo eShop or an invalid value, an error is shown in Nintendo eShop.\nThis function jumps to Nintendo eShop after the application is closed, so be sure to run the shutdown process beforehand. The application is not restarted after Nintendo eShop is shut down.\nDepending on which system updates have been applied, Nintendo eShop might not be installed on the user's 3DS system. Be sure to call the nn::applet::IsEshopAvailable function before any jump to make sure that Nintendo eShop has been installed.\n",0]
,["Pages/Page_55582486.html#PageId_55582508","5.3.9. Initial Parameters That Can Be Obtained at Startup",
"\n5.3.9. Initial Parameters That Can Be Obtained at Startup\nIn cases where restarts happen from applications or from System Settings after a jump, the following functions determine how the application was restarted.\nTable 5-7. Functions That Get the Initial Parameters When Restarting\n \t Function\n \t Initial Parameters\n \t nn::applet::GetStartupArgument\n \t Parameters specified with the nn::applet::RestartApplication function.\n \t nn::applet::IsFromMset\n \t The System Settings screen jumped to from the application.\n \t nn::news::IsFromNewsList\n \t The type of notification and parameters set. The user is notified if Start Software is selected from the notifications list.\n \t nn::friends::IsFromFriendList\n \t Friend's friend key. The user is notified if Join Game is selected.\n ",0]
,["Pages/Page_55582486.html#PageId_68586235","5.3.10. Jump to E-manual",
"\n5.3.10. Jump to E-manual\nIt is possible to jump from an application to the e-manual that users start from the HOME Menu.\nCode 5-18. Jump to E-manual\n void nn::applet::JumpToManual();\nAfter the jump, the screen shows the application's manual.\nThe function jumps after suspending the application, so after calling the function, use the nn::applet::WaitForStarting function to wait for resumption from the HOME Menu. The HOME Menu resumes the application after the e-manual closes.\n",0]
,["Pages/Page_55582486.html#PageId_55582509","5.4. Initializing the FS Library",
"\n5.4. Initializing the FS Library\nIn many cases, the next library to initialize is the FS library, which allows access to files on media. Call the nn::fs::Initialize function to initialize the FS library. You must use the classes provided by the FS library to access files on media.\n",0]
,["Pages/Page_55582486.html#PageId_55582510","5.5. Initializing the GX Library",
"\n5.5. Initializing the GX Library\nUse the GX library to draw to the LCD screen or render 3D graphics. Call the nngxInitialize function to initialize the GX library. During initialization, you must specify functions for handling memory allocation and release requests from the library.\nAfter calling the nngxInitialize function, do any other required operations, such as creating command-list objects for executing graphics commands or allocating memory for the display and render buffers for displaying on the LCD.\nNote that the 3DS LCD layouts and resolutions differ from those of the NTR or TWL, as shown in Figure 5-3.\n Figure 5-3. LCD Layouts and Display Resolutions\nUpper LCD Lower LCD 256 192 NITRO/TWL 240 320 240 400 3DS\nThis figure shows an implementation example in a sample program. For more information about the features and settings used, see the separate 3DS Programming Manual: Basic Graphics and the CTR-SDK API Reference. For more information about stereoscopic display, see the 3DS Programming Manual: Advanced Graphics.\n",0]
,["Pages/Page_55582486.html#PageId_55582511","5.5.1. Initializing the Library",
"5.5.1. Initializing the Library\n When calling the nngxInitialize function, you must specify the memory allocator and deallocator functions that will handle memory requests from the library.\n Code 5-19. Initializing the GX Library\n void SetupNngxLibrary(const uptr fcramAddress, const size_t memorySize)\n{\n InitializeMemoryManager(fcramAddress, memorySize);\n if (nngxInitialize(GetAllocator, GetDeallocator) == GL_FALSE)\n {\n NN_PANIC(\"nngxInitialize() failed.\\n\");\n }\n}\n",0]
,["Pages/Page_55582486.html#PageId_55582512","5.5.1.1. Allocator",
"\n5.5.1.1. Allocator\nThe memory accessed by the GPU for the texture image data and rendering buffer needed for graphics processing is allocated using the allocator function specified in the call to the nngxInitialize function.\nThe allocator takes four arguments.\n",0]
,["Pages/Page_55582486.html#Anchor_55582512_第1引数（確保先のメモリ空間）","First Argument (Allocation Memory Space)",
"First Argument (Allocation Memory Space)\nThe first argument specifies the memory space for allocation, passed as a GLenum type. The memory space for allocation depends on the value passed.\nWhen passing NN_GX_MEM_FCRAM, the memory region is allocated from main memory, and in such cases, this memory must be allocated from the device memory portion of main memory. Device memory is a region in main memory for which the OS guarantees address integrity when it is accessed by both peripheral devices and the main process. For more information, see 3.1.2. Device Memory.\nWhen passing NN_GX_MEM_VRAMA or NN_GX_MEM_VRAMB, the memory region is allocated from VRAM-A or VRAM-B, respectively. Call the nngxGetVramStartAddr function to get the starting address and the nngxGetVramSize function to get the size, passing NN_GX_MEM_VRAMA or NN_GX_MEM_VRAMB as appropriate.\n",0]
,["Pages/Page_55582486.html#Anchor_55582512_第2引数（メモリ領域の用途）","Second Argument (Memory Region Use)",
"Second Argument (Memory Region Use)\nThe second argument specifies the memory region use, passed as a GLenum type. The memory region byte alignment depends on the value passed.\nWhen passing NN_GX_MEM_TEXTURE, the memory region is used for texture image data. The region is 128-byte aligned regardless of the data format.\nWhen passing NN_GX_MEM_VERTEXBUFFER, the memory region is used for vertex buffers. Depending on the data stored, the memory may be 1-, 2-, or 4-byte aligned, but because the data type for storage is not passed to the allocator, we recommend an implementation that allocates at the maximum 4-byte alignment.\nWhen passing NN_GX_MEM_RENDERBUFFER, the memory region is used for render buffers (color, depth, and stencil). The alignment may be 32-, 64-, or 96-byte aligned depending on the bits per pixel (16, 24, or 32), but again the format is not passed to the allocator. Consequently, either use a fixed format for the render buffer used by the application, or use an implementation that allocates at 192-byte alignment, which is the least common multiple.\nWhen passing NN_GX_MEM_DISPLAYBUFFER, the memory region is used for display buffers. The region is 16-byte aligned regardless of the data format. When allocating in VRAM, do not allocate the last 1.5 MB.\nWhen passing NN_GX_MEM_COMMANDBUFFER, the memory region is used for command lists. The region is 16-byte aligned.\nWhen passing NN_GX_MEM_SYSTEM, the memory region is used for library system memory. Depending on the allocation size, the memory may be 1-, 2-, or 4-byte aligned, but to make things simpler, we recommend an implementation that allocates at the maximum 4-byte alignment.\n",0]
,["Pages/Page_55582486.html#Anchor_55582512_第3引数（オブジェクトの名前）","Third Argument (Object Name)",
"Third Argument (Object Name)\nThe third argument specifies the name (ID) of the object, passed as a GLuint type. It is passed when the second argument is a value other than NN_GX_MEM_SYSTEM and is used when managing memory.\n",0]
,["Pages/Page_55582486.html#Anchor_55582512_第4引数（メモリ領域のサイズ）","Fourth Argument (Memory Region Size)",
"Fourth Argument (Memory Region Size)\nThe fourth argument specifies the memory region size, passed as a GLsizei type. Allocate memory of the specified size.\nThe application allocates memory of the appropriate alignment and size, and passes the starting address to the library as a void* type. Memory management must be handled by the application, such as remembering these four arguments and the starting address of the memory region as a set, and releasing memory using the deallocator function described later.\n",0]
,["Pages/Page_55582486.html#PageId_55582513","5.5.1.2. Deallocator",
"\n5.5.1.2. Deallocator\nThe deallocator function specified in the call to nngxInitialize is called to release the memory allocated by the allocator. Four arguments are passed to the deallocator. The first three have the same values as the first three arguments passed to the allocator function, and the last argument specifies the starting address of the memory region to release.\nThe application must take the argument values to identify the memory region allocated by the allocator and release it.\n",0]
,["Pages/Page_55582486.html#PageId_55582514","5.5.2. Command-List Object Creation",
"\n5.5.2. Command-List Object Creation\nAfter the call to nngxInitialize completes, the command-list objects required to run the gl and nngx library functions called for graphics processing must be created.\nCreate a command-list object using the nngxGenCmdlists function, specify the current command list using the nngxBindCmdlist function, and then use the nngxCmdListStorage function to allocate the memory for the 3D command buffer and for accumulating command requests.\nCode 5-20. Creating Command List Objects\n void CreateCmdList()\n{\n nngxGenCmdlists(1, &m_CmdList);\n nngxBindCmdlist(m_CmdList);\n nngxCmdlistStorage(256*1024, 128);\n nngxSetCmdlistParameteri(NN_GX_CMDLIST_RUN_MODE, NN_GX_CMDLIST_SERIAL_RUN);\n}\nA 3D command buffer of 256 KB and one command list that can accumulate up to a maximum of 128 command requests are allocated in this code example. However, it is possible to allocate multiple command lists and use them by switching between them each frame. When doing so, note that the command lists must be executed in the order that 3D commands were accumulated.\n",0]
,["Pages/Page_55582486.html#PageId_55582515","5.5.3. Allocating Memory for the Display Buffer and Render Buffer",
"\n5.5.3. Allocating Memory for the Display Buffer and Render Buffer\nAllocate memory for the display buffer, which is used for displaying to the LCD, and for the render buffer, which is the render target.\nTo allocate a framebuffer, you must bind each of the render buffers (color, depth, stencil) to a framebuffer object. During rendering, color data is written to the color buffer, depth data is written to the depth buffer, and stencil data is written to the stencil buffer. Note that the stencil buffer must share a buffer with the depth buffer.\nIf the format is the same for the upper and lower screens and there is no need for rendering in parallel, we recommend sharing the same framebuffer object and render buffer between the upper and lower screens to save memory. When doing so, set the buffer width and height large enough to accommodate both screens.\nCode 5-21. Allocating Render Buffers\n void CreateRenderbuffers(\n GLenum format, GLsizei width, GLsizei height)\n{\n glGenFramebuffers(1, m_FrameBufferObject);\n glGenRenderbuffers(2, m_RenderBuffer);\n glBindRenderbuffer(GL_RENDERBUFFER, m_RenderBuffer[0]);\n glRenderbufferStorage(GL_RENDERBUFFER | NN_GX_MEM_VRAMA, format,\n width, height);\n glBindFramebuffer(GL_FRAMEBUFFER, m_FrameBufferObject);\n glFramebufferRenderbuffer(GL_FRAMEBUFFER, GL_COLOR_ATTACHMENT0,\n GL_RENDERBUFFER, m_RenderBuffer[0]);\n glBindRenderbuffer(GL_RENDERBUFFER, m_RenderBuffer[1]);\n glRenderbufferStorage(GL_RENDERBUFFER | NN_GX_MEM_VRAMB,\n GL_DEPTH24_STENCIL8_EXT, width, height);\n glFramebufferRenderbuffer(GL_FRAMEBUFFER, GL_DEPTH_STENCIL_ATTACHMENT,\n GL_RENDERBUFFER, m_RenderBuffer[1]);\n}\nThis code example allocates the color buffer in VRAM-A and the depth/stencil buffer in VRAM-B.\nUnder the usual framebuffer architecture, you can display the contents of the color buffer as is, but the 3DS color buffer data format is a block format and cannot be displayed on the LCD without first converting to a linear format. Consequently, in the 3DS system, the display buffer is between the color buffer and the actual display on the LCD. The contents of the color buffer are copied to the display buffer and then converted. You can also apply hardware-based anti-aliasing and vertical flipping during this process.\nInitialization only allocates memory for the display buffer.\nCode 5-22. Allocating Display Buffers\n void CreateDisplaybuffers(\n GLenum format0, GLsizei width0, GLsizei height0, GLenum area0,\n GLenum format1, GLsizei width1, GLsizei height1, GLenum area1)\n{\n // Upper Screen (DISPLAY0)\n nngxActiveDisplay(NN_GX_DISPLAY0);\n nngxGenDisplaybuffers(2, m_Display0Buffers);\n nngxBindDisplaybuffer(m_Display0Buffers[0]);\n nngxDisplaybufferStorage(format0, width0, height0, area0);\n nngxBindDisplaybuffer(m_Display0Buffers[1]);\n nngxDisplaybufferStorage(format0, width0, height0, area0);\n nngxDisplayEnv(0, 0);\n // Lower Screen (DISPLAY1)\n nngxActiveDisplay(NN_GX_DISPLAY1);\n nngxGenDisplaybuffers(2, m_Display1Buffers);\n nngxBindDisplaybuffer(m_Display1Buffers[0]);\n nngxDisplaybufferStorage(format1, width1, height1, area1);\n nngxBindDisplaybuffer(m_Display1Buffers[1]);\n nngxDisplaybufferStorage(format1, width1, height1, area1);\n nngxDisplayEnv(0, 0);\n}\nThis code example uses two display buffers per LCD for multi-buffering. Display buffers are the only buffers where multiples must be allocated for multi-buffering.\nThe display buffers may be allocated from main memory (device memory). If you use a display buffer format that requires more bits per pixel than the format for the color buffer, copying from the color buffer causes an error.\nThis is the extent of initialization required for display to the LCD screens. At this point, run nngxRunCmdlist once to be sure that each buffer has been allocated.\n",0]
,["Pages/Page_55582486.html#PageId_55582516","5.6. Memory Management",
"\n5.6. Memory Management\n",0]
,["Pages/Page_55582486.html#PageId_55582517","5.6.1. Memory Blocks",
"Heap memory, device memory, and VRAM allocated for the application must be managed by the application itself. Classes are provided by CTR-SDK for memory management by applications.\n5.6.1. Memory Blocks\nThe memory block feature is equivalent to the concept of an arena used with the NTR/TWL and Revolution systems. After a memory region of a particular size is allocated, memory can be cut from the memory block using the heap classes of the FND library (described later) and used. Instances of the heap classes defined in the FND library can be created by specifying a memory block as an argument.\nMemory blocks are allocated in units of 4096 bytes. Memory blocks are generally used for allocating work memory or stacks from the heap memory available to applications, when allocations from device memory cannot be used. There are also libraries for simplifying the implementation of applications through the use of memory blocks.\nMemory block allocation is handled by creating an instance of the nn::os::MemoryBlock class, or nn::os::StackMemoryBlock or nn::os::StackMemory class for stacks. Before creating an instance of these classes, you must call the nn::os::InitializeMemoryBlock function to specify the memory region to use as a memory block.\nCode 5-23. Specifying a Memory Region to Use as a Memory Block\n void nn::os::InitializeMemoryBlock(uptr begin, size_t size);\nSpecify the start address of the memory region in begin, and the size of the memory region in size. Both must have 4096-byte alignment.\nEither create an instance of the nn::os::MemoryBlock class (nn::os::StackMemoryBlock class for stacks) using a memory region of the size to be allocated for the memory block, or allocate the memory block using the Initialize function after creating an empty instance. Size specifications must be made in units of 4096 bytes.\nYou can get the start address of the allocated memory block using the GetAddress function and the size using the GetSize function. In addition, the GetStackBottom and GetStackSize interface functions are provided for stacks so that you can directly pass stacks to threads. The SetReadOnly and IsReadOnly functions can be used to get and set read-only attributes. However, there are no versions of these two functions for use with stacks.\nWhen a memory block is no longer needed, it can be explicitly deallocated by calling the Finalize member function.\n Note:\n The nn::os::SetupHeapForMemoryBlock function remains because it is used in some sample demos. However, we recommend not calling it when using memory blocks.\n We recommend not using the nn::os::MemoryBlock and nn::os::StackMemoryBlock classes in your application, because future updates could potentially change the classes in a way that breaks your code.\n",0]
,["Pages/Page_55582486.html#PageId_55582518","5.6.2. Frame Heaps",
"\n5.6.2. Frame Heaps\nA frame heap is a memory management class used to cut a memory region of a specified size out of a larger memory region specified at initialization time. In addition to using byte boundaries for the alignment specification, you can select to allocate memory from the beginning of the heap or the end of the heap depending on the sign used. Only when allocating memory from the beginning of the heap can you change the size of the memory region ultimately allocated.\nThe allocated memory regions cannot be deallocated individually. When deallocating memory, all allocated memory regions, or only the part allocated from the beginning, or only the part allocated from the end can be deallocated at the same time.\nInstances of a frame heap can be specified using a class template (nn::fnd::FrameHeapTemplate) that locks operations, or with nn::fnd::FrameHeap, which does not lock operations, or with nn::fnd::ThreadSafeFrameHeap, which is thread-safe (lock operations are nn::os::CriticalSection).\n",0]
,["Pages/Page_55582486.html#PageId_55582519","5.6.3. Unit Heaps",
"\n5.6.3. Unit Heaps\nA unit heap is a memory management class used to cut a fixed size memory region (called a unit) from a larger memory region specified at time of initialization. Alignment is specified at time of initialization, with 4-byte alignment specified by default. Consecutively allocated memory regions are not necessarily allocated from a continuous memory region.\n Allocated memory regions can be deallocated independently. You can free all memory regions you have allocated by calling the Invalidate function followed by the Finalize function. This terminates the heap. To continue using the heap, first rebuild it by calling Initialize.\nInstances of a unit heap can be created using a class template (nn::fnd::UnitHeapTemplate) that locks operations, or with nn::fnd::UnitHeap, which does not lock operations, or with nn::fnd::ThreadSafeUnitHeap, which is thread-safe (lock operations are nn::os::CriticalSection).\n",0]
,["Pages/Page_55582486.html#PageId_55582520","5.6.4. Expanded Heaps",
"\n5.6.4. Expanded Heaps\nAn expanded heap is a memory management class used to cut a memory region of a specified size from a larger memory region specified at time of initialization. In addition to using byte boundaries for the alignment specification, you can select to allocate empty memory by searching from the beginning of the heap or searching from the end of the heap depending on the sign used. You can also change the size of the allocated memory region.\nAllocated memory regions can be deallocated independently. If you repeatedly allocate and deallocate memory, there is a possibility that it will become impossible to allocate a memory region even though its size is smaller than the available memory obtained by the GetTotalFreeSize function. This problem occurs because there is no longer a contiguous memory region of the specified size in the heap. You can get the maximum size that can be allocated as contiguous memory by using the GetAllocatableSize function.\nInstances of an expanded heap can be created using a class template (nn::fnd::ExpHeapTemplate) that locks operations, or with nn::fnd::ExpHeap, which does not lock operations, or with nn::fnd::ThreadSafeExpHeap, which is thread-safe (lock operations are nn::os::CriticalSection).\n",0]
,["Pages/Page_55582486.html#PageId_55582521","5.7. DLL Features (RO Library)",
"\n5.7. DLL Features (RO Library)\nA dynamic link library (DLL) allows you to use a module that is loaded into memory dynamically. This reduces the amount of memory that an application uses for code and can make an application start up faster.\n",0]
,["Pages/Page_55582486.html#PageId_55582522","5.7.1. DLL Glossary",
"The CTR-SDK provides the RO library so that you can use DLLs.\n5.7.1. DLL Glossary\nThis section explains the terminology related to the DLL features provided by the CTR-SDK. These terms may have different meanings and usage than they ordinarily would outside of the context of DLLs.\n",0]
,["Pages/Page_55582486.html#Anchor_55582522_モジュール","Module",
"Module\nA logical unit of executable code.\n",0]
,["Pages/Page_55582486.html#Anchor_55582522_静的モジュール","Static module",
"Static module\nA module that has an entry function (nnMain) and is loaded at startup. You can make applications start faster by shrinking their static modules.\n",0]
,["Pages/Page_55582486.html#Anchor_55582522_動的モジュール","Dynamic module",
"Dynamic module\nA module that can be loaded and executed dynamically. You can reduce memory usage by splitting features into dynamic modules that are then switched in and out.\n",0]
,["Pages/Page_55582486.html#Anchor_55582522_シンボル","Symbol",
"Symbol\nInformation that indicates the location of a variable or function in a module.\n",0]
,["Pages/Page_55582486.html#Anchor_55582522_参照（インポート）","Import (Reference)",
"Import (Reference)\nThe act of using (or a statement that uses) a variable or function indicated by a symbol in another module.\n",0]
,["Pages/Page_55582486.html#Anchor_55582522_解決","Resolve",
"Resolve\nThe act of making an imported symbol usable.\n",0]
,["Pages/Page_55582486.html#Anchor_55582522_公開（エクスポート）","Export (Publish)",
"Export (Publish)\nThe act of allowing (or a statement that allows) other modules to use a variable or function indicated by a symbol.\n",0]
,["Pages/Page_55582486.html#Anchor_55582522_公開種別","Export type",
"Export type\nThe format in which a symbol is exported. There are three export types: names, indices, and offsets.\n",0]
,["Pages/Page_55582486.html#PageId_55582531","5.7.2. Characteristics and Limitations of the RO Library",
"\n5.7.2. Characteristics and Limitations of the RO Library\nThe RO library has the following characteristics that set it apart from ordinary DLL implementations.\n\tThree different types of symbols can be exported.\nYou can resolve a symbol by a name, index, or offset. Although it is possible to choose an export type for each individual symbol, the CTR-SDK build system only supports one export type per module.\nFor more information about how to specify export types, see the CTR-SDK Build System Manual (for DLLs) and the Guide to Developing a Build System (for DLLs).\n \tReferences between modules are resolved automatically.\nThe simple act of loading a module resolves inter-module references so that functions and variables can be used. You can manually get a pointer to any symbol that has been exported as a name or an index.\n \tApplications load modules into memory.\nApplications must load and adjust the location of dynamic modules in memory.\n \tC++ code is supported.\nYou can use C++ code in a dynamic module. You can also import and resolve C++ symbols between modules. If you export a symbol as a name, however, you must use the symbol’s mangled name to manually get a pointer to it.\n \tC++ exceptions can be caught between modules.\nExceptions can be thrown by one module and then caught by another.\nThe RO library has the following restrictions and limitations.\n\tA single module cannot export more than 65,535 symbol names. \tThe maximum length of a symbol that can be exported by name is 8,192 characters. \tYou cannot include functions from the C standard library in dynamic modules. \tAlignment is ignored for any static variables or functions defined in a dynamic module with more than 8-byte alignment. \tUp to 64 dynamic modules can be loaded simultaneously. \tWhen using a nonstandard feature with weak symbols in C/C++, the system does not always operate as intended.\nWhen using the static library as a dynamic module, first confirm with the creator of the library whether such use is possible.\n Warning:\n Using the static libraries provided in the SDK as dynamic modules is prohibited.\n Do not combine multiple dynamic modules in the same static library. This could cause various bugs to occur due to unintended library operation, including the existence of multiple global variables.\n",0]
,["Pages/Page_55582486.html#PageId_55582532","5.7.3. Files Used by the RO Library",
"\n5.7.3. Files Used by the RO Library\nThe RO library implements DLL features using data created with the following file formats.\nTable 5-8. Files Used by the RO Library\n \t File Format (Extension)\n \t Description\n \t CRS\n \t This file has import and export information for a static module. It does not contain executable code. Because an application can only have a single static module, it also only has one CRS file.\n \t CRR\n \t This file has management data for one or more dynamic modules. It must be placed directly under a specific directory (/.crr/) within a ROM archive.\n \t CRO\n \t This file has import and export information and executable code for a dynamic module.\n The following figure shows the relationship between these files.\nFigure 5-4. Relationship Between Files Used by the RO Library\nStatic Module crs crr cro\nIn general, you only need to create and use a single CRR file with information about all of the CRO files used by an application. Use multiple CRR files if you also want to optimize the amount of memory used by each CRR file or if you want to distribute additional programs.\n Note:\n For more information about how to create these files, see the CTR-SDK Build System Manual (for DLLs) or the Guide to Developing a Build System (for DLLs).\n",0]
,["Pages/Page_55582486.html#PageId_55582533","5.7.4. Importing and Exporting",
"\n5.7.4. Importing and Exporting\nIf two modules share header files, they can call each other’s functions and access each other’s variables with ordinary source code. They do not need to keep track of whether the symbols are exported.\nIf two modules do not share header files, they must use explicit import and export statements to call each other’s functions and access each other’s variables.\nTo import and export symbols explicitly, add the definitions in the following table to your source code.\nTable 5-9. Definitions for Explicit Import and Export Statements\n \t Definition\n \t Description\n \t NN_DLL_EXPORT\n \t Add this to function and variable declarations that you want to export to other modules.\n \t NN_DLL_IMPORT\n \t Add this to function and variable declarations that have been exported by other modules.\n Code 5-24. Sample Code for Explicit Import and Export Declarations\n // Explicit export declarations\nNN_DLL_EXPORT int g_Variable;\nNN_DLL_EXPORT void Function()\n{\n // (omitted)\n}\n// Explicit import declarations\nextern NN_DLL_IMPORT int g_Variable;\nextern NN_DLL_IMPORT void Function();\n Note:\n If you export a symbol explicitly, it is always exported. It will not be dead-stripped, even if it is not used within a module.\n",0]
,["Pages/Page_55582486.html#PageId_55582534","5.7.5. A Comparison of Export Types",
"\n5.7.5. A Comparison of Export Types\nThe following table shows the differences caused by symbol export types.\nTable 5-10. Differences Caused by Export Types\n \t Item\n \t Name\n \t Index\n \t Offset\n \t What is the size of the import information?\n \t Large\n \t Small\n \t Small\n \t What is the size of the export information?\n \t Large\n \t Small\n \t 0\n \t What is a module’s required load speed?\n \t Slow\n \t Average\n \t Fast\n \t Can pointers be obtained manually?\n \t Yes\n \t Yes\n \t No\n \t Can the imported module be created in advance?\n \t Yes\n \t No\n \t No\n \t How many build steps?\n \t Normal\n \t Normal\n \t Many\n Symbol names present richer functionality than symbol indices, which in turn present richer functionality than offsets. However, functionality does entail other costs in file size and processing time.\nIn general, choose to export symbols as offsets. If you want to get symbol pointers manually or use dynamic modules like libraries, choose to export symbols as names or indices as necessary.\n Note:\n Public types can also be specified for symbols in static modules.\n",0]
,["Pages/Page_55582486.html#PageId_55582535","5.7.6. Special Dynamic Module Functions",
"\n5.7.6. Special Dynamic Module Functions\nIf a dynamic module’s source code exports functions with particular names, the RO library calls those functions when the module is initialized and at other specified times.\nCode 5-25. Special Functions\n extern \"C\" NN_DLL_EXPORT void nnroProlog();\nextern \"C\" NN_DLL_EXPORT void nnroEpilog();\nextern \"C\" NN_DLL_EXPORT void nnroUnresolved();\nThe nnroProlog function is called after the DoInitialize function has finished initializing a module. This allows you to implement module-specific initialization.\nThe nnroEpilog function is called after the DoFinalize function has finished finalizing a module. This allows you to implement module-specific finalization.\nThe nnroUnresolved function is called when a module uses an external symbol that has not been resolved. This allows you to detect and handle calls to unresolved symbols.\nImplement these functions in your application as necessary.\n Note:\n The nnroUnresolved function may also be used in a static module. However, one restriction is that it will not work if a symbol whose reference has been resolved later becomes unresolved.\n",0]
,["Pages/Page_55582486.html#PageId_55582536","5.7.7. Basic Workflow",
"\n5.7.7. Basic Workflow\n",0]
,["Pages/Page_55582486.html#PageId_55582537","5.7.7.1. Initialize the RO Library",
"This section explains the basic workflow for using a dynamic module.\n5.7.7.1. Initialize the RO Library\nInitialize the RO library with the nn::ro::Initialize function. Initialization requires a CRS file, which must already be loaded into memory. Note that the content of the CRS file must be stored in a buffer that has been allocated in a memory region outside of device memory, with a starting address that is 4096-byte aligned.\nThe RO library is responsible for managing the buffer with the CRS file. Do not overwrite or release this buffer until you have finalized the RO library.\n",0]
,["Pages/Page_55582486.html#PageId_55582538","5.7.7.2. Register Management Data",
"\n5.7.7.2. Register Management Data\nBefore using a dynamic module, you must load the CRR file that manages it and then register management data with the nn::ro::RegisterList function. Note that the content of the CRR file must be stored in a buffer that has been allocated in a memory region outside of device memory, with a starting address that is 4096-byte aligned.\nThe RO library is responsible for managing the buffer with the CRR file. Do not overwrite or release this buffer until you have unregistered the management data by calling the Unregister function on the nn::ro::RegistrationList pointer returned by the nn::ro::RegisterList function.\n",0]
,["Pages/Page_55582486.html#PageId_55582539","5.7.7.3. Load Dynamic Modules",
"\n5.7.7.3. Load Dynamic Modules\nLoad dynamic modules with the nn::ro::LoadModule function. The application must load a module’s CRO file into memory in advance. Note that the content of the CRO file must be stored in a buffer that has been allocated in a memory region outside of device memory, with a starting address that is 4096-byte aligned.\nYou must also provide a buffer to be used for the .data/.bss sections. This buffer must have a starting address that is 8-byte aligned. It must not be smaller than the value of the bufferSize member variable in the nn::ro::SizeInfo structure that is obtained when the content of the CRO file (REQUIRED_SIZE_FOR_GET_SIZE_INFO bytes from the beginning) is passed to the nn::ro::GetSizeInfo function The SizeInfo structure also contains information about memory regions that can be used after modules are loaded. If bufferSize is smaller than the memory region that is freed after a module is loaded, the buffer can be allocated from that memory region.\nThe following table shows how the value specified for fixLevel affects dynamic module features and the memory regions that are released after modules are loaded. If nothing is specified for fixLevel, it is treated as if it were FIX_LEVEL_1.\nTable 5-11. Effects of fixLevel on Dynamic Module Behavior\n \t Item\n \t FIX_LEVEL_0\n \t FIX_LEVEL_1\n \t FIX_LEVEL_2\n \t FIX_LEVEL_3\n \t Can this module be reused after it is unloaded?\n \t Yes\n \t No\n \t No\n \t No\n \t When another module is loaded, are its symbols automatically linked with this module?\n \t Yes\n \t Yes\n \t No\n \t No\n \t When another module is loaded, are this module’s symbols automatically linked with that module?\n \t Yes\n \t Yes\n \t Yes\n \t No\n \t Can you get the address of the symbols in this module?\n \t Yes\n \t Yes\n \t Yes\n \t No\n \t Are the symbols in all modules that have been loaded until now automatically linked with this module?\n \t Yes\n \t Yes\n \t Yes\n \t Yes\n \t What is the address at the end of the memory region managed by the library?\n \t fix0End\n \t fix1End\n \t fix2End\n \t fix3End\n A memory region is released after a module is loaded. The size of the region for FIX_LEVEL_2 is less than or equal to that of FIX_LEVEL_3, the region for FIX_LEVEL_1 is smaller, and the region for FIX_LEVEL_0 is smaller still. More memory is released when symbol names are exported than when any other type of symbol is exported.\nIn general, specify true for doRegister so that any references to unresolved symbols are automatically resolved when another dynamic module is loaded. If you specify false, references are resolved to symbols in dynamic modules that have already been loaded but they are not automatically resolved when another module is loaded. In the latter case, you must manually resolve symbols by calling Link with the nn::ro::Module pointer returned by the nn::ro::LoadModule function.\n",0]
,["Pages/Page_55582486.html#PageId_55582540","5.7.7.4. Start to Use Dynamic Modules",
"\n5.7.7.4. Start to Use Dynamic Modules\nBefore you use the functions and variables in a dynamic module, you must call DoInitialize with the nn::ro::Module pointer returned by the nn::ro::LoadModule function. This constructs global objects in the dynamic module and runs the initialization process implemented by the nnroProlog function.\nYou can call the DoInitialize function immediately after a module is loaded as long as its initialization process does not reference global objects in another dynamic module. If the initialization processes for multiple dynamic modules reference each other’s global objects, however, load all of those dynamic modules before calling the DoInitialize function.\nYou can use the Module class’s GetName function to get the name of a dynamic module. This function returns the same name that was specified when the module was built. (If you are using the CTR-SDK build system, this is the name specified by TARGET_MODULE). This name is also used by the nn::ro::FindModule function to search for loaded dynamic modules.\nYou can use the Module::IsAllSymbolResolved function to determine whether all external references from a dynamic module have been resolved. To unresolve all of a module’s resolved references, including references to the module itself, call the Module::Unlink function. To resolve those references again, call the Module::Link function.\nThere are two ways to manually get a pointer to a symbol: the nn::ro::GetPointer function, which searches through the symbols in every module for a name, and the nn::ro::Module::GetPointer function, which searches through the symbols in a particular module for a name or index. You can also use the nn::ro::GetAddress function to get the address of a symbol that you found by name.\n",0]
,["Pages/Page_55582486.html#PageId_55582541","5.7.7.5. Finalize Dynamic Modules",
"\n5.7.7.5. Finalize Dynamic Modules\nTo free the memory region used by a module that is no longer necessary, you must first call the Module class’s DoFinalize function to destroy the global objects in that dynamic module and run the shutdown processing implemented by the nnroEpilog function. After this is complete, call the Module class’s Unload function to unload the dynamic module.\nWhen a dynamic module is unloaded, it returns to its preloaded state: any memory managed by the library is released and all references are made unresolved. You can then release the buffer that had the content of the CRO file.\nYou generally need to reload a dynamic module if you want to reuse it after it has been unloaded. However, if you loaded the module with FIX_LEVEL_0 (FIX_LEVEL_NONE) specified as fixLevel and you either do not initialize any static variables or you initialize all static variables with the nnroProlog function, you can call the nn::ro::LoadModule function to reuse the same buffer and other settings without reloading the CRO file. There are restrictions on the use of static variables because if they were overwritten while the dynamic module was in use, they are not restored to their preloaded state when the module is unloaded.\n",0]
,["Pages/Page_55582486.html#PageId_55582542","5.7.7.6. Unregister Management Data",
"\n5.7.7.6. Unregister Management Data\nTo unregister the management data and release the memory region, you must call the Unregister function with the nn::ro::RegistrationList class pointer returned by the nn::ro::RegisterList function.\nAfter the management data has been unregistered, the buffer with the content of the CRR file is no longer managed by the library. Even though you cannot load a new dynamic module managed by that CRR file after the management data has been unregistered, you can still use dynamic modules that have already been loaded.\n",0]
,["Pages/Page_55582486.html#PageId_55582543","5.7.7.7. Finalize the RO Library",
"\n5.7.7.7. Finalize the RO Library\nFinalize the RO library with the nn::ro::Finalize function.\nAfter you have called the nn::ro::Finalize function, you can release all the memory that was used by the RO library; this includes the buffers with the content of the CRS, CRR, and CRO files.\n",0]
,["Pages/Page_55582486.html#PageId_55582544","5.7.8. Enumeration and Searching of Dynamic Modules",
"\n5.7.8. Enumeration and Searching of Dynamic Modules\nAll dynamic modules can be enumerated, regardless of whether they are loaded by automatic link with the nn::ro::Module::Enumerate function. Pass the class inherited from the nn::ro::Module::EnumerateCallback function to the argument of the Enumerate function. For every dynamic module, the operator function is called back with the pointer to the dynamic module as an argument.\nDynamic modules can be searched by the nn::ro::Module::Find function. If nn::ro::Module::Find finds the dynamic module whose specified string and name match, it returns the pointer to the module, and if it cannot find it, it returns NULL. However, make sure that the search target is only a dynamic module that is loaded by automatic link.\n",0]
,["Pages/Page_55582486.html#PageId_55582545","5.7.9. Information About the Memory Region Used by Dynamic Modules",
"\n5.7.9. Information About the Memory Region Used by Dynamic Modules\nInformation about the memory region used by dynamic modules can be obtained by the nn::ro::Module::GetRegionInfo function. The information of the memory region is stored in the nn::ro::RegionInfo structure passed to the pri argument.\nCONFIDENTIAL\n",0]
,["Pages/Page_55582546.html","6. Input Devices ",
"6. Input Devices\n",0]
,["Pages/Page_55582546.html#PageId_55582547","6.1. Libraries That Use Devices",
"Use the libraries and classes that support each input device to easily incorporate into your application the input from the various input devices on the system, such as the digital buttons, Circle Pad, touch panel, accelerometer, gyro sensor, microphone, and cameras.\n6.1. Libraries That Use Devices\nTo access the input and other devices on the system from your application, you must use the libraries provided by CTR-SDK. The functions in many of the libraries for using devices return an instance of the nn::Result class.\nCall the nn::Result class member function IsSuccess or IsFailure to find out whether the function completed processing successfully. If IsSuccess returns true, the function completed successfully; if it returns false, the function failed. The IsFailure return values have the opposite meaning; where true means the function failed, and false means the function completed successfully.\nThe nn::Result class records error severity, a description, and the name of the module that raised the error. In addition to checking for function success, you may sometimes need to use this detailed information to find a way to work around or fix an error in your code.\n",0]
,["Pages/Page_55582546.html#PageId_55582548","6.2. HID Library",
"\n6.2. HID Library\nUsing the HID library, you can handle input from the digital buttons (+Control Pad, A/B/X/Y/L/R Buttons, and START), Circle Pad, touch panel, accelerometer, gyro sensor, debug pad, and Circle Pad Pro.\nCall the nn::hid:Initialize function to initialize the HID library. Successive calls to the initialization function do nothing and return an error.\nAfter initialization, input is sampled automatically, and you can obtain input from each device based on the corresponding class. The timing and cycle of the input sampling start differ depending on the type of device. To end sampling, the class created by the acceleration and gyro sensors is destroyed. Call the nn::hid::ExtraPad::StopSampling function when done to finalize the Circle Pad Pro, and for all others, finalize the HID library.\n Note:\n The C Stick, ZL Button, and ZR Button on SNAKE hardware can be handled the same way as a CTR unit with the Circle Pad Pro always attached. In this case, the C Stick corresponds to the Right Circle Pad, and the ZL and ZR Buttons correspond to the same buttons on the Circle Pad Pro.\n For information about the C Stick and differences with the Circle Pad Pro, see 6.2.7. C Stick.\nTable 6-1. Types and Inputs\n \t Type\n \t Class Handling Input\n \t Sampling Start Trigger\n \t Cycle\n \t Digital buttons and Circle Pad\n \t nn::hid::PadReader\n \t HID library initialization\n \t 4 ms\n \t Touch panel\n \t nn::hid::TouchPanelReader\n \t HID library initialization\n \t 4 ms\n \t Accelerometer\n \t nn::hid::AccelerometerReader\n \t Reader class creation\n \t Avg. 10 ms\n \t Gyro sensor\n \t nn::hid::GyroscopeReader\n \t Reader class creation\n \t Avg. 10 ms\n \t Debug pad\n \t nn::hid::DebugPadReader\n \t HID library initialization (when connected)\n \t 16 ms\n \t Circle Pad Pro\n \t nn::hid::ExtraPadReader\n \t ExtraPad class StartSampling function\n \t 8–32 ms\n \tC Stick, ZL / ZR Button \tnn::hid::ExtraPadReader \tExtraPad class StartSampling function \t8–32 ms\n Note:\n The library lets you set a sampling frequency of 8-32 ms for the C Stick, ZL Button, and ZR Button on SNAKE hardware, but we recommend setting a sampling frequency of 10-21 ms to match the hardware capabilities.\n",0]
,["Pages/Page_55582546.html#PageId_55582549","6.2.1. Digital Buttons and Circle Pad",
"Call the nn::hid::Finalize function to finalize use of the library. When using the nn::hid::ExtraPadReader class, you must first call the nn::hid::ExtraPad::Finalize function.\n6.2.1. Digital Buttons and Circle Pad\nCall the nn::hid::PadReader class's Read or ReadLatest member functions to get input from the digital buttons and Circle Pad as an nn::hid::PadStatus structure. The Read function can get sampling results in order of the latest result, but it cannot reacquire sampling results. When the function is called at a cycle faster than the sampling cycle, it cannot get sampling results. On the other hand, the ReadLatest function can get only the latest sampling result. It can also reacquire sampling results, so even when it is called at a cycle faster than the sampling cycle, it can still get sampling results.\nThe nn::hid::PadStatus structure's hold member variable records the button being held when input was sampled, the trigger variable records the button that was pressed when input was sampled, and release variable records the button that was released when input was sampled, all mapped to bit values. For the ReadLatest function, both the trigger and release members are evaluated for their states at that time, so any changes between calls are not necessarily reflected. Input bits for +Control Pad input may in fact be input from the Circle Pad emulating the +Control Pad. The actual Circle Pad input is recorded to the stick member variable as a biaxial coordinate value.\nTable 6-2. Buttons and Definitions\n \t Definition\n \t Corresponding Button\n \t BUTTON_UP\n \t +Control Pad (Up)\n \t BUTTON_DOWN\n \t +Control Pad (Down)\n \t BUTTON_LEFT\n \t +Control Pad (Left)\n \t BUTTON_RIGHT\n \t +Control Pad (Right)\n \t BUTTON_A\n \t A Button\n \t BUTTON_B\n \t B Button\n \t BUTTON_X\n \t X Button\n \t BUTTON_Y\n \t Y Button\n \t BUTTON_L\n \t L Button\n \t BUTTON_R\n \t R Button\n \t BUTTON_START\n \t START or SELECT (for standard operations)\n \t BUTTON_SELECT_FOR_DEBUGGING\n \t SELECT (only for debugging)\n \t BUTTON_EMULATION_UP\n \t Emulated +Control Pad (Up) input using Circle Pad\n \t BUTTON_EMULATION_DOWN\n \t Emulated +Control Pad (Down) input using Circle Pad\n \t BUTTON_EMULATION_LEFT\n \t Emulated +Control Pad (Left) input using Circle Pad\n \t BUTTON_EMULATION_RIGHT\n \t Emulated +Control Pad (Right) input using Circle Pad\n Use the nn::hid::EnableSelectButton and nn::hid::DisableSelectButton functions to enable and disable SELECT sampling.\nCode 6-1. Enabling and Disabling SELECT Sampling\n bool nn::hid::EnableSelectButton();\nvoid nn::hid::DisableSelectButton();\nCalling the EnableSelectButton function returns true when the function has successfully enabled sampling of SELECT. The function always returns false and the sampling cannot be enabled unless the system is set to debug mode. Calling the function when SELECT sampling is already enabled returns BUTTON_SELECT_FOR_DEBUGGING, so you can distinguish the SELECT input from the START input.\nThe Circle Pad may return a coordinate value even when the user is not touching it. Consequently, be sure to set an appropriate play value and clamp mode with the nn::hid::PadReader class's SetStickClamp and SetStickClampMode member functions, respectively. There are three clamp modes available: circular (STICK_CLAMP_MODE_CIRCLE), cruciform (STICK_CLAMP_MODE_CROSS), and minimal (STICK_CLAMP_MODE_MINIMUM). Use the GetStickClampMode function to get the current clamp mode, and use the GetStickClamp function to get the clamp value. Circular clamping is the default clamp setting. The following examples show clamped Circle Pad input, with the original input value coordinates given as (x, y), the distance from the origin as d, the clamp minimum and maximum values as min and max, the clamped coordinates as (x', y'), and the clamped distance from the origin as d'.\n",0]
,["Pages/Page_55582546.html#Anchor_55582549_円形クランプ","Circular Clamping",
"Circular Clamping\nd <= min\n(x', y') = (0, 0)\nmin < d < max\n(x', y') = ((d - min) / d * x, (d - min) / d * y)\nd > max\n(x', y') = ((max - min) / d * x, (max - min) / d * y)\n",0]
,["Pages/Page_55582546.html#Anchor_55582549_十字形クランプ","Cruciform Clamping",
"Cruciform Clamping\nx < 0\n(x', y') = (x + min, y) But x + min must be 0 or greater.\nx >= 0\n(x', y') = (x - min, y) But x - min must be 0 or less.\ny < 0\n(x', y') = (x, y + min) But y + min must be 0 or greater.\ny >= 0\n(x', y') = (x, y - min) But y - min must be 0 or less.\nd' > (max - min)\n(x', y') = ((max - min) / d * x, (max - min) / d * y)\n",0]
,["Pages/Page_55582546.html#Anchor_55582549_最小クランプ","Minimal Clamping",
"Minimal Clamping\nMinimal clamping combines circular and cruciform clamping. When using minimal clamping (minimal values), unclamped coordinate values are those that lie within the unclamped ranges of both the circular and cruciform clamping ranges. Coordinates outside this region are clamped to within this minimum.\nFigure 6-1 shows how the ranges for clamped Circle Pad input coordinates change.\nFigure 6-1. Valid Input Ranges for Circular, Cruciform, and Minimal Clamping\nmin max STICK_CLAMP_MODE_CIRCLE STICK_CLAMP_MODE_CROSS STICK_CLAMP_MODE_MINIMUM min(CROSS) min(CIRCLE)\nIn STICK_CLAMP_MODE_CROSS, for coordinates close to either the x-axis or y-axis, only the value for that axis changes (that is, if close to the x-axis, only the x-coordinate value changes).\nClamped input coordinate values for either axis produce output values as shown below in any of the clamp modes.\nFigure 6-2. Relationship Between Input and Output Coordinates\n max-min min max input output -max -min min-max\nIn any of the clamp modes, the output value is 0 until the input value passes the min threshold, and the output value is ±(max - min) after the input value passes the max threshold, with the clamped output value ranging from 0 to ±(max - min).\nIn any of the clamp modes, the obtainable output coordinates describe a circle with radius (max – min). Choose the appropriate clamp mode for the input you need. STICK_CLAMP_MODE_CIRCLE preserves the angle of the input coordinates from the origin and is better suited to uses requiring finer directional control. STICK_CLAMP_MODE_CROSS only outputs the coordinate value for the closest axis, either the x-axis or the y-axis, and is better suited to uses emphasizing axial directional input, such as when selecting items from a menu.\n",0]
,["Pages/Page_55582546.html#Anchor_55582549_スライドパッドの座標値の正規化","Normalizing Circle Pad Coordinate Values",
"Normalizing Circle Pad Coordinate Values\nThe nn::hid::PadReader class's NormalizeStick member function takes the Circle Pad’s coordinate value obtained from the Read or ReadLatest member functions and normalizes it to an f32 floating-point value between –1.0 and +1.0 with (max – min) = 1.0.\nUse the NormalizeStickWithScale function to normalize Circle Pad coordinate values with a sensitivity adjustment. Configure the sensitivity adjustment by calling the SetNormalizeStickScaleSetting and specifying values for the scale (default of 1.5) and threshold (default of 141) parameters. Normalizing multiplies values that are lower than threshold by (1/scale), while values equal to threshold or higher gradually approach ±1.0. Use this feature to make the Circle Pad respond as if its movable range were scale times big.\n",0]
,["Pages/Page_55582546.html#Anchor_55582549_スライドパッドの十字ボタンエミュレーション","Emulating the +Control Pad on the Circle Pad",
"Emulating the +Control Pad on the Circle Pad\n",0]
,["Pages/Page_55582546.html#PageId_55582555","6.2.1.1. Circle Pad Hardware Performance",
"The +Control Pad emulation bits for Circle Pad input (BUTTON_EMULATION_*) are used to judge which direction is being indicated by the controller, by using circular clamping with a lower limit of 40 and an upper limit of 145. The values set using the SetStickClamp and SetStickClampMode functions are not used for this purpose. Positive and negative values for the x-axis and y-axis are interpreted to mean left, right, up, and down, respectively, and the bit for a particular direction is set if that direction is within 120° of the input direction. Consequently, the 30° overlap zone between directions is interpreted as a diagonal input.\nFigure 6-3. BUTTON_EMULATION_ Judgment Range*\nDOWN LEFT RIGHT UP X Y 30° 120° 60°\n6.2.1.1. Circle Pad Hardware Performance\nThe Circle Pad included in the 3DS system is made up of a resistive plate, shaft, and key top. This composite structure includes some tolerance, resulting in a slight lag in response compared to the analog sticks for the Nintendo GameCube or Wii consoles when reversing the direction of input.\nFigure 6-4. Delayed Response to Input Inversion Due to the Circle Pad’s Hardware\nResistive Plate Shaft Key Top Resistive Plate As the key top moves to the right, the shaft gets closer to the left side. If the key top is then moved to the left, the shaft position does not change immediately. Movement of Circle Pad Detected Movement Passage of Time\nActual input values might also differ even when moving the Circle Pad along the same path of movement. This phenomenon is called path dependence and is also caused due to the Circle Pad hardware.\nFor example, when moving the Circle Pad from the left side to the top, going past the center, the shaft is touching the left edge of the key top, with input values tending more toward -X. Conversely, when moving the Circle Pad from the right side to the top, going past the center, the shaft is touching the right edge of the key top, with input values tending more toward +X. Input values exhibit this same tendency in the vertical direction for ±Y values.\nFigure 6-5. Circle Pad Path Dependence\nResistive Plate Shaft touching left edge. Shaft touching right edge. Path from left to top past the center Path from right to top past the center Values entered (example) Circle Pad path of movement\nWe recommend that your application factor in some tolerance for this phenomenon, such as for input detection thresholds.\n",0]
,["Pages/Page_55582546.html#PageId_55582556","6.2.2. Touch Panel",
"\n6.2.2. Touch Panel\nCall the nn::hid::TouchPanelReader class's Read or ReadLatest member functions to get input from the touch panel as an nn::hid::TouchPanelStatus structure. The Read function can get sampling results in order of the latest result, but it cannot reacquire sampling results. When the function is called at a cycle faster than the sampling cycle, it cannot get sampling results. On the other hand, the ReadLatest function can get only the latest sampling result. It can also reacquire sampling results, so that even when it is called at a cycle faster than the sampling cycle, it can still get sampling results.\nThe nn::hid::TouchPanelStatus structure's x and y members record the touch panel input coordinates in pixels, with the upper-left corner as the origin (when holding the system so that the lower screen is toward the user). Note that the coordinate axes on the touch panel differ from the LCD coordinate axes used in the GX library. Areas in the five-dot region on the outermost of the screen that is difficult to touch are returned as clamped coordinate values. Accordingly, the x values actually returned are between 5 and 314, and the y values between 5 and 234.\nCode 6-2. Converting Touch Panel Input Coordinates to LCD Coordinates\n x = nn::gx::DISPLAY1_WIDTH - touchPanel.y;\ny = nn::gx::DISPLAY1_HEIGHT - touchPanel.x;\nThe touch member records whether the stylus is touching the touch panel. The member value is 0 if the stylus is not touching the panel and 1 if it is.\n",0]
,["Pages/Page_55582546.html#PageId_55582557","6.2.3. Accelerometer",
"\n6.2.3. Accelerometer\nCall the Read or ReadLatest member functions of the nn::hid::AccelerometerReader class to get input from the accelerometer as an nn::hid::AccelerometerStatus structure. The Read function can get sampling results in order of the latest result, but it cannot reacquire sampling results. When the function is called at a cycle faster than the sampling cycle, it cannot get sampling results. On the other hand, the ReadLatest function can get only the latest sampling result. It can also reacquire sampling results, so that even when it is called at a cycle faster than the sampling cycle, it can still get sampling results.\nThe accelerometer is turned on when an instance of the AccelerometerReader class is created and it is turned off when an instance is destroyed. To conserve battery life, only instantiate the AccelerometerReader class when it is used. However, if you repeatedly create and destroy an instance of the AccelerometerReader class in a function that is called every frame (for example), the frequent power cycling wastes battery power and leads to unexpected malfunctions.\nThe x, y, and z members of the nn::hid::AccelerometerStatus structure record input from the accelerometer's three axes. The x-axis is equivalent to the left-right axis on the +Control Pad, the y-axis is equivalent to a line perpendicular to the lower LCD screen, and the z-axis is equivalent to the up-down axis on the +Control Pad. The raw input values from these three axes do not accurately describe the acceleration of the system, so be sure to first convert the raw values to G units using the nn::hid::AccelerometerReader class's ConvertToAcceleration member function before using them in your application.\nFigure 6-6. The Three Accelerometer Axes\n+x +y +z\nThe accelerometer’s zero point may vary by up to 0.05 G over time and 0.08 G due to temperature changes, for a maximum variance of 0.13 G. Applications that use the accelerometer must account for this variance. Variance over time can be mostly rectified by calibrating, but variance due to temperature can reoccur in a short period even after calibrating. This 0.08 maximum temperature-induced variance equates to a roughly five-degree tilt. When detecting movements of finer precision, we recommend calibrating immediately if the user notices anything strange.\n Note:\n Hold the Y or B Button for three seconds while the HOME Menu is displayed to calibrate the accelerometer.\nThe accelerometer’s maximum sensitivity may also vary by up to ±8%. After factoring in the zero-point variance offset, the maximum input value is 10% less than the theoretical maximum value of approximately 1.8 G, at 1.62 G. Applications must not depend on any input values greater than this.\n Warning:\n The output value of the accelerometer has a superimposed at-rest noise of ±0.02 G. The output value has an additional superimposed noise of ±0.05 G from conductive vibration when the speaker is outputting sound. The effect of this noise input must be considered when detecting small acceleration.\n The conductive vibration is highest in the 1-kHz range. The effect can be reduced by adjusting the sound playback volume.\nCall the SetSensitivity member function of the nn::hid::AccelerometerReader class to set the input play and detection sensitivity values, and use the GetSensitivity member function to get these values. Either of these values may be set in the range from 0 to MAX_OF_ACCELEROMETER_SENSITIVITY, with the default values of 0 for the play and MAX_OF_ACCELEROMETER_SENSITIVITY for the detection sensitivity. Setting the detection sensitivity to 0 means only 0 will be returned. Specifying MAX_OF_ACCELEROMETER_SENSITIVITY for this setting gives a response based directly on the value read from the device.\nLooking at the accelerometer input value as a set of triaxial coordinates, the accelerometer change value for any axis is interpreted to be within the play range if it is no greater than the play value. Values within the play range are output as 0, and changes within this range are output as no change at all.\nThe following figure shows the relationship between the accelerometer input and output values, and the play range. Use this play range setting to minimize any false readings caused by small changes in position, such as being bumped by the user's hands.\nFigure 6-7. Relationship Between Input and Output Values Due to the Play Range Setting\nOutput Play Input\nUse the nn::hid::AccelerometerReader class to carry out axial rotation on output values (already adjusted for sensitivity and play) after adjusting for an offset. You can also use axial rotation of output values to apply any angle tilt to the accelerometer.\nCode 6-3. Offsetting Accelerometer Output Values\n class nn::hid::AccelerometerReader\n{\n void EnableOffset();\n void DisableOffset();\n bool IsEnableOffset() const;\n void SetOffset(s16 x, s16 y,s16 z);\n void GetOffset(s16* pX, s16* pY, s16* pZ) const;\n void ResetOffset();\n}\nEnable offsetting of output values by calling EnableOffset, and disable by calling DisableOffset. Call IsEnableOffset to get the current setting; a return value of true indicates that the offset is enabled. When the offset is enabled, each component of the offset value is subtracted from each component of the output value.\nSet the offset value itself by calling SetOffset. Use SetOffset to specify offset values individually for each axis. Note that each component of the offset value is specified not as an acceleration value (in G), but rather as a pre-conversion sampling value. Use the GetOffset function to get the current setting. Call ResetOffset to return the offset to the initial value of 0 for each component.\n Note:\n The SetOffsetFromBaseStatus function has been removed from CTR-SDK.\n Warning:\n Do not use the offset value settings to calibrate the accelerometer.\nCode 6-4. Accelerometer Axial Rotation\n class nn::hid::AccelerometerReader\n{\n void EnableAxisRotation();\n void DisableAxisRotation();\n bool IsEnableAxisRotation() const;\n void SetAxisRotationMatrix(const nn::math::MTX34 mtx);\n void GetAxisRotationMatrix(nn::math::MTX34* pMtx) const;\n void ResetAxisRotationMatrix();\n}\nEnable axial rotation of output values by calling EnableAxisRotation, and call DisableAxisRotation to disable. Rotation is disabled by default. Call IsEnableAxisRotation to get the current setting; a return value of true indicates that rotation is enabled. When enabled, the previously set rotation matrix is applied to the output value.\nTo set the rotation matrix (a 3 × 4 matrix), call SetAxisRotationMatrix; to get the currently set matrix, call GetAxisRotationMatrix. Call ResetAxisRotationMatrix to revert to the identity matrix (no rotation).\nWhen both an offset rotation and axial rotation are enabled, the offset is applied first, and then the rotation is applied to the resulting value.\n Warning:\n Do not use the axial rotation settings to calibrate the accelerometer.\n",0]
,["Pages/Page_55582546.html#PageId_55582558","6.2.3.1. Cautions for Implementing Application-Specific Calibration Routines",
"\n6.2.3.1. Cautions for Implementing Application-Specific Calibration Routines\n Warning:\n Applications are now prohibited from implementing their own calibration routines.\n",0]
,["Pages/Page_55582546.html#PageId_55582559","6.2.4. Gyro Sensor",
"\n6.2.4. Gyro Sensor\nCall the nn::hid::GyroscopeReader class’s Read or ReadLatest member functions to get the gyro sensor’s input value as a nn::hid::GyroscopeStatus structure. The Read function can get sampling results in order of the latest result, but it cannot reacquire sampling results. When the function is called at a cycle faster than the sampling cycle, it cannot get sampling results. On the other hand, the ReadLatest function can get only the latest sampling result. It can also reacquire sampling results, so even when it is called at a cycle faster than the sampling cycle, it can still get sampling results.\nThe gyro sensor is turned on when an instance of the GyroscopeReader class is created, and it is turned off when an instance is destroyed. To conserve battery life, only instantiate the GyroscopeReader class when it is used. However, if you repeatedly create and destroy an instance of the GyroscopeReader class in a function that is called every frame (for example), the frequent power cycling wastes battery power and leads to unexpected malfunctions.\nThe speed, angle, and direction members of the nn::hid::GyroscopeStatus structure record the gyro sensor’s angular velocity, angle of rotation, and 3D attitude. The angular velocity and angle of rotation values are 3D vectors, with the x component recording the pitch direction, the y component the yaw direction, and the z component the roll direction. An angular velocity of 360 dps is represented by a value of 1.0, and an angle of rotation of 360° by a value of 1.0. Pitch is the degree of tilt forward and back about the axis running along the width of the lower screen, yaw is rotation about an axis perpendicular to the lower screen, and roll is tilt to left and right about the axis running along the height of the lower screen.\nFigure 6-8. The Three Components of the Gyro Sensor\nYaw(+y) Pitch(+x) Roll(+z)\nThe gyro sensor’s maximum sensitivity to angular velocity can vary by up to ±8%. After factoring in the zero-point variance offset, the maximum input value is 10% less than the theoretical maximum value of approximately 1800 dps, at 1620 dps. Applications must not depend on any input values greater than this.\nThe 3D attitude is recorded as a 3 × 3 matrix. This matrix is calculated based on the angular velocity, and you can change the angular velocity multiple referenced in calculation by calling the nn::hid::GyroscopeReader::SetDirectionMagnification function. Specify a multiple of 1.0 to use the output angular velocity without modification in calculation. Specify 2.0 to use a value of double the detected angular velocity.\nThe nn::hid::GyroscopeReader class detects when the system is at rest and automatically calibrates the zero-point offset (zero-point drift correction). The correction setting is applied alike to all directions.\nCode 6-5. Gyro Sensor Zero-Point Drift Correction\n class nn::hid::GyroscopeReader\n{\n void EnableZeroDrift();\n void DisableZeroDrift();\n bool IsEnableZeroDrift() const;\n f32 GetZeroDriftEffect() const;\n void ResetZeroDriftMode();\n void SetZeroDriftMode(const nn::hid::ZeroDriftMode& mode);\n void GetZeroDriftMode(nn::hid::ZeroDriftMode& mode) const;\n}\nTo enable zero-point drift correction, call EnableZeroDrift; to disable it, call DisableZeroDrift. Correction is enabled by default. Call IsEnableZeroDrift to get the current setting; a return value of true indicates that drift correction is enabled. When enabled, the previously set rotation matrix is applied to the output value. The return value from a call to GetZeroDriftEffect indicates the degree of drift correction being applied. A value of 0 indicates that no correction has been performed (movement was detected). Values approaching 1.0 indicate stability (no movement).\nThe degree of correction and the angular velocity at which the system is considered at rest both depend on the drift correction mode. Set and get the zero-point drift correction mode using the SetZeroDriftMode and GetZeroDriftMode functions, and use ResetZeroDriftMode to revert to the initial value (GYROSCOPE_ZERODRIFT_STANDARD).\nTable 6-3. Gyro Sensor Zero-Point Drift Correction Mode\n \t Definition\n \t Description\n \t GYROSCOPE_ZERODRIFT_LOOSE\n \t Correction is applied more loosely, and constant-velocity movement might not be detected.\n \t GYROSCOPE_ZERODRIFT_STANDARD\n \t Standard correction. (Default.)\n \t GYROSCOPE_ZERODRIFT_TIGHT\n \t Correction is applied strictly, allowing the detection of more precise movements.\n The zero-point offset may vary by up to 50 dps when zero-point drift correction is disabled. An application must adequately account for this variance when disabling correction, such as when detecting extremely small movements.\n Note:\n Unless GYROSCOPE_ZERODRIFT_LOOSE is specified, the correction may not work as well even when the system is at rest. We recommend implementing your application to account for this, such as by applying GYROSCOPE_ZERODRIFT_LOOSE correction for scenes where the user is not expected to move the system, and then returning to the previously used correction mode during other use.\nSet the zero-point play correction to avoid reacting to small changes in angular velocity. The play correction setting is applied equally to all directions.\nCode 6-6. Gyro Sensor Zero-Point Play Correction\n class nn::hid::GyroscopeReader\n{\n void EnableZeroPlay();\n void DisableZeroPlay();\n bool IsEnableZeroPlay() const;\n f32 GetZeroPlayEffect() const;\n void SetZeroPlayParam(f32 radius);\n void GetZeroPlayParam(f32& radius) const;\n void ResetZeroPlayParam();\n}\nCall the EnableZeroPlay function to enable zero-point play correction and call DisableZeroPlay to disable it. Correction is disabled by default. Call IsEnableZeroPlay to get the current setting; a return value of true indicates that play correction is enabled. The return value from a call to GetZeroPlayEffect indicates the degree of play correction being applied. The return value is negative when correction is disabled and 0 or greater when correction is enabled. As the angular velocity approaches the currently set play value, the return value approaches 0. A return value of exactly 0 indicates no correction.\nTo set the absolute value of the angular velocity for which play correction is 0, call the SetZeroPlayParam function; to get the current setting, call GetZeroPlayParam. Call ResetZeroPlayParam to revert to the initial value of 0.005. An absolute angular velocity of 360 dps is represented by a value of 1.0.\nIf both zero-point drift and play correction are enabled, values are corrected first for drift and then for play.\nUse the nn::hid::GyroscopeReader class to apply axial rotation to angular velocity after correcting for zero-point drift and play. The class calculates the rotation matrix based on output values when the system is at rest, allowing you to implement gyro sensor calibration in your application. You can also use axial rotation of output values to apply any angle tilt to the gyro sensor.\nCode 6-7. Gyro Sensor Axial Rotation\n class nn::hid::GyroscopeReader\n{\n void EnableAxisRotation();\n void DisableAxisRotation();\n bool IsEnableAxisRotation() const;\n void SetAxisRotationMatrix(const nn::math::MTX34 mtx);\n void GetAxisRotationMatrix(nn::math::MTX34* pMtx) const;\n void ResetAxisRotationMatrix();\n}\nTo enable axial rotation of angular velocity, call EnableAxisRotation; to disable, call DisableAxisRotation. Rotation is disabled by default. Call IsEnableAxisRotation to get the current setting; a return value of true indicates that rotation is enabled. When enabled, the currently set rotation matrix is applied to the angular velocity.\nTo set the rotation matrix (a 3 × 4 matrix), call SetAxisRotationMatrix; to get the currently set matrix, call GetAxisRotationMatrix. Call ResetAxisRotationMatrix to revert to the identity matrix (no rotation).\nThe nn::hid::GyroscopeReader class uses the accelerometer input value to correct the gyro sensor’s 3D attitude. Anytime you use the gyro sensor, you are also using the accelerometer. When passing NULL as the value of the pAccelerometerReader parameter to the (overloaded) constructor, the GyroscopeReader class internally creates and uses an instance of the nn::hid::AccelerometerReader class that has the default settings. Pass a pointer to a configured instance of the nn::hid::AccelerometerReader class if you want to use different values for input play and detection sensitivity.\nCode 6-8. 3D Attitude Correction Using the Accelerometer\n class nn::hid::GyroscopeReader\n{\n GyroscopeReader(nn::hid::AccelerometerReader* pAccelerometerReader = NULL,\n nn::hid::Gyroscope& gyroscope = nn::hid::GetGyroscope());\n void EnableAccRevise();\n void DisableAccRevise();\n bool IsEnableAccRevise() const;\n f32 GetAccReviseEffect() const;\n void SetAccReviseParam(f32 revise_pw, f32 revise_range);\n void GetAccReviseParam(f32& revise_pw, f32& revise_range) const;\n void ResetAccReviseParam();\n}\nTo enable correction using the accelerometer, call the EnableAccRevise function; to disable, call DisableAccRevise. Call IsEnableAccRevise to get the current setting; a return value of true indicates that correction is enabled. The return value from a call to GetAccReviseEffect indicates the degree of correction being applied. The return value is always 0 when correction is disabled and 0 or greater when correction is enabled. The return value approaches 0 as the gyroscope’s 3D attitude direction (GyroscopeStatus.direction) approaches the accelerometer’s direction.\nTo set the accelerometer correction parameters (weight and enabled range), call SetAccReviseParam; to get the current settings, call GetAccReviseParam. Call ResetAccReviseParam to revert to the initial settings of 0.03 for weight and 0.4 for enabled range. For the revise_pw parameter, specify a value of 0.0 through 1.0 for the accelerometer weight. Higher values mean more severe correction. For the revise_range parameter, specify the accelerometer range to correct within. The range is 1.0 to the ±revise_range value. For example, specify a value of 0.4 to apply correction to acceleration values from 0.6 G through 1.4 G. The correction parameters are applied equally to all directions.\nWhen applying angular velocity axial rotation to the gyro sensor with accelerometer correction enabled, specify the same rotation matrix for use with both the gyro sensor and accelerometer. When using an instance created with the default settings, the library makes sure internally that the same matrix is used, but if you use an instance created with any other settings, you must do this yourself. If different matrices are used, the accelerometer correction might not work properly.\n",0]
,["Pages/Page_55582546.html#PageId_55582560","6.2.5. Debug Pad (Control Pad for Debugging)",
"\n6.2.5. Debug Pad (Control Pad for Debugging)\nCall the nn::hid::DebugPadReader class’s Read or ReadLatest functions to get input from the digital buttons and two analog sticks on the debug pad as an nn::hid::DebugPadStatus structure. The Read function can get sampling results in order of the latest result, but it cannot reacquire sampling results. Sampling results cannot be obtained if the function is called more frequently than the sampling frequency of 16 ms. On the other hand, the ReadLatest function can get only the latest sampling result. It can also reacquire sampling results, so even when it is called at a cycle faster than the sampling cycle, it can still get sampling results.\nThe nn::hid::DebugPadStatus structure’s hold member records which button was held at the time of sampling, the trigger member records which button was pressed at the time of sampling, and the release member records which button was released at the time of sampling. For the ReadLatest function, both the trigger and release members are evaluated for their states at that time, so any changes between calls are not necessarily reflected. The leftStickX and leftStickY members record the left analog stick’s x and y axes, and the rightStickX and rightStickY members record the right analog stick’s x and y axes as values ranging from –1.0 to 1.0.\nCall the SetStickClampMode function to set the analog stick clamp mode, and call GetStickClampMode to get the current setting. This value cannot be set independently for the left and right analog sticks. You can choose either the STICK_CLAMP_MODE_CIRCLE_WITH_PLAY or STICK_CLAMP_MODE_CIRCLE_WITHOUT_PLAY clamp mode.\nTable 6-4. Debug Pad Digital Buttons and Definitions\n \t Definition\n \t Corresponding Button\n \t DEBUG_PAD_BUTTON_UP\n \t +Control Pad (Up)\n \t DEBUG_PAD_BUTTON_DOWN\n \t +Control Pad (Down)\n \t DEBUG_PAD_BUTTON_LEFT\n \t +Control Pad (Left)\n \t DEBUG_PAD_BUTTON_RIGHT\n \t +Control Pad (Right)\n \t DEBUG_PAD_BUTTON_A\n \t A Button\n \t DEBUG_PAD_BUTTON_B\n \t B Button\n \t DEBUG_PAD_BUTTON_X\n \t X Button\n \t DEBUG_PAD_BUTTON_Y\n \t Y Button\n \t DEBUG_PAD_TRIGGER_L\n \t L Trigger\n \t DEBUG_PAD_TRIGGER_R\n \t R Trigger\n \t DEBUG_PAD_TRIGGER_ZL\n \t ZL Trigger\n \t DEBUG_PAD_TRIGGER_ZR\n \t ZR Trigger\n \t DEBUG_PAD_BUTTON_PLUS\n \t Plus (+) Button\n \t DEBUG_PAD_BUTTON_MINUS\n \t Minus (-) Button\n \t DEBUG_PAD_BUTTON_HOME\n \t HOME Button\n ",0]
,["Pages/Page_55582546.html#PageId_55582561","6.2.6. Circle Pad Pro",
"\n6.2.6. Circle Pad Pro\nThe Circle Pad Pro is an optional peripheral device that is attached to the CTR for use. Using the Circle Pad Pro in addition to the standard input devices provided with the CTR system allows you to make use of the circle pad installed in the Circle Pad Pro (hereafter called the Right Circle Pad).\nThe circle pad installed by default in the CTR system is simply called the Circle Pad, and the digital buttons (the ZL and ZR Buttons). Input from input devices installed in the Circle Pad Pro is transmitted to the CTR system using infrared communication. The sampling cycle covers a range from 8 ms to 32 ms in 1-ms intervals. For a detailed description of how to perform settings, see 6.2.6.4. Sampling Start and State Acquisition.\n Note:\n For the process flow for using Circle Pad Pro in applications, see Appendix: Process Flows for Using the Circle Pad Pro.\n For more information about the C Stick, ZL Button, and ZR Button on SNAKE and for the differences from the Circle Pad Pro, see 6.2.7. C Stick.\n",0]
,["Pages/Page_55582546.html#PageId_55582562","6.2.6.1. Hardware Internal States",
"\n6.2.6.1. Hardware Internal States\nThe Circle Pad Pro hardware has only two states: the Active State in which communication with the CTR system is possible, and the Standby State in which no communication is performed.\nTable 6-5. Hardware Internal States\n \t Internal State\n \t Description\n \t Active State\n \t State in which communication with the CTR is possible. Connection to the CTR can be made only in this state.\n The device enters this state as soon as a battery is inserted.\n \t Standby State\n \t No communication with the CTR is performed in this state. When not in use, battery consumption is kept to a minimum to extend battery life.\n The device enters this state if button input and infrared communication are not performed for a period of five minutes. The device returns to Active State by pushing one of the digital buttons on the Circle Pad Pro (ZL, ZR, or R).\n Note:\n The Circle Pad Pro has no indicator to display its internal state. The device’s internal state cannot be obtained from the library.\n",0]
,["Pages/Page_55582546.html#PageId_55582563","6.2.6.2. Software Internal State",
"\n6.2.6.2. Software Internal State\nSoftware (library) internal states transition as shown in the following diagram.\nFigure 6-9. Software Internal State Transition (Circle Pad Pro)\nNO_CONNECTION CONNECTED STOPPED StartSampling() StopSampling() Disconnect caused by external factor Transition to sleep Internal state Explicit transition Automatic transition\nConnection status of internal states with the Circle Pad Pro is summarized in the following table.\nTable 6-6. Software Internal States\n \t Internal State\n \t Description\n \t NO_CONNECTION\n \t Connection with the Circle Pad Pro has not been established in this state.\n This is the same internal state as immediately after initialization.\n \t CONNECTED\n \t Connection with the Circle Pad Pro is established and sampling is being performed in this state.\n \t STOPPED\n \t Connection with the Circle Pad Pro, which had been established up to this point, has been interrupted due to an external cause (such as battery consumption or detachment from the CTR system).\n This internal state is also entered when the CTR system transitions to Sleep Mode.\n This internal state is defined by the nn::hid::ExtraPad::ConnectionState enumerator, taking a CONNECTION_STATE_* value.\n",0]
,["Pages/Page_55582546.html#PageId_55582564","6.2.6.3. Initialization",
"\n6.2.6.3. Initialization\nBefore Circle Pad Pro input sampling can begin, the nn::hid::ExtraPad class initialization function must be called.\nCode 6-9. Circle Pad Pro Initialization Function\n static void nn::hid::ExtraPad::Initialize(void* workingMemory);\nSpecify the buffer for infrared communication in workingMemory. The buffer must have a size of 4096 bytes and a starting address of 4096 bytes. Buffers allocated from device memory cannot be used.\nAfter initialization completes, the nn::hid::ExtraPadReader class can be used.\n",0]
,["Pages/Page_55582546.html#PageId_55582565","6.2.6.4. Sampling Start and State Acquisition",
"\n6.2.6.4. Sampling Start and State Acquisition\nUse the following functions to begin sampling and get the state.\nCode 6-10. Functions Used to Start Sampling and Get States\n class nn::hid::ExtraPad\n{\n static nn::Result StartSampling(s32 samplingThreadPriority, s32 period);\n static ConnectionState GetConnectionState();\n static bool IsSampling();\n}\nCircle Pad Pro sampling is performed by calling the nn::hid::ExtraPad::StartSampling function. Calling the function before initialization has completed generates an error with the same value as the nn::hid::MakeResultNotInitialized function. Processing of this function requires 50 to 200 ms when connection with the Circle Pad Pro has succeeded, and 100 ms when connection has failed.\nSpecify a sampling thread priority level in samplingThreadPriority. The specifiable range is 0 to 31. The higher the priority (the closer to 0), the more stable sampling becomes.\nSpecify the sampling cycle (in milliseconds) in period. The specifiable range is 8 to 32.\nWhen sampling is started, application resources are consumed and the sampling thread is created. (The thread priority level is the value specified in samplingThreadPriority). This thread receives sampling data from the Circle Pad Pro according to the cycle setting specified in period, and sends approximately once every second for continuous communication with the Circle Pad Pro. The higher the value specified for the sampling cycle, the larger the processing volume per unit of time. The processing burden on the application core and system core grows in proportion to the length of the cycle. To lighten the load on the system, it is most effective to set a lower value for the sampling cycle.\n Warning:\n When the load from other processes is especially high, it interferes with sampling thread operating cycles and may cause delays in input, or disconnection of the Circle Pad Pro.\nSampling cannot start unless the Circle Pad Pro is in the Active State. It is not possible to determine whether the device is in the Active State from the library. Prompt the user to enter input from one of the digital buttons (R/ZR/ZL) on the Circle Pad Pro when the StartSampling function sends back a return value indicating that the Circle Pad Pro cannot be found (the same value as for the nn::hid::MakeResultNoConnection function). After you have returned to the Active State, you can reconnect.\nWhen the StartSampling function is called, a connection is made after a disconnect has been performed once.\n Note:\n To perform ongoing detection of the Circle Pad Pro, a load must be set at less than a 32-ms cycle, assuming the StartSampling function is called at a frequency of once per second. This is smaller than sampling processing.\nThe nn::hid::ExtraPad::GetConnectionState function returns the Circle Pad Pro connection state as an internal state. Reconnect after performing a disconnect once, when a disconnect occurs due to an external cause and CONNECTION_STATE_STOPPED is returned.\nThe nn::hid::ExtraPad::IsSampling function returns whether sampling is in progress. If the value true is returned, sampling is being performed and Circle Pad Pro input is reflected in the nn::hid::ExtraPadStatus structure acquired by the nn::hid::ExtraPadReader class. When the value true is returned, it guarantees that the internal state is also in a connected state (CONNECTED), but note that if a connection or disconnect is underway, the value false could be returned even if the internal state is in a connected state.\n Note:\n After Circle Pad Pro sampling begins, the nn::hid::PadReader class can no longer be used, but even if the Circle Pad Pro is not connected, input from the system’s digital buttons and circle pad is reflected in the nn::hid::ExtraPadStatus structure obtained by the nn::hid::ExtraPadReader class.\n It is unnecessary for the application supporting the Circle Pad Pro to use the connection state to switch between classes and structures, because it uses the nn::hid::ExtraPadReader class and the nn::hid::ExtraPadStatus structure.\n",0]
,["Pages/Page_55582546.html#PageId_55582566","6.2.6.5. Stop Sampling",
"\n6.2.6.5. Stop Sampling\nCall the nn::hid::ExtraPad::StopSampling function to stop sampling.\nCode 6-11. Function Used to Stop Sampling\n static nn::Result nn::hid::ExtraPad::StopSampling();\nAfter a disconnect has succeeded, the sampling thread is destroyed and the internal state transitions to a not connected state (NO_CONNECTION). This function always succeeds in processing as long as initialization has already been completed when it is called.\n",0]
,["Pages/Page_55582546.html#PageId_55582567","6.2.6.6. Getting Sampling Results",
"\n6.2.6.6. Getting Sampling Results\nYou can get sampling results with the Read or ReadLatest function under the nn::hid::ExtraPadReader class, reflecting the nn:: hid::ExtraPadStatus structure. The Read function can get sampling results in order of the latest result, but it cannot reacquire sampling results. When the function is called at a cycle faster than the sampling cycle, it cannot get sampling results. On the other hand, the ReadLatest function can get only the latest sampling result. It can also reacquire sampling results, so even when it is called at a cycle faster than the sampling cycle, it can still get sampling results.\nCode 6-12. nn::hid::ExtraPadStatus Structure\n struct nn::hid::ExtraPadStatus {\n AnalogStickStatus stick;\n AnalogStickStatus extraStick;\n bit32 hold;\n bit32 trigger;\n bit32 release;\n u8 batteryLevel;\n bool isConnected;\n NN_PADDING2;\n};\nThe Circle Pad Pro’s input from the system is reflected in stick, in the same way as in the nn::hid::PadStatus structure.\nInput from the Circle Pad Pro’s Right Circle Pad is reflected in extraStick.\nThe hold, trigger, and release member variables are the same as those in the nn::hid::PadStatus structure. The following buttons have been added to the device.\nTable 6-7. Buttons Added to the Extra Pad Reader\n \t Definition\n \t Corresponding Button\n \t BUTTON_ZL\n \t Circle Pad Pro ZL button\n \t BUTTON_ZR\n \t Circle Pad Pro ZR button\n \t BUTTON_EMULATION_R_UP\n \t Right Circle Pad + button for upward emulation input\n \t BUTTON_EMULATION_R_DOWN\n \t Right Circle Pad + button for downward emulation input\n \t BUTTON_EMULATION_R_LEFT\n \t Right Circle Pad + button for left emulation input\n \t BUTTON_EMULATION_R_RIGHT\n \t Right Circle Pad + button for right emulation input\n Note:\n When the Circle Pad Pro is attached, it is difficult to press the R Button, so the Circle Pad Pro has been fitted with its own R Button. The application cannot detect whether the pressed R Button is the one on the CTR system or on the Circle Pad Pro.\n When the Circle Pad Pro is not performing sampling, input from the CTR system is reflected in the nn::hid::ExtraPadStatus structure in 4-ms sampling cycles by the nn::hid::ExtraPadReader class. However, when Circle Pad Pro sampling is being performed, the sampling cycle for input from the CTR system uses the sampling cycle specified by the nn::hid::ExtraPad::StartSampling function (between 8 and 32 ms).\nCircle Pad Pro battery level is stored in two values (0 and 1) in batteryLevel. Even when the value 0 is returned, there is approximately one day remaining of continuous operation.\n Warning:\n Even if the value 1 is returned for remaining battery level, inserting a battery whose battery life is already partially consumed may result in the Circle Pad Pro failing to restart. If communication no longer works after inserting the battery, replace it with a new battery. This phenomenon occurs only when inserting a battery. After a new battery has been inserted, normal operation continues until the remaining battery life reaches 0.\nResults of library searches for whether sampling is in progress are stored in isConnected.\n Note:\n The time required until the application can get Circle Pad Pro input (input delay) is approximately 2 ms or more (2 ms + sampling cycle) when the volume of other processing being performed by the application is sufficiently small. It takes 0 sampling cycles or more to get user input from the Circle Pad Pro, plus communication time and CTR processing, which requires approximately 2 ms.\n",0]
,["Pages/Page_55582546.html#PageId_55582568","6.2.6.7. Circle Pad Clamp Processing",
"\n6.2.6.7. Circle Pad Clamp Processing\nFunctions used by the CTR system for circle pad clamp processing are defined with the same arguments as nn::hid::PadReader class member functions. Operation is also the same as with this class.\nFunctions used in Right Circle Pad clamp processing use the same settings as the circle pad on the CTR system side, except that the function name Stick is used instead of ExtraStick. These settings can be performed individually.\nCode 6-13. Functions Used in Right Circle Pad Clamp Processing\n class nn::hid::ExtraPadReader\n{\n void SetExtraStickClamp(s16 min, s16 max);\n void GetExtraStickClamp(s16* pMin, s16* pMax) const;\n StickClampMode GetExtraStickClampMode() const;\n void SetExtraStickClampMode(StickClampMode mode);\n f32 NormalizeExtraStick(s16 x);\n void NormalizeExtraStickWithScale(\n f32* normalized_x, f32* normalized_y, s16 x, s16 y);\n void SetNormalizeExtraStickScaleSettings(f32 scale, s16 threshold);\n void GetNormalizeExtraStickScaleSettings(f32* scale, s16* threshold) const;\n}\n",0]
,["Pages/Page_55582546.html#PageId_55582569","6.2.6.8. Event Notification",
"\n6.2.6.8. Event Notification\nYou can register events (nn::os::LightEvent class) that notify changes in the connection state and completion of sampling.\nCode 6-14. Functions Used in Event Notification\n class nn::hid::ExtraPad\n{\n static void RegisterConnectionEvent(nn::os::LightEvent* pLightEvent);\n static void UnregisterConnectionEvent();\n static void RegisterSamplingEvent(nn::os::LightEvent* pLightEvent);\n static void UnregisterSamplingEvent();\n}\nEvent notifications associated with changes in connection state are registered and unregistered with the *ConnectionEvent functions, and event notifications for completing sampling are registered and unregistered with the *SamplingEvent functions. After an event is registered, thread processing for sampling increases just slightly.\nThe processing load during registration of events that notify of changes in the connection state is so minor that it can be ignored. However, registration of the sampling complete event requires processing of each sampling cycle, so there is more processing load on the CPU. We recommend that these functions only be used on applications where event notification is used.\nChanges in connection state can also be determined by nn::hid::ExtraPad class member functions, GetConnectionState and IsSampling, and by the isConnected structure member variable of nn::hid::ExtraPadStatus.\n",0]
,["Pages/Page_55582546.html#PageId_55582570","6.2.6.9. Calibration Applet",
"\n6.2.6.9. Calibration Applet\nA library applet called the Circle Pad Pro calibration applet is provided to calibrate the feel of controls on the Right Circle Pad within the Circle Pad Pro. Follow the guidelines that provide examples where applications supporting the Circle Pad Pro can call up the Circle Pad Pro calibration applet.\nFor more information, see 12.1.7. Circle Pad Pro Calibration Applet.\n",0]
,["Pages/Page_55582546.html#PageId_55582571","6.2.6.10. Differences Between the Circle Pad and the Right Circle Pad",
"\n6.2.6.10. Differences Between the Circle Pad and the Right Circle Pad\nInput coordinates sampled from the Circle Pad and the Right Circle Pad have a tendency to change as a result of electrical fluctuations, even when operations are performed intentionally using the pad directly. The amount of change in values when key positions on the pads are fixed and the probability that this might occur differs for the Circle Pad and the Right Circle Pad, as indicated in the following table. The Right Circle Pad is especially susceptible to these changes, so caution is required.\nTable 6-8. Probability That Circle Pad and Right Circle Pad Input Coordinates Will Change\n \t Amount of Change\n \t Circle Pad\nx-coordinate\n \t Circle Pad\ny-coordinate\n \t Right Circle Pad\nx-coordinate\n \t Right Circle Pad\ny-coordinate\n \t –3\n \t 0.000006 %\n \t 0.000006 %\n \t 0.002 %\n \t 0.001 %\n \t –2\n \t 0.000178 %\n \t 0.000178 %\n \t 0.349 %\n \t 0.352 %\n \t –1\n \t 0.003541 %\n \t 0.003541 %\n \t 3.485 %\n \t 3.273 %\n \t ±0\n \t 99.949837 %\n \t 99.949837 %\n \t 92.326 %\n \t 92.743 %\n \t +1\n \t 0.003541 %\n \t 0.003541 %\n \t 3.491 %\n \t 3.285 %\n \t +2\n \t 0.000178 %\n \t 0.000178 %\n \t 0.346 %\n \t 0.345 %\n \t +3\n \t 0.000006 %\n \t 0.000006 %\n \t 0.002 %\n \t 0.001 %\n The probability of change occurring within the unit of time noted is determined according to the following formula:\nAmount of sampling data obtained during unit of time × Probability from Table 6-8.\nIf the pad is positioned in the center after the user’s finger is removed, the value will not change from the 0 position. This is because even with some variation in value, the minimum clamping value is never exceeded.\n",0]
,["Pages/Page_55582546.html#PageId_57065985","6.2.7. C Stick",
"\n6.2.7. C Stick\n",0]
,["Pages/Page_55582546.html#PageId_57066431","6.2.7.1. Properties of C Stick Hardware",
"The library lets you use the C Stick on SNAKE without differentiating from the Right Circle Pad on the Circle Pad Pro, but the actual hardware is different. You must consider hardware differences when using this approach.\n6.2.7.1. Properties of C Stick Hardware\nThe C Stick on SNAKE is an analog input device that detects minor deformations (strain) when pressure is applied to a resin stick and reads the magnitude of the deformation as changes in voltage.\nNote the following points because the output value from the C Stick depends on the pressure on the stick part.\n\tIt may be difficult to maintain the maximum input value depending on the strength of the user. \tWhen too much pressure is applied, the output value from the C Stick does not change (the output value is saturated). \tWhen the C Stick is strongly pressed from directly above, the output value from the C Stick is undefined. ",0]
,["Pages/Page_55582546.html#Anchor_57066431_最大値を入力するために必要な荷重による影響","Effect on the Pressure Required to Input the Maximum Value",
" \tWhen the X Button is strongly held down, the C Stick output value might fluctuate due to the close physical proximity to the X Button.\nIn addition, due to variances in the performance of the sensors on each system, note the following.\n\tSensitivity variances between individual systems have an effect on resolution.\nEffect on the Pressure Required to Input the Maximum Value\nThe maximum detectable pressure range of the C Stick is approximately 240 gf. Consequently, it might be difficult for some users to apply the maximum pressure continuously.\nThe minimum pressure value differs depending on the clamping method and input direction. The detectable pressure range of the C Stick is summarized in the following table.\nTable 6-9. Detectable Pressure Range of C Stick\n \tClamping Method \tMinimum Detectable Pressure \tMaximum Detectable Pressure\n \tUp, Down, Left, Right (4 directions) \tDiagonal 45° directions\n \tCircular (min=40, max=145) \tApprox. 68 gf \tApprox. 72 gf \tApprox. 240 gf\n \tCross (min=36, max=145) \tApprox. 63 gf \tApprox. 90 gf\n \tMinimal (min=40, max=145) \tApprox. 63 gf \tApprox. 72 gf\n ",0]
,["Pages/Page_55582546.html#Anchor_57066431_出力値が飽和することによる影響","Effect of Saturated Output Value",
"Effect of Saturated Output Value\nWhen excessive force is applied to the C Stick, the output value of the C Stick no longer changes, even if more pressure is applied. This condition is called \"saturation of the output value.\"\nC Stick input is measured on two independent axes (the x-axis and y-axis). In a situation where the output value is saturated for both axes, the system can no longer detect any C Stick operations by the user.\nFor example, if the C Stick is moved in a large circular motion with enough force and the C Stick input axes are aligned with the system, the output value does not change for some regions at ±45° angles from the input axes. This is illustrated below.\nFigure 6-10. Saturation of Output Values (C Stick Input Axes Aligned With System)\nx y X Y Constant value is output in this region\nThe orange x-axis and y-axis show the orientation of the system, and the black x-axis and y-axis show the input axis of the C Stick. The orange circle shows the input pressure, the light shaded area (in the middle) shows where a raw output value can be obtained from the C Stick device, and the dark shaded area shows where the output value does not change for either axis. The area where the value does not change is drawn larger than the actual area for illustrative purposes.\nThe C Stick input axes are rotated 45° from the orientation of the system to minimize problems from the user's perspective.\nFigure 6-11. Saturation of Output Values (C Stick Input Axes Rotated 45° From System Orientation)\nx y X Y Constant value is output in this region\nThe rotation of the input axes is handled by the system. Applications do not need to apply any rotation to C Stick input retrieved from the library.\n",0]
,["Pages/Page_55582546.html#Anchor_57066431_真上から強く押し込んだ場合の挙動","Behavior When Strongly Pressed From Above",
"Behavior When Strongly Pressed From Above\nThis action causes the stick part to bend, which may result in the following symptoms.\n\tThe C Stick output value fluctuates even though no directional force is applied. ",0]
,["Pages/Page_55582546.html#Anchor_57066431_Xボタンを長押しすることによる影響","Effect of Holding Down the X Button",
" \tThe input is processed as a different direction than what the user intended.\nEffect of Holding Down the X Button\nWhen strong pressure is applied to the X Button, the C Stick output value might fluctuate even if it is not being used. This issue occurs due to the deformation of the housing when the X Button is strongly pressed, which can also cause the C Stick to bend.\nThis issue does not occur when the X Button is rapidly pressed, and requires significant force to occur when holding down the X Button. More force is required to reproduce this issue on the development hardware and the new Nintendo 3DS than on the new Nintendo 3DS XL.\nIn practice, Nintendo expects the effect of this issue on the C Stick output value to stay within the following ranges.\nTable 6-10. C Stick Output Value Fluctuation Range Caused by Holding X Button\n \tClamping Method \tx-axis \ty-axis\n \tCircular (min=40, max=145) \t0 to 10 \t0 to –35\n \tCross (min=36, max=145) \t0 \t0 to –38\n \tMinimal (min=40, max=145) \t0 to 10 \t0 to –37\n ",0]
,["Pages/Page_55582546.html#Anchor_57066431_感度の個体差による分解能への影響","Effect of Sensitivity Variations Between Individual Systems on Resolution",
"Effect of Sensitivity Variations Between Individual Systems on Resolution\nThe C Stick has slight differences in sensitivity between individual systems and is calibrated during the manufacturing process to mitigate these differences. Due to the calibration process, some systems have higher resolution than others.\nDepending on the individual system and the clamping mode, it may not be possible to get all of the values within the clamping range from the C Stick. The change in value is not guaranteed to be consecutive on systems with higher resolution, and this tendency becomes even more pronounced on systems with lower resolution. Output is guaranteed, however, for the center point and the outer edge.\nFor this reason, Nintendo does not recommend implementations that require input from a narrow range or expect a smooth change in value.\nThe figure below shows the output value distribution on a low-resolution system with circular clamping applied, in addition to an example of the narrow detection range that is not recommended. The orange background represents the range of values available to the application, and the black points represent the actual values that are output. Note that the values of adjacent black dots are not guaranteed to be consecutive. The green circle on the left side shows a narrow detection range when the C Stick output value is converted to a vector length. The green square on the right shows a narrow detection range when using the raw C Stick output value. In other words, depending on the input direction, there might not be any points that satisfy the required vector length, and there might not be any points at the raw value being detected.\nFigure 6-12. Distribution of C Stick Output Values and Examples of Narrow Detection Ranges (Circular Clamping, Low Resolution System)\n",0]
,["Pages/Page_55582546.html#PageId_57066847","6.2.7.2. Differences From the Circle Pad Pro",
"\n6.2.7.2. Differences From the Circle Pad Pro\nWhen using input to the SNAKE C Stick with the HID library, note the following differences from the specifications and behavior of the Circle Pad Pro.\n\tThe configurable sampling frequency is different. \tThe device is never disconnected due to external factors. \tThe behavior when waking from Sleep Mode is different. ",0]
,["Pages/Page_55582546.html#Anchor_57066847_設定可能なサンプリング周期が異なる","Different Configurable Sampling Frequency",
" \tThe center point and sensitivity are not calibrated in the Circle Pad Pro Calibration Applet.\nDifferent Configurable Sampling Frequency\nA sampling frequency of 10 to 21 ms can be set for the SNAKE C Stick, ZL Button, and ZR Button hardware.\nThe nn::hid::ExtraPad::StartSampling function lets you specify a frequency in the range of 8 to 32 ms, but the hardware handles values below 10 ms as 10 ms, and values above 21 ms as 21 ms. The function returns data at that frequency.\nWe recommend setting a sampling frequency of 10 to 21 ms based on the sampling frequency of the hardware.\n",0]
,["Pages/Page_55582546.html#Anchor_57066847_外的要因による切断が発生しない","No Disconnects due to External Factors",
"No Disconnects due to External Factors\nThe Circle Pad Pro, which was connected using infrared communication, could be disconnected by external factors such as being detached or a dead battery. The SNAKE C Stick, ZL Button, and ZR Button, however, are part of the system itself, so nn::hid::ExtraPad::GetConnectionState never returns nn::hid::ExtraPad::CONNECTION_STATE_STOPPED due to external factors.\nBecause the battery never runs out, the batteryLevel member of the nn::hid::ExtraPadStatus structure is always set to 1 while input is being sampled.\n",0]
,["Pages/Page_55582546.html#Anchor_57066847_スリープ復帰時の挙動が異なる","Different Behavior When Waking From Sleep Mode",
"Different Behavior When Waking From Sleep Mode\nThe Circle Pad Pro and the C Stick have the following differences in behavior when the system enters Sleep Mode without calling nn::hid::ExtraPad::StopSampling.\n\tCircle Pad Pro\nInfrared communication stops when the system enters Sleep Mode, which would cause sampling requests to fail immediately after the system wakes. To prevent this, the sampling group is removed and the library treats the Circle Pad Pro as having been stopped. However, because the internal state changes based on the infrared communication status, the internal state before detecting the stoppage is unstable.\nSpecifically, the nn::hid::ExtraPad::GetConnectionState function generally returns CONNECTION_STATE_STOPPED, but it might sometimes return CONNECTION_STATE_CONNECTED. \tC Stick\nSampling requests succeed immediately after waking from Sleep Mode and the connection state is retained.\nSpecifically, the nn::hid::ExtraPad::GetConnectionState function always returns CONNECTION_STATE_CONNECTED.\nThe value returned by the nn::hid::ExtraPad::IsSampling function also depends on the internal state, so that value changes at the same time.\nTo handle this behavior, we recommend calling nn::hid::ExtraPad::StopSampling to stop the sampling process before entering Sleep Mode. If you call nn::hid::ExtraPad::StopSampling, resume sampling by calling nn::hid::ExtraPad::StartSampling after waking from Sleep Mode. Nintendo also recommends this procedure before and after calling functions where the system could enter Sleep Mode before control returns to the application, such as the HOME Menu or a library applet.\n",0]
,["Pages/Page_55582546.html#Anchor_57066847_拡張スライドパッド補正アプレットでは中点補正および感度補正が行われない","No Center Point or Sensitivity Calibration in Circle Pad Pro Calibration Applet",
"No Center Point or Sensitivity Calibration in Circle Pad Pro Calibration Applet\nSNAKE works differently from CTR when the Circle Pad Pro Calibration Applet is called. On SNAKE, the system enters a mode to check the operation of the C Stick and displays a description of how the C Stick is calibrated.\nThis is because the C Stick center point is automatically calibrated at the following times.\n\tWhen power is turned on\nIf the C Stick is pressed when the power is turned on, it will not be calibrated correctly. Even so, it is still possible to correctly calibrate the C Stick after waking from Sleep Mode, as described below. \tWhen waking from Sleep Mode\nIt is physically impossible to operate the C Stick while the system is closed, so no C Stick input ever occurs during sleep. You can safely assume that the device was calibrated correctly in this case. \tDuring sampling (when the user is not using the control)\nThe application does not need to consider the effects of this calibration because it takes place when the C Stick output value is below the lower limit of the clamping.\n Warning:\n The center point calibration after Sleep Mode is triggered when the system wakes. Consequently, the calibration does not take place when the system is reopened if the application rejects the Sleep Mode request. The message that is displayed in the calibration applet tells the user to put the system to sleep by closing it.\n Note that center point calibration does not take place when an application rejects the sleep request for one of the following reasons.\n\tThe application does not want to disconnect even if the system is closed. \tThe system does not enter Sleep Mode when closed while in Sound Mode if headphones are connected.\n",0]
,["Pages/Page_55582546.html#PageId_55582572","6.3. MIC Library",
"\n6.3. MIC Library\nThe MIC library handles audio input from the microphone obtained by automatic sampling.\n",0]
,["Pages/Page_55582546.html#PageId_55582573","6.3.1. Buffer Allocation",
"Call the nn::mic::Initialize function to initialize the MIC library. The microphone can be used after this function successfully completes, but to sample microphone input in an application, you must take care of other preparations required for sampling, such as allocating the buffers for storing the sampling results, configuring the microphone gain, and dealing with microphone power control.\n6.3.1. Buffer Allocation\nThe application allocates the buffer for storing sampling results. The starting address of the buffer must be 4096-byte aligned, its size must be a multiple of 4096 bytes, and it must be allocated from non-device memory. Pass the allocated buffer to the MIC library using the nn::mic::SetBuffer function. The last 4 bytes of the buffer are set aside for management purposes, so the actual space available for storing sampling results is the value specified minus these 4 bytes. Use the nn::mic::GetSamplingBufferSize function to get the size of the buffer used to store sampling results.\nCalling the nn::mic::SetBuffer function after a buffer is already allocated causes an error. To reallocate a buffer, first call the nn::mic::ResetBuffer function and then call the nn::mic::SetBuffer function.\n",0]
,["Pages/Page_55582546.html#PageId_55582574","6.3.2. Microphone Gain Settings",
"\n6.3.2. Microphone Gain Settings\nThe microphone gain setting determines the amplification multiple for audio input from the microphone.\nUse the nn::mic::GetAmpGain and nn::mic::SetAmpGain functions to get and set the gain. You can set the gain in the range from 0 to 119 with each increase of 1 representing a 0.5 dB increment. 0 equates to 10.5 dB (a multiple of roughly 3.4), and 119 equates to 70.0 dB (a multiple of roughly 3162). As shown in the following table, the four gain levels for the NITRO microphone can be used by converting to gain setting values.\nTable 6-11. NITRO Settable Multiples and Gain Settings\n \t Ratio\n \t dB\n \t Gain Setting Values\n \t 20 x\n \t 26.0\n \t 31\n \t 40 x\n \t 32.0\n \t 43\n \t 80 x\n \t 38.0\n \t 55\n \t 160 x\n \t 44.0\n \t 67\n The microphone gain setting is set to AMP_GAIN_DEFAULT_VALUE when the library is initialized.\n",0]
,["Pages/Page_55582546.html#PageId_55582575","6.3.3. Microphone Power Control",
"\n6.3.3. Microphone Power Control\nUse the nn::mic::SetAmp function to control power to the microphone (microphone amp). Pass true as an argument to turn the microphone on. Microphone input is unstable immediately after turning the microphone on or recovering from sleep, so the first second of sampling is forcibly muted.\nCall the nn::mic::GetAmp function to get the current setting.\n",0]
,["Pages/Page_55582546.html#PageId_55582576","6.3.4. Start Sampling",
"\n6.3.4. Start Sampling\nThe preceding steps have prepared the microphone for sampling. Call the nn::mic::StartSampling function to start sampling automatically.\nCode 6-15. Start Microphone Sampling\n nn::Result nn::mic::StartSampling(\n nn::mic::SamplingType type, nn::mic::SamplingRate rate, s32 offset,\n size_t size, bool loop);\nSpecify the type of data to get in the type parameter. You can choose from the following four types of data, depending on factors such as your bit width and sign requirements.\nTable 6-12. Microphone Sampling Data Types\n \t Type\n \t Bit Width\n \t Signed\n \t Sampling Value Range\n \t Sampling Value Indicating Mute\n \t SAMPLING_TYPE_8BIT\n \t 8\n \t None\n \t 0 to 255\n \t 128\n \t SAMPLING_TYPE_16BIT\n \t 16\n \t None\n \t 0 to 65,535\n \t 32,768\n \t SAMPLING_TYPE_SIGNED_8BIT\n \t 8\n \t Yes\n \t –128 to 127\n \t 0\n \t SAMPLING_TYPE_SIGNED_16BIT\n \t 16\n \t Yes\n \t –32,768 to 32,767\n \t 0\n Specify the sampling rate in the rate parameter. You can choose from the following four sampling rates.\nTable 6-13. Microphone Sampling Rates\n \t Rate\n \t Sampling Rate\n \t SAMPLING_RATE_32730\n \t 32.73 kHz (32,728.498046875 Hz)\n \t SAMPLING_RATE_16360\n \t 16.36 kHz (16,364.2490234375 Hz)\n \t SAMPLING_RATE_10910\n \t 10.91 kHz (10,909.4993489583 Hz)\n \t SAMPLING_RATE_8180\n \t 8.18 kHz (8182.12451171875 Hz)\n Specify the offset from the start of the sampling data storage location (the start of the buffer) in the offset parameter. This value must be a multiple of 2 that is greater than or equal to 0.\nSpecify the number of bytes of sampling results to store for each sample in the size parameter. This value must be small enough that (offset + size) is no larger than the size specified when allocating the buffer.\nSpecify whether to continue sampling after storing size bytes of sampling results in the loop parameter. Pass true to continue sampling and treat the buffer as a ring buffer (the region of size bytes starting from offset).\nIf you call the nn::mic::StartSampling function while already sampling, the current sampling session is terminated and a new sampling session is started. If this function is called while the system is closed, it returns nn::mic::ResultShellClose and sampling does not begin. If the system is closed during ongoing sampling, sampling is automatically stopped and resumes when the system is opened.\nCall the nn::mic::AdjustSampling function to change the sampling rate during sampling. When you change the sampling rate this way, the new rate is used for sampling data starting from the current storage location.\nCall the nn::mic::IsSampling function to check whether the microphone is currently being sampled. However, this entails a significant processing burden because it sends a request directly to the device. It is not suitable for operations that involve calling at each frame.\n",0]
,["Pages/Page_55582546.html#PageId_55582577","6.3.4.1. Synchronization With Sound Processing",
"Call the nn::mic::SetLowPassFilter function and pass true in the enable parameter to apply a low-pass filter using a microphone input cutoff frequency of 45% of the sampling rate. The default value is false (no filtering). However, data sampled with a sampling rate of SAMPLING_RATE_32730 was sampled using a low-pass filter, so applying a low-pass filter using this function has no effect.\n6.3.4.1. Synchronization With Sound Processing\nThe DSP that processes sound and the processor that handles the microphone are separate devices. It is not possible to synchronize them perfectly. It is possible, however, to keep them in near synchronization by correcting differences in timing.\nKeep the timers in sync by periodically calculating mismatches between the sampling count and elapsed time of the microphone, and the playback time of the audio, and correct any offset. Also correct mismatches in the sampling frequency by calling Voice::SetPitch.\n",0]
,["Pages/Page_55582546.html#PageId_55582578","6.3.5. Getting Sampling Results",
"\n6.3.5. Getting Sampling Results\nCall the nn::mic::GetLastSamplingAddress function to get the address of the most recent sampling results.\nThe nn::os::Event class instance, which is obtainable by a call to the nn::mic::GetBufferFullEvent function, is a manually resetting event that enters the signaled state when the buffer cannot store any more sampling results. This event enters the signaled state when the buffer has stored size bytes of sampling results from the offset position and remains in the signaled state until the ClearSignal function is called.\nDue to differences in individual CTR systems in terms of the range of values obtained as input, the guaranteed input value ranges for each sampling type are defined by the TYPE_*_GUARANTEED_INPUT_MIN(MAX) constants. Do not design applications that expect values outside of these guaranteed input ranges when determining if there is microphone input.\nTable 6-14. Guaranteed Microphone Input Ranges for Each Sampling Type\n \t Sampling Type\n \t Lower Limit\n \t Upper Limit\n \t SAMPLING_TYPE_8BIT\n \t 27\n \t 228\n \t SAMPLING_TYPE_16BIT\n \t 7105\n \t 58415\n \t SAMPLING_TYPE_SIGNED_8BIT\n \t –101\n \t 100\n \t SAMPLING_TYPE_SIGNED_16BIT\n \t –25,663\n \t 25,647\n ",0]
,["Pages/Page_55582546.html#PageId_55582579","6.3.5.1. Prohibited Ranges for Microphone Input Determination",
"The default behavior is for microphone input values to be clamped to within these guaranteed ranges. If you need input values across a broader range, you can disable clamping by calling the nn::mic::SetClamp function, but note that you might still be unable to obtain input values from outside the guaranteed input ranges.\n6.3.5.1. Prohibited Ranges for Microphone Input Determination\nCall the nn::mic::GetForbiddenArea function, passing in the microphone amplifier gain setting and sampling type, to get the lower and upper limits for sampling results that must not be recognized as microphone input. The application must not recognize any sampling results with values between these lower and upper limits as microphone input. The obtainable values are shown in Table 6-15.\nThe rows shaded in light gray in Table 6-15 show where the gain is 68 (44.5 dB) or higher. In these ranges, microphone input is subject to marked static and other noise due to sources such as system speaker output, button clicks, and the sound of the stylus contacting the touch panel. These ranges are unsuitable for determining whether there is any microphone input based on amplitude levels. The rows in the table shaded in darker gray show where the gain is 104 (62.5 dB) or higher, where the full range of microphone input is noisy. Only use these ranges when invalid microphone input is not a problem.\nTable 6-15. Prohibited Ranges for Microphone Input Determination\n \t Sampling Type\n \t Gain\n \t dB\n \t Prohibited Ranges for Microphone Input Detection (Noise Component)\n \t SAMPLING_TYPE_8BIT\n \t 0 to 31\n \t 10.5 to 26.0\n \t 125 to 131\n \t 32 to 43\n \t 26.5 to 32.0\n \t 123 to 133\n \t 44 to 55\n \t 32.5 to 38.0\n \t 119 to 137\n \t 56 to 67\n \t 38.5 to 44.0\n \t 112 to 144\n \t 68 to 80\n \t 44.5 to 50.5\n \t 96 to 160\n \t 81 to 91\n \t 51.0 to 56.0\n \t 77 to 179\n \t 92 to 103\n \t 56.5 to 62.0\n \t 18 to 238\n \t 104 to 119\n \t 62.5 to 70.0\n \t 0 to 255\n \t SAMPLING_TYPE_16BIT\n \t 0 to 31\n \t 10.5 to 26.0\n \t 32,000 to 33,536\n \t 32 to 43\n \t 26.5 to 32.0\n \t 31,488 to 34,048\n \t 44 to 55\n \t 32.5 to 38.0\n \t 30,464 to 35,072\n \t 56 to 67\n \t 38.5 to 44.0\n \t 28,672 to 36,864\n \t 68 to 80\n \t 44.5 to 50.5\n \t 24,576 to 40,960\n \t 81 to 91\n \t 51.0 to 56.0\n \t 19,712 to 45,824\n \t 92 to 103\n \t 56.5 to 62.0\n \t 4608 to 60,928\n \t 104 to 119\n \t 62.5 to 70.0\n \t 0 to 65,535\n \t SAMPLING_TYPE_SIGNED_8BIT\n \t 0 to 31\n \t 10.5 to 26.0\n \t –3 to +3\n \t 32 to 43\n \t 26.5 to 32.0\n \t –5 to +5\n \t 44 to 55\n \t 32.5 to 38.0\n \t –9 to +9\n \t 56 to 67\n \t 38.5 to 44.0\n \t –16 to +16\n \t 68 to 80\n \t 44.5 to 50.5\n \t –32 to +32\n \t 81 to 91\n \t 51.0 to 56.0\n \t –51 to +51\n \t 92 to 103\n \t 56.5 to 62.0\n \t –110 to +110\n \t 104 to 119\n \t 62.5 to 70.0\n \t –128 to +127\n \t SAMPLING_TYPE_SIGNED_16BIT\n \t 0 to 31\n \t 10.5 to 26.0\n \t –768 to +768\n \t 32 to 43\n \t 26.5 to 32.0\n \t –1280 to +1280\n \t 44 to 55\n \t 32.5 to 38.0\n \t –2304 to +2304\n \t 56 to 67\n \t 38.5 to 44.0\n \t –4096 to +4096\n \t 68 to 80\n \t 44.5 to 50.5\n \t –8192 to +8192\n \t 81 to 91\n \t 51.0 to 56.0\n \t –13,056 to +13,056\n \t 92 to 103\n \t 56.5 to 62.0\n \t –28,160 to +28,160\n \t 104 to 119\n \t 62.5 to 70.0\n \t –32,768 to +32,767\n",0]
,["Pages/Page_55582546.html#PageId_55582580","6.3.6. Stop Sampling",
"\n6.3.6. Stop Sampling\nUse the nn::mic::StopSampling function to stop sampling. This function only stops sampling. It does not turn off power to the microphone.\n",0]
,["Pages/Page_55582546.html#PageId_55582581","6.3.7. Closing the MIC Library",
"\n6.3.7. Closing the MIC Library\nTo stop using input from the microphone, such as when quitting an application, first stop sampling, and then do the following.\n \tCall the nn::mic::SetAmp function and pass false as an argument to turn off the microphone power. \tCall the nn::mic::ResetBuffer function to free up allocated buffers. \tCall the nn::mic::Finalize function to close the MIC library.\nIf you want to stop sampling for a time and then sample more later, just turn off the microphone power to save battery life.\nThe microphone gain setting is set to AMP_GAIN_DEFAULT_VALUE when the library is closed.\n",0]
,["Pages/Page_55582546.html#PageId_55582582","6.4. Camera Library and Y2R Library",
"\n6.4. Camera Library and Y2R Library\n",0]
,["Pages/Page_55582546.html#PageId_55582583","6.4.1. Initializing",
"The camera library handles operations for the camera on the system. Images captured from the camera are only in YUV format. For conversion to RGB format, we recommend using the YUVtoRGB circuit, which also supports conversion to the native GPU format. Use the Y2R library for YUVtoRGB circuit operations.\n6.4.1. Initializing\nTo initialize the camera library, call the nn::camera::Initialize function; to initialize the Y2R library, call the nn::y2r::Initialize function. However, calling the initializers is not sufficient to prepare the camera and the YUVtoRGB circuit. You must also configure the settings for each and ready them to send and receive data.\n",0]
,["Pages/Page_55582546.html#PageId_55582584","6.4.2. Photography Environment Settings",
"\n6.4.2. Photography Environment Settings\nThis section describes the configurable settings for the photography environment. You must specify which camera to configure by selecting from the following options.\nTable 6-16. Specifying Which Camera to Configure\n \t Setting Value\n \t Target Camera\n \t SELECT_NONE\n \t Specifies no cameras. Used to, for example, configure standby settings.\n \t SELECT_OUT1\n \t Right outer camera.\n \t SELECT_IN1\n \t Inner camera.\n \t SELECT_IN1_OUT1\n \t Right outer camera and inner camera.\n \t SELECT_OUT2\n \t Left outer camera.\n \t SELECT_OUT1_OUT2\n \t Both left and right outer cameras.\n \t SELECT_IN1_OUT2\n \t Right outer camera and inner camera.\n \t SELECT_ALL\n \t All cameras. Both left and right outer cameras and inner camera.\n Using both outer cameras together with SELECT_OUT1_OUT2 is also called stereo mode, with the images taken by the outer cameras appearing in 3D. When doing so, make sure the photographic environment settings of the two cameras are the same.\n Note:\n For more information about stereoscopic display and calibration methods using the stereo camera, see 3DS Programming Manual: Advanced Graphics.\n Warning:\n Configuring the photographic environment settings while capturing could cause distortion of the captured images. Consequently, first pause capture and then configure the settings.\n When specifying SELECT_ALL, note that the cameras selected differ from in the past when there was only one outer camera.\n Note that configuring the photographic environment settings while the camera is restarting may cause the library’s processing to block for an extended period.\n Image data taken by the camera includes variations based on the camera itself, ambient light, and color variation in the subject. For example, camera variations include angle-of-view, resolution, color reproducibility, rotation, and distortion. An image taken with the same angle and camera setting is different in each system.\n",0]
,["Pages/Page_55582546.html#Anchor_55582584_解像度","Resolution",
"Resolution\nCall the nn::camera::SetSize function to configure the resolution of the images captured by the camera. The resolution is the size of the image before trimming. Choose from the following resolution options.\nTable 6-17. Resolution\n \t Setting Value\n \t Resolution\n \t Description\n \t SIZE_VGA\n \t 640 × 480\n \t VGA\n \t SIZE_QVGA\n \t 320 × 240\n \t QVGA\n \t SIZE_QQVGA\n \t 160 × 120\n \t QQVGA\n \t SIZE_CIF\n \t 352 × 288\n \t CIF (aspect ratio of 11:9)\n \t SIZE_QCIF\n \t 176 × 144\n \t QCIF (aspect ratio of 11:9)\n \t SIZE_DS_LCD\n \t 256 × 192\n \t Resolution of the DS LCD.\n \t SIZE_DS_LCDx4\n \t 512 × 384\n \t Resolution at twice the height and width of the DS LCD.\n \t SIZE_CTR_TOP_LCD\n \t 400 × 240\n \t Resolution of the 3DS upper LCD\n \t SIZE_CTR_BOTTOM_LCD\n \t 320 × 240\n \t Resolution of the 3DS lower LCD. Same as QVGA.\n Images captured using the SIZE_CIF, SIZE_QCIF, and SIZE_CTR_TOP_LCD settings have a 4:3 aspect ratio, with the left and right sides of the images trimmed.\nCall the nn::camera::SetDetailSize function to configure the other resolution settings. You can freely set the resolution of the captured images to crop from the original VGA-sized image by specifying the height and width of the output image. Make sure that the width and height are greater than or equal to the output image size. If not trimming, the output image width times the height must be a multiple of 128. To maintain compatibility, be sure to specify the cropX0 parameter as both an even number and a value that results in a multiple of 4 (cropX1 - cropX0 + 1).\nTo take images in stereo mode, make sure that the two cameras are set to the same resolution.\n",0]
,["Pages/Page_55582546.html#Anchor_55582584_鮮明度","Sharpness",
"Sharpness\nCall the nn::camera::SetSharpness function to set a camera's sharpness. Valid sharpness values range from -4 to +5.\n",0]
,["Pages/Page_55582546.html#Anchor_55582584_露光","Exposure",
"Exposure\nCall the nn::camera::SetExposure function to set the camera's exposure. Valid exposure values range from -5 to +5.\nCall the nn::camera::SetAutoExposure function to enable or disable the auto exposure (AE) feature. The exposure value is unstable immediately after starting up the camera, so we recommend leaving the AE feature enabled. Call the nn::camera::IsAutoExposure function to get the camera's current AE setting. Note that the AE feature is enabled when setting the exposure with the nn::camera::SetExposure function, even if you have disabled the AE feature previously.\nCall the nn::camera::SetAutoExposureWindow function to set the region used as the standard for automatic calculation when in automatic exposure mode. Specify this region as a portion of the 640 × 480 VGA maximum size of a captured image, changing the starting coordinates, width, and height within the following ranges. The three rightmost columns of the table show the initial setting values for the inner, right outer, and left outer cameras.\nTable 6-18. Specifying the Standard Region for Exposure\n \t Parameter\n \t Setting\n \t Setting Value Range\n \t IN1\n \t OUT1\n \t OUT2\n \t startX\n \t Starting coordinate (horizontal)\n \t 0 to 600 (in 40-pixel increments)\n \t 80\n \t 0\n \t 0\n \t startY\n \t Starting coordinate (vertical)\n \t 0 to 450 (in 30-pixel increments)\n \t 60\n \t 0\n \t 0\n \t width\n \t Width\n \t 40 to 640 (in 40-pixel increments) 640 or less when summed with startX\n \t 480\n \t 640\n \t 640\n \t height\n \t Height\n \t 30 to 480 (in 30-pixel increments) 480 or less when summed with startY\n \t 360\n \t 480\n \t 480\n ",0]
,["Pages/Page_55582546.html#Anchor_55582584_フレームレート","Frame Rate",
"Frame Rate\nCall the nn::camera::SetFrame Rate function to set how many frames per second (fps) to capture. You can choose from the following values. When in stereo mode, use the same frame rate for both outer cameras.\nTable 6-19. Frame Rate\n \t Setting Value\n \t Frame Rate\n \t FRAME_RATE_15\n \t Fixed at 15 fps.\n \t FRAME_RATE_15_TO_5\n \t Automatically varies from 15 to 5 fps depending on the available light.\n \t FRAME_RATE_15_TO_2\n \t Automatically varies from 15 to 2 fps depending on the available light.\n \t FRAME_RATE_10\n \t Fixed at 10 fps.\n \t FRAME_RATE_8_5\n \t Fixed at 8.5 fps.\n \t FRAME_RATE_5\n \t Fixed at 5 fps.\n \t FRAME_RATE_20\n \t Fixed at 20 fps.\n \t FRAME_RATE_20_TO_5\n \t Automatically varies from 20 to 5 fps depending on the available light\n \t FRAME_RATE_30\n \t Fixed at 30 fps.\n \t FRAME_RATE_30_TO_5\n \t Automatically varies from 30 to 5 fps depending on the available light.\n \t FRAME_RATE_15_TO_10\n \t Automatically varies from 15 to 10 fps depending on the available light.\n \t FRAME_RATE_20_TO_10\n \t Automatically varies from 20 to 10 fps depending on the available light.\n \t FRAME_RATE_30_TO_10\n \t Automatically varies from 30 to 10 fps depending on the available light.\n ",0]
,["Pages/Page_55582546.html#Anchor_55582584_ホワイトバランス","White Balance",
"White Balance\nCall the nn::camera::SetWhiteBalance function to set the camera's white balance. Choose from the following white balance setting values.\nTable 6-20. White Balance\n \t Setting Value\n \t Aliases\n \t Description\n \t WHITE_BALANCE_AUTO\n \t WHITE_BALANCE_NORMAL\n \t Automatic white balance.\n \t WHITE_BALANCE_3200K\n \t WHITE_BALANCE_TUNGSTEN\n \t Tungsten light (incandescent light bulb).\n \t WHITE_BALANCE_4150K\n \t WHITE_BALANCE_WHITE_FLUORESCENT_LIGHT\n \t White fluorescent.\n \t WHITE_BALANCE_5200K\n \t WHITE_BALANCE_DAYLIGHT\n \t Daylight.\n \t WHITE_BALANCE_6000K\n \t WHITE_BALANCE_CLOUDY\n \t Cloud cover.\n \t WHITE_BALANCE_HORIZON\n \t Sunset.\n \t WHITE_BALANCE_7000K\n \t WHITE_BALANCE_SHADE\n \t Shade.\n Call the nn::camera::SetWhiteBalance function and configure the white balance setting to WHITE_BALANCE_AUTO to enable the auto white balance feature. Any other setting value will disable the auto white balance feature.\nUse the nn::camera::SetAutoWhiteBalance function to enable or disable the auto white balance feature after enabling it by using WHITE_BALANCE_AUTO. If some other white balance setting was used other than WHITE_BALANCE_AUTO, you cannot use the nn::camera::SetAutoWhiteBalance function. Use the nn::camera::IsAutoWhiteBalance function to get the current auto white balance setting.\nCall nn::camera::SetAutoWhiteBalanceWindow to set the region used as the benchmark for auto white balance function when automatically calculating the white balance. Specify this region as a portion of the 640 × 480 VGA maximum size of a captured image, changing the starting coordinates, width, and height within the following ranges. The three rightmost columns of the table show the initial setting values for the inner, right outer, and left outer cameras.\nTable 6-21. Specifying the White Balance Standard Region\n \t Parameter\n \t Setting\n \t Setting Value Range\n \t IN1\n \t OUT1\n \t OUT2\n \t startX\n \t Starting coordinate (horizontal)\n \t 0 to 600 (in 40-pixel increments)\n \t 0\n \t 0\n \t 0\n \t startY\n \t Starting coordinate (vertical)\n \t 0 to 450 (in 30-pixel increments)\n \t 0\n \t 0\n \t 0\n \t width\n \t Width\n \t 40 to 640 (in 40-pixel increments) 640 or less when summed with startX\n \t 640\n \t 640\n \t 640\n \t height\n \t Height\n \t 30 to 480 (in 30-pixel increments) 480 or less when summed with startY\n \t 480\n \t 480\n \t 480\n Note:\n The automatic adjustment of the white balance may be degraded if there is little change in the input images, or the input image has little contrast, as with a plain wall.\n",0]
,["Pages/Page_55582546.html#Anchor_55582584_撮影モード","Photo Mode",
"Photo Mode\nCall the nn::camera::SetPhotoMode function to set the camera's photo mode to match the subject of the photo. Choose from the following values.\nTable 6-22. Photo Mode\n \t Setting Value\n \t Photo Mode\n \t Description\n \t PHOTO_MODE_NORMAL\n \t No correction\n \t No compensation is made to the camera settings.\n \t PHOTO_MODE_PORTRAIT\n \t Portrait mode\n \t Settings are configured for portrait photography.\n \t PHOTO_MODE_LANDSCAPE\n \t Landscape mode\n \t Settings are configured for landscape photography.\n \t PHOTO_MODE_NIGHTVIEW\n \t Night view mode\n \t Settings are configured for photography in limited light conditions.\n \t PHOTO_MODE_LETTER\n \t Text mode\n \t Settings configured for photographing a QR code or other written characters.\n Changing the photo mode overwrites the contrast, gain, sharpness, exposure, and white balance settings as follows, and changes the standard regions for exposure for the outer and inner cameras. When set to All, the start coordinate is (0, 0) with a height of 480 and a width of 640. When set to Center, the start coordinate is (80, 60) with a height of 360 and a width of 480.\nTable 6-23. Photography Environment Settings Changed by Changing the Photo Mode\n \t Photo Mode\n \t Contrast\n \t Gain\n \t Sharpness\n \t Exposure\n \t White Balance\n \t Outer\nCameras\n \t Inner\nCamera\n \t No correction\n \t NORMAL\n \t Normal\n \t 0\n \t 0\n \t NORMAL\n \t All\n \t Center\n \t Portrait mode\n \t LOW\n \t Normal\n \t –2\n \t 0\n \t NORMAL\n \t Center\n \t Center\n \t Landscape mode\n \t NORMAL\n \t Normal\n \t +1\n \t 0\n \t DAYLIGHT\n \t All\n \t Center\n \t Night view mode\n \t NORMAL\n \t Maximum\n \t –1\n \t +2\n \t NORMAL\n \t All\n \t Center\n \t Text mode\n \t HIGH\n \t Normal\n \t +2\n \t +2\n \t NORMAL\n \t All\n \t Center\n ",0]
,["Pages/Page_55582546.html#Anchor_55582584_反転処理","Flipping",
"Flipping\nCall the nn::camera::FlipImage function to specify how to flip the camera's output images. Choose from the following values.\nTable 6-24. Flipping\n \t Setting Value\n \t Flipping to Apply\n \t FLIP_NONE\n \t No flipping\n \t FLIP_HORIZONTAL\n \t Horizontal flipping\n \t FLIP_VERTICAL\n \t Vertical flipping\n \t FLIP_REVERSE\n \t Rotate image 180°\n ",0]
,["Pages/Page_55582546.html#Anchor_55582584_エフェクト","Effects",
"Effects\nCall the nn::camera::SetEffect function to specify any special effects to apply to the camera's output images. Choose from the following values.\nTable 6-25. Effects\n \t Setting Value\n \t Effect\n \t EFFECT_NONE\n \t No special effects\n \t EFFECT_MONO\n \t Monochrome\n \t EFFECT_SEPIA\n \t Sepia tone (ocher)\n \t EFFECT_NEGATIVE\n \t Negative\n \t EFFECT_NEGAFILM\n \t Film-tone negative Same as EFFECT_NEGATIVE, but with the U and V values swapped\n \t EFFECT_SEPIA01\n \t Sepia tone (red ocher)\n Applying an effect and then changing other settings may change the effect. To give an image a softer feel, apply a sepia effect and then reduce the image's sharpness; to give an image a warmer, redder look, apply the film-tone negative effect and then raise the image's color temperature.\n",0]
,["Pages/Page_55582546.html#Anchor_55582584_コントラスト","Contrast",
"Contrast\nCall the nn::camera::SetContrast function to set the camera's contrast (gamma curve). Choose from the following values.\nTable 6-26. Contrast\n \t Setting Value\n \t Contrast\n \t CONTRAST_PATTERN_n (n is 01 to 11)\n \t Contrast pattern number n.\n \t CONTRAST_HIGH\n \t Sets the contrast ratio to higher than the default value (pattern number 7).\n \t CONTRAST_NORMAL\n \t Default setting (pattern number 6).\n \t CONTRAST_LOW\n \t Sets the contrast ratio to lower than the default value (pattern number 5).\n ",0]
,["Pages/Page_55582546.html#Anchor_55582584_レンズ補正","Lens Correction",
"Lens Correction\nLens correction is a means of adjusting differences in brightness that may occur between the center and edges of an image by raising the brightness of the edges to more closely match the center. Call the nn::camera::SetLensCorrection function to set the camera's lens correction. Choose from the following values.\nTable 6-27. Lens Correction\n \t Setting Value\n \t Lens Correction\n \t LENS_CORRECTION_OFF\n \t Disables lens correction.\n \t LENS_CORRECTION_ON_70\n \t Enables lens correction at a value of 70.\n \t LENS_CORRECTION_ON_90\n \t Enables lens correction at a value of 90.\n \t LENS_CORRECTION_DARK\n \t Sets edges to be darker than the default setting (LENS_CORRECTION_OFF).\n \t LENS_CORRECTION_NORMAL\n \t Default setting (LENS_CORRECTION_ON_70).\n \t LENS_CORRECTION_BRIGHT\n \t Sets edges to be brighter than the default setting (LENS_CORRECTION_ON_90).\n ",0]
,["Pages/Page_55582546.html#Anchor_55582584_コンテキスト","Context",
"Context\nUse contexts to switch multiple photography environment settings at the same time. Use the nn::camera::SwitchContext function to switch contexts. Each camera has two contexts, A and B, for a total of six sets of settings. These contexts can be switched independently, so the outer camera can be in context A, while the inner camera is in context B.\nEach context can specify three settings: resolution, flipping, and special effects.\n",0]
,["Pages/Page_55582546.html#Anchor_55582584_ノイズフィルタ","Noise Filter",
"Noise Filter\nWhen the screen changes from bright to dark or from dark to bright, the camera module applies a noise filter to remove noise from the automatically captured image. The images captured from one of the outer cameras may appear fuzzy when in stereo mode with this noise filter feature enabled. To prevent this, call the nn::camera::SetNoiseFilter function and pass false for the on parameter to disable the noise filter. Pass true for the on parameter to enable the noise filter. All cameras have the noise filter enabled by default.\n",0]
,["Pages/Page_55582546.html#Anchor_55582584_撮影環境の一括設定","Configuring Photography Environment Settings in Batch",
"Configuring Photography Environment Settings in Batch\nThe API provides a feature to simultaneously configure all of the photography environment settings.\nCall the nn::camera::SetPackageParameterWithoutContext function to configure all photography environment settings with no context value specified (other than resolution, flipping, and effects).\nCall the nn::camera::SetPackageParameterWithContext function to configure all photography environment settings with context values specified (resolution, flipping, and effects).\n",0]
,["Pages/Page_55582546.html#PageId_55582598","6.4.3. Capture Settings",
"\n6.4.3. Capture Settings\nThe images captured by the camera are written line by line in FIFO order, with the YUV-format data sent to a buffer prepared by the application. The application then sends the data to the YUVtoRGB circuit and the resulting RGB-format data to a buffer. The following diagram shows this set of operations.\nFigure 6-13. Captured Image Data Flow\nCamera FIFO(10KByte) YUVtoRGB Output Buffer Buffer(YUV) Buffer(RGB) CameraModule CapturedImage Hardware Application nn::camera::SetReceiving() nn::y2r::SetSendingYuv() Data Transfer nn::y2r::SetReceiving()\nThe following sections describe the settings required to take YUV-format image data through to the application buffer.\n",0]
,["Pages/Page_55582546.html#Anchor_55582598_ポートについて","About Ports",
"About Ports\nAs with the stereo mode, it is possible to use two cameras at once, making it necessary to specify which camera to use for acquiring captured images. Of the three cameras, the inner camera and the right outer camera are connected to one port, and the left outer camera is connected to its own port.\nMost functions that configure image capture require that a port be specified, using the following enumerators.\nTable 6-28. Port Specifications\n \t Enumerator\n \t Description\n \t PORT_NONE\n \t No port is specified.\n \t PORT_CAM1\n \t Specifies the port to which the inner and right outer cameras are connected.\n \t PORT_CAM2\n \t Specifies the port to which the left outer camera is connected.\n \t PORT_BOTH\n \t Specifies both ports.\n ",0]
,["Pages/Page_55582546.html#Anchor_55582598_トリミング","Trimming",
"Trimming\nTrimming crops a captured image to the size required by the application. Trim an image if the camera's resolution and the required size of the captured image differ.\nCall the nn::camera::SetTrimming function to enable or disable trimming. Call the nn::camera::SetTrimmingParams or nn::camera::SetTrimmingParamsCenter functions to specify the range to trim. Call the nn::camera::IsTrimming function to check whether trimming is currently enabled, and call the nn::camera::GetTrimmingParams functions to get the trimming range.\n Warning:\n Set trimming prior to capturing images.\nWhen setting the trimming position and range using the nn::camera::SetTrimmingParams function, specify the position to start trimming as (x1, y1) and the position to stop trimming as (x2, y2). The (x1, y1) coordinate is included in the trimming operation, but the (x2, y2) coordinate is excluded. The following limitations apply to these settings.\n\tThe x1 and y1 coordinate values for the trimming start position must be even values. \tx1 must be less than x2, and y1 must be less than y2. \tThe post-trimming width (x2 – x1) and height (y2 – y1) must also be even values. \tThe post-trimming image width times the height must be a multiple of 128.\nWhen setting the trimming position and range using the nn::camera::SetTrimmingParamsCenter function, specify the trimming size width and height (trimWidth and trimHeight) and the camera resolution width and height (camWidth and camHeight) for trimming based on the center of the captured image. The following code gives an example of how the (x1, y1) and (x2, y2) coordinates are calculated. Be sure that the calculated positions meet the restrictions described for the SetTrimmingParams function.\nCode 6-16. Calculating Positions for Centered Trimming\n x1 = (camWidth - trimWidth) / 2;\ny1 = (camHeight - trimHeight) / 2;\nx2 = x1 + trimWidth;\ny2 = y1 + trimHeight;\nThe captured image size sent to the buffer is the trimmed size. The cost of a transfer is still the same for different camera resolutions, provided you trim the images to the same size. However, trimming high-resolution images may cause the image to appear compressed due to the narrower field of view.\n",0]
,["Pages/Page_55582546.html#Anchor_55582598_転送バイト（ライン）数","Number of Transfer Bytes (Lines)",
"Number of Transfer Bytes (Lines)\nThe images captured by the camera are stored by the hardware FIFO line by line, and then written with multiple transfers to the buffer prepared by the application. The FIFO capacity is fixed at 10 KB. The number of bytes sent in a single transfer must meet the following conditions.\n\tThe number of bytes sent in a single transfer must be a multiple of 256. \tThe number of bytes sent in a single transfer must be no more than 10 KB (10,240 bytes). \tThe total number of transfer bytes must be a multiple of the number of bytes sent in a single DMA transfer.\nThe total number of transfer bytes is the width times the height of the trimmed image, multiplied by 2, which is the number of bytes per pixel.\nCall the nn::camera::SetTransferLines function to set the number of bytes in a single transfer in terms of the number of lines. You can simply set the single-transfer line count to the value returned by the nn::camera::GetMaxLines function, but note that execution halts in this function if the number of lines does not match the conditions described above. If you cannot set the number of lines, such as when setting an optional resolution using the nn::camera::SetDetailSize function, instead call the nn::camera::SetTransferBytes function to set the number of bytes in a single transfer. You can simply set the single-transfer byte count to the value returned by the nn::camera::GetMaxBytes function, but note that execution halts in this function if the number of bytes (width × height × 2) is not a multiple of 256.\n Warning:\n Set the number of transfer bytes (lines) prior to capturing images. To prevent buffer errors, the GetMaxLines and GetMaxBytes functions calculate FIFO capacity as 5 KB.\nCall the nn::camera::GetTransferBytes function to get the current balance setting.\n",0]
,["Pages/Page_55582546.html#Anchor_55582598_受信バッファ","Receive Buffer",
"Receive Buffer\nCall the nn::camera::GetFrameBytes function to get the size of the buffer required for receiving one frame of captured video. The starting address of the buffer is 4-byte aligned. An alignment below 64 bytes may reduce the transfer rate. Only a buffer allocated in device memory may be specified.\n",0]
,["Pages/Page_55582546.html#PageId_55582603","6.4.4. Starting Capture",
"\n6.4.4. Starting Capture\nBefore transferring or capturing an image, call the nn::camera::Activate function to activate the camera to use for capture. You cannot activate the inner camera and the outer camera (R) at the same time, because the two cameras are connected to the same port. The outer camera (L) is connected to a different port. You can activate it at the same time as either the inner camera or the outer camera (R).\nAfter making sure that the camera is active, call nn::camera::SetReceiving to begin transfer, and then call nn::camera::StartCapture to begin image capture.\nCode 6-17. nn::camera::SetReceiving Function\n void nn::camera::SetReceiving(nn::os::Event* pEvent, void* pDst,\n nn::camera::Port port, size_t imageSize, s16 transferUnit);\nSpecify the event for receiving notification that transfer has completed in the pEvent parameter. Specify the starting address of the receive buffer in pDst. Specify the port in port. Specify the byte size of a single frame of captured video (the receive buffer size) in imageSize. In transferUnit, specify the byte size of the data in a single transfer as returned by nn::camera::GetTransferBytes.\nYou can call nn::camera::IsFinishedReceiving to get whether the single frame of captured video has finished transferring.\nTo check whether an error has occurred during capture, such as during FIFO writing, check whether the error event returned by nn::camera::GetBufferErrorInterruptEvent is in the signaled state. If a buffer error has occurred, this error event is in the signaled state and is an automatically resetting event of the nn::os::Event class. This error event also changes to a signal state when a camera error causes the camera to restart. Recover from an error by restarting in the order of transfer, and then capture.\nYou can call nn::camera::IsBusy to find out whether the camera is currently capturing an image. You can also call nn::camera::GetVsyncInterruptEvent to get the event that enters the signaled state when the camera's VSYNC interrupt occurs. Use this function in a process that synchronizes with camera VSYNC, or in a process that changes the camera environment when a frame is not being transferred.\nCall nn::camera::SynchronizeVsyncTiming to synchronize the camera VSYNC interrupt timing, such as when you are using the stereo camera to display in stereoscopic view. This function attempts to synchronize the VSYNC interrupt timing of the two cameras. This process does not maintain the synchronization. The function must be called again when synchronization is lost. The four frames after calling this function may be very dark, because it places the camera into standby before restarting it. The two cameras have a small gap in the timing of the image capture being sent, even if the cameras have the same configuration. VSYNC interrupt timing has a large gap after calling nn::camera::Activate to start the camera, or when changing the camera configuration even when capturing video with the same configuration and fixed frame rate.\nThe capture image (YUV4:2:2 format) is output in the following alignment.\n \t + 0 Byte\n \t + 1 Byte\n \t + 2 Byte\n \t + 3 Byte\n \t Y (n)\n \t U (n)\n \t Y (n + 1)\n \t V (n)\n ",0]
,["Pages/Page_55582546.html#PageId_55582604","6.4.5. YUVtoRGB Circuit Settings",
"\n6.4.5. YUVtoRGB Circuit Settings\nUse the YUVtoRGB circuit to convert YUV-format data to RGB format at the hardware level. This circuit also supports output to the native GPU block format. However, the CTR system is only equipped with one YUVtoRGB circuit. When converting captured images from multiple cameras, such as when in stereo mode, use a mutex or other mechanism to make sure that multiple conversion requests are not issued simultaneously.\nThis section describes settings related to data conversion using the YUVtoRGB circuit.\n",0]
,["Pages/Page_55582546.html#Anchor_55582604_入力フォーマット","Input Format",
"Input Format\nCall the nn::y2r::SetInputFormat function to set the input YUV data format. Call the nn::camera::GetInputFormat function to get the current setting. Choose from the following values.\nTable 6-29. Input Format\n \t Setting Value\n \t Format\n \t INPUT_YUV422_INDIV_8\n \t Input the individual Y, U, and V values for YUV4:2:2 as 8 bits each.\n \t INPUT_YUV420_INDIV_8\n \t Input the individual Y and U values for YUV4:2:0 as 8 bits each.\n \t INPUT_YUV422_INDIV_16\n \t Input the individual Y, U, and V values for YUV4:2:2 as 16 bits each (padding required).\n \t INPUT_YUV420_INDIV_16\n \t Input the individual Y and U values for YUV4:2:0 as 16 bits each (padding required).\n \t INPUT_YUV422_BATCH\n \t Input the Y, U, and V values for YUV4:2:2 all together in 32 bits.\n The data formats for each value are shown below.\nYUV4:2:2/YUV4:2:0 individual input (8 bit)\n \t Component\n \t + 0 Byte\n \t + 1 Byte\n \t + 2 Byte\n \t + 3 Byte\n \t Y\n \t Y (n)\n \t Y (n + 1)\n \t Y (n + 2)\n \t Y (n + 3)\n \t U\n \t U (n)\n \t U (n + 1)\n \t U (n + 2)\n \t U (n + 3)\n \t V\n \t V (n)\n \t V (n + 1)\n \t V (n + 2)\n \t V (n + 3)\n YUV4:2:2/YUV4:2:0 individual input (16 bit padding)\n \t Component\n \t + 0 Byte\n \t + 1 Byte\n \t + 2 Byte\n \t + 3 Byte\n \t Y\n \t Y (n)\n \t padding\n \t Y (n + 1)\n \t padding\n \t U\n \t U (n)\n \t padding\n \t U (n + 1)\n \t padding\n \t V\n \t V (n)\n \t padding\n \t V (n + 1)\n \t padding\n YUV4:2:2 batch input\n \t Component\n \t + 0 Byte\n \t + 1 Byte\n \t + 2 Byte\n \t + 3 Byte\n \t YUV\n \t Y (n)\n \t U (n)\n \t Y (n + 1)\n \t V (n)\n You can only get captured images from the camera in YUV batch format. In most cases, specify INPUT_YUV422_BATCH when converting captured images.\n",0]
,["Pages/Page_55582546.html#Anchor_55582604_1ラインの幅と入力ライン数","Line Width and Line Count",
"Line Width and Line Count\nCall the nn::y2r::SetInputLineWidth function to specify the line width of the data to convert (the input data). Call the nn::y2r::GetInputLineWidth function to get the current setting. The line width must be set to a multiple of 8, up to a maximum value of 1024.\nCall the nn::y2r::SetInputLines function to set the number of input lines. Call the nn::y2r::GetInputLines function to get the current setting.\n",0]
,["Pages/Page_55582546.html#Anchor_55582604_出力フォーマット","Output Format",
"Output Format\nThe data converted by the YUVtoRGB circuit is stored in the output buffer. Call the nn::y2r::SetOutputFormat function to set the output data format. Call the nn::camera::GetOutputFormat function to get the current setting. Choose from the following output formats.\nTable 6-30. Output Format\n \t Setting Value\n \t Format\n \t OUTPUT_RGB_32\n \t 32-bit RGB (RGBA8888)\n \t OUTPUT_RGB_24\n \t 24-bit RGB (RGB888)\n \t OUTPUT_RGB_16_555\n \t 16-bit RGB (RGBA8888)\n \t OUTPUT_RGB_16_565\n \t 16-bit RGB (RGB565)\n The data formats for each value are shown below.\n32-bit RGB (OUTPUT_RGB_32)\n+0 Byte +1 Byte +2 Byte +3 Byte A [7 : 0] B (n) G (n) R (n)\n24-bit RGB (OUTPUT_RGB_24)\n+0 Byte +1 Byte +2 Byte R (n) G (n) B (n)\n16-bit RGB (OUTPUT_RGB_16_555)\n+0 Byte +1 Byte +2 Byte +3 Byte 5 bit 5 bit 5 bit 1 bit 5 bit 5 bit 5 bit 1 bit R (n) G (n) B (n) A [7] R (n + 1) G (n + 1) B (n + 1) A [7]\n16-bit RGB (OUTPUT_RGB_16_565)\n+0 Byte +1 Byte +2 Byte +3 Byte 5 bit 6 bit 5 bit 5 bit 6 bit 5 bit R (n) G (n) B (n) R (n + 1) G (n + 1) B (n + 1)\nFormats that output the alpha component use the alpha value that was set by the nn::y2r::SetAlpha function. The OUTPUT_RGB_32 format uses bits 0 to 7 of the set alpha value, while the OUTPUT_RGB_16_555 format only uses the 7th bit. Call the nn::camera::GetAlpha function to get the current alpha value.\n",0]
,["Pages/Page_55582546.html#Anchor_55582604_ブロックアライメント","Block Alignment",
"Block Alignment\nCall the nn::y2r::SetBlockAlignment function to set the block alignment for the data stored in the output buffer. Call the nn::camera::GetBlockAlignment function to get the current setting. Choose from the following block alignments.\nTable 6-31. Block Alignment\n \t Setting Value\n \t Block Alignment\n \t BLOCK_LINE\n \t Horizontal line format. The usual linear format. The 24-bit and 32-bit RGB output formats cannot be used directly as OpenGL standard-format textures due to byte-order issues.\n \t BLOCK_8_BY_8\n \t 8x8 block format. This is the native GPU block format. Data in this format can be used as native-format textures.\n Warning:\n When using BLOCK_8_BY_8 block alignment, the input image height (vertical line count) must be a multiple of 8.\n",0]
,["Pages/Page_55582546.html#Anchor_55582604_出力バッファ","Output Buffer",
"Output Buffer\nYou can call the nn::y2r::GetOutputImageSize function to get the size of the buffer required for receiving one frame of output data. The starting address of the buffer is 4-byte aligned. An alignment below 64 bytes may reduce the transfer rate. Only a buffer allocated in device memory may be specified.\n",0]
,["Pages/Page_55582546.html#Anchor_55582604_変換係数","Conversion Coefficient",
"Conversion Coefficient\nChoose the coefficient for YUV to RGB conversion from the following standard conversion coefficients. Call the nn::y2r::SetStandardCoefficient function to set the conversion coefficient.\nSelect the type of conversion coefficient for converting images output by the cameras from those returned by the nn::camera::GetSuitableY2rStandardCoefficient function. When making a selection, consider the possibility of future changes in the camera module.\nYou can choose from the following four types of standard conversion coefficients.\nTable 6-32. Types of Standard Conversion Coefficient\n \t Setting Value\n \t Conversion Coefficient Type (Value Range)\n \t COEFFICIENT_ITU_R_BT_601\n \t ITU-R BT.601 (0 ≤ Y, U, V ≤ 255)\n \t COEFFICIENT_ITU_R_BT_709\n \t ITU-R BT.709 (0 ≤ Y, U, V ≤ 255)\n \t COEFFICIENT_ITU_R_BT_601_SCALING\n \t ITU-R BT.601 (16 ≤ Y ≤ 235, 16 ≤ U, V ≤ 240)\n \t COEFFICIENT_ITU_R_BT_709_SCALING\n \t ITU-R BT.709 (16 ≤ Y ≤ 235, 16 ≤ U, V ≤ 240)\n ",0]
,["Pages/Page_55582546.html#Anchor_55582604_回転","Rotation",
"Rotation\nYou can rotate an image when converting the format. To specify how many degrees to rotate an image, call the nn::y2r::SetRotation function; to get the current rotation degree setting, call the nn::y2r::GetRotation function. You can choose from the following four rotation settings, including no rotation.\nTable 6-33. Rotation Angle\n \t Setting Value\n \t Rotation Angle\n \t ROTATION_NONE\n \t No rotation.\n \t ROTATION_CLOCKWISE_90\n \t Clockwise 90°\n \t ROTATION_CLOCKWISE_180\n \t 180°\n \t ROTATION_CLOCKWISE_270\n \t Clockwise 270° (counterclockwise 90°)\n When you rotate an image, the post-conversion data no longer has valid image data ordering. Consequently, your application must correct the data ordering after receiving each frame.\n Note:\n This may be changed in the future so that valid data ordering is output by transfer.\nFigure 6-14. Output Data Ordering Differences Due to Block Alignment and Rotation\nROTATION_NONE ROTATION_CLOCKWISE_90 ROTATION_CLOCKWISE_180 ROTATION_CLOCKWISE_270 Output Buffer BLOCK_LINE BLOCK_8_BY_8\n",0]
,["Pages/Page_55582546.html#Anchor_55582604_一括設定","Batch Configuring",
"Batch Configuring\nCall the nn::y2r::SetPackageParameter function to configure all of the YUVtoRGB circuit settings at the same time. You can get all the settings at the same time using the nn::y2r::GetPackageParameter function.\n",0]
,["Pages/Page_55582546.html#PageId_55582613","6.4.6. Starting Format Conversion",
"\n6.4.6. Starting Format Conversion\nData conversion is carried out in parallel with sending and receiving, so preparations for sending and receiving data must be completed before conversion is begun.\nUse the following functions to prepare to send input data. nn::y2r::SetSendingYuv for batched YUV data. nn::y2r::SetSendingY for just the Y data. nn::y2r::SetSendingU for just the U data. nn::y2r::SetSendingV for just the V data. These functions take the input data buffer's size, the total transfer data size, and the size of one line of input data, specified in bytes, as arguments. Only a buffer allocated in device memory may be specified. Note that the total transfer data size must be a multiple of the size of one line. The offset value added when one line of input data is transferred (transferStride) may be specified for any of these functions.\nCall nn::y2r::SetReceiving to prepare to receive output data. In the arguments, specify the buffer storing the output data, the total size of the data to receive, and the transfer size of a single chunk of received data in bytes. You cannot specify a buffer in VRAM. Only a buffer allocated in device memory may be specified. To improve performance, we recommend specifying the transfer size as the size of eight lines of output data. Call the nn::camera::GetOutputImageSize function to get the current setting. The size value specified for eight lines must be the size of a single pixel in bytes returned by the nn::y2r::GetOutputFormatBytes function multiplied by the width of a single line multiplied by 8. You can also specify an offset value added to each transfer (transferStride). To add an offset to each line, specify the size of one line of output data for the size of a single transfer.\nA good time to prepare to send and receive data is immediately after the event specified by the nn::camera::IsFinishedReceiving or nn::camera::a SetReceiving function is in the signaled state, which indicates that the captured image has been fully received and you have confirmed the input data. Before preparing to send or receive data, call the nn::y2r::IsBusyConversion function to check whether the system is busy converting formats.\nCall the nn::y2r::StartConversion function to begin format conversion after data send/receive preparations are complete. Data is sent and received at the same time as format conversion begins. Call the nn::y2r::StopConversion function if you must forcibly halt format conversion, such as when an error occurs during capture operations.\nCall the nn::y2r::IsBusyConversion function to check whether the system is busy converting formats. To check whether the system has completed sending input data, call the nn::y2r::IsFinishedSendingYuv function for batched YUV data, the nn::y2r::IsFinishedSendingY function for just the Y data, the nn::y2r::IsFinishedSendingU function for just the U data, and the nn::y2r::IsFinishedSendingV function for just the V data. To check whether the system has finished receiving output data, call the nn::y2r::IsFinishedReceiving function.\nYou can use a combination of these functions to check whether format conversion and data transmission has completed for a frame. You can also check whether data transfer is complete by using the event class (automatically resetting event) returned by the nn::y2r::GetTransferEndEvent function. This event class receives an interrupt notification when transfer has completed. The nn::y2r::SetTransferEndInterrupt function must be called to enable interrupt notifications before getting the event class. (The default is to disable them.) Call the nn::y2r::GetTransferEndInterrupt function to check whether notifications are currently enabled.\nA hardware bug prevents the transfer completion event obtained by the nn::y2r::GetTransferEndEvent function from being signaled, and prevents the nn::y2r::IsBusyConversion function from returning true, if the following (rare) sequence occurs: (1) while using the cameras and YUVtoRGB circuit simultaneously, (2) a buffer error occurs during camera data transfer, and (3) during recovery from that error the processing of the nn::camera::SetReceiving function overlaps the YUVtoRGB circuit data transfer processing at a particular time. For this reason, always make sure to specify a timeout when waiting for the signal status of a transfer completion event.\nSpecify a timeout longer than the time required for conversion. The time required for conversion depends on the size of the input image and the output format. Output of a VGA image in 16-bit RGB format takes about 13 milliseconds. Output of a VGA image in 24-bit RGB format takes about 16 milliseconds.\nIf this bug occurs, forcibly terminate conversion by calling the nn::y2r::StopConversion function. This makes the YUVtoRGB circuit usable again.\nThe probability of occurrence of this bug is proportional to the frequency of camera buffer errors, so use the camera under conditions where buffer errors are unlikely to arise. When buffer errors occur frequently, respond by lowering the camera frame rate or with another method. Also, set a higher priority for the thread that calls the nn::camera::SetReceiving function.\n",0]
,["Pages/Page_55582546.html#PageId_55582614","6.4.7. Playing the Shutter Sound",
"\n6.4.7. Playing the Shutter Sound\nThe shutter sound is forcibly played even when the speaker volume is set to 0 and the camera LED is temporarily turned off.\n Note:\n SNAKE and FTR do not have a camera indicator LED.\nCode 6-18. Playing the Shutter Sound\n nn::Result nn::camera::PlayShutterSound(nn::camera::ShutterSoundType type);\nSpecify one of the following shutter sound types for the type parameter.\nTable 6-34. Shutter Sound Types\n \t Setting Value\n \t Shutter Sound Type\n \t SHUTTER_SOUND_TYPE_NORMAL\n \t Normal shutter sound.\n \t SHUTTER_SOUND_TYPE_MOVIE\n \t Sound played when starting video capture.\n \t SHUTTER_SOUND_TYPE_MOVIE_END\n \t Sound played when ending video capture.\n ",0]
,["Pages/Page_55582546.html#PageId_55582615","6.4.8. Ending Capture",
"\n6.4.8. Ending Capture\nTo stop image capture, do the following. Stopping image capture without following the steps below can lead to audio noise when displaying the HOME Menu.\n \tCall the nn::y2r::StopConversion function to stop format conversion. \tCall the nn::camera::StopCapture function to stop capture. \tCall nn::camera::Activate(SELECT_NONE) to put all cameras into standby mode. \tCall the nn::camera::Finalize and nn::y2r::Finalize functions to close the camera and Y2R libraries.\n",0]
,["Pages/Page_55582546.html#PageId_55582616","6.4.9. Support for Sleep Mode",
"\n6.4.9. Support for Sleep Mode\nnn::camera::ResultIsSleeping (or nn::y2r::ResultIsSleeping) is returned to indicate the system is closed when a Camera (or Y2R) library function is called while the system is closed. This includes during initialization. Note that this return value is returned as long as the system is closed, even if it is not in Sleep Mode.\nThe camera is designed so that operations stop if the system is closed, regardless of Sleep Mode. If the system is closed while capturing an image, capture resumes when the system is opened. Note, however, that when capture resumes there is a period of time immediately after the camera is activated by the Activate function where the image is unstable. This is due to processing equivalent to the nn::camera::Activate(SELECT_NONE) function being performed inside the library when the system is closed. There is also a possibility that the system will enter a state where the IsBusy function always returns true depending on the exact timing the system was closed. This status will be canceled when the system is opened, but do not perform polling using the IsBusy function if a process for entering Sleep Mode when the system is closed has been implemented.\nIf the system enters sleep in the midst of RGB conversion by the Y2R library, conversion is forcibly terminated. Conversion does not resume after recovering from sleep. If supporting sleep, do not enter sleep during conversion (when the IsBusyConversion function returns true or while waiting for an event obtained by the GetTransferEndEvent function). Implement code so that the system only enters sleep after checking that conversion is complete. Particularly note that events will not enter signal status after recovering from sleep if sleep is entered while waiting for an event obtained using the GetTransferEndEvent function.\n",0]
,["Pages/Page_55582546.html#PageId_55582617","6.4.10. Conflicts With Camera Mode",
"\n6.4.10. Conflicts With Camera Mode\nYou cannot press the L Button and the R Button simultaneously to enter camera mode from the HOME Menu while an application is using the cameras. If you attempt to do so, a dialog box is displayed with a message stating that the cameras are in use.\nThe cameras are considered to be in use if either the CAMERA or the Y2R library has been initialized. If an application that uses the cameras initializes either of these libraries when it is started, the cameras are considered to be in use when the HOME Menu is displayed even if the application is not actually using them. Even if the Y2R library alone is used to convert YUV images into RGB images—during movie playback, for example—the cameras are considered to be in use and the system does not enter camera mode.\nInitialize the CAMERA and Y2R libraries just before you use them and shut them down afterwards whenever you can. Do not leave the CAMERA and Y2R libraries initialized while they are not in use.\nCONFIDENTIAL\n",0]
,["Pages/Page_55582618.html","7. File System ",
"7. File System\n",0]
,["Pages/Page_55582618.html#PageId_55582619","7.1. FS Library",
"This chapter describes the FS library used to access media and cautions for each media type.\n7.1. FS Library\n",0]
,["Pages/Page_55582618.html#PageId_55582620","7.1.1. Initializing",
"You must use the FS library to access 3DS system memory devices (Nintendo 3DS Cards and SD cards).\n7.1.1. Initializing\nCall the nn::fs::Initialize function to initialize the FS library. It is not a problem to call this function again even after the library is already initialized.\nFunction calls against files or directories cause an error unless they are made after the FS library is initialized.\n",0]
,["Pages/Page_55582618.html#PageId_55582621","7.1.2. Finalizing",
"\n7.1.2. Finalizing\nTo finish using the FS library, close all open files and directories, and unmount all archives.\nYou must also either finalize or cancel use of the FS library when shutting down the application and when transitioning to Sleep Mode. For more information, see 5.3.1.1. Cautions When Shutting Down and 5.3.3.4. Prohibited Processes While in Sleep Mode.\n",0]
,["Pages/Page_55582618.html#PageId_55582622","7.1.3. Specifying Paths",
"\n7.1.3. Specifying Paths\nAll paths (to files or directories) must be specified as absolute paths. The “/” symbol (slash) is used as the path delimiter.\nYou can use wide or multiple-byte characters (ASCII characters only) in path specification strings used with FS library functions. However, keep track of the stack size when using multiple-byte strings, because the library must convert multiple-byte strings to wide-character strings, which requires the allocation of a large buffer from the stack. Consequently, use wide-character strings unless you have a good reason not to.\n",0]
,["Pages/Page_55582618.html#PageId_55582623","7.1.4. Accessing Files",
"\n7.1.4. Accessing Files\nChoose the best class for your purposes from the following three types for accessing files on media.\nTable 7-1. Classes Used for File Access\n \t Class\n \t Description\n \t nn::fs::FileInputStream\n \t Opens a file for reading.\n \t nn::fs::FileOutputStream\n \t Opens a file for writing. If the specified file does not exist, one may be created depending on the settings specified in the class initialization.\n \t nn::fs::FileStream\n \t Opens a file for reading and writing, depending on the access mode specified.\n Warning:\n Much as with Initialize and TryInitialize, the functions used for file access have versions prepended with and without Try. Both versions operate the same way, but be sure to use the Try versions within your application.\n FS library functions generally do not return until they complete their execution. The library also processes file-access requests in the order they arrive, so a file access by a high-priority thread will not be processed until the file accesses requested before it have completed.\n",0]
,["Pages/Page_55582618.html#PageId_55582624","7.1.4.1. nn::fs::FileInputStream Class",
"\n7.1.4.1. nn::fs::FileInputStream Class\nUse this class to open a file for reading. Specify the file for reading in the arguments to the constructor or to the Initialize or TryInitialize functions. The application halts if the file specified in the arguments to the constructor or to the Initialize function does not exist. Use the return value from the TryInitialize function instead for error checking. The application halts if file access is attempted from an instance that did not successfully open the file or if the file is opened again from an instance that already has it open.\nUse the GetSize or TryGetSize functions to get the size of the file. This can be used to determine the size to use for the read buffer.\nUse the Read or TryRead functions to read a file. The arguments specify the buffer into which to copy file contents, and the size of the buffer. The return value is the number of bytes actually copied to the buffer, or 0 if the end of the file has been reached. If at all possible, allocate the buffer with a 4-byte alignment. Though dependent on device and memory region, read speeds are substantially slower for buffers that are not 4-byte aligned and whose current position does not change in 4-byte units.\nUse the GetPosition or TryGetPosition functions to get, or the SetPosition or TrySetPosition functions to set, the file read start position (current position). The current position is the number of bytes from the start of the file. You can also use the Seek or TrySeek functions to set the base position and the offset from there. Note that although read speeds are dependent on device and memory region, read speeds are substantially slower if the current position is not set to a multiple of 4 bytes from the start of the file. If the current position is set before the start of the file or after the end of the file, the application halts on the next attempt at accessing the file.\nTable 7-2. Specifying the Base Position\n \t Value\n \t Description\n \t POSITION_BASE_BEGIN\n \t Sets the current position based on the start of the file.\n \t POSITION_BASE_CURRENT\n \t Sets the current position based on the current position in the file.\n \t POSITION_BASE_END\n \t Sets the current position based on the end of the file.\n Call the Finalize function to close the file after you are done using it.\nThe following code sample shows opening a file using TryInitialize, checking if it opened properly, and then reading from it.\nCode 7-1. File Reading\n nn::fs::FileInputStream fis;\nnn::Result result = fis.TryInitialize(L\"rom:/test.txt\");\nif (result.IsSuccess())\n{\n s64 fileSize;\n result = fis.TryGetSize(&fileSize);\n NN_LOG(\"FileSize=%lld\\n\", fileSize);\n buf = heap.Allocate(fileSize);\n s32 ret;\n result = fis.TryRead(&ret, buf, fileSize);\n ...\n heap.Free(buf);\n}\nfis.Finalize();\n",0]
,["Pages/Page_55582618.html#PageId_55582625","7.1.4.2. nn::fs::FileOutputStream Class",
"\n7.1.4.2. nn::fs::FileOutputStream Class\nUse this class to open a file for writing. Specify the file for writing in the arguments to the constructor or to the Initialize or TryInitialize functions. Use the return value from the TryInitialize function instead for error checking. If the specified file does not exist and the createIfNotExist parameter is set to true, a new file of size zero is created. The application halts if the file specified in the arguments to the constructor or to the Initialize function does not exist and the createIfNotExist parameter is set to false. The application halts if file access is attempted from an instance that did not successfully open the file or if the file is opened again from an instance that already has it open.\nUse the SetSize or TrySetSize functions before writing to set the size of the file. The file writing position will be adjusted if the file size is reset smaller in the middle of a write operation. The GetSize or TryGetSize functions return the current file size.\n Note:\n The TryRead function successfully reads in the file of size zero created by the TryInitialize function. You must be careful if the TryInitialize function is called with true passed to the createIfNotExist parameter, and then later the file size is set using the TrySetSize function.\n When the Game Card is removed or the process is otherwise interrupted between calls to TryInitialize and TrySetSize, the next time TryRead is called, the result is that a file of size zero is read.\n For handling files of fixed size, if the application is not checking the size using the TryGetSize function before calling TryRead, we recommend creating the file using the TryCreateFile function, which can set the file size, rather than using the createIfNotExist parameter to create the file.\nUse the Write or TryWrite functions to write data to the file. The arguments specify the starting address of a buffer that contains data to write to the file and the number of bytes of data to write. The return value is the number of bytes actually written to the file. When writing past the end of the file, the file is expanded if possible. If at all possible, allocate the buffer with a 4-byte alignment. Though dependent on device and memory region, write speeds are substantially slower for buffers that are not 4-byte aligned. You can specify whether to flush the file cache (write the cache contents to media) while the file is written to by passing the appropriate value in the flush parameter. We recommend specifying false for this value to avoid wearing out the memory media and to prevent data corruption from memory cards possibly being removed during write operations. Instead, call the Flush or TryFlush functions just before closing the file. However, if you chose not to write and flush concurrently, be sure to flush the cache before you close the file.\nUse the GetPosition or TryGetPosition functions to get, or the SetPosition or TrySetPosition functions to set, the file write start position (current position). The current position is the number of bytes from the start of the file. You can also use the Seek or TrySeek functions to set the base position and the offset from there. Note that although write speeds are dependent on device and memory region, write speeds are substantially slower if the current position is not set to a multiple of 4 bytes from the start of the file. If the current position is set before the start of the file or after the end of the file, the application halts on the next attempt at accessing the file.\nCall the Finalize function to close the file after you are done using it.\nThe following code sample shows opening a file using TryInitialize, checking if it opened properly, and then writing to it.\nCode 7-2. File Writing\n nn::fs::FileOutputStream fos;\nnn::Result result = fos.TryInitialize(L\"sdmc:/test.txt\", true);\nif (result.IsSuccess())\n{\n s32 ret;\n result = fos.TryWrite(&ret, buf, sizeof(buf));\n}\nfos.Finalize();\n",0]
,["Pages/Page_55582618.html#PageId_55582626","7.1.4.3. nn::fs::FileStream Class",
"\n7.1.4.3. nn::fs::FileStream Class\nUse this class to open a file for both reading and writing. The initialization arguments are different, but the member functions operate the same way as for the previous two classes.\nSpecify the file to access and the access mode in the arguments to the constructor or to the Initialize or TryInitialize functions. Specify the access mode as a combination of the following flags.\nTable 7-3. Access Mode Flags\n \t Flag\n \t Description\n \t OPEN_MODE_READ\n \t Opens a file for reading.\n \t OPEN_MODE_WRITE\n \t Opens a file for writing. Reading is also possible.\n \t OPEN_MODE_CREATE\n \t When combined with OPEN_MODE_WRITE, if the file specified at initialization does not already exist, it is created.\n",0]
,["Pages/Page_55582618.html#PageId_55582627","7.1.5. Accessing Directories",
"\n7.1.5. Accessing Directories\n",0]
,["Pages/Page_55582618.html#PageId_55582628","7.1.5.1. nn::fs::Directory Class",
"Use the nn::fs::Directory class to get information about directories and directory contents (subdirectories and files).\n7.1.5.1. nn::fs::Directory Class\nUse this class to open directories and list their contents. Specify the directory in the arguments to the constructor or to the Initialize or TryInitialize functions. The application halts if the directory specified in the arguments to the constructor or to the Initialize function does not exist. Use the return value of the TryInitialize function instead for error checking. The application halts if directory access is attempted from an instance that did not successfully open the directory, or if the directory is opened again from an instance that already has it open.\nA slash is needed at the end of the path when specifying the root directory for media, such as the \"/\" at the end of the \"sdmc:/\" path. The ending slash may also be added for non-root directories, but it is not needed.\nUse the Read function to get directory entries. The arguments specify an array for directory entry information (an nn::fs::DirectoryEntry structure) and the number of elements in the array. The return value is the number of entries actually stored in the array. Once all entries have been obtained, calls to the Read function return 0.\nCall the Finalize function to close the directory after you are done using it.\nThe following code sample shows opening a directory using TryInitialize, checking whether it opened properly, and then getting its entries.\nCode 7-3. Directory Access\n nn::fs::Directory dir;\nnn::fs::DirectoryEntry entry[ENTRY_MAX];\nnn::Result result = dir.TryInitialize(L\"sdmc:/TestDirectory\");\nif (result.IsSuccess())\n{\n s32 readCount;\n while (true)\n {\n result = dir.TryRead(&readCount, entry, ENTRY_MAX);\n if (readCount == 0) break;\n ...\n }\n}\ndir.Finalize();\n",0]
,["Pages/Page_55582618.html#PageId_55582629","7.1.6. File and Directory Operations",
"\n7.1.6. File and Directory Operations\n",0]
,["Pages/Page_55582618.html#PageId_55582630","7.1.6.1. Creating Files",
"Use these functions to create, rename, or delete files and directories.\n7.1.6.1. Creating Files\nUse the nn::fs::CreateFile or nn::fs::TryCreateFile functions to create a file of the specified size. The application halts if an error occurs on a call to the nn::fs::CreateFile function. Use the return value from the nn::fs::TryCreateFile function instead for error checking.\nAn error occurs if you attempt to create a file of the same full name as an existing file. If an error occurs for some reason other than during an attempt to create a file with the same name as an existing file, it is possible that an unnecessary file has been created, so delete any such unnecessary files. If no unnecessary files have been created, the delete operation returns nn::fs::ResultNotFound.\n",0]
,["Pages/Page_55582618.html#PageId_55582631","7.1.6.2. Renaming Files",
"\n7.1.6.2. Renaming Files\nUse the nn::fs::RenameFile or nn::fs::TryRenameFile functions to rename a file. The application halts if an error occurs on a call to the nn::fs::RenameFile function. Use the return value from the nn::fs::TryRenameFile function instead for error checking.\nAn error occurs if you call these functions on a file that is open or if you attempt to rename a file to a name already used by another file in the same directory (including attempting to rename a file and specifying the name it already has).\n",0]
,["Pages/Page_55582618.html#PageId_55582632","7.1.6.3. Deleting Files",
"\n7.1.6.3. Deleting Files\nUse the nn::fs::DeleteFile or nn::fs::TryDeleteFile functions to delete a file. The application halts if an error occurs on a call to the nn::fs::DeleteFile function. Use the return value from the nn::fs::TryDeleteFile function instead for error checking.\nAn error occurs if you call these functions on a file that is open.\n",0]
,["Pages/Page_55582618.html#PageId_55582633","7.1.6.4. Creating Directories",
"\n7.1.6.4. Creating Directories\nUse the nn::fs::CreateDirectory or nn::fs::TryCreateDirectory functions to create a directory. The application halts if an error occurs on a call to the nn::fs::CreateDirectory function. Use the return value from the nn::fs::TryCreateDirectory function instead for error checking.\nAn error occurs if you call these functions on a directory located in a nonexistent directory or if you attempt to create a directory with a name already used by another directory in the same parent directory.\n",0]
,["Pages/Page_55582618.html#PageId_55582634","7.1.6.5. Renaming Directories",
"\n7.1.6.5. Renaming Directories\nUse the nn::fs::RenameDirectory or nn::fs::TryRenameDirectory functions to rename a directory. The application halts if an error occurs on a call to the nn::fs::RenameDirectory function. Use the return value from the nn::fs::TryRenameDirectory function instead for error checking.\nAn error occurs if you call these functions on a directory that is open or if you attempt to rename a directory to a name already used by another directory in the same parent directory (including attempting to rename a directory and specifying the name it already has).\n",0]
,["Pages/Page_55582618.html#PageId_55582635","7.1.6.6. Deleting Directories",
"\n7.1.6.6. Deleting Directories\nUse the nn::fs::DeleteDirectory or nn::fs::TryDeleteDirectory functions to delete a directory. A directory cannot be deleted unless it is empty. The application halts if an error occurs on a call to the nn::fs::DeleteDirectory function. Use the return value from the nn::fs::TryDeleteDirectory function instead for error checking.\nAn error occurs if you call these functions on a directory that is open.\nThe nn::fs::TryDeleteDirectoryRecursively function attempts to completely delete the specified directory by recursively deleting all entries. If an error occurs during this process, the function returns that error.\n",0]
,["Pages/Page_55582618.html#PageId_55582636","7.1.7. Checking the SD card State",
"\n7.1.7. Checking the SD card State\nThe SDK provides functions to check whether an SD card is inserted, to send notification when an SD card is inserted or removed, and to check whether an SD card can be written to.\nCode 7-4. Checking the SD card Insertion State, Notifying of Insertion/Removal, and Checking for Writability\n bool nn::fs::IsSdmcInserted();\nvoid RegisterSdmcInsertedEvent(nn::os::LightEvent* p);\nvoid UnregisterSdmcInsertedEvent();\nvoid RegisterSdmcEjectedEvent(nn::os::LightEvent* p);\nvoid UnregisterSdmcEjectedEvent();\nbool nn::fs::IsSdmcWritable();\nnn::Result nn::fs::GetSdmcSize(s64* pTotal, s64* pFree);\nCall the nn::fs::IsSdmcInserted function to check whether an SD card is inserted. The function returns true if a device is currently inserted in the SD card slot, even if it is a broken SD card or something other than an SD card, such as an empty SD card Adapter. The processing to check whether an SD card is inserted entails a heavy processor load; we recommend using the following functions to register an event class that waits for notification when an SD card is inserted or removed.\nCall the nn::fs::RegisterSdmcInsertedEvent and nn::fs::UnregisterSdmcInsertedEvent to register and unregister an instance of the nn::os::LightEvent class to receive notifications of SD card insertions.\nCall nn::fs::RegisterSdmcEjectedEvent and nn::fs::UnregisterSdmcEjectedEvent to register and unregister an instance of the nn::os::LightEvent class to receive notifications of SD card ejections.\nThe nn::fs::IsSdmcWritable function returns true if an SD card is inserted and can be written to.\nThe nn::fs::GetSdmcSize function returns the total capacity of an SD card (pTotal) and the available capacity (pFree).\n",0]
,["Pages/Page_55582618.html#PageId_55582637","7.1.8. Latency Emulation",
"\n7.1.8. Latency Emulation\nYou can use the following function to debug changes in access speeds. It emulates file access latency in an application caused by conflicting file system access with SpotPass or another background process.\nCode 7-5. Initializing Latency Emulation\n void nn::fs::InitializeLatencyEmulation(void);\nUse the Config tool’s Debug Mode to enable and disable latency emulation. While the application is running, file accesses are delayed by the number of milliseconds specified by FS Latency Emulation only when the corresponding item is set to enable in the Config tool and this function has enabled latency emulation.\n",0]
,["Pages/Page_55582618.html#PageId_55582638","7.1.9. Access Priority Settings",
"\n7.1.9. Access Priority Settings\nFile system access priority is supported. This allows you to access multiple files from multiple threads, because the execution order is appropriately adjusted, and items with a higher priority setting are processed more quickly.\n",0]
,["Pages/Page_55582618.html#PageId_55582639","7.1.9.1. Types of Access Priority",
"Access priority requires real-time capability in the same way as streaming (an established number of cycles is required for an established amount of processing). Appropriate settings are provided for file access. Using these settings keeps delay time resulting from file access to a minimum.\n7.1.9.1. Types of Access Priority\nThe access priorities that can be set are listed below, in priority order.\nTable 7-4. Access Priority Types\n \t Type\n \t Definition\n \t Description\n \t Real-time Priority\n \t PRIORITY_APP_REALTIME\n \t Special priority level used for accessing files which, if loading is delayed, could detract from the user’s experience. This includes the loading of streaming data.\n There are, however, some restrictions on its use.\n \t Normal Priority\n \t PRIORITY_APP_NORMAL\n \t Priority level used for accessing general purpose files, such as model data, scene data, and all types of save data.\n \t Low Priority\n \t PRIORITY_APP_LOW\n \t Priority level used for accessing files which can be executed anytime the system is available for processing, for which the priority is lower than normal. This includes autosave.\n The definition used to specify access priority level is defined in the nn::fs::PriorityForApplication enumerator.\n Note:\n For the restrictions on real-time priority see the CTR-SDK API Reference.\n",0]
,["Pages/Page_55582618.html#PageId_55582640","7.1.9.2. Access Priority Setting Targets",
"\n7.1.9.2. Access Priority Setting Targets\nThe following list shows a range of targets for access priority settings.\nTable 7-5. Access Priority Setting Targets and Functions Used in Settings\n \t Setting Target\n \t Function Used in Setting\n \t Overall File System\n \t nn::fs::SetPriority\n \t Archive\n \t nn::fs::SetArchivePriority\n \t File Stream and Directory\n \t TrySetPriority or SetPriority of all classes\n The Overall File System setting target refers to general access from the application and accessing of archives performed without specifying an archive name. This includes save data formats. If an access priority has not been set explicitly, the normal priority is applied.\nThe Archive setting target refers to archives whose name must be specified for an archive that is already mounted. Different access priority settings are possible for each archive. If the access setting is not set explicitly, the overall file system setting at the time the archive was mounted is applied. Even if the setting is changed for the overall system after the archive is mounted, the archive setting itself is not affected. Similarly, even if the archive setting is changed, the setting for the overall file system is not affected.\nThe File Stream and Directory setting is applied to objects accessed in the file stream (such as nn::fs::FileStream) and directory objects (nn::fs::Directory). Access priority settings can differ for each object even if it resides in the same file or directory. Unless the access priority setting is set explicitly, the archive setting at the point when the object was created is applied. Even if the archive setting is changed after creating an object, the various settings for each object is not affected. Similarly, even if individual settings of various objects are changed, the archive setting is not affected.\n",0]
,["Pages/Page_55582618.html#PageId_55582641","7.1.9.3. Cautions",
"\n7.1.9.3. Cautions\nAccess priority changes the priorities within the file system. If the priority of the threads that call file access functions is not set at a high level, the file access process will not immediately start (even if a particular item has real-time priority). Set the priority of threads that call up file access functions at a high enough priority to meet the demands of their particular processing.\nIn addition, the order of completing access of desired files is not guaranteed. There is always a possibility that access of files with a lower priority level may be completed before files with a higher access priority, even though they were requested at a later time. Do not implement an application so that it is dependent on the order of file access completion, when multiple files are accessed in parallel.\nAlso, do not perform file access performance design based on measured performance values. For estimated access times, see CTR-SDK API Reference.\n",0]
,["Pages/Page_55582618.html#PageId_55582642","7.1.10. Restriction on the Number of Files and Directories Opened Simultaneously",
"\n7.1.10. Restriction on the Number of Files and Directories Opened Simultaneously\nThere are limits to the number of files and directories that can be opened at the same time using the file system.\nFor safe operation, limit the number of files and directories that an application opens simultaneously to the following.\n\tUp to four files of the archive that directly access the SD card and the expanded save data archive combined \tUp to 10 files for the save data archive (including the save data of other applications) \tUp to 10 total files\n Note:\n A ROM archive is not subject to these limits. Its limits are in accordance with the parameters defined by calling the MountRom function.\n",0]
,["Pages/Page_55582618.html#PageId_55582643","7.2. ROM Archives",
"\n7.2. ROM Archives\nROM archives are read-only archives for accessing ROMFS that are created at build time. ROM archives must be mounted explicitly by applications. The mounting procedure and arguments are the same regardless of whether the application is card-based software or a downloadable application.\nThe use of ROM archives requires working memory allocated by the application. The required size of this working memory depends on the number of files and directories that can be opened simultaneously. You can get the required working memory size by calling nn::fs::GetRomRequiredMemorySize. If this function returns a negative value, you cannot mount a ROM archive. After your application has allocated the required amount of memory (or more) with 4-byte alignment, call nn::fs::MountRom to mount the ROM archive.\nCode 7-6. Mounting a ROM Archive\n s32 nn::fs::GetRomRequiredMemorySize(size_t maxFile, size_t maxDirectory,\n bool useCache = true);\nnn::Result nn::fs::MountRom(const char* archiveName, size_t maxFile,\n size_t maxDirectory, void* workingMemory,\n size_t workingMemorySize, bool useCache = true);\nSpecify the number of files and directories that can be opened simultaneously in maxFile and maxDirectory, respectively. The number of files that can be opened simultaneously only depends on the amount of working memory. This number is not affected by factors like the length of filenames.\nSpecify a value of true in the useCache parameter to cache metadata and shorten the time required to open files or scan directories. Note that this increases the amount of working memory required.\nSpecify the name of the archive to mount in the archiveName parameter. The archive is mounted to rom: if you call the overloaded version that omits this parameter.\nPass the working memory and its size to workingMemory and workingMemorySize.\n Note:\n You do not need to handle errors for these functions. If an error occurs in a function, an error screen displays but an error is not returned to the application.\n",0]
,["Pages/Page_55582618.html#PageId_55582644","7.2.1. Specifying Archive Names",
"\n7.2.1. Specifying Archive Names\nOnly single-byte alphanumeric characters and some symbols excluding the colon as archive name delimiter may be used to specify archive names. Names are case-sensitive. Names must be specified as at least one character and no more than eight, including the colon delimiter.\nDo not use archive names that start with the dollar symbol ($). For information about characters and words that cannot be used in archive, file, and directory names, see the API Reference.\n",0]
,["Pages/Page_55582618.html#PageId_55582645","7.3. Save Data",
"\n7.3. Save Data\nFor card-based software, the application-specific save data region is located in the backup memory. For downloaded applications, the save data region is located in an archive file on an SD card. The save data region can be accessed by the FS library as an archive. The function and parameters used to access this archive are the same regardless of whether the accessing application is stored on a Nintendo 3DS Card or an SD card.\nCode 7-7. Mounting, Formatting, and Committing Save Data Regions\n nn::Result nn::fs::MountSaveData(const char* archiveName = \"data:\");\nnn::Result nn::fs::MountSaveData(const char* archiveName, bit32 uniqueId);\nnn::Result nn::fs::MountDemoSaveData(const char* archiveName, bit32 uniqueId,\n bit8 demoIndex);\nnn::Result nn::fs::FormatSaveData(size_t maxFiles, size_t maxDirectories,\n bool isDuplicateAll = false);\nnn::Result nn::fs::CommitSaveData(const char* archiveName = \"data:\");\nCall the nn::fs::MountSaveData function to mount a save data region to the archive path name specified in the archiveName parameter. The save data from another application can be mounted by calling the overloaded function with the uniqueId parameter. Call the nn::fs::MountDemoSaveData function to mount the save data region of the demos. Specify the index of the demo for demoIndex.\nIf an error belonging to the class nn::fs::ResultNotFormatted is returned, format the save data region by calling the nn::fs::FormatSaveData function and then try mounting it again. When formatting, specify the maximum number of files and directories using the maxFiles and maxDirectories parameters. There are no restrictions on the values that can be specified. For more information about specifying archive names, see 7.2.1. Specifying Archive Names.\n Note:\n The values to be specified in uniqueId upon mounting the save data region are based on the unique ID specified in each application’s RSF file. To specify another application’s unique ID, you must first specify that application’s unique ID in the RSF file of the application to be mounted.\n Warning:\n The same error class (nn::fs::ResultNotFound) is returned when mounting the save data region from a downloaded application (including demos) if a Nintendo 3DS Card is not inserted, or if the inserted 3DS Card does not have a formatted save data region.\n You cannot escape from this state if you do not start the card-based software application, or start the card-based software application but do not format the save data region. Be sure to display a message that accommodates the reason the caused the error. For example, your message could say something like: “Could not find save data for (media name). If you have never run the game before, run it now, create save data, and try again.”\nThe library supports automatic redundancy for the entire save data region. The library mirrors data over the entire save data region when the isDuplicateAll parameter during formatting was specified as true. When writing files with automatic redundancy enabled, you must call nn::fs::CommitSaveData before unmounting the save data region or the file updates will not be written to the media. Likewise, if the power is cut before the updates are committed to memory, only the old data will be available the next time the system is booted and the save data is mounted.\n Warning:\n If save data consists of multiple interdependent files, you must call nn::fs::CommitSaveData when these dependencies are not contradictory.\nWhen automatic redundancy is enabled, the memory available for save data files is half of the physical capacity of the backup region. A portion of this space is also reserved for file system management. Use the Worksheet for Calculating the Save Data Capacity, found in the API Reference, to calculate the actual available capacity of the backup region. The current implementation uses regions of 512 byte blocks when saving files.\nThe mounted save data region can be treated as an archive. You can create files freely within the archive. Filenames and directory names can be up to 16 characters long, and the maximum path length is 253 characters. Only half-width alphanumeric characters and some symbols can be used for filenames and directory names. Slashes (\"/\") are used to delimit folders in paths. Other than the amount of available capacity for save data, there are no restrictions on the maximum size of the file that can be created or the maximum size that can be written at one time.\nCall the nn::fs::GetArchiveFreeBytes function to get the available capacity of an archive.\nCode 7-8. Getting an Archive’s Available Capacity\n nn::Result nn::fs::GetArchiveFreeBytes(s64* pOut, const char* archiveName);\nFor the pOut parameter, specify a pointer to a variable of type s64 to receive the number of available bytes. For the archiveName parameter, use the name of the archive specified when it was mounted.\nThe files within the archive are protected by a tamper detection feature that uses hash values. If the hash value of the data that is accessed does not match the expected value, the system determines that the data has been tampered with and returns an error. When automatic redundancy is not enabled, mismatching hash errors can also occur when trying to access data that was corrupted if the system was turned off during a save or if the card was removed during a save.\nWhen you finish accessing the save data region, call the nn::fs::Unmount function, specifying the archive name as an argument, to unmount the save data.\nCode 7-9. Unmounting\n nn::Result nn::fs::Unmount(const char* archiveName);\n",0]
,["Pages/Page_55582618.html#PageId_55582646","7.3.1. Measures Against Rollback of Save Data",
"Downloaded applications, much like Nintendo DSiWare titles, create a save data region automatically as soon as they are imported into the target media. When a downloaded application is deleted, its save data is also deleted.\n7.3.1. Measures Against Rollback of Save Data\n Note:\n See the File System: Save Data Rollback Prevention Feature section in the CTR-SDK API Reference.\n Warning:\n In general, if an application uses the save data rollback prevention feature, do not support backing up save data in the banner specifications file. (Set DisableSaveDataBackup to True.) For more information, see the 3DS Overview developer manual included in the CTR Overview package and the description of ctr_makebanner included in the ../documents/tools/ folder of the CTR-SDK. Switching between using and not using the save data rollback prevention feature when applying a patch is prohibited.\n",0]
,["Pages/Page_55582618.html#PageId_55582647","7.3.2. Handling Errors When Files or Directories Do Not Exist",
"\n7.3.2. Handling Errors When Files or Directories Do Not Exist\nEven if an application takes various measures to create save data correctly, if the following conditions are met, it is still possible to reach a state where mounting is completed successfully, but save data files do not exist.\n\tThe save data was formatted the first time it is created. \tAfter the formatting is completed, while creating files or directories (and before the save data is committed when automatic redundancy is enabled), the application crashes for one of the following reasons. \tThe Power Button was held down. \tThe card was removed. \tPower was cut off partway through the process.\nThis occurs particularly in applications that allow the system to go into a sleep state, when the system is closed and then left alone.\nIn cases like these, nn::fs::ResultNotFound could be returned for file or directory operations. Implement your application so that the user’s save data can be restored to its normal state.\n",0]
,["Pages/Page_55582618.html#PageId_55582648","7.4. Expanded Save Data",
"\n7.4. Expanded Save Data\nThe term expanded save data refers to data that is created on an SD card and managed separately from the save data. The expanded save data region can only be used on the system it was created on. We recommend that the expanded save data region be used to store any application-specific data that is linked to (relies on) information that only exists on a specific system (for example, friend information). Do not use the expanded save data region to store data that is required in order to make progress in the game. The system never automatically creates expanded save data.\nCode 7-10. Mounting, Creating, and Deleting Expanded Save Data\n nn::Result nn::fs::MountExtSaveData(const char* archiveName,\n nn::fs::ExtSaveDataId id);\nnn::Result nn::fs::CreateExtSaveData(nn::fs::ExtSaveDataId id,\n const void* iconData, size_t iconDataSize,\n u32 entryDirectory, u32 entryFile);\nnn::Result nn::fs::DeleteExtSaveData(nn::fs::ExtSaveDataId id);\nTo use expanded save data, you must first mount it by specifying the expanded save data ID in a call to the nn::fs::MountExtSaveData function. If the function returns a value of nn::fs::ResultNotFormatted, nn::fs::ResultNotFound, nn::fs::ResultBadFormat, or nn::fs::ResultVerificationFailed and expanded save data has already been created, delete expanded save data using the nn::fs::DeleteExtSaveData function and create expanded save data by calling the nn::fs::CreateExtSaveData function and then re-mount.\nThe expanded save data is mounted to the archive path specified in the archiveName parameter. For more information about specifying archive names, see 7.2.1. Specifying Archive Names.\nSpecify the expanded save data ID in the id parameter. The expanded save data ID is a number that identifies the expanded save data. The expanded save data ID for expanded save data that applications can access must be set as either ExtSaveDataNumber in the makerom RSF file (only one ID can be specified) or AccessibleSaveDataIds in AccessControlInfo (where multiple IDs can be specified). Normally you would specify a unique ID issued by Nintendo for expanded save data IDs created by applications. Consequently, when sharing expanded save data among multiple applications, you must specify the unique ID for one of those applications.\nWhen creating expanded save data, the iconData and iconDataSize parameters are used to specify an icon for display on the data management screen (as an icn file created using the ctr_makebanner32 tool) and the icon’s size. Use the entryDirectory and entryFile parameters to specify the number of directories and files to store in the save data\nThe mounted expanded save data region can be treated as an archive. You can create files freely within the archive. However, the size of files cannot be changed after they are created unless the nn::fs::TryCreateFile function is used to create them. Filenames and directory names can be up to 16 characters long, and the maximum path length is 248 characters. Only half-width alphanumeric characters and certain symbols can be used for filenames and directory names. Slashes (\"/\") are used to delimit folders in paths. Archive sizes are variable.\nThe files within the archive are protected by a tamper detection feature that uses hash values. If the hash value of the data that is accessed does not match the expected value, the system determines that the data has been tampered with and returns an error. Mismatching hash errors call also occur when trying to access data that was corrupted if the system was turned off during while writing data or if the card was removed while writing data. Unlike save data, the library does not support expanded save data mirroring.\nThere are no data protection features, so removing an SD card while a file is writing will very likely result in corrupted expanded save data. You must re-create any corrupted expanded save data after deleting using the nn::fs::DeleteExtSaveData function.\nWhen you finish accessing the expanded save data region, call the nn::fs::Unmount function, specifying the archive name as an argument, to unmount the expanded save data.\nDeleting downloaded applications has no effect on expanded save data. Expanded save data can be deleted from the Data Management screen of System Settings.\n Note:\n The application is free to use up to a total of 32 MB of expanded save data. If you want to use more than 32 MB, please contact Nintendo.\n",0]
,["Pages/Page_55582618.html#PageId_55582649","7.4.1. Uses of Expanded Save Data",
"\n7.4.1. Uses of Expanded Save Data\nExpanded save data can be used to save information such as the following.\n\tApplication-specific data \tData shared by a series (shared among multiple titles or versions of titles in the same series) \tDownloaded data (such as additional items or levels) ",0]
,["Pages/Page_55582618.html#PageId_55582650","7.4.1.1. Application-Specific Data",
" \tContextual CTR banner data (created in the application, or downloaded from a server)\n7.4.1.1. Application-Specific Data\nThis can include relatively unimportant data that is unrelated to the game's progress, data that is linked to information that is only saved on the system, or large user-created data.\n",0]
,["Pages/Page_55582618.html#PageId_55582651","7.4.1.2. Data Shared by a Series",
"\n7.4.1.2. Data Shared by a Series\nThis refers to data that is shared by multiple titles in the same series (including different versions of a title). You can share data between titles in a series by using the common expanded save data ID throughout the series.\n",0]
,["Pages/Page_55582618.html#PageId_55582652","7.4.1.3. Downloaded Data",
"\n7.4.1.3. Downloaded Data\nThis refers to additional levels or other such data that are downloaded by the application by registering a download task. Only the application that registered a download task can access the data acquired from that download task, but you can make this data accessible to other applications that share the expanded save data by moving it to expanded save data.\n",0]
,["Pages/Page_55582618.html#PageId_55582653","7.4.1.4. Contextual CTR Banner Data",
"\n7.4.1.4. Contextual CTR Banner Data\nThis refers to data that can replace portions of the data in CTR title banners. The portions that can be replaced are the scrolling text that is displayed at the bottom of the upper screen and a single texture for the replacement name. The system does not support replacing icon data.\nThere are two types of contextual CTR banner data: local contextual banners, which are created by applications, and downloaded contextual banners, which are downloaded from servers.\n",0]
,["Pages/Page_55582618.html#Anchor_55582653_ローカル拡張バナー","Local Contextual Banners",
"Local Contextual Banners\nLocal data can be used to display a message based on the game's progress or to change part of the texture that is displayed in the CTR title banner. The text can be up to 255 characters (either single byte or double byte), and the data size can be up to 128 KB. It is possible to include multiple images within a single texture and to apply these images to multiple models. Prepare \"COMMON\" data used for all languages in addition to any language-specific data that may be enabled for the target region.\n",0]
,["Pages/Page_55582618.html#Anchor_55582653_DL拡張バナー","Downloaded Contextual Banners",
"Downloaded Contextual Banners\nThis is provided to a server and can be used to change the display. The text and textures have the same specifications as for local contextual banners. You can specify an expiration date (year, month, and day) for downloaded contextual banners.\n",0]
,["Pages/Page_55582618.html#Anchor_55582653_CTR拡張バナーデータの表示について","Displaying Contextual CTR Banner Data",
"Displaying Contextual CTR Banner Data\nThe text displayed for the contextual banner data alternates in the following order: (1) text for downloaded contextual banners, (2) text for local contextual banners. If the texture included within a local contextual banner has the same name as a texture included within a downloaded contextual banner, the system gives priority to the downloaded contextual banner’s texture.\n",0]
,["Pages/Page_55582618.html#PageId_55582654","7.4.2. Access From Multiple Game Cards",
"\n7.4.2. Access From Multiple Game Cards\nMore than one person may share a single 3DS system using a single SD card, with both people owning game cards having the same title. This alone does not represent a problem because save data is written to the backup memory of each separate game card. Note, however, that bugs may arise depending on the configuration of the data saved in expanded save data.\nSpecifically, situations like the following may occur.\n\tThe program may run out of control if the integrity of save data and expanded save data is lost. \tIf you use fixed filenames for save data, files stored in expanded save data created on one game card may overwrite that of the other, regardless of the user’s intention. \tContrary to the developer’s intention, the same number of SD cards will be required for multiple game cards to be played on the same 3DS system.\nFor example, unintentional overwriting of data can be avoided by assigning unique directory and filenames when creating files in expanded save data. However, rather than using a name freely chosen by the user, such as a character name, as the basis for naming such files, apply a text string such as one that includes the current time. In addition, when writing information linked with expanded save data in save data, note that the expanded save data associated with that information may not exist on the SD card.\n Warning:\n As for contextual CTR banner data, there is no way to handle situations like this. The downloaded contextual banner data or local contextual banner data last created is enabled, regardless of which game card is inserted.\n",0]
,["Pages/Page_55582618.html#PageId_55582655","7.4.3. Accessing Multiple Items of Expanded Save Data",
"\n7.4.3. Accessing Multiple Items of Expanded Save Data\nYou can specify multiple unique IDs (up to a maximum of six) for the accessible save data attributes (AccessibleSaveDataIds in AccessControlInfo) in the RSF file to enable access to the following data.\n\tSave data with the same unique IDs as the unique IDs specified \tExpanded save data with the same expanded save data IDs as the unique IDs specified\n Warning:\n Individual items of expanded save data can be deleted in System Settings. Avoid saving data that needs to be as consistent as expanded save data whenever possible.\n For titles that use CTR contextual banners, create expanded save data that takes the title's unique ID as its expanded save data ID in addition to the expanded save data for shared access. This is because the files used to display the contextual banner must be in the ExBanner directory for expanded save data created with the title’s unique ID.\n Note:\n For information about how to write the RSF file, see the reference for the ctr_makerom CTR-SDK tool or the 3DS Programming Manual: How to Create Applications.\n",0]
,["Pages/Page_55582618.html#PageId_55582656","7.5. Archives That Directly Access SD Cards",
"\n7.5. Archives That Directly Access SD Cards\nCall the nn::fs::MountSdmcWriteOnly function to mount an archive that directly accesses the inserted SD card. Note that the FileSystemAccess permission attribute under AccessControlInfo in the RSF file must specify – DirectSdmcWrite.\nCode 7-11. Mounting an Archive That Directly Accesses an SD card\n nn::Result nn::fs::MountSdmcWriteOnly(const char* archiveName = \"sdmcwo:\");\nNo files or directories can be read in archives mounted using this function, but written files are not encrypted, so they can be read from a PC. Unlike any expanded save data on the same SD card, you can change the size of files after they are created.\nThere are fewer errors possible when mounting this kind of archive than when mounting expanded save data, and you can handle these errors in the same way as for expanded save data. However, because reading is prohibited, you cannot directly check for the existence of any file or directory. You must attempt writing once and then handle any nn::fs::ResultAlreadyExists errors returned by the write function.\nCall the nn::fs::Unmount function and pass the archive name as an argument to unmount an archive.\n Note:\n Applications are restricted from writing depending on the path. For more information about restrictions and cautions, see the File System section of the guidelines.\n",0]
,["Pages/Page_55582618.html#PageId_55582657","7.6. Media-Specific Cautions",
"\n7.6. Media-Specific Cautions\n",0]
,["Pages/Page_55582618.html#PageId_55582658","7.6.1. Nintendo 3DS Cards",
"7.6.1. Nintendo 3DS Cards\nWhen save data is mounted and the return value is nn::fs::ResultVerificationFailed, the save data is corrupted due to the memory card being removed or the power being cut while data was writing. In such cases, you must reformat the save data. If data automatic redundancy was enabled, you would normally never see this return value due to user actions such as removing the memory card. However, it is possible that data was tampered with. As an exception, handle this situation by forcibly formatting the save data or taking similar measures.\n",0]
,["Pages/Page_55582618.html#Anchor_55582658_アクセス速度の変化に対する検証","Verifying Different Access Speeds",
"Verifying Different Access Speeds\nThe performance of access to ROM archives on Nintendo 3DS Cards by the FS Library can vary greatly depending on the condition of the media. System updates may also improve performance. If you plan to sell your application on Nintendo 3DS Card, verify the following to make sure that changes in access speed do not cause issues.\n\tFor CARD1 applications: \tEnable DebugMode using the config tool (with latency emulation enabled) and play through all modes. \tSet the development card speed to Fast and play through all modes of the Release build of the application written to a development card\n \tFor CARD2 applications: \tEnable DebugMode using the config tool (with latency emulation enabled) and play through all modes. \tFrom the PARTNER-CTR Debugger Card Control dialog box, in the Card Emulation Control tab, set the transfer speed in the emulation memory speed settings to Fast, and play through all modes of the application (Release build CCI file) loaded in emulation memory. \tSet the development card speed to Fast and play through all modes of the Release build of the application written to a development card\n Warning:\n Be sure to test using the latest version of the PARTNER-CTR Debugger/Writer.\n",0]
,["Pages/Page_55582618.html#PageId_55582660","7.6.2. SD Memory Cards",
"\n7.6.2. SD Memory Cards\nNote the following points when you implement an application that accesses an SD card, including expanded save data or downloadable application stored in the SD card.\n",0]
,["Pages/Page_55582618.html#Anchor_55582660_SDメモリカードを直接参照する際の注意点","Cautions for Directly Accessing SD Memory Cards",
"Cautions for Directly Accessing SD Memory Cards\nArchives for accessing SD cards mounted using the nn::fs::MountSdmc function (mounted under sdmc:/ if not otherwise specified) are provided for debugging purposes only. Note that these archives are not accessible from production versions.\nNote that this mount point cannot be accessed in retail versions of games. Note also that SD cards may be swapped out while the system is asleep. To remount an SD card that has been removed, first call nn::fs::Unmount to unmount it from the file system, and then call the appropriate mounting function to remount.\n",0]
,["Pages/Page_55582618.html#Anchor_55582660_ストリーミング再生時の注意点","Streaming Playback Cautions",
"Streaming Playback Cautions\nIn some situations, SD card file access may become slower, such as when the SD card is almost full, it is significantly fragmented, or it is near the end of its service life. Most functions that access SD cards are affected by this and slow down; the effect is particularly large with functions for creating files (for example, nn::fs::CreateExtSaveData).\nNote that calling these functions while the system is streaming sound or movies may cause choppy audio or dropped frames, because file access blocks until the functions complete executing.\n",0]
,["Pages/Page_55582618.html#Anchor_55582660_リード・ディスターブへの対策","“Read Disturb” Measures",
"“Read Disturb” Measures\nSD cards have a limit to their data storage capacity in relation to their read capacity. When trying to read beyond the limit, the data can become degraded in a phenomenon known as read disturb. Depending on the area where the read disturb phenomenon occurs, all data on the SD card might become unreadable.\nOf particular concern is that this can occur just by opening a file to be loaded from the SD card. Some SD cards on the market are not sufficiently resistant to the read disturb phenomenon. The best way to lower the risk of this phenomenon occurring is to reduce, as much as possible, the amount of file opening and closing that occurs on the application side. For example, when multiple accesses are required at different offsets to the same file, perform the accesses all within a small number of open and close processes, rather than opening and closing the file for each access.\nIn addition, by repeatedly reading the same region on the SD card, data retention becomes unstable. Problems can occur most often in access to ROM archives and add-on content that has not been rewritten. Even if the application is card-based software, be careful if there is a possibility of selling the card-based software as a downloadable application in the future.\nAs a measure to retain the data longer when the particular data is repeatedly read from the SD card (such as when repeatedly streaming playback of short waveform data), you can read the data from the SD card to the buffer in internal memory and use the data on that buffer. Making the buffer size 16 KB or more is effective, because the situation improves with a larger size.\nThis measure is not a restriction, and you are not required to implement it when memory is limited.\n Note:\n For the developers using the NW4C Sound Library, see the explanation in the nw::snd::SoundArchivePlayer class reference.\n",0]
,["Pages/Page_55582618.html#PageId_55582664","7.7. Difference Between Save Data and Expanded Save Data",
"\n7.7. Difference Between Save Data and Expanded Save Data\n",0]
,["Pages/Page_55582618.html#PageId_55582665","7.7.1. Characteristics of Save Data and Expanded Save Data",
"When an application goes on sale, you can now select the 3DS Card (CARD2) as the storage media for that application, thereby increasing the storage capacity available for application-specific save data. This allows you to save data that had to be saved as expanded save data (due to storage capacity issues) in the past. With this change in specifications, you must carefully distinguish between save data and expanded save data based on the type and purpose of the data being saved. This chapter describes the distinguishing characteristics of save data and expanded save data and where to save each type of data.\n7.7.1. Characteristics of Save Data and Expanded Save Data\nSave data and expanded save data have the following distinguishing characteristics.\nTable 7-6. Characteristics of Save Data and Expanded Save Data\n \t Item\n \t Save Data\n \t Expanded Save Data\n \t Redundancy\n \t Supported\n \t Not supported\n \t Backup\n \t Supported. (Downloadable applications only.)\n Usually enabled (See below.)\n \t Not supported\n \t Rollback prevention\n \t Supported. (Downloadable applications only.)\n Backup must be disabled if this feature is used.\n \t Not supported\n \t Storage media\n \t Card-based applications: Card backup region\n Downloadable applications: SD card\n \t SD card\n \t When storage is allocated\n \t Card-based applications: From the first use.\n Downloadable applications: At time of installation.\n \t When allocated by the application.\n \t Removal\n \t Only from inside the application.\n \t Can be removed from inside an application or on the Data Management screen in System Settings.\n \t Data loss\n \t The risk of losing data can be reduced by using the backup and redundancy features.\n \t The risk of losing data cannot be reduced.\n \t Lost data recovery\n \t With redundancy: Lost data needs to be recovered only when an entire archive is lost.\n Without redundancy: Lost data needs to be recovered when an entire archive is lost or when individual files or directories are lost.\n \t Lost data needs to be recovered when an entire archive is lost or when individual files or directories are lost.\n \t Ensuring sufficient storage capacity\n \t Unnecessary. (Save data must fit into a fixed amount of allocated storage.)\n \t Must be performed each time a file is created.\n In some applications, the backup feature has been disabled for the following reasons.\n\tThey are using rollback prevention. \tInconsistencies may arise between expanded save data and save data if only save data is rolled back using the backup feature. ",0]
,["Pages/Page_55582618.html#PageId_55582666","7.7.2. Policy for Selecting the Storage Location for Data",
" \tRestoring save data from backups may be problematic.\nFor example, users might repeatedly transfer DLC or rare or hidden characters or items to other users over and over again, restoring their save data each time.\n7.7.2. Policy for Selecting the Storage Location for Data\nIn general, save important data in save data. Important data may include data that can make further progress in a game impossible if lost. For data that can be lost and the player can still progress in the game, and data where the amount of storage required is variable, save in expanded save data. Because expanded save data can be deleted on the Data Management screen under System Settings, developers must note that this data may disappear at times that are beyond the control of the application. In addition, developers also must consider the fact that packaged versions of applications available on cards may be played on other consoles, and that an SD card other than the one on which the expanded save data accessed last time is stored may be inserted in a console the next time a particular game is played.\nSave the following information in save data to protect a user’s data.\n\tData necessary for progress in a game \tData necessary for consistency with game progress data\nIf data necessary for consistency with game progress is saved in expanded save data and save data is deleted, initialization may be required or consistency of data may be lost if the backup feature is used. This can massively increase work involved in the debugging process, such as requiring you to roll back save data in each location of the game or having to delete save data and then verify the consistency of data.\nWe recommend that the following data also be saved in save data.\n\tImportant data required to enjoy the game\nSuch data includes screenshots taken when a stage is first cleared or congratulatory messages sent from friends. \tData that requires consistency to be maintained across multiple files\nSuch data includes command data and textures used to replay scenes.\nThe chance of losing data at the file level is lower with save data. However, with data linked to a single file and saved, the risk of losing the file is the same whether you use expanded save data or save data without redundancy.\nWe recommend that the following data be saved in expanded save data if losing it will not adversely affect game progress.\n\tData that can be redownloaded from the network or that can be re-created while playing the game \tData shared with other applications\nWe advise developers to save data shared between games, particularly games played in parallel, in expanded save data. Developers must keep in mind that using shared data in conjunction with the save data backup feature may lead to dishonest activity such as generating an excessive number of items. \tData where the number of files or amount of storage required is not fixed\nSuch data includes music or stages created by the user or videos recorded by the user.\nWith expanded save data, you specify the number of files and directories that can be saved, but there is no limit on the size of files. In the case of save data, on the other hand, even though the number of directories and files that can be saved is similarly specified when save data is initialized, save data is unsuitable for saving multiple instances of data having an unfixed size because storage capacity is limited. \tData imported from the save data of another application\nAlthough you can access the save data of other applications, because incompatibilities may arise depending on the particular combination of titles, use expanded save data even when transferring data from an earlier version. Save data may be accessed, however, when transferring save data from a downloadable demo or another download-only application.\nCONFIDENTIAL\n",0]
,["Pages/Page_55582667.html","8. Time ",
"8. Time\nThe 3DS system can handle two kinds of time: ticks as a unit of time, calculated from the system clock; and the real-time clock (RTC) that comes with a battery backup.\nThe system provides a timer and alarm feature that uses system ticks to allow applications to measure the passage of time.\n",0]
,["Pages/Page_55582667.html#PageId_55582668","8.1. Class for Representing Time",
"In addition to a feature to get the current time from the RTC, there is also a feature to set off an alarm at a specified time and date.\n8.1. Class for Representing Time\nThe SDK is designed to use the nn::fnd::TimeSpan class as an argument to time functions, in part to avoid any confusion about units. Within this class, time is expressed in nanoseconds using 64-bit integers. To prevent ambiguity in the units, no implicit conversion from integers to this data type is provided. However, 0 can be converted implicitly to this data type.\nThe nn::fnd::TimeSpan class has static member functions (the From*Seconds functions) for generating instances of this class from integer values expressing the time in various time units (seconds, milliseconds, microseconds, or nanoseconds). It also has member functions (the Get*Seconds functions) that can obtain the time value of the instance (measured in seconds, milliseconds, microseconds, or nanoseconds) as an s64 type.\nYou can also perform comparison (==, !=, <, >, <=, ,>=) and arithmetic (+, -, +=, -=) operations between instances of this class.\nCode 8-1. Instance Generation and Get Functions for the Various Time Units\n // From*Seconds()\nstatic nn::fnd::TimeSpan FromSeconds(s64 seconds);\nstatic nn::fnd::TimeSpan FromMilliSeconds(s64 milliSeconds);\nstatic nn::fnd::TimeSpan FromMicroSeconds(s64 microSeconds);\nstatic nn::fnd::TimeSpan FromNanoSeconds(s64 nanoSeconds);\n// Get*Seconds()\ns64 GetSeconds() const;\ns64 GetMilliSeconds() const;\ns64 GetMicroSeconds() const;\ns64 GetNanoSeconds() const;\n",0]
,["Pages/Page_55582667.html#PageId_55582669","8.2. Ticks",
"\n8.2. Ticks\nA tick is the time it takes for the CPU to go through one clock cycle while the CPU is operating at 268 MHz (roughly 3.73 nanoseconds). The number of ticks in one second is defined by the nn::os::Tick::TICKS_PER_SECOND constant.\n Warning:\n When running in extended mode on SNAKE, the tick value remains the same as in standard mode. In other words, one tick is the equivalent to three CPU clock cycles while in extended mode.\nTick values are available using the nn::os::Tick class, and the conversion constructors and conversion operators let you convert from this class to the nn::fnd::TimeSpan class (which represents actual time), and vice versa.\nTwo constructors are available: one generates an instance from the tick value represented by an s64 type, and the other generates an instance from the tick value converted from the time represented by an object of the nn::fnd::TimeSpan class.\nThe conversion operators include one to convert from a tick value to an s64-type value and another to convert to an object of the nn::fnd::TimeSpan class. You can also perform arithmetic (+, -, +=, -=) operations between instances of the nn::os::Tick class.\nIn addition, you can call the ToTimeSpan function to generate an instance of the nn::fnd::TimeSpan class that expresses the time span converted from a tick value.\nCall the GetSystemCurrent function to get the time elapsed since the system was started up as a tick value (an instance of the nn::os::Tick class).\n",0]
,["Pages/Page_55582667.html#PageId_55582670","8.3. Timers",
"\n8.3. Timers\nThe timer feature sends a notification when the specified amount of time has passed. A timer object may be in the signaled or non-signaled state, and it transitions from the non-signaled to the signaled state when the specified time has passed. Timer instances are limited to eight at any one time.\nTimer objects are defined by the nn::os::Timer class. Generate an instance and then call the Initialize or TryInitialize function to initialize. When initializing a timer object, you can choose whether to manually or automatically reset its signaled state. After a manual-reset timer enters the signaled state, all threads waiting for that timer to enter the signaled state are released and the timer remains in the signaled state until it is cleared. After an automatic-reset timer enters the signaled state, of those threads that are waiting for it to enter the signaled state, only the highest-priority thread is released, after which the object resets itself to the non-signaled state.\nThere are single-use timers that only transition to the signaled state once after the allotted time, and multi-use periodic timers that transition to the signaled state in cycles of the specified period. Call the StartOneShot function to start a single-use timer. Call the StartPeriodic function to start a periodic timer. You can stop both timer types by calling the Stop function.\nCall the Wait function to cause a thread to wait until a timer enters the signaled state. Call the Signal function to put a timer in the signaled state without waiting the specified time. After a manually resetting timer enters the signaled state, it remains that way until you call the ClearSignal function.\nCall the Finalize function to explicitly destroy an instance.\nFor more information about applications that use timers, see 5.3.1.1. Cautions When Shutting Down. Be sure to carry out all proper processing, such as destroying object instances, at this time.\n",0]
,["Pages/Page_55582667.html#PageId_55582671","8.4. Alarms",
"\n8.4. Alarms\nAn alarm is a feature that calls the registered handler after the specified time has passed. Alarms generate threads internally to call the handler. Consequently, you must call the nn::os::InitializeAlarmSystem function to initialize the alarm system prior to using alarms.\nAlarm objects are defined by the nn::os::Alarm class. Generate an instance and then call the Initialize or TryInitialize function to initialize.\nThere are single-use alarms that only call the handler once after the allotted time, and multi-use periodic timers that call the handler in cycles of the specified period. Call the SetOneShot function to set a single-use alarm. Call the SetPeriodic function to set a periodic alarm. You can cancel both alarm types by calling the Cancel function.\nCall the CanSet function to check whether alarms can be set. This returns false if an alarm is set and the handler has yet to be called. Even after canceling an alarm by calling Cancel, this check will not return true until the handler has been called once.\nHandler types are defined below.\nCode 8-2. Alarm Handler Type Definitions\n typedef void(* nn::os::AlarmHandler)(void *param, bool cancelled);\nAny arguments needed when setting the alarm are passed in the param parameter. Generally, false is passed in the cancelled parameter, but true is passed when the handler has been called after the alarm was canceled with the Cancel function.\nCall the Finalize function to explicitly destroy an instance.\n Warning:\n In the current implementation, the alarm system uses two threads internally. As a result, the alarm system becomes unstable if you register many handlers that take a long time to complete.\nFor more information about applications that use alarms, see 5.3.1.1. Cautions When Shutting Down. Be sure to carry out all proper processing, such as destroying object instances, at this time.\n",0]
,["Pages/Page_55582667.html#PageId_55582672","8.5. RTC",
"\n8.5. RTC\nRTC stands for “real-time clock,” the hardware clock included in the system. The clock has its own battery backup and continues keeping time even if the system loses power.\nYou can only set the clock from the system settings. The clock can be set forward as far as 2049/12/31, but the clock itself can keep time until it reaches 2099/12/31. Because the clock will not reach its upper limit until at least 50 years have passed since it was set, there is no need to check whether the clock has reset itself while an application is running.\n",0]
,["Pages/Page_55582667.html#PageId_55582673","8.5.1. Class for Representing Dates and Times",
"This section explains how to use RTC time in an application.\n8.5.1. Class for Representing Dates and Times\nThe CTR-SDK system provides the nn::fnd::DateTime class for representing dates and times. You can get the current time of the RTC by calling the nn::fnd::DateTime::GetNow function, which returns an instance of this class.\nThe constructor with arguments allows you to specify milliseconds in addition to the year, month, day, hours, minutes, and seconds. The constructor with no parameters generates an instance representing 2000/01/01 00:00:00.000.\nThe dates and times that can be handled by this class are in the range from nn::fnd::DateTime::MIN_DATE_TIME (1900/01/01 00:00:00.000) to nn::fnd::DateTime::MAX_DATE_TIME (2189/12/31 23:59:59.999). All years are calculated in the Gregorian calendar with 2000/01/01 (Sat) as the standard, and the dates and times that are calculated assume that one day is exactly 86,400 seconds in length.\nWhen subtracting one nn:fnd::DateTime class instance from another, the date and time difference is returned as an instance of the nn::fnd::TimeSpan class. When adding an nn::fnd::TimeSpan instance to an nn::fnd::DateTime instance, the resulting date and time is returned as an instance of the nn::fnd::DateTime class.\nThe year, month, day, day of the week, hour (in 24-hour notation), minute, second, and millisecond are available as date and time parameters. All of these parameters can be obtained using Get* functions, and all of them except for the day of the week can be replaced using Replace* functions. The Get* function for the day of the week parameter returns an enumerated type (nn::fnd::Week), whereas the Get* functions for all other parameters return s32 values. The Replace* functions return new instances that have the replaced parameters. The parameters of the original instance will not be overwritten.\nIn the versions of the GetParameters and FromParameters functions that take the nn::fnd::DateTimeParameters structure as arguments, you can get or replace all parameters at the same time. In calls to FromParameters, the member of the structure that indicates the day of the week are ignored. The result is indeterminate if the date/time parameters are replaced with invalid values. You can check whether a particular set of date/time parameters is valid by calling the IsValidParameters function. In functions that take a structure as an argument, the day of the week is also checked for validity, so you must be careful when setting the parameters for the structures. If the day of the week is unknown, check the validity using an overloaded version of the function that does not take the day of the week as an argument.\nThe DateToDays function returns a value indicating how many days have passed between the reference date (2000/01/01) and the specified date. The result is indeterminate if an invalid date was specified. To check whether a given date is valid, call the IsValidDate function. To check whether a particular year is a leap year, call the IsLeapYear function, which returns 1 if the specified year is a leap year.\nThe DaysToDate function returns the number of days that have elapsed since the reference date. The DaysToWeekday function returns the number of days that have elapsed since the reference day of the week.\n",0]
,["Pages/Page_55582667.html#PageId_55582674","8.5.2. RTC Alarm Feature",
"\n8.5.2. RTC Alarm Feature\nThe system includes an RTC alarm feature. This feature sends a notification to the running application when the time set for the alarm is reached. Alarm times can be set by the minute. Depending on the clock settings, the alarm notification may be delayed by around one minute. The alarm feature is suitable as an alarm clock or for similar uses, but it is not suitable for precise time-based notification applications, such as an hourglass. For these uses, see 8.3. Timers or 8.4. Alarms.\nUse the RTC alarm feature in the PTM library. You must first initialize the library by calling nn::ptm::Initialize before you can use it. After you are done using it, call nn::ptm::Finalize.\nCode 8-3. Initializing and Finalizing the PTM Library\n nn::Result nn::ptm::Initialize();\nnn::Result nn::ptm::Finalize();\nThe RTC alarm feature notifies the running application that the clock has reached the set time by setting the specified event to the signaled state.\n Warning:\n The application cannot receive notification while in Sleep Mode. When displaying the HOME Menu or a library applet, the thread that started the HOME Menu or library applet remains suspended and the event enters the signaled state. Care must be taken not to implement an RTC alarm in a standby thread because it will not have permission to perform graphics or sound operations.\nUse the following functions to specify the event to use and to set the alarm time.\nCode 8-4. RTC Alarm Feature Functions\n nn::Result nn::ptm::RegisterAlarmEvent(nn::os::Event &event);\nnn::Result nn::ptm::SetRtcAlarm(nn::fnd::DateTime datetime);\nnn::Result nn::ptm::GetRtcAlarm(nn::fnd::DateTime *pDatetime);\nnn::Result nn::ptm::CancelRtcAlarm();\nCall nn::ptm::RegisterAlarmEvent to specify the event to receive the RTC alarm feature notification. The application must generate and initialize the instance of the nn::os::Event class passed in the event parameter.\nCall nn::ptm::SetRtcAlarm to set the alarm time. For the datetime parameter, specify an instance of the nn::fnd::DateTime class with the instance’s time specified in minutes. This function returns nn::ptm::ResultOverWriteAlarm if the alarm time is already set, but it does indeed overwrite the alarm time with the new value. There is no immediate notification if the time set is in the past.\nCall nn::ptm::GetRtcAlarm to get the alarm’s current setting. For the pDatetime parameter, pass a pointer to an instance of the nn::fnd::DateTime class to receive the alarm time. The function returns nn::ptm::ResultNoAlarm if the alarm is not set.\nCall nn::ptm::CancelRtcAlarm to cancel a previously set RTC alarm. The function returns nn::ptm::ResultNoAlarm if the alarm is not set.\n",0]
,["Pages/Page_55582667.html#PageId_55582675","8.5.3. Handling Time Modification Offset Values",
"\n8.5.3. Handling Time Modification Offset Values\nThe system records the cumulative offset value in seconds when the user changes the clock time in system settings either forward or back. Call nn::cfg::GetUserTimeOffset to get this offset value. For more information, see 11.2.8. RTC Modification Offset Value.\nWhen starting an application on the same system, you can compare this offset value with the offset from the last time the application was started to check whether the user has changed the clock in the meantime. You can then use this in your application, but note that, when started on a different system, the application must not impede player progress due to different values.\n",0]
,["Pages/Page_55582667.html#PageId_55582676","8.6. Mixed Use of Ticks and RTCs Prohibited",
"\n8.6. Mixed Use of Ticks and RTCs Prohibited\nTicks (the nn::os::Tick class) and RTCs (the nn::fnd::DateTime class) handle time similarly, but how time advances and the accuracy is different. If the same time period is measured by tick and RTC, the results are not necessarily the same. For this reason, values obtained with ticks must not be used in combination with values obtained using an RTC.\nTicks differ on individual systems and vary significantly with temperature. They can have a margin of error up to ±300 seconds over a period of a month.\nRTCs also differ on individual systems and vary significantly with temperature. They can have a margin of error up to ±60 seconds over a period of a month. nn::fnd::DateTime::GetNow returns an interpolated current time value so its speed of advance can vary by up to ±1 s per hour.\nMost of the time that time is handled within libraries, such as for sound, animation or streaming playback, the speed of advancing time is again different from that for ticks and an RTC. Because of this, when an application must synchronize with a performance or sound playback, you must understand the specifications of individual libraries and use speeds that match those specifications.\nCONFIDENTIAL\n",0]
,["Pages/Page_55582677.html","9. Threads ",
"9. Threads\n",0]
,["Pages/Page_55582677.html#PageId_55582678","9.1. Initializing and Starting",
"The nn::os::Thread class defined in the SDK only defines the basic functions for dealing with threads, such as how to start them, join them, get parameters, and change parameters. Threads used by applications must inherit from this thread class.\n9.1. Initializing and Starting\nAfter the constructor creates a thread, the thread has yet to be either initialized or started. If you are managing the stack in your application, call the Start function to initialize and start a thread; to have the library automatically manage stack memory, call StartUsingAutoStack. Calling the member functions that start with Try (TryStart and TryStartUsingAutoStack) returns an error if the functions fail, such as due to insufficient resources.\n",0]
,["Pages/Page_55582677.html#PageId_55582679","9.1.1. Running Application Threads in the System Core",
"If the application manages stack memory, a GetStackBottom member function (that returns the bottom of the stack as an uptr value) must be defined for the object passed as a stack region to the member functions. Both the nn::os::StackMemoryBlock class, which allocates stack memory blocks, and the nn::os::StackBuffer class, which can be located within static memory and structures, satisfy this condition and can be safely passed as arguments. Make sure that the application does not allow the stack memory to become invalid (released) until after the threads have terminated.\n9.1.1. Running Application Threads in the System Core\nYou can allocate some of the system core’s CPU time for applications to run application threads in the system core.\nTo start a thread in the system core, use the nn::os::SetApplicationCpuTimeLimit function to specify the percentage of CPU time to allocate, and then specify 1 for coreNo. You must allocate CPU time before you start a thread on the system core; failure to do so results in an error.\nCode 9-1. Functions for Allocating CPU Time on the System Core for an Application\n nn::Result nn::os::SetApplicationCpuTimeLimit(s32 limitPercent);\ns32 nn::os::GetApplicationCpuTimeLimit();\nUse the limitPercent parameter to specify the percentage of the system core’s CPU time to allocate to your application. You can specify values in the range from 5 to 30. The specified percentage of CPU time is allocated from the beginning of each 2-millisecond cycle. In other words, specifying a value of 25 causes 0.5 milliseconds (2 * 25 / 100) to be allocated to the application and the remaining 1.5 milliseconds to be allocated to the system.\nYou can use the nn::os::GetApplicationCpuTimeLimit function to get the current ratio of CPU allocation. This returns 0 by default because no CPU time is initially allocated to the application.\n Warning:\n After you have allocated CPU time for your application, you cannot restore this setting to 0.\n Even if no application threads are running, the system will not use the time allocated to the application. As a result, wireless communication and other system core processes slow down after CPU time is allocated to the application.\n",0]
,["Pages/Page_55582677.html#PageId_55582680","9.1.2. ManagedThread Class",
"\n9.1.2. ManagedThread Class\nThe ManagedThread class adds functionality to the Thread class. Basic operation for the two classes is the same, except that the functions for initialization and execution are separated. The following table details the distinction.\nTable 9-1. Functions Added to the ManagedThread Class\n \t Added Features\n \t Associated Functions\n \t Retrieving information related to the stack\n \t GetStackBufferBegin, GetStackBufferEnd, GetStackBufferSize, GetStackBottom, GetStackSize\n \t Name retention\n \t GetName, SetName\n \t Acceleration of ID retrieval\n \t GetId, GetCurrentId\n \t Retrieving the instance corresponding to the current thread\n \t GetCurrentThread\n \t Enumuration of the thread\n \t Enumerate\n \t Searching the thread\n \t FindById, FindByStackAddress\n When sharing resources with the Thread class, the total number of ManagedThread class threads is subject to the restriction of the number of threads that can be created. Also, twice the local storage is consumed to use ManagedThread when the nn::os::ManagedThread::InitializeEnvironment function is called.\n",0]
,["Pages/Page_55582677.html#PageId_55582681","9.2. Thread Functions",
"\n9.2. Thread Functions\nThe operations performed by a thread are implemented in the thread function passed to the member function that initializes and starts the thread. Declare a thread function that takes one or no arguments and does not return a value (a void return type).\nSome of the Start functions of the Thread class can be used by a thread function that does not take any arguments, and there is an overloaded version that lets you use a template to specify the type of argument that is passed to a thread function. Note that because the arguments passed in are copied to the thread's stack, the template must specify arguments of types that can be copied and the amount of space available in the stack will be reduced by an equivalent amount.\n",0]
,["Pages/Page_55582677.html#PageId_55582682","9.3. Completion and Destruction",
"\n9.3. Completion and Destruction\nA thread completes when its thread function completes or when it is released from the blocked state by the parent nn::os::WaitObject class's Wait* functions. The Join function waits for thread completion unconditionally. If you need more fine-grained control (for example, to wait with a timeout), wait for the thread to exit using the nn::os::WaitObject::WaitOne function and then call Join. Follow this same approach if you need to avoid thread blocking due to the Join function.\nCall the IsAlive function to check whether a thread is still alive (not yet completed).\nCall the Finalize function to destroy an unneeded thread. When doing so, you must follow the procedure below.\nIf the thread was started using the Start or TryStart functions, you must explicitly call the Join function before destroying the thread. Do not call Detach.\nIf the thread was started using the StartUsingAutoStack or TryStartUsingAutoStack functions, you must explicitly call the Join or Detach functions before destroying the thread. After calling Detach, you can only call the Finalize function or the destructor for that thread.\n",0]
,["Pages/Page_55582677.html#PageId_55582683","9.4. Scheduling",
"\n9.4. Scheduling\nThreads are scheduled according to their priority, and you can set the priority of any thread. Thread priorities can be specified as integers between 0 and 31, with 0 indicating the highest priority and 31 the lowest. Standard threads specify the DEFAULT_THREAD_PRIORITY of 16.\nCall the Yield function to yield execution to other threads of the same priority. This has no effect if there are no threads with the same priority.\nCall the Sleep function to put threads into a sleep state for a specified time.\nWhen scheduling occurs as a result of an interrupt to a currently executing thread, the interrupted thread is placed at the top of the thread queue and scheduling is controlled so there is as little thread switching as possible. If you try to create and execute a new thread with a priority lower than or equal to the currently executing thread, thread switching may not occur if an interrupt from a system process prevents immediate scheduling. We recommend using events to wait for thread switching if you need to ensure thread switching.\n",0]
,["Pages/Page_55582677.html#PageId_55582684","9.5. Getting and Setting Parameters",
"\n9.5. Getting and Setting Parameters\nEach thread has its own parameters: a thread ID and a priority.\nTo get a parameter, call the Get* member function to get the instance parameter; to get the parameter for the current thread, call the GetCurrent* member function. Similarly, call the Change* or ChangeCurrent* functions to set a parameter.\nCall the GetMainThread function to get the current thread (main thread) object.\n",0]
,["Pages/Page_55582677.html#Anchor_55582684_スレッドID","Thread ID",
"Thread ID\nEach thread is assigned its own ID as a bit32 type. You can get these IDs by calling the GetId or GetCurrentId functions, but the IDs cannot be changed.\n",0]
,["Pages/Page_55582677.html#Anchor_55582684_優先度","Priority",
"Priority\nYou can set the priority for each thread as an s32 type. Use the GetPriority or GetCurrentPriority functions to get the current priority. Call the ChangePriority or ChangeCurrentPriority functions to change the priority.\n",0]
,["Pages/Page_55582677.html#PageId_55582687","9.6. Thread-Local Storage",
"\n9.6. Thread-Local Storage\nEach thread for storing uptr types has 16 slots of thread-local storage. You can reserve thread-local storage for use by generating an instance of the nn::os::ThreadLocalStorage class, but attempting to reserve more than 16 slots will fail, and the application will be forcibly halted by a PANIC.\nTo set a value in thread-local storage, call the SetValue function; to get a value, call the GetValue function. All thread-local storage slots are set to 0 when a thread is started.\nUse the nn::os::ThreadLocalStorage class constructor with parameters to register a callback function to be called when ending a thread. The thread-local storage value is passed as an argument when the callback function is called.\n",0]
,["Pages/Page_55582677.html#PageId_55582688","9.7. Synchronization Objects",
"\n9.7. Synchronization Objects\n",0]
,["Pages/Page_55582677.html#PageId_55582689","9.7.1. Critical Sections",
"Access to non-thread-safe libraries or shared resources must be handled by means of the application synchronizing between threads. The SDK provides synchronization objects such as the CriticalSection class.\n9.7.1. Critical Sections\nA CriticalSection is a synchronization object used to provide mutual exclusion. Allowing only one thread at a time to enter a CriticalSection object effectively prohibits multiple threads from accessing the same resource at the same time. CriticalSection objects require more memory than mutexes (described below), but are faster in most cases. There is no upper limit on how many can be created as long as there is memory available.\nCriticalSection objects are defined by the nn::os::CriticalSection class. Generate an instance and call the Initialize or TryInitialize function to initialize, and then call the Enter or TryEnter functions to enter the CriticalSection and lock its resources. If you call Enter to lock a CriticalSection object that is already locked, execution of the thread that called the function will be blocked until the existing lock is released. These objects allow recursive locks, A lock request from the thread that has the original lock will be nested (the nesting level will be incremented) without the thread being blocked. If you call TryEnter instead, the function returns only whether it succeeded in entering the object, and the thread is not blocked.\nCall the Leave function to release a lock on a CriticalSection object. If this function is called from the locking thread, the nesting level is decremented and the lock is released when the nesting level reaches 0.\nCall the Finalize function to explicitly destroy an instance.\n",0]
,["Pages/Page_55582677.html#PageId_55582690","9.7.1.1. Thread Priority Inversion",
"Use the nn::os::CriticalSection::ScopedLock object to lock a CriticalSection object. The lock is automatically released when the object goes out of scope.\n9.7.1.1. Thread Priority Inversion\nCriticalSection objects do not inherit the priority of the thread that generates them. Consequently, if low-priority thread A has a lock on a CriticalSection object and then high-priority thread B requests a lock on that object, thread B may be blocked by some thread C, which has a priority higher than A, but lower than B. In other words, B's priority is effectively lowered, with B's and C's relative priority levels being inverted.\n",0]
,["Pages/Page_55582677.html#PageId_55582691","9.7.2. Mutexes",
"\n9.7.2. Mutexes\nMutexes are synchronization objects used for providing mutual exclusion. Much like CriticalSections, these objects effectively prohibit multiple threads from accessing the same resource at the same time. Unlike CriticalSections, they implement thread priority inheritance, and there is a limit of 32 on how many can be created. Due to priority inheritance, if a high-priority thread requests a lock on a mutex object that is already locked by a low-priority thread, the locking thread's priority is temporarily increased to match the priority of the thread that requested a lock.\nMutex objects are defined by the nn::os::Mutex class. Generate an instance and call the Initialize or TryInitialize function to initialize, and then call the Lock or TryLock functions to lock a mutex object. If you call Lock to lock a mutex object that is already locked, execution of the thread that called the function will be blocked until the existing lock is released. Mutex objects allow recursive locks. Requesting another lock from the same thread causes the new lock request to be nested. If you call TryLock instead, the function returns only whether it succeeded in locking the object within the timeout period, and the thread will not be blocked.\nCall the Unlock function to release the lock on a locked mutex object. Unlock can only be called from the thread that has the current lock. The object will not be unlocked until all recursive locks have been released.\nCall the Finalize function to explicitly destroy an instance.\nUse the nn::os::Mutex::ScopedLock class to lock a mutex object. The lock begins when the ScopedLock object is created. The lock is automatically released when the object goes out of scope.\n",0]
,["Pages/Page_55582677.html#PageId_55582692","9.7.3. Events",
"\n9.7.3. Events\nEvents are simple synchronization objects that send notification that an event has occurred. An event object may be in the signaled or non-signaled state, and transitions from the non-signaled to the signaled state when the specified event has occurred. You can synchronize threads by having them wait for an event to occur. You can only have 32 instances of the Event class at any one time.\nEvent objects are defined by the nn::os::Event class. Generate an instance and then call the Initialize function to initialize. During initialization, you can choose whether the event is a manually resetting event or an automatically resetting event. When manually resetting events enter the signaled state, they remain in that state until manually cleared, during which time all threads waiting for that event are released. When automatically resetting events enter the signaled state, only the highest priority thread of all those threads waiting for it to enter the signaled state is released, after which the object resets itself to the non-signaled state.\nCall the Wait function to cause threads to wait until an event enters the signaled state. You can specify the length of the timeout period and also check to see whether an event has occurred during the timeout period. If you set the timeout period to 0, control returns immediately, allowing you to check for event occurrence without execution being blocked.\nCall the Signal function to put an event in the signaled state. When a manually resetting event enters the signaled state, it remains in that state until manually cleared by calling the ClearSignal function. If one or more threads are waiting when an automatically resetting event enters the signaled state, only the highest priority thread of all those threads waiting for it to enter the signaled state will be released, after which the object resets itself to the non-signaled state. If no threads are waiting for events, the object remains in the signaled state.\n",0]
,["Pages/Page_55582677.html#PageId_55582693","9.7.3.1. Light Events",
"Call the Finalize function to explicitly destroy an instance.\n9.7.3.1. Light Events\nLight events are simple synchronization objects that send flag notifications between threads. They are functionally no different from standard events.\nLight events are defined using the nn::os::LightEvent class. The nn::os::LightEvent class is better than the nn::os::Event class in most respects. The only exception is that it cannot wait for multiple synchronization objects like nn::os::WaitObject::WaitAny can. We recommend the use of the nn::os::LightEvent class whenever possible. There is no upper limit on how many can be created as long as there is memory available.\nYou must call the Initialize function on instances that were created using the constructor that has no arguments. During initialization, you can choose whether the event is a manually resetting event or an automatically resetting event. The behavior is the same as the nn::os::Event class in either case. You can also specify the type of event using the non-default constructor. There is no need to call the Initialize function on instances that were created using the constructor that takes arguments.\nWith the exception of the fact that the Wait member function of the nn::os::LightEvent class does not allow you to specify a timeout, the Wait, Signal, ClearSignal, and Finalize member functions of this class work just like the corresponding functions in the nn::os::Event class.\nThe nn::os::LightEvent class adds the following member functions.\nYou can check the flag using the TryWait member function. This function only returns the flag's status and does not block execution of the thread. For LightEvents that are configured as automatically resetting events, the flag is only cleared (that is, set to false to indicate the \"non-signaled\" state) if the flag had previously been set (set to true to indicate the \"signaled\" state). You can use the TryWait function to specify a timeout time.\nThe Pulse member function releases threads that are waiting for the flag to be set. For automatically resetting LightEvents, it only releases the single highest-priority thread and clears the flag. Unlike the Signal member function, it clears the flag even if no threads are waiting. For manually resetting events, it releases all threads that are waiting, and then clears the flag.\n",0]
,["Pages/Page_55582677.html#PageId_55582694","9.7.4. Semaphores",
"\n9.7.4. Semaphores\nSemaphores are synchronization objects that have counters. Every time there is a request to acquire a semaphore, the semaphore counter decrements by 1, while the thread that requested the semaphore waits for the counter to be greater than 0. When a semaphore is released, its counter is incremented by 1. Once its counter is greater than 0, the semaphore is passed to the highest-priority thread of those threads that are waiting on the semaphore. Semaphores can be used to manage resources by limiting the number of threads that can access those resources at the same time. You can only have eight instances of the Semaphore class at any one time.\nSemaphore objects are defined by the nn::os::Semaphore class. Generate an instance and then call the Initialize or TryInitialize function to initialize. When initializing, specify the counter's initial and maximum values.\nCall the Acquire or TryAcquire functions to acquire a semaphore. If the counter is less than 0 when Acquire is called, the calling thread blocks until the semaphore can be acquired. You can specify the length of the timeout period when calling TryAcquire and also check to determine whether the semaphore was acquired during the timeout period. If you set the timeout period to 0, control returns immediately, allowing you to check for semaphore acquisition without execution being blocked.\nCall the Release function to release an acquired semaphore. You can specify either 1 or something other than 1 for the counter increment value; this value is used to assign the initial value of instances that were created with an initial value of 0. When releasing a semaphore, call the function with no arguments so that the counter increment is 1.\n",0]
,["Pages/Page_55582677.html#PageId_55582695","9.7.4.1. Light Semaphores",
"Call the Finalize function to explicitly destroy an instance.\n9.7.4.1. Light Semaphores\nLight semaphores are synchronization objects that have the same features as standard semaphores. Light semaphores are defined using the nn::os::LightSemaphore class. The nn::os::LightSemaphore class is better than the nn::os::Semaphore class in most respects. The only exception is that it cannot wait for multiple synchronization objects like nn::os::WaitObject::WaitAny can. We recommend the use of nn::os::LightSemaphore class whenever possible. There is no upper limit on how many can be created as long as there is memory available.\nThe difference between light semaphores and standard semaphores is that light semaphores do not define a TryInitialize member function. The member functions of the nn::os::LightSemaphore class work just like the corresponding functions in the nn::os::Semaphore class.\n",0]
,["Pages/Page_55582677.html#PageId_55582696","9.7.5. Blocking Queues",
"\n9.7.5. Blocking Queues\nBlocking queues are synchronization objects used for safely passing messages between threads. Thread execution is blocked when attempting to either insert more elements into a queue than the buffer size allows or extract an element from an empty queue. When a thread is waiting for messages from multiple other threads, blocking queues can be used to pass messages from one to many, or from many to many. These blocking queues are equivalent to the \"message queue\" feature in the NITRO, TWL, and Revolution SDKs.\nTwo classes define blocking queues: nn::os::BlockingQueue and nn::os::SafeBlockingQueue. nn::os::BlockingQueue uses CriticalSection objects internally for synchronizing between threads, which could lead to deadlocks in situations where priorities might be inverted. If this problem is a possibility, use nn::os::SafeBlockingQueue, which uses mutexes to avoid such issues. The member variables and functions are the same for both classes.\nGenerate an instance and then call the Initialize or TryInitialize function to initialize. When initializing, specify an array of type uptr and the number of array elements to use as the queue buffer.\nCall the Enqueue or TryEnqueue functions to add an element (of type uptr) to the end of the queue. If the queue is full when Enqueue is called, the calling thread is blocked until an element can be added to the queue. When calling TryEnqueue, control is returned whether or not an element was successfully added, allowing you to attempt to add an element without execution being blocked.\nCall the Jam or TryJam functions to insert an element at the beginning of the queue. If the queue is full when Jam is called, the calling thread is blocked until an element can be added to the queue. When calling TryJam, control is returned regardless of whether an element was successfully added, allowing you to attempt to add an element without execution being blocked.\nCall the Dequeue or TryDequeue functions to remove an element from the beginning of the queue. If the queue is empty when Dequeue is called, the calling thread is blocked until an element can be removed from the queue. When calling TryDequeue, control is returned regardless of whether an element was successfully removed, allowing you to attempt to remove an element without execution being blocked.\nCall the GetFront or TryGetFront functions to get the first element in a queue without removing the element. If the queue is empty when GetFront is called, the calling thread is blocked until an element can be obtained from the queue (that is, until an element is added to the queue). When calling TryGetFront, control is returned regardless of whether an element was successfully obtained, allowing you to attempt to remove an element without execution being blocked.\nCall the Finalize function to explicitly destroy an instance.\n",0]
,["Pages/Page_55582677.html#PageId_55582697","9.7.6. Light Barriers",
"\n9.7.6. Light Barriers\nLight barriers are synchronization objects that wait for the arrival of multiple threads. Until the number of threads specified during initialization is met, any threads that arrive early are made to wait. However, this class cannot be used to wait for the arrival of M out of N threads (M < N).\nLight barriers are defined using the nn::os::LightBarrier class. You must call the Initialize function on instances that were created using the constructor that has no arguments. During initialization, you specify how many threads to wait for. You can also specify the number of threads to wait for using the version of the constructor that takes arguments. There is no need to call the Initialize function on instances that were created using the constructor that takes arguments. There is no upper limit on how many light barriers can be created as long as there is memory available.\nThe Await member function waits for other threads to arrive. Thread execution is blocked until the number of threads specified when this function was called have arrived.\n",0]
,["Pages/Page_55582677.html#PageId_55582698","9.7.7. Deadlocks",
"\n9.7.7. Deadlocks\nYou must make sure to avoid deadlocking when using critical sections, mutexes, and semaphores for mutual exclusion between multiple threads.\nFor example, assume two threads A and B, which need mutex objects X and Y to access resources. If A locks X and B locks Y, both threads A and B will be permanently blocked. This situation is known as being deadlocked.\nOne simple method to avoid deadlocks is to have all threads that need to access resources request mutex locks in the same predetermined order.\n",0]
,["Pages/Page_55582677.html#PageId_55582699","9.8. Upper Limit of Resources",
"\n9.8. Upper Limit of Resources\nThe number of instances that can be generated at the same time for threads, synchronous objects, and timers is restricted.\nClasses for which the number of instances that can be generated is restricted are listed below.\n\tnn::os::Thread class (See 9.1. Initializing and Starting through 9.6. Thread-Local Storage.) \tnn::os::Event class (See 9.7.3. Events.) \tnn::os::Mutex class (See 9.7.2. Mutexes.) \tnn::os::Semaphore class (See 9.7.4. Semaphores.) \tnn::os::Timer class (See 8.3. Timers.)\nThe member functions defined to get that number of resources and upper limit are shown below.\nCode 9-2. Member Functions to Get Number of Resources Used and Upper Limit\n static s32 GetCurrentCount();\nstatic s32 GetMaxCount();\nThe GetCurrentCount function returns the number of instances currently being used.\nThe GetMaxCount function returns the upper limit value for the number of instances that can be generated.\nBecause the library and other functions begin generating these instances as soon as the application has started, further restrictions to the number of resources the application can use might occur. For more information, see 8. Upper Limit of Resources in the CTR System Programming Guide, and the explanations for each library.\nCONFIDENTIAL\n",0]
,["Pages/Page_55582700.html","10. Sound ",
"10. Sound\n",0]
,["Pages/Page_55582700.html#PageId_55582701","10.1. Initialization",
"The CTR-SDK sound library controls sound playback by communicating with the components loaded by the DSP library. The sound library comes with 24 voice objects. An application can allocate the required number of voice objects from this selection and then play back sounds by registering a wave buffer (information about sound source data).\nFigure 10-1. How Sound-Related Libraries Interact\nDSP Library SND Library Voice WaveBuffer ChannelCount SampleFormat SampleRate Pitch Priority State MixParam Volume MasterVolume Status Data DefaultComponent DspCycles SyncObject status loopFlag userParam bufferAddress sampleLength Component Send Allocate Append Signal pAdpcmContext Member [R/W] Member [Read] next Id Class/Structure Member [Write] Member [Hidden] AdpcmParam InterpolationType AuxReturnVolume AuxCallback\n10.1. Initialization\nYou must use the DSP library to play back sound on the system. Consequently, before initializing the SND library used for sound playback, you must initialize the DSP library and load the components for sound playback.\nUse the nn::dsp::Initialize function to initialize the DSP library, and then use the nn::dsp::LoadDefaultComponent function to load the components for sound playback.\nCall the nn::snd::Initialize function to initialize the SND library.\nCode 10-1. Initializing the DSP and SND Libraries\n nn::Result result;\nresult = nn::dsp::Initialize();\nresult = nn::dsp::LoadDefaultComponent();\nresult = nn::snd::Initialize();\n",0]
,["Pages/Page_55582700.html#PageId_55582702","10.1.1. Setting the Number of Output Buffers",
"\n10.1.1. Setting the Number of Output Buffers\nYou can use the nn::snd::SetOutputBufferCount function to specify the number of output buffers for the sound data that is ultimately output from the DSP.\nCode 10-2. Setting the Number of Output Buffers\n void nn::snd::SetOutputBufferCount(s32 count);\ns32 nn::snd::GetOutputBufferCount();\nYou can specify a count of either 2 or 3. The default is 2.\nTwo output buffers minimize the delay until sound data is actually played, but sound may break up if there are delays in sound thread processing.\nThree output buffers cause sound to be delayed by approximately five milliseconds more than two output buffers, but they also prevent sound from breaking up when there are slight delays in the sound thread.\nThis function clears the content of the output buffers. Call it immediately after the library is initialized or at another time when sound is not being played.\nYou can get the current setting with the nn::snd::GetOutputBufferCount function.\n",0]
,["Pages/Page_55582700.html#PageId_55582703","10.2. Allocating Voice Objects",
"\n10.2. Allocating Voice Objects\nThe SND library synthesizes and then plays sounds on the basis of the information about the sound source data bound to the library's 24 voice objects. In other words, the library can play sounds from up to 24 sound sources at the same time.\nVoice objects are limited resources. An application must use the nn::snd::AllocVoice function to allocate voice objects to bind to the sound source data for playback.\nCode 10-3. Allocating Voice Objects\n nn::snd::Voice* nn::snd::AllocVoice(\n s32 priority, nn::snd::VoiceDropCallbackFunc callback, uptr userArg);\nThe priority parameter specifies the priority of the voice object to allocate in the range from 0 to nn::snd::VOICE_PRIORITY_NODROP (0x7FFF = 32767). The higher the value, the higher the priority. If you specify a value outside of this range, an assert fails and processing halts.\nSpecifying a value for priority changes the behavior of the function when the maximum number of voice objects has already been allocated.\nWhen priority is set to nn::snd::VOICE_PRIORITY_NODROP and the lowest-priority allocated voice objects are also nn::snd::VOICE_PRIORITY_NODROP, voice object allocation fails and the function returns NULL. For any other value, the lowest-priority allocated voice object is dropped. Attempting to allocate a lowest-priority voice object will fail.\nThe callback parameter specifies the callback function to be called after the library forcibly drops a voice object. No callback occurs when this value is NULL. The userArg parameter specifies any arguments to be passed to the callback. Specify NULL if this is not needed.\nThe types of the callback functions are defined as follows.\nCode 10-4 Voice Object Drop Callback Function\n typedef void (* VoiceDropCallbackFunc)(nn::snd::Voice *pVoice, uptr userArg);\n",0]
,["Pages/Page_55582700.html#PageId_55582704","10.2.1. Dropped-Voice Mode",
"The pVoice parameter takes a pointer to the dropped voice object, and the userArg parameter takes any arguments specified at allocation.\n10.2.1. Dropped-Voice Mode\nThe SND library releases (drops) low-priority voice objects when an attempt is made to allocate more than the maximum number of voice objects and when internal DSP processing is in danger of increasing.\nTwo modes exist to control this latter restriction; you can use the nn::snd::SetVoiceDropMode function to configure them.\nCode 10-5 Setting the Dropped-Voice Mode\n void nn::snd::SetVoiceDropMode(nn::snd::VoiceDropMode mode);\nWhen mode is VOICE_DROP_MODE_DEFAULT, only predicted values are used to determine whether to drop voice objects.\nWhen mode is VOICE_DROP_MODE_REAL_TIME, both predicted values and the actual processing load are used to determine whether to drop voice objects. You must configure three output buffers to be used when you set this mode.\n",0]
,["Pages/Page_55582700.html#PageId_55582705","10.3. Setting Sound Source Data Information",
"\n10.3. Setting Sound Source Data Information\nThe memory region (buffer region) for storing sound source data must be allocated as a contiguous 32-byte-aligned region in device memory. The buffer region must be 32-byte aligned and sized to a multiple of 32 bytes. When allocating sound source data buffers from this region, buffers must be contiguous memory regions and the starting addresses must be 32-byte aligned, but the 32-byte multiple size restriction does not apply.\nIn some cases, sound source data written to a buffer might only be written to the cache. Be sure to call the nn::snd::FlushDataCache function to write the data to memory.\nPass the sound source data to the DSP as an nn::snd::WaveBuffer sound source data information structure. Sound source data information must be initialized with the nn::snd::InitializeWaveBuffer function before configuring information about the sound source data. This is also the case when reusing information about sound source data that has already been played.\nAfter initializing the sound source data, set the following member variables: bufferAddress for the starting address of the buffer, sampleLength for the sample length, and loopFlag for marking whether to loop playback. Specify the DSP ADPCM sample format using the pAdpcmContext member variable. You can specify a value of your own choosing for the user parameter (userParam). Do not change the values of the other members of this structure.\nSet other information about the sound source data (number of channels, sample format, sampling rate, and basic information about ADPCM parameters) in the voice object.\nUse the nn::snd::Voice::SetChannelCount function to set the number of channels. Set this number to 1 for monaural data, and 2 for stereo data. Any other values are invalid.\nUse the nn::snd::Voice::SetSampleFormat function to set the sample format. The SND library supports 8-bit, 16-bit PCM, and DSP ADPCM formats.\nTable 10-1. List of Sample Formats\n \t Value\n \t Type\n \t Stereo Playback\n \t SAMPLE_FORMAT_PCM8\n \t 8-bit PCM\n \t Interleaved\n \t SAMPLE_FORMAT_PCM16\n \t 16-bit PCM\n \t Interleaved\n \t SAMPLE_FORMAT_ADPCM\n \t DSP ADPCM\n \t No\n When the sample format is DSP ADPCM, set the ADPCM parameters using the nn::snd::Voice::SetAdpcmParam function. Set the nn::snd::WaveBuffer member variable pAdpcmContext to the address of the ADPCM context data structure stored in the sound source data, and do not change the context data until after playback has finished.\nUse the nn::snd::Voice::SetSampleRate function to set the sampling rate. Use the frequency of the sound source data.\nUse the nn::snd::Voice::SetInterpolationType function to set the method of interpolating the sound data. Use the nn::snd::Voice::GetInterpolationType function to get the current setting. Three interpolation methods are supported, as shown in the following table. The default value is INTERPOLATION_TYPE_POLYPHASE.\nTable 10-2. List of Interpolation Methods\n \t Value\n \t Interpolation Method\n \t INTERPOLATION_TYPE_POLYPHASE\n \t Interpolation using four points. The optimal coefficients are chosen based on the specified sampling rate and pitch.\n \t INTERPOLATION_TYPE_LINEAR\n \t Linear interpolation.\n \t INTERPOLATION_TYPE_NONE\n \t No interpolation. Noise occurs in the sound played back when the sound source data sampling frequency is not 32,728 Hz.\n After setting all the information about the sound source, use the nn::snd::Voice::AppendWaveBuffer function to register the sound source to the voice object. Multiple sound sources can be registered consecutively, but 4 is the maximum number of sound sources that can be played back by one voice object in one sound frame (roughly 4.889 ms).\nUse the nn::snd::WaveBuffer member variable Status to check the state of a sound source after registration. This state is STATUS_FREE before a voice object is registered, STATUS_WAIT while waiting for playback, STATUS_PLAY during playback, and STATUS_DONE after playback has finished. Sound source data is managed by the voice object when in STATUS_WAIT and STATUS_PLAY, so do not change any settings when in these states.\nYou can modify a registered sound source by calling nn::snd::Voice::UpdateWaveBuffer. However, the only information that can be modified is the sample length (sampleLength) and loop specification flag (loopFlag). Additionally, depending on when the data is updated using SendParameterToDsp, data after the specified sample length might be played back, or modifications might be invalid because playback is already completed.\nYou can delete a registered sound source by calling nn::snd::Voice::DeleteWaveBuffer. Do not overwrite this data by using SendParameterToDsp to update the data until playback is complete.\nFor streaming playback of DSP ADPCM sound source data, you only have to set the pAdpcmContext member variable of the first sound source data registered to the voice object. The context is not updated for sound source data registered later if their pAdpcmContext member variables are set to NULL.\n",0]
,["Pages/Page_55582700.html#PageId_55582706","10.4. Creating Sound Threads",
"\n10.4. Creating Sound Threads\nDesign your application to create threads (sound threads) and have the threads wait for notifications from the DSP library to the SND library. Notifications occur roughly every 4.889 ms. Set the priority of the created threads as high as possible and avoid any intensive processing within the threads to keep sound playback from being interrupted.\nBasically, what sound threads do is loop the following processes.\n \tThe sound thread waits for notification from the DSP library using the nn::snd::WaitForDspSync function. \tThe application checks the state of the sound source data information registered to the allocated voice object. After playback has finished, it registers the next sound source data information for playback using the nn::snd::Voice::AppendWaveBuffer function. When doing so it normally only registers the sound source data information within the sounds thread, while another thread has already loaded the sound source data to be used for sound playback into a buffer. \tThe sound thread calls the nn::snd::SendParameterToDsp function to send any parameters that have changed since the previous notification and any newly registered sound source data information to the DSP to update sound playback.\n Warning:\n Functions that manipulate voice objects are not thread-safe, with the exception of nn::snd::AllocVoice and nn::snd::FreeVoice. You must ensure mutual exclusion (for example, by using a critical section) when calling these functions by threads other than the sound thread.\n",0]
,["Pages/Page_55582700.html#PageId_55582707","10.5. Sound Playback",
"\n10.5. Sound Playback\nStarting, stopping, and pausing sound playback is carried out by changing the state of a voice object. Use the nn::snd::Voice::SetState and nn::snd::Voice::GetState functions to set and get the voice object state. Set the state to STATE_PLAY to start playback, STATE_STOP to stop playback, and STATE_PAUSE to pause playback.\nTable 10-3. Voice Object States\n \t State\n \t Description\n \t STATE_PLAY\n \t Order to start sound playback or an indication that playback is underway.\n \t STATE_STOP\n \t Order to stop sound playback or an indication that playback is stopped.\n \t STATE_PAUSE\n \t Order to pause sound playback or an indication that playback is paused. Set the state to STATE_PLAY to resume playback.\n State changes may not be applied immediately. There may be a slight lag until parameters are sent by the nn::snd::SendParameterToDsp function (in other words, until the sound frame update period (roughly 4.889 ms) has passed).\nThere are various other playback settings aside from states.\n",0]
,["Pages/Page_55582700.html#Anchor_55582707_優先順位","Priority",
"Priority\nUse the nn::snd::Voice::SetPriority function to set the priority of a voice object. Use the nn::snd::Voice::GetPriority function to get the current setting. Sounds are played in the order of voice object priority (for objects of the same priority, the most recently allocated object is played first), so there is a chance that low-priority voice objects might not be played if the processing load is too great.\n",0]
,["Pages/Page_55582700.html#Anchor_55582707_マスターボリューム","Master Volume",
"Master Volume\nThe master volume is the overall volume for the SND library. Use the nn::snd::SetMasterVolume function to set this. Set to a value of 1.0 to play sounds at their normal volume. Call the nn::snd::GetMasterVolume function to get the current setting.\n",0]
,["Pages/Page_55582700.html#Anchor_55582707_ボリューム","Volume",
"Volume\nRepresents the volume for each voice object. Use the nn::snd::Voice::SetVolume function to set the volume. Use the nn::snd::Voice::GetVolume function to get the current setting. Set the volume to 1.0 to specify unity gain.\n",0]
,["Pages/Page_55582700.html#Anchor_55582707_ミックスパラメータ","Mix Parameters",
"Mix Parameters\nMix parameters control the gain for four channels (FrontLeft/FrontRight/RearLeft/RearRight).\nUse the nn::snd::Voice::SetMixParam function to set these parameters. Use the nn::snd::Voice::GetMixParam function to get the current settings. The gain values for the left and right channels are stored in the members of the nn::snd::MixParam structure. Set the gain to 1.0 to play the channel at its normal volume.\nThe sound playback volume is the product of the master volume, volume, and mix parameter values.\n",0]
,["Pages/Page_55582700.html#Anchor_55582707_ピッチ","Pitch",
"Pitch\nPitch is the speed applied to the sampling rate of the sound source data. Use the nn::snd::Voice::SetPitch function to set the pitch. Use the nn::snd::Voice::GetPitch function to get the current setting. Set the pitch to 1.0 to play the data at its normal rate. Setting the pitch to 0.5 for sound source data with a sampling rate of 32 kHz would cause it to play at 16 kHz.\n",0]
,["Pages/Page_55582700.html#Anchor_55582707_問い合わせ","Checking",
"Checking\nUse the nn::snd::Voice::IsPlaying function to check whether a sound is currently playing.\nUse the nn::snd::Voice::GetPlayPosition function to get the current playback position. The value that is returned indicates the starting position (measured in the number of samples) in main memory of the next value that will be processed by the DSP.\n",0]
,["Pages/Page_55582700.html#Anchor_55582707_AUXバス","AUX Buses",
"AUX Buses\nThe two AUX buses (A and B) can be used to apply effects like delay to the sounds being played. To set and get the volume of the AUX buses, call nn::snd::SetAuxReturnVolume and nn::snd::GetAuxReturnVolume, respectively. Set the volume to 1.0 to specify unity gain. Because the mix parameters contain members for setting the gain of the AUX buses, you can adjust the audio data that is sent to the AUX buses for each channel independently.\nTo apply an effect to sounds on the AUX buses, set a callback function for each bus. Set callbacks using nn::snd::RegisterAuxCallback, and clear callbacks using nn::snd::ClearAuxCallback. To get the callback that is currently set, call nn::snd::GetAuxCallback. The types of the callback functions are defined as follows.\nCode 10-6. Callback Functions for AUX Buses\n typedef void(*AuxCallback)(nn::snd::AuxBusData* data, s32 sampleLength,\n uptr userData);\nThe sampling length (not the size in bytes) is passed into the sampleLength parameter, and the sound data is passed into the data parameter. Buffer addresses are set for each channel; by overwriting the data in these buffers, you can play sound data with effects applied as the output from the AUX buses.\n",0]
,["Pages/Page_55582700.html#Anchor_55582707_ボイスの補間方法","Voice Interpolation",
"Voice Interpolation\nYou can set the interpolation method used when converting from the sound source data’s sampling rate to the desired playback frequency. Call the nn::snd::Voice::SetInterpolationType or nn::snd::Voice::GetInterpolationType functions to set or get the interpolation method.\nYou can set the interpolation method to the default four-point (INTERPOLATION_TYPE_POLYPHASE), linear (INTERPOLATION_TYPE_LINEAR), or none (INTERPOLATION_TYPE_NONE). With four-point interpolation, the library chooses the optimal coefficients based on the sampling rate and pitch.\n",0]
,["Pages/Page_55582700.html#Anchor_55582707_フィルタ","Filters",
"Filters\nYou can apply a filter to each voice object. Call the nn::snd::Voice::SetFilterType or nn::snd::Voice::GetFilterType to set or get the filter setting. You can set the filter to monopolar (FILTER_TYPE_MONOPOLE), bipolar (FILTER_TYPE_BIQUAD), or the default (FILTER_TYPE_NONE). There are also functions for setting the coefficients for each filter.\nCall the nn::snd::Voice::SetMonoFilterCoefficients or nn::snd::Voice::GetMonoFilterCoefficients functions to set or get the monopolar filter coefficients. Even if you don’t alter the coefficients, you can specify a cutoff frequency to act as a monopolar low-pass filter.\nCall the nn::snd::Voice::SetBiquadFilterCoefficients or nn::snd::Voice::SetBiquadFilterCoefficients functions to set or get the bipolar filter coefficients. This filter type only allows the coefficients to be specified.\nWhen setting using coefficients, calculate the coefficients for each filter using a base frequency of 32,728 Hz.\n",0]
,["Pages/Page_55582700.html#Anchor_55582707_クリッピングモード","Clipping Mode",
"Clipping Mode\nAny portion of the final sound output that exceeds 16 bits is clipped. Two clipping methods are used: either normal clipping or soft clipping that reduces high-frequency noise. Call the nn::snd::SetClippingMode to set the clipping mode. Specify either CLIPPING_MODE_NORMAL or CLIPPING_MODE_SOFT. Call the nn::snd::GetClippingMode function to get the current setting. Soft clipping is the default clipping mode.\nThe sound output is clipped non-linearly when using soft clipping, which reduces distortion, but this also corrects sample values that are not at the maximum amplitude. This has almost no effect on normal music and most other audio, but harmonics such as single-frequency sine waves may be added for sound input.\nThe following figure shows the waveforms for a high-amplitude sine wave after clipping in each mode. The green shows the results of soft clipping.\nFigure 10-2. Clipping Mode Differences\namplitude Normal Clip Soft Clip tim [sample]\n",0]
,["Pages/Page_55582700.html#Anchor_55582707_自動フェードイン","Automatic Fade-In",
"Automatic Fade-In\nYou can automatically fade in audio from a volume of 0 at the start of playback to the previously set volume over the course of a single sound frame. You can set fade-in processing for each voice object using the nn::snd::Voice::SetStartFrameFadeInFlag function, passing true as the argument to enable fade-in. The default is false (no fade-in).\n",0]
,["Pages/Page_55582700.html#Anchor_55582707_bcwavファイルの利用","Using BCWAV Files",
"Using BCWAV Files\nUse the SetupBcwav function of the nn::snd::Voice class to easily use the waveform files converted by the ctr_WaveConverter tool (bcwav files) for sound playback.\nCode 10-7. Using BCWAV Files\n bool nn::snd::Voice::SetupBcwav(uptr addrBcwav,\n nn::snd::WaveBuffer* pWaveBuffer0, nn::snd::WaveBuffer* pWaveBuffer1,\n nn::snd::Bcwav::ChannelIndex channelIndex = nn::snd::Bcwav::CHANNEL_INDEX_L);\nFor the addrBcwav parameter, specify the starting address of a buffer to load the bcwav file to. The data loaded into the buffer is used (as is) as the sound source data, so the buffer is also subject to the requirements for sound source data. Specifically, the memory must be in device memory with the starting address 32-byte aligned, the buffer size must be a multiple of 32 bytes, and the loaded data must be written to memory using the nn::snd::FlushDataCache function.\nFor the pWaveBuffer0 and pWaveBuffer1 parameters, specify pointers to the nn::snd::WaveBuffer structures used for initial and loop playback. The structures must be created by the application. If you know that the sound source does not have a loop flag set, you can pass NULL to the pWaveBuffer1 parameter.\nFor the channelIndex parameter, when using stereo sound source data, specify which channel’s sound source data to allocate to the Voice class. When using monaural sound source data, you must specify CHANNEL_INDEX_L for this parameter. In the current version, stereo sound source data converted by the ctr_WaveConverter tool is not interleaved. Consequently, you must prepare two instances of the Voice class to play stereo BCWAV files.\nThe function returns true if successful and the data is prepared for playback. Of the parameters not included in the BCWAV file header, values of 1.0 are used as the defaults for the volume and pitch. Mix parameters are not set.\nUse the nn::snd::Bcwav class to access BCWAV file header information.\n",0]
,["Pages/Page_55582700.html#Anchor_55582707_エフェクト（ディレイ、リバーブ）","Effects (Delay and Reverb)",
"Effects (Delay and Reverb)\nYou can apply effects to sound playback by either implementing effects in your application by using an AUX bus callback function, or by using the effects provided by the library.\nThe SND library provides delay (nn::snd::FxDelay class) and reverb (nn::snd::FxReverb class) effects. To use them, generate an instance of the appropriate class, set the effect parameters, allocate working memory, and then call the nn::snd::SetEffect function, specifying the effect instance and the AUX bus to apply the effect to. You can only apply one type of effect per bus, and if you call SetEffect multiple times, only the effect from the last call is applied. The CPU rather than the DSP handles the actual effect processing.\nTo stop using an effect, call the nn::snd::ClearEffect function, specifying the AUX bus to clear. This function only clears effects, and does not cancel any AUX bus callback function.\n Note:\n For more information about the effect parameters, see the API Reference.\n",0]
,["Pages/Page_55582700.html#PageId_55582722","10.5.1. Sound Output Mode",
"\n10.5.1. Sound Output Mode\nThe SND library provides three sound output modes: mono, stereo, and surround. Call nn::snd::SetSoundOutputMode to set the output mode and nn::snd::GetSoundOutputMode to get the current setting.\nCode 10-8. Sound Output Mode Definitions and Getter/Setter Functions\n typedef enum\n{\n OUTPUT_MODE_MONO = 0,\n OUTPUT_MODE_STEREO = 1,\n OUTPUT_MODE_3DSURROUND = 2\n} nn::snd::OutputMode;\nbool nn::snd::SetSoundOutputMode(nn::snd::OutputMode mode);\nnn::snd::OutputMode nn::snd::GetSoundOutputMode(void);\n",0]
,["Pages/Page_55582700.html#PageId_55582723","10.5.1.1. Mono",
"If nn::snd::SetSoundOutputMode returns true, the operation succeeded, and the sound output mode is set to the value specified by the mode parameter. By default, the sound output mode is set to stereo (OUTPUT_MODE_STEREO).\n10.5.1.1. Mono\nThe mix that is output through the left and right speakers is shown below. The four input channels (FrontLeft, FrontRight, RearLeft, and RearRight) are the result of mixing the outputs of all voices with the output of the AUX buses.\nOutput = ( FrontLeft + FrontRight + RearLeft + RearRight ) * 0.5\n",0]
,["Pages/Page_55582700.html#PageId_55582724","10.5.1.2. Stereo",
"\n10.5.1.2. Stereo\nThe mixes that are output through the left and right speakers are shown below. The four input channels (FrontLeft, FrontRight, RearLeft, and RearRight) are the result of mixing the outputs of all voices with the output of the AUX buses.\nOutputLeft = ( FrontLeft + RearLeft )\nOutputRight = ( FrontRight + RearRight )\n",0]
,["Pages/Page_55582700.html#PageId_55582725","10.5.1.3. Surround",
"\n10.5.1.3. Surround\nThe four input channels (FrontLeft, FrontRight, RearLeft, and RearRight) undergo 3D surround processing to impart spatial widening to the output. The four input channels are the result of mixing the outputs of all voices with the output of the AUX buses. This 3D surround operation calculates the speaker output based on the \"position\" and \"depth\" parameters of the virtual speakers. Although the 3D surround operation is performed on the mixed output (as opposed to individual voices), it is possible to bypass the output of the front channels (FrontLeft and FrontRight) on a per-voice basis so that they are not affected by the 3D surround operation.\nAfter 3D surround processing, sound volume tends to seem greater when the pan position is set on either left or right edges compared to when set in the center. If this difference in volume is a concern, correct output accordingly to mitigate the effect, such as by limiting the left and right edge mix parameters to a maximum of roughly 0.8.\n",0]
,["Pages/Page_55582700.html#Anchor_55582725_仮想スピーカーの位置","Positions of the Virtual Speakers",
"Positions of the Virtual Speakers\nUse nn::snd::SetSurroundSpeakerPosition to specify the virtual speaker position mode. If this function succeeds in setting the mode, it returns true.\nCode 10-9. Setting the Virtual Speaker Position\n bool nn::snd::SetSurroundSpeakerPosition(nn::snd::SurroundSpeakerPosition pos);\nSpecify one of the following modes for the pos parameter.\nTable 10-4. Modes for the Virtual Speaker Position\n \t Value\n \t Description\n \t SURROUND_SPEAKER_POSITION_SQUARE\n \t Square mode. Positions the virtual speakers in a square pattern.\n \t SURROUND_SPEAKER_POSITION_WIDE\n \t Wide mode. Positions the left and right virtual speakers further apart.\n The virtual speaker mode determines the angle of symmetry of the four channels. The following figure shows the angles at which the speakers are positioned for each mode.\nFigure 10-3. Virtual Speaker Placement for Each Mode\nFrontLeft FrontRight RearLeft RearRight Center 45° 135° 60° 110° SURROUND_SPEAKER_POSITION_SQUARE SURROUND_SPEAKER_POSITION_WIDE Listening Position\n",0]
,["Pages/Page_55582700.html#Anchor_55582725_かかり具合（サラウンドのデプス値）","Surround Depth",
"Surround Depth\nYou can vary the intensity of the surround effect by specifying a depth value using nn::snd::SetSurroundDepth. If this function succeeds in setting the depth value, it returns true.\nCode 10-10. Setting the Surround Depth Value\n bool nn::snd::SetSurroundDepth(f32 depth);\nSet the depth parameter to a value between 0.0 and 1.0, inclusive. Specifying 0.0 produces the minimum effect, and specifying 1.0 produces the maximum effect. The default value is currently 1.0.\nThe 3D surround operation automatically adapts depending on whether the sound is being output through the speakers or through headphones. This depth value is only valid when sound is output through the speakers. It is disabled when sound is output through the headphones and has no effect on the surround effect.\n",0]
,["Pages/Page_55582700.html#Anchor_55582725_フロントバイパス設定","Front Bypass Setting",
"Front Bypass Setting\nThe output for the rear channels is always affected by the 3D surround operation. In contrast, each voice object that is output to the front channels can be configured on an individual basis to bypass the 3D surround effect. You can configure the bypass setting by calling the SetFrontBypassFlag member function of the nn::snd::Voice class.\nCode 10-11. Front Bypass Setting for Voice Objects\n void nn::snd::Voice::SetFrontBypassFlag(bool flag);\nSet the flag parameter to true to make the output for the front channels bypass the 3D sound operation. This argument defaults to false (in which case, the data for the front channels does not bypass the 3D surround operation).\nFigure 10-4. Effect of the Front Bypass Setting on the 3D Surround Operation\nVoice Bypass 3D Surround Front Rear true false Output\nYou can also set the front bypass for the front channel of the AUX bus.\nCode 10-12. Setting the AUX Bus Front Bypass\n bool nn::snd::SetAuxFrontBypass(nn::snd::AuxBusId busId, bool flag);\nSpecify the AUX bus ID in the busId parameter, and pass true in the flag parameter to bypass. The default value for all buses is false (no bypass).\n",0]
,["Pages/Page_55582700.html#PageId_55582726","10.5.2. Headphone Connection State",
"\n10.5.2. Headphone Connection State\nCall the nn::snd::GetHeadphoneStatus or nn::snd::UpdateHeadphoneStatus function to find out whether headphones are connected to the audio jack. The function returns true when headphones are connected.\nThe GetHeadphoneStatus function returns the headphone state from the states regularly updated by the SendParameterToDsp function called by the sound thread, and so the results may be up to 32 sound frames (approximately 160 ms) old. Use the UpdateHeadphoneStatus function if you need real-time results. Note that this function entails a heavier processing load, as it updates the DSP state.\nCode 10-13. Headphone Connection State\n bool nn::snd::GetHeadphoneStatus();\nbool nn::snd::UpdateHeadphoneStatus();\n",0]
,["Pages/Page_55582700.html#PageId_55582727","10.5.3. Getting the Output Audio Data",
"\n10.5.3. Getting the Output Audio Data\nYou can load the mixed audio data that will ultimately be played back through the speakers into a buffer.\nCode 10-14. Getting the Output Audio Data\n bool nn::snd::GetMixedBusData(s16* pData,\n s32 nSamplesPerFrame = NN_SND_SAMPLES_PER_FRAME);\nFor the pData parameter, specify a buffer for storing the audio data. The buffer’s starting address must be 4-byte aligned. Calculate the required size of the buffer as sizeof(s16) * nSamplesPerFrame * 2.\nFor the nSamplesPerFrame parameter, specify the number of samples per channel (usually NN_SND_SAMPLES_PER_FRAME).\nThe function returns true if it successfully loads the audio data. Audio data is stored in stereo 16-bit PCM format, with the left and right channels interleaved. Header information is not included. The sampling rate is the sound DSP sampling rate (approximately 32,728 Hz).\n",0]
,["Pages/Page_55582700.html#PageId_55582728","10.5.4. Encoding to DSP ADPCM Format",
"\n10.5.4. Encoding to DSP ADPCM Format\nCall the nn::snd::EncodeAdpcmData function to encode monaural 16-bit PCM data in the DSP ADPCM format.\nCode 10-15. Encoding to DSP ADPCM Format\n s32 nn::snd::GetAdpcmOutputBufferSize(s32 nSamples);\nvoid nn::snd::EncodeAdpcmData(s16* pInput, u8* pOutput, s32 nSamples,\n s32 sampleRate, s32 loopStart, s32 loopEnd,\n nn::snd::DspsndAdpcmHeader* pInfo);\nFor the pInput parameter, specify the starting address of a buffer storing the monaural 16-bit PCM data to encode. The function can only encode monaural audio data. Specify the number of samples and the sampling rate in the nSamples and sampleRate parameters.\nFor the pOutput parameter, specify a buffer for storing the encoded DSP ADPCM data. The buffer’s starting address must be 4-byte aligned. Get the required size of the buffer by calling the nn::snd::GetAdpcmOutputBufferSize function, passing the number of audio data samples as an argument.\nFor the loopStart and loopEnd parameters, specify the starting and ending sample positions for looping. Specify sample position values relative to the start of the 16-bit PCM data, which is considered as 0.\nFor the pInfo parameter, specify a pointer to a structure storing the DSP ADPCM data header information.\n",0]
,["Pages/Page_55582700.html#PageId_55582729","10.5.5. Decoding From DSP ADPCM Format",
"\n10.5.5. Decoding From DSP ADPCM Format\nCall the nn::snd::DecodeAdpcmData function to decode audio data in the DSP ADPCM format to monaural 16-bit CPM data.\nCode 10-16. Decoding From DSP ADPCM Format\n void nn::snd::DecodeAdpcmData(const u8* pInput, s16* pOutput,\n const nn::snd::AdpcmParam& param,\n nn::snd::AdpcmContext& context, s32 nSamples);\nFor the pInput parameter, specify the starting address of a buffer storing the DSP ADPCM data to decode. For the param and context parameters, specify the DSP ADPCM data parameters and context. For the nSamples parameter, specify the number of audio data samples.\nFor the pOutput parameter, specify a buffer for storing the decoded monaural 16-bit PCM data. The buffer’s starting address must be 4-byte aligned.\nAfter execution completes, context stores the context as of the end of decoding.\n",0]
,["Pages/Page_55582700.html#PageId_55582730","10.5.6. Converting Between Sample Positions and Nibbles",
"\n10.5.6. Converting Between Sample Positions and Nibbles\nThe library provides functions for converting between PCM data sample positions and the number of DSP ADPCM nibbles.\nCode 10-17. Converting Between Sample Positions and Nibbles\n u32 nn::snd::ConvertAdpcmPos2Nib(u32 nPos);\nu32 nn::snd::ConvertAdpcmNib2Pos(u32 nNib);\n",0]
,["Pages/Page_55582700.html#PageId_55582731","10.5.7. Sound Output When the System Is Closed and Sleep Is Rejected",
"\n10.5.7. Sound Output When the System Is Closed and Sleep Is Rejected\nIf sleep is rejected when the system is closed, sound is forcibly output to the headphones, but you can control that behavior with the following function.\nCode 10-18. Controlling Sound Output When the System Is Closed and Sleep Is Rejected\n nn::Result nn::snd::SetHeadphoneOutOnShellClose(bool forceout);\nSpecify false for the forceout argument to have sound output from the speakers even when the system is closed (if the headphones are not connected). Specify true to have sound output from the headphones regardless of whether the headphones are connected.\n Warning:\n If you specify false for the forceout argument, be sure to reject the request to sleep. If the request is not rejected, sound is output from the speakers in the time between when the system is closed and when it transitions to the sleep state.\n If this function is called from within the callback function that receives the sleep request, however, that particular sleep request does not change the setting, and the setting takes effect starting with the next sleep request.\n",0]
,["Pages/Page_55582700.html#PageId_55582732","10.5.8. Source of Noise and Countermeasures",
"\n10.5.8. Source of Noise and Countermeasures\n",0]
,["Pages/Page_55582700.html#PageId_55582733","10.5.8.1. A buzzing noise comes from the speaker",
"The device design may cause noise in the following circumstances.\n10.5.8.1. A buzzing noise comes from the speaker\nThe speaker and physical structure of CTR has shown a tendency for clipping noise to occur around 500 Hz. This noise is caused by the surround process amplifying the playback when playing a sound containing the 500-Hz range with a pan.\nIt occurs under the following conditions.\n\tThe speaker is playing sound. \tThe playback is a sine wave in the 400-Hz to 600-Hz range, or a sine wave like sound, such as a flute or French horn. \tThe volume is set to a high value. \tThe pan is set to the maximum value. \tSurround is ON.\nPossible ways of handling this include:\n\tDo not pan across extremes. \tCenter the playback, and maintain the volume by playing back in moderate volume from the two speakers. \tSuppress the 400-Hz to 600-Hz range using the equalizer. ",0]
,["Pages/Page_55582700.html#PageId_55582734","10.5.8.2. A mechanical buzzing noise comes from the speaker",
" \tChange the tone (waveform) of the playback.\n10.5.8.2. A mechanical buzzing noise comes from the speaker\nThis noise, which is caused by the vibration from loud playback, is transmitted to the 3D depth slider. The 3D depth slider and the body rattle against each other.\nThis noise becomes most noticeable with a simple sine wave tone in the 400-Hz to 1-kHz range. This noise is conclusively identified by holding down the 3D depth slider with a finger. The noise is this type if the buzzing is muted by the pressure on the slider.\nThis noise is mitigated by reducing the speaker output volume, or playing a sound that is not a simple sine wave tone.\n",0]
,["Pages/Page_55582700.html#PageId_55582735","10.5.8.3. Light static sound is superimposed on the playback",
"\n10.5.8.3. Light static sound is superimposed on the playback\nThis noise is caused by the design of the speaker.\nThis noise is somewhat prominent in single tones using sine waves at about 400 Hz to 1 kHz.\nThis noise is mitigated by reducing the speaker output volume, or playing a sound that is not a simple sine wave tone.\n",0]
,["Pages/Page_55582700.html#PageId_55582736","10.5.8.4. A snapping or popping noise is heard from the earphone under certain circumstances",
"\n10.5.8.4. A snapping or popping noise is heard from the earphone under certain circumstances\nIn the following cases, a snapping or popping noise is audible from the earphones.\n\tWhen power is turned on or off \tWhen entering or leaving Sleep Mode \tWhen entering compatibility mode\nThis noise is due to the design of the system. There is no mitigation measure. If the noise is heard when the power is turned on with the volume slider set to zero, the sound always occurs on that unit in these circumstances.\nThere are production and development units that cause this noise. But this noise does not occur with PARTNER-CTR.\n",0]
,["Pages/Page_55582700.html#PageId_55582737","10.6. Reusing Sound Source Data Information",
"\n10.6. Reusing Sound Source Data Information\nInformation for sound source data that has been played back can be reused by initializing with the nn::snd::InitializeWaveBuffer function. Use the status member of the sound source data information to check whether sound source data playback has finished.\nTable 10-5 Sound Source Data Information States\n \t State\n \t Description\n \t STATUS_FREE\n \t State immediately after initializing sound source data information.\n \t STATUS_WAIT\n \t State immediately after registering sound source data information to a voice object.\n \t STATUS_PLAY\n \t State when sound source data is being played.\n \t STATUS_DONE\n \t State when sound source data playback is finished. Includes when sound playback has been stopped.\n \t STATUS_TO_BE_DELETED\n \t State when registered sound source data is scheduled for deletion using nn::snd::Voice::DeleteWaveBuffer.\n The state transitions to STATUS_DONE the next time nn::snd::SendParameterToDsp is executed.\n The following diagram shows these state transitions.\nFigure 10-5. Sound Source Data Information State Transitions\nSTATUS_FREE STATUS_WAIT STATUS_PLAY STATUS_DONE nn::snd::InitializeWaveBuffer() nn::snd::Voice::AppendWaveBuffer() nn::snd::Voice::SetState(STATE_PLAY) nn::snd::Voice::SetState(STATE_STOP) or Playing wave data is finished.\n",0]
,["Pages/Page_55582700.html#PageId_55582738","10.7. Releasing Voice Objects",
"\n10.7. Releasing Voice Objects\nUse the nn::snd::FreeVoice function to release voice objects that are no longer needed. However, voice objects targeted for dropping by the library at the time of allocation must not be released using this function.\n",0]
,["Pages/Page_55582700.html#PageId_55582739","10.8. Finalizing",
"\n10.8. Finalizing\nFollow the steps below to finalize the DSP and SND libraries used for sound playback.\n \tCall the nn::snd::Finalize function to close the SND library. \tCall the nn::dsp::UnloadComponent function to unload the components loaded into the DSP library and stop the library. \tCall the nn::dsp::Finalize function to close the DSP library.\nCode 10-19. Finalizing Sound Processing\n nn::snd::Finalize();\nnn::dsp::UnloadComponent();\nnn::dsp::Finalize();\nCONFIDENTIAL\n",0]
,["Pages/Page_55582740.html","11. System Settings ",
"11. System Settings\n",0]
,["Pages/Page_55582740.html#PageId_55582741","11.1. Initialization",
"This chapter describes how applications can get settings, such as user information and sound settings, from the system settings.\n11.1. Initialization\nUse the CFG library to access information handled by System Settings or about the 3DS system itself.\nYou must call the nn::cfg::Initialize function to initialize the CFG library before you can use its functionality, with the exception of a few functions not bound by this restriction. After initialization, CFG library functions can be called up until finalization occurs.\nCode 11-1. Initializing the CFG Library\n void nn::cfg::Initialize(void);\n",0]
,["Pages/Page_55582740.html#PageId_55582742","11.2. Getting Information",
"\n11.2. Getting Information\n",0]
,["Pages/Page_55582740.html#PageId_55582743","11.2.1. User Name",
"After initializing the library, call the provided functions to access various kinds of information.\n11.2.1. User Name\nYou can get the user name configured in the system settings.\nCode 11-2. Getting the User Name\n void nn::cfg::GetUserName(nn::cfg::UserName* pUserName);\nstruct nn::cfg::UserName\n{\n wchar_t userName[CFG_USER_NAME_LENGTH];\n bool isNgUserName;\n NN_PADDING1;\n};\nFor the pUserName parameter, specify a pointer to an nn::cfg::UserName structure for storing the user name.\nThe user name is stored as a wide character string in the userName member of the nn::cfg::UserName structure, and true is stored in the isNgUserName member if the user’s name includes any words that fail a profanity check.\nIn the Japan region, the profanity check uses Japanese, in the North American region it uses American English and the System Settings language, and in Europe it uses British English and the System Settings language.\n",0]
,["Pages/Page_55582740.html#PageId_55582744","11.2.2. Birthday",
"\n11.2.2. Birthday\nYou can get the user’s birthday configured in the system settings.\nCode 11-3. Getting the User’s Birthday\n void nn::cfg::GetBirthday(nn::cfg::Birthday* pBirthday);\nstruct nn::cfg::Birthday\n{\n s8 month;\n s8 day;\n};\nFor the pBirthday parameter, specify a pointer to an nn::cfg:Birthday structure for storing the birthday.\n",0]
,["Pages/Page_55582740.html#PageId_55582745","11.2.3. Country Code",
"\n11.2.3. Country Code\nYou can get the country code for the user’s country and region of residence configured in the system settings.\nCode 11-4. Getting the Country Code\n nn::cfg::CfgCountryCode nn::cfg::GetCountry(void);\nFor more information about the country codes defined in the system, see the nn/cfg/CTR/cfg_CountryCode.h header file.\nUse the following function to make conversions between country codes and country name codes (ISO 3166-1 alpha-2 format).\nCode 11-5. Converting Between Country Codes and Country Name Codes\n nn::Result nn::cfg::ConvertCountryCodeToIso3166a2(\n char* iso3166a2, nn::cfg::CfgCountryCode countryCode);\nnn::Result nn::cfg::ConvertIso3166a2ToCountryCode(\n nn::cfg::CfgCountryCode* pCountryCode, const char* iso3166a2);\n Note:\n The nn::cfg::GetCountryCodeA2 function will be removed from CTR-SDK.\n Warning:\n Applications that use the function for converting between country codes and country name codes must be sure to handle the nn::cfg::ResultNotFound return value if it is returned.\n",0]
,["Pages/Page_55582740.html#PageId_55582746","11.2.4. Language Code",
"\n11.2.4. Language Code\nYou can get the language code for the language used for display configured in the system settings.\nCode 11-6. Getting the Language Code\n nn::cfg::CfgLanguageCode nn::cfg::GetLanguage(void);\nThe following table shows the language codes defined in the system.\nTable 11-1. Language Codes\n \t Values\n \t Language\n \t Language Name (ISO 639-1 alpha-2)\n \t CFG_LANGUAGE_JAPANESE\n \t Japanese\n \t ja\n \t CFG_LANGUAGE_ENGLISH\n \t English\n \t en\n \t CFG_LANGUAGE_FRENCH\n \t French\n \t fr\n \t CFG_LANGUAGE_GERMAN\n \t German\n \t de\n \t CFG_LANGUAGE_ITALIAN\n \t Italian\n \t it\n \t CFG_LANGUAGE_SPANISH\n \t Spanish\n \t es\n \t CFG_LANGUAGE_SIMP_CHINESE\n \t Chinese (Simplified)\n \t zh\n \t CFG_LANGUAGE_KOREAN\n \t Korean\n \t ko\n \t CFG_LANGUAGE_DUTCH\n \t Dutch\n \t nl\n \t CFG_LANGUAGE_PORTUGUESE\n \t Portuguese\n \t pt\n \t CFG_LANGUAGE_RUSSIAN\n \t Russian\n \t ru\n \t CFG_LANGUAGE_TRAD_CHINESE\n \t Chinese (Traditional)\n \t zh\n Use the following function to covert the obtained language code to a language name in ISO 639-1 alpha-2 format.\nCode 11-7. Converting From Language Code to Language Name\n const char* nn::cfg::GetLanguageCodeA2(CfgLanguageCode cfgLanguageCode);\nThe function returns NULL if there is no string corresponding to the language code specified in the cfgLanguageCode parameter.\n Note:\n This function can be called without initialization occurring beforehand.\n",0]
,["Pages/Page_55582740.html#PageId_55582747","11.2.5. Simple Address Information",
"\n11.2.5. Simple Address Information\nYou can get the user’s simple address information (country, region, latitude, longitude) configured in System Settings.\nCode 11-8. Getting Simple Address Information\n void nn::cfg::GetSimpleAddress(nn::cfg::SimpleAddress* pSimpleAddress);\nstruct nn::cfg::SimpleAddress\n{\n u32 id;\n wchar_t countryName[CFG_SIMPLE_ADDRESS_NUM_LANGUAGES]\n [CFG_SIMPLE_ADDRESS_NAME_LENGTH];\n wchar_t regionName[CFG_SIMPLE_ADDRESS_NUM_LANGUAGES]\n [CFG_SIMPLE_ADDRESS_NAME_LENGTH];\n u16 latitude;\n u16 longitude;\n};\nFor the pSimpleAddress parameter, specify a pointer to an nn::cfg::SimpleAddress structure for storing the simple address information.\nThe countryName and regionName members of the nn::cfg::SimpleAddress structure store the country name and region name as wide-character strings, and the latitude and longitude members store the latitude and longitude.\n",0]
,["Pages/Page_55582740.html#PageId_55582748","11.2.5.1. Simple Address Information ID",
"The latitude and longitude member values are displayed in increments of 360° ÷ 65546 (approximately 0.005°). Northern latitudes from 0° through 90° are stored as values from 0x0000 through 0x4000, southern latitudes from 0.005° through 90° as values from 0xFFFF through 0xC000, eastern longitudes from 0° through 179.995° as values from 0x0000 through 0x7FFF, and western longitudes from 0.005° through 180° as values from 0xFFFF through 0x8000.\n11.2.5.1. Simple Address Information ID\nThe following function gets only the simple address information ID.\nCode 11-9. Getting Simple Address Information ID\n void nn::cfg::GetSimpleAddressId(nn::cfg::SimpleAddressId* pSimpleAddressId);\nstruct nn::cfg::SimpleAddressId\n{\n u32 id;\n nn::cfg::CfgCountryCode GetCountryCode(void) const;\n u8 GetRegionCode(void) const;\n};\nFor the pSimpleAddressId parameter, specify a pointer to an nn::cfg::SimpleAddressId structure.\nThe nn::cfg::SimpleAddressId structure has a GetCountryCode member function to get the country code and a GetRegionCode member function to get the region code. For the values available from these respective member functions, see 11.2.3. Country Code.\n",0]
,["Pages/Page_55582740.html#PageId_55582749","11.2.5.2. Getting the Simple Address Information From the ID",
"\n11.2.5.2. Getting the Simple Address Information From the ID\nThe simple address information can be obtained from the simple address information ID\nCode 11-10. Getting Simple Address Information From the ID\n nn::Result nn::cfg::GetSimpleAddress(nn::cfg::SimpleAddress* pSimpleAddress,\n nn::cfg::SimpleAddressId simpleAddressId,\n uptr pWorkMemory, u32 workMemorySize);\nThe simple address information obtained based on the ID specified in simpleAddressId is stored in pSimpleAddress.\nWorking memory is needed for operation of this function. A memory region at least as large as nn::cfg::CFG_SIMPLE_ADDRESS_WORKMEMORY_SIZE must be reserved and the memory location and size specified in pWorkMemory and workMemorySize respectively.\n",0]
,["Pages/Page_55582740.html#PageId_55582750","11.2.5.3. Converting Simple Address Information IDs Between 3DS and Wii U",
"\n11.2.5.3. Converting Simple Address Information IDs Between 3DS and Wii U\nUse the following function to convert simple address information IDs between 3DS and Wii U.\nCode 11-11. Converting Simple Address IDs Between 3DS and Wii U\n nn::cfg::SimpleAddressId nn::cfg::ConvertToWiiUSimpleAddressId(\n nn::cfg::SimpleAddressId ctrSimpleAddressId);\nnn::cfg::SimpleAddressId nn::cfg::ConvertToCtrSimpleAddressId(\n nn::cfg::SimpleAddressId wiiUSimpleAddressId);\n",0]
,["Pages/Page_55582740.html#PageId_55582751","11.2.6. Region Codes",
"\n11.2.6. Region Codes\n Note:\n The region codes here are those set in the 3DS system at the time of shipment. Region codes set in Game Cards are specified in a BSF file, and applications will not run if the system and card region codes do not match or if the card does not have a set region code. For more information about BSF files, see the reference manual for the CTR-SDK tool ctr_makebanner.\nYou can get the region code for the system’s target market.\nCode 11-12. Getting the Region Code\n nn::cfg::CfgRegionCode nn::cfg::GetResion(void);\nThe following table shows the region codes defined in the system.\nTable 11-2. Region Codes\n \t Values\n \t Target Market\n \t 3-Letter Code\n \t CFG_REGION_JAPAN\n \t Japan\n \t JPN\n \t CFG_REGION_AMERICA\n \t Americas\n \t USA\n \t CFG_REGION_EUROPE\n \t Europe and Australia\n \t EUR\n \t CFG_REGION_CHINA\n \t China\n \t CHN\n \t CFG_REGION_KOREA\n \t South Korea\n \t KOR\n \t CFG_REGION_TAIWAN\n \t Taiwan\n \t TWN\n Use the following function to covert the obtained region code to a three-letter string.\nCode 11-13. Converting From Region Code to 3-Letter String\n const char* nn::cfg::GetRegionCodeA3(CfgRegionCode cfgRegionCode);\nThe function returns NULL if there is no string corresponding to the language code specified in the cfgRegionCode parameter.\n",0]
,["Pages/Page_55582740.html#PageId_55582752","11.2.7. Sound Output Mode",
"\n11.2.7. Sound Output Mode\nYou can get the sound output mode configured in System Settings.\nCode 11-14. Getting the Sound Output Mode\n nn::cfg::CfgSoundOutputMode nn::cfg::GetSoundOutputMode(void);\nThe following table shows the sound output modes defined in the system.\nTable 11-3. Sound Output Modes\n \t Values\n \t Sound Output Mode\n \t CFG_SOUND_OUTPUT_MODE_MONO\n \t Monaural\n \t CFG_SOUND_OUTPUT_MODE_STEREO\n \t Stereo\n \t CFG_SOUND_OUTPUT_MODE_SURROUND\n \t 3D Surround Sound\n ",0]
,["Pages/Page_55582740.html#PageId_55582753","11.2.8. RTC Modification Offset Value",
"\n11.2.8. RTC Modification Offset Value\nYou can get the offset value saved to the hardware as the cumulative total of user changes to the RTC time.\nCode 11-15. Getting the RTC Modification Offset Value\n nn::fnd::TimeSpan nn::cfg::GetUserTimeOffset(void);\nThe function returns the modification offset in seconds. This is the cumulative total of the absolute values of all user changes made to the clock with the system settings. For more information about how to handle these values, see 8.5.3. Handling Time Modification Offset Values.\n",0]
,["Pages/Page_55582740.html#PageId_55582754","11.2.9. Parental Controls",
"\n11.2.9. Parental Controls\nAn application must check whether restrictions are enabled in Parental Controls before photographs and images can be exchanged or friends added. Call nn::cfg::IsParentalControlEnabled to check whether the parental controls are enabled.\nCode 11-16. Checking Whether Parental Controls Are Enabled\n bool nn::cfg::IsParentalControlEnabled(void);\nTable 11-4. Parental Controls Settings and Restricted Functionality\n \t Item\n \t Restricted Application Functionality\n \t Section\n \t Age Restriction\n \t N/A (restricted to the system side)\n \t -\n \t Use of Internet Browser\n \t N/A (restricted to the system side)\n \t -\n \t Using Nintendo e-Shopping to Purchase Merchandise and Services\n \t Purchasing Content Using ECDK\n \t 11.2.9.6\n \t 3D Image Display\n \t N/A (restricted to the system side)\n \t -\n \t Use of Miiverse\n \t Posting to Miiverse and Viewing Miiverse\n \t 11.2.9.7\n \t Sending and Receiving Photos, Images, Voice Recordings, Videos, or Text\n \t Sending and Receiving Rich UGC\n \t 11.2.9.2\n \t Uploading Rich UGC (North America)\n \t 11.2.12\n \t Internet Communication With Other Users\n \t Data Exchange With Other Users\n \t 11.2.9.4\n \t StreetPass Communication With Other Users\n \t Using StreetPass\n \t 11.2.9.5\n \t Friend Registration\n \t Friend Registration Within the Application\n \t 11.2.9.3\n \t Use of DS Download Play\n \t N/A\n \t -\n \t Viewing Distributed Videos\n \t Viewing videos obtained by communication\n \t 11.2.9.8\n ",0]
,["Pages/Page_55582740.html#PageId_55582755","11.2.9.1. Temporarily Suspending Parental Controls by Entering a PIN",
"11.2.9.1. Temporarily Suspending Parental Controls by Entering a PIN\nWhen Parental Controls are in force, applications can temporarily suspend Parental Controls by having the user input a PIN. Parental Controls are then suspended if the entered PIN matches the PIN in the Parental Controls settings. Note that neither the PIN entered by the user nor the PIN in the Parental Controls settings are ever displayed on the screen.\nYou can compare to the PIN in the Parental Controls settings by calling the nn::cfg::CheckParentalControlPinCode function.\nCode 11-17. Comparing to the Parental Controls PIN\n bool nn::cfg::CheckParentalControlPinCode(const char *input);\nThis function returns true if the string passed to input matches the PIN (four single-byte digits).\nThe software keyboard applet includes a mode for temporarily suspending Parental Controls. When started in this mode, the software keyboard applet operates according to a specialized sequence. The application can then determine whether to suspend Parental Controls based on the return value from the applet.\n",0]
,["Pages/Page_55582740.html#PageId_55582756","11.2.9.2. Restrictions on the Transmission of Data That May Include Personal Information",
"\n11.2.9.2. Restrictions on the Transmission of Data That May Include Personal Information\nCall the nn::cfg::IsRestrictPhotoExchange function to check whether photo exchanges (Sending and Receiving Photos, Images, Voice Recordings, Videos, or Text) are restricted. If restricted, and so long as Parental Controls are not temporarily suspended, the application cannot exchange photos or other images with any other system. This restriction includes not only the sending and receiving of photos, but also screen images, voice recordings, videos, and text; or any data that could include private information.\nCode 11-18. Confirmation of Restrictions on the Transmission of Data That May Include Personal Information\n bool nn::cfg::IsRestrictPhotoExchange(void);\nBe careful, as true is returned when the restriction is active.\n",0]
,["Pages/Page_55582740.html#PageId_55582757","11.2.9.3. Restrictions on Adding Friends",
"\n11.2.9.3. Restrictions on Adding Friends\nCall the nn::cfg::IsRestrictAddFriend function to check whether adding friends is restricted by the Parental Controls settings. If restricted, friend registration from within an application will end in an error. In principle, the application is not permitted to temporarily cancel this restriction.\nCode 11-19. Checking Whether Adding Friends Is Restricted\n bool nn::cfg::IsRestrictAddFriend(void);\nBe careful, as true is returned when the restriction is active.\n",0]
,["Pages/Page_55582740.html#PageId_55582758","11.2.9.4. Restrictions on Internet Communication With Other Users",
"\n11.2.9.4. Restrictions on Internet Communication With Other Users\nThe nn::cfg::IsRestrictP2pInternet function can be used to confirm whether exchanging data or online play with other players through Internet communication has been restricted by Parental Controls. If restriction on Internet communication has been enabled, Internet communication must not be performed for the purpose of downloading user-created content or engaging in online play with other players unless the restriction is temporarily lifted.\nCode 11-20. Confirmation of Restrictions of Internet Communication With Other Users\n bool nn::cfg::IsRestrictP2pInternet(void);\nBe careful, as true is returned when the restriction is active.\n",0]
,["Pages/Page_55582740.html#PageId_55582759","11.2.9.5. Restrictions on Communication via StreetPass",
"\n11.2.9.5. Restrictions on Communication via StreetPass\nThe nn::cfg::IsRestrictP2pCec function can be used to confirm whether exchanging data with other players through StreetPass has been restricted by Parental Controls. If restriction on communication through StreetPass has been enabled, StreetPass does not work at all, and an error will occur if an attempt is made to register StreetPass data. The application cannot temporarily cancel this restriction.\nCode 11-21. Checking Restrictions on Communication via StreetPass\n bool nn::cfg::IsRestrictP2pCec(void);\nBe careful, as true is returned when the restriction is active.\n",0]
,["Pages/Page_55582740.html#PageId_55582760","11.2.9.6. Restrictions on Nintendo 3DS Shopping Services",
"\n11.2.9.6. Restrictions on Nintendo 3DS Shopping Services\nYou can use the nn::cfg::IsRestrictShopUse function to determine whether Nintendo 3DS Shopping Services have been restricted by Parental Controls. When they have been restricted, applications cannot add to their balance, purchase content, or take other similar actions unless the restriction is temporarily revoked.\nCode 11-22. Checking Restrictions on Nintendo 3DS Shopping Services\n bool nn::cfg::IsRestrictShopUse(void);\nBe careful, as true is returned when the restriction is active.\n",0]
,["Pages/Page_55582740.html#PageId_55582761","11.2.9.7. Miiverse Restrictions",
"\n11.2.9.7. Miiverse Restrictions\nNintendo provides a function to check whether viewing or posting to Miiverse is restricted in Parental Controls. Call nn::cfg::IsRestrictMiiverseBrowse to check whether viewing Miiverse is restricted. Call nn::cfg::IsRestrictMiiversePost to check whether posting to Miiverse is restricted.\nThe device Parental Controls configuration values correspond to the function's return values are described below.\nTable11-2. Relationship Between Miiverse Restrictions Configuration and Return Values\n \t Restriction Name in Device Configuration\n \t IsRestrictMiiverseBrowse\n \t IsRestrictMiiversePost\n \t \"Restrict Posting and Browsing\"\n \t true\n \t true\n \t \"Posting only\"\n \t false\n \t true\n \t \"Do Not Restrict\"\n \t false\n \t false\n The application cannot get Miiverse posts from other users, or post to Miiverse unless these restrictions are temporarily lifted.\n",0]
,["Pages/Page_55582740.html#PageId_55582762","11.2.9.8. Restriction of Video Content Acquired Through Communication",
"\n11.2.9.8. Restriction of Video Content Acquired Through Communication\nCall nn::cfg::IsRestrictWatchVideo to check whether Parental Controls is restricting viewing of video content acquired through communication. An application may not play back video acquired through communication when this restriction is active, unless the restriction is temporarily lifted.\nCode 11-23. Check for Restriction of Video Content Acquired Through Communication\n bool nn::cfg::IsRestrictWatchVideo(void);\nBe careful, as true is returned when the restriction is active.\n",0]
,["Pages/Page_55582740.html#PageId_55582763","11.2.10. Checking for EULA Acceptance",
"\n11.2.10. Checking for EULA Acceptance\nUsers must first accept the terms of the End-User Licensing Agreement (EULA) before the application can use the Nintendo 3DS Network Service, which includes Nintendo Network and StreetPass. Call the nn::cfg::IsAgreedEula function to check whether the user has accepted the EULA terms. If they have not, the application must not use these networking features.\nCode 11-24. Checking for EULA Acceptance\n bool nn::cfg::IsAgreedEula(void);\nThe function returns true if the user has accepted the terms of the EULA. The FS library must be initialized before calling this function.\nFor more information about which features require EULA acceptance, see the Guidelines.\n",0]
,["Pages/Page_55582740.html#PageId_55582764","11.2.11. System-Specific ID",
"\n11.2.11. System-Specific ID\nYou can get the system-specific ID used to identify the system.\nCode 11-25. Getting the System-Specific ID\n bit64 nn::cfg::GetTransferableId(bit32 uniqueId);\nFor the uniqueId parameter, specify the unique 20-bit ID assigned to the application.\nThe system-specific ID is a 64-bit value that is guaranteed to be unique to a certain degree. This ID is also transferable in cases such as when a new replacement system has been bought. However, this ID cannot be recovered if the system was lost, stolen, or broken. The system–specific ID is changed when the user runs format system memory, and the original ID cannot thereafter be recovered.\nPossible uses of this system ID include the following.\n\tEnsuring that initial values of application parameters are different for each system. \tCreating data accessible only from one specific system. \tThe identifier or its seed for use in local communication.\n Note:\n When save data is created, the system-specific ID is saved, and subsequently the use of that saved system-specific ID in the save data can support changes such as those resulting from repairs. In addition, upon saving, a 128-bit value that matches the current time is saved, which can prevent the same data from being saved to multiple cards.\nIf you are using the ID to create data accessible only from that system, note that this data will be inaccessible if the system is formatted with format system memory, lost, or stolen.\n",0]
,["Pages/Page_55582740.html#PageId_55582765","11.2.12. Restrictions Based on COPPACS",
"\n11.2.12. Restrictions Based on COPPACS\nThe COPPA Compliance System (COPPACS) is a system provided by Nintendo to enable applications created for North America (if the system region is North America, and the country setting is U.S. or Canada) to comply with the Children’s Online Privacy Protection Act (COPPA).\n Note:\n For a list of applications subject to COPPACS, see the UGC section of the guidelines. Plans are to provide details about COPPACS in the future in the System Application and Applet Specifications.\nYou can determine whether restrictions based on COPPACS are in effect.\nCode 11-26. Getting Restrictions Based on COPPACS\n bool nn::cfg::IsCoppacsSupported();\nnn::cfg::CfgCoppacsRestriction nn::cfg::GetCoppacsRestriction(void);\nYou can confirm the support method for COPPACS by calling the nn::cfg::GetCoppacsRestriction function.\nWhen CFG_COPPACS_RESTRICTION_NONE is returned, no restrictions are in effect, so COPPACS support is unnecessary.\nWhen CFG_COPPACS_RESTRICTION_NEED_PARENTAL_PIN_CODE or CFG_COPPACS_RESTRICTION_NEED_PARENTAL_AUTHENTICATION is returned, restrictions are in effect, so COPPACS support must be provided.\nThe former can be released by entering the parental control authentication number. Enter and check the authentication number within the application. If the correct authentication number is entered, a temporary suspension can be performed (see 11.2.9.1. Temporarily Suspending Parental Controls by Entering a PIN). The latter cannot be released from within the application. The COPPACS authentication procedure within the system settings must be used.\nNote that you must temporarily exit the application when performing the authentication procedure for this setting. You can confirm the setting by restarting the application when returning to the application from System Settings. When continuing a process which was being performed before jumping to System Settings, always reconfirm the support method for COPPACS. In some cases, when reconfirming, you may be asked to perform the authentication procedure within System Settings.\nTo simply confirm which countries are subject to COPPACS with the current System Settings, you can use the nn::cfg::IsCoppacsSupported function. Note that if the system setting is for one of the countries on the list, the value true is returned even if COPPACS restrictions have not been enabled.\n Note:\n A description of how to jump to the COPPACS authentication procedure screen (PARENTAL_CONTROLS_COPPACS) is provided in 5.3.7. Jump to System Settings. For implementation examples, see the sample demo (coppacs in cfg).\n",0]
,["Pages/Page_55582740.html#PageId_55582766","11.3. Finalizing",
"\n11.3. Finalizing\nCall the nn::cfg::Finalize function when done using the CFG library.\nCode 11-27. Finalizing the CFG Library\n void nn::cfg::Finalize(void);\nIf this function is called before initialization, nothing will happen.\nThe number of times the library’s initialization function has been called is recorded. Until the finalize function is called the same number of times, the library remains in use.\nCONFIDENTIAL\n",0]
,["Pages/Page_55582779.html","13. Supplemental Libraries ",
"13. Supplemental Libraries\n",0]
,["Pages/Page_55582779.html#PageId_55582780","13.1. PTM Library",
"This chapter describes supplemental libraries provided for using internal system resources, such as power and the pedometer, and shared resources such as internal fonts.\n13.1. PTM Library\n",0]
,["Pages/Page_55582779.html#PageId_55582781","13.1.1. Initializing and Finalizing",
"The PTM library is provided for getting power-related information and using RTC-based alarms.\n13.1.1. Initializing and Finalizing\nThe PTM is initialized and finalized using the nn::ptm::Initialize function and the nn::ptm::Finalize function.\nCode 13-1. Initializing and Finalizing the PTM Library\n nn::Result nn::ptm::Initialize();\nnn::Result nn::ptm::Finalize();\nNeither function returns an error as long as the hardware is not damaged.\n",0]
,["Pages/Page_55582779.html#PageId_55582782","13.1.2. Getting Power-Related Information",
"\n13.1.2. Getting Power-Related Information\nThe following power-related information can be obtained: connection status of the power adapter, charge status of the battery, and the battery level.\nCode 13-2. Getting Power-Related Information\n nn::ptm::AdapterState nn::ptm::GetAdapterState();\nnn::ptm::BatteryChargeState nn::ptm::GetBatteryChargeState();\nnn::ptm::BatteryLevel nn::ptm::GetBatteryLevel();\nYou can get the connection status of the power adapter by calling the nn::ptm::GetAdapterState function. The following table shows the possible return values.\nTable 13-1. nn::ptm::AdapterState Enumerator\n \t Values\n \t Description\n \t ADAPTERSTATE_NOCONNECTED\n \t Power adapter not connected\n \t ADAPTERSTATE_CONNECTED\n \t Power adapter connected\n You can get the battery charge status by calling the nn::ptm::GetBatteryChargeState function. The following table shows the possible return values.\nTable 13-2. nn::ptm::BatteryChargeState Enumerator\n \t Values\n \t Description\n \t BATTERYCHARGESTATE_NOCHARGING\n \t Not charging\n \t BATTERYCHARGESTATE_CHARGING\n \t Charging\n You can get the battery level by calling the nn::ptm::GetBatteryLevel function. The following table shows the possible return values.\nTable 13-3. nn::ptm::BatteryLevel Enumerator\n \t Values\n \t Description\n \t BATTERYLEVEL_0 (BATTERYLEVEL_MIN)\n \t Battery level is 0%\n \t BATTERYLEVEL_1\n \t Battery level is 1% to 5%\n \t BATTERYLEVEL_2\n \t Battery level is 6% to 10%\n \t BATTERYLEVEL_3\n \t Battery level is 11% to 30%\n \t BATTERYLEVEL_4\n \t Battery level is 31% to 60%\n \t BATTERYLEVEL_5 (BATTERYLEVEL_MAX)\n \t Battery level is 61% to 100%\n ",0]
,["Pages/Page_55582779.html#PageId_55582783","13.1.3. Alarms Using the RTC",
"\n13.1.3. Alarms Using the RTC\nFor information about this feature, see 8.5.2. RTC Alarm Feature.\n",0]
,["Pages/Page_55582779.html#PageId_55582784","13.2. PL Library",
"\n13.2. PL Library\n",0]
,["Pages/Page_55582779.html#PageId_55582785","13.2.1. Pedometer",
"The PL library is provided so that applications can use features and resources built into the 3DS system such as the pedometer and internal (shared) fonts. Although there are no functions for initializing or finalizing the PL library itself, other libraries may need to be initialized in order to use these features and resources.\n13.2.1. Pedometer\nPedometer information is recorded in terms of the number of steps for each hour for up to 120 months (approximately 10 years). Because pedometer information is stored in the power-related module, you must initialize the PTM library ahead of time in order to access pedometer information. For information about initializing the PTM library, see 13.1.1. Initializing and Finalizing.\nUse the following functions to get pedometer-related information.\nCode 13-3. Functions for Getting Pedometer Information\n bool nn::pl::GetPedometerState();\nu32 nn::pl::GetTotalStepCount();\ns8 nn::pl::GetStepHistoryEntry(nn::pl::PedometerEntry* pEntry);\nvoid nn::pl::GetStepHistory(u16 pStepCounts[], s32 numHours,\n nn::fnd::DateTime start);\nnn::Result nn::pl::GetStepHistoryAll(nn::pl::PedometerHistoryHeader& header,\n nn::pl::PedometerHistoryData& data);\nThe nn::pl::GetPedometerState function returns whether the accelerometer is functioning as a pedometer. The accelerometer functions as a pedometer when the power is on and the system is closed. Applications therefore do not need to track whether the accelerometer is functioning as a pedometer because they have usually transitioned into Sleep Mode.\nThe nn::pl::GetTotalStepCount function returns the number of steps accumulated so far.\nThe nn::pl::GetStepHistoryEntry function stores the year and month of recorded step count entries in the nn::pl::PedometerEntry array specified by pEntry and returns the number of entries stored as its return value. Allocate enough memory for the array specified by pEntry so that the maximum number of entries (NUM_MONTHHISTORIES) can be stored.\nThe nn::pl::GetSetpHistory function stores step count information for each hour for the number of hours specified by numHours (future direction only) starting from and including the hour specified by start in the array specified by pStepCounts. Zero is stored for hours for which there is no step count information.\nThe nn::pl::GetHistoryAll function is used to get all step count information. The step count information obtained is split into header information and data. The order of data corresponds to the order of header information, but header information is not necessarily arranged in order of year and month. The year and month associated with step count information can be confirmed using monthInfo included in header information. If INVALID_COUNTER is stored in unusedCounter for an entry, it indicates that the data is invalid and no step count data has been recorded for that entry.\n Note:\n CTR-SDK includes the PedometerChanger development tool, which lets you view and manipulate the pedometer information.\n",0]
,["Pages/Page_55582779.html#PageId_55582786","13.2.2. Internal Fonts",
"\n13.2.2. Internal Fonts\nInternal fonts are provided as shared resources that can be accessed by applications. The type of internal fonts loaded as standard differs depending on the region set for the system.\nThe types of internal fonts that can be used are defined as shown below by the nn::pl::SharedFontType enumerator type.\nTable 13-4. nn::pl::SharedFontType Enumerator\n \t Values\n \t Description\n \t SHARED_FONT_TYPE_STD\n \t European fonts. Standard for the Japanese, European, and United States regions.\n \t SHARED_FONT_TYPE_CN\n \t Chinese fonts. Standard for the Chinese region.\n \t SHARED_FONT_TYPE_KR\n \t Korean fonts. Standard for the Korean region.\n \t SHARED_FONT_TYPE_TW\n \t Taiwanese fonts. Standard for the Taiwanese region.\n ",0]
,["Pages/Page_55582779.html#PageId_55582787","13.2.2.1. Loading Internal Fonts",
"13.2.2.1. Loading Internal Fonts\nInternal fonts are loaded using the nn::pl::InitializeSharedFont function. Although fonts for all regions are built into systems for any region, the InitializeSharedFont function only loads those fonts associated with the system region.\nCode 13-4. Loading Internal Fonts\n nn::Result nn::pl::InitializeSharedFont();\nnn::pl::SharedFontLoadState nn::pl::GetSharedFontLoadState();\nCalling the nn::pl::InitializeSharedFont function starts loading internal fonts. However, loading of internal fonts may not yet be complete when the function finishes executing. The return value (nn::pl::SharedFontLoadState) of the nn::pl::GetSharedFontLoadState function can be used to verify that fonts have finished loading.\nTable 13-5. nn::pl::SharedFontLoadState Enumerator\n \t Values\n \t Description\n \t SHARED_FONT_LOAD_STATE_NULL\n \t Load not started.\n \t SHARED_FONT_LOAD_STATE_LOADING\n \t Loading.\n \t SHARED_FONT_LOAD_STATE_LOADED\n \t Load complete.\n \t SHARED_FONT_LOAD_STATE_FAILED\n \t Load failed.\n You can get the start address, size, and font type of loaded font data using the nn::pl::GetSharedFontAddress, nn::pl::GetSharedFontSize, and nn::pl::GetSharedFontType functions, respectively.\nCode 13-5. Getting Loaded Font Data Information\n void* nn::pl::GetSharedFontAddress();\nsize_t nn::pl::GetSharedFontSize();\nnn::pl::SharedFontType nn::pl::GetSharedFontType();\nIf you want to display characters only included in the internal font of a region other than the system region to, for example, display messages sent from a system of another region, you must mount the internal font archive using the nn::pl::MountSharedFont function and have the application load the corresponding internal font.\nCode 13-6. Loading Internal Fonts (Other Regions)\n nn::Result nn::pl::MountSharedFont(const char* archiveName,\n nn::pl::SharedFontType sharedFontType, size_t maxFile,\n size_t maxDirectory, void* workingMemory, size_t workingMemorySize);\nnn::Result nn::pl::UnmountSharedFont(const char* archiveName);\nnn::Result nn::pl::GetSharedFontRequiredMemorySize(\n s32* pOut, nn::pl::SharedFontType sharedFontType, size_t maxFile,\n size_t maxDirectory);\narchiveName specifies the archive name of the font archive to be mounted.\nsharedFontType specifies the type of internal font to be mounted. The files loaded differ depending on the type of internal font specified here. If the specified font does not exist, nn::pl::ResultSharedFontNotFound is returned as the return value.\nTable 13-6. Internal Font Types and Associated Filenames (When “font” Is Specified in the Archive Name)\n \t Internal Font Type\n \t Filename\n \t SHARED_FONT_TYPE_STD\n \t font:/cbf_std.bcfnt.lz\n \t SHARED_FONT_TYPE_CN\n \t font:/cbf_zh-Hans-CN.bcfnt.lz\n \t SHARED_FONT_TYPE_KR\n \t font:/cbf_ko-Hang-KR.bcfnt.lz\n \t SHARED_FONT_TYPE_TW\n \t font:/cbf_zh-Hant-TW.bcfnt.lz\n Font files are compressed in LZ77 format and should be decompressed using the CX library before using them as fonts.\nSpecify the number of files and directories that can be opened simultaneously in maxFile and maxDirectory, respectively. Pass the working memory and its size to workingMemory and workingMemorySize. Use the nn::pl::GetSharedFontRequiredMemorySize function to get the size of the working memory required.\nUnmount the archive using the nn::pl::UnmountSharedFont function after font files have finished loading.\n",0]
,["Pages/Page_55582779.html#PageId_55582788","13.2.2.2. Using Font Data",
"\n13.2.2.2. Using Font Data\nThe same format as BCFNT files converted using ctr_FontConverter is used for internal font data. The nn::font::ResFont class of the FONT library must be used to display internal fonts.\nFor information about how to display fonts using the FONT library, see the API Reference and sample demos.\n",0]
,["Pages/Page_55582779.html#PageId_55582789","13.2.3. Play Coins",
"\n13.2.3. Play Coins\nPlay Coins accumulate as the user walks around with their system. You are free to make use of these accumulated Play Coins. For example, users might exchange Play Coins for bonus items in your application.\nTo use Play Coins, you must include the header file nn/pl/CTR/pl_GameCoin.h and add the library file libnn_plCoin.\n Note:\n CTR-SDK includes a development tool (PlayCoinSetter) for setting the number of Play Coins a system has.\n",0]
,["Pages/Page_55582779.html#PageId_55582790","13.2.3.1. Initialization and Finalization",
"\n13.2.3.1. Initialization and Finalization\nThe initialization and finalization of the library are performed by calling the nn::pl::InitializeGameCoin and nn::pl::FinalizeGameCoin functions.\nCode 13-7. Initializing and Finalizing the Play Coin Library\n void nn::pl::InitializeGameCoin();\nvoid nn::pl::FinalizeGameCoin();\nBefore initializing the Play Coin library, you must initialize the FS and PTM libraries. Because there is no support for nested initialization calls, even if you call the initialization function multiple times, calling the nn::pl::FinalizeGameCoin function once will finalize use of the library.\n",0]
,["Pages/Page_55582779.html#PageId_55582791","13.2.3.2. Getting the Number of Play Coins Held",
"\n13.2.3.2. Getting the Number of Play Coins Held\nYou can get the number of Play Coins held by the system with the nn::pl::GetGameCoinCount function.\nCode 13-8. Getting the Number of Play Coins Held\n nn::Result nn::pl::GetGameCoinCount(u16* pCount);\nThe currently held number of Play Coins is stored in pCount.\nThis function has a high load and entails a write to system NAND memory. Other than when starting the application, call it only when there is a possibility that the number of Play Coins might have increased or decreased, such as when recovering from Sleep Mode, the HOME Menu, or a library applet.\nWhen this function returns nn::pl::ResultGameCoinDataReset, it indicates that the Play Coins have been reset due to corrupt data or some other reason, but it is handled as a success (meaning that the IsSuccess function returns true). When informing the user that the Play Coins have been reset, check whether this value has been returned.\n",0]
,["Pages/Page_55582779.html#PageId_55582792","13.2.3.3. Spending Play Coins",
"\n13.2.3.3. Spending Play Coins\nPlay Coins are spent with the nn::pl::UseGameCoin function.\nCode 13-9. Spending Play Coins\n nn::Result nn::pl::UseGameCoin(u16* pCount, u16 useCount);\nWhen the process is successful, the number of Play Coins after spending is stored in pCount. When the process fails, an undefined value is stored there.\nSpecify the number of Play Coins to spend in useCount. When the number specified is more than the number held, no Play Coins are spent, and nn::pl::ResultLackOfGameCoin is returned to indicate that there were not enough Play Coins.\nThis function’s load is high and it entails a write to system NAND memory.\nCONFIDENTIAL\n",0]
,["Pages/Page_55582794.html","14. Infrared Communication Between Systems ",
"14. Infrared Communication Between Systems\nThis chapter describes communication between systems using the IR library, which allows applications to use the CTR infrared communications module.\n Note:\n CTR-SDK includes a development tool (IrCommunicationChecker) for checking the information communicated between systems by infrared communication.\n Warning:\n If you are developing an extended SNAKE application that uses infrared for communication between systems, be sure to test communication between CTR and SNAKE to verify that the processing speed differences do not cause any communication problems.\n",0]
,["Pages/Page_55582794.html#PageId_55582795","14.1. nn::ir::Communicator Class",
"\n14.1. nn::ir::Communicator Class\nFunctions for communication between systems using the infrared communications module are all defined as static functions of the nn::ir::Communicator class.\n Warning:\n The nn::ir::Communicator class only supports 1:1 communication between systems. It cannot be used for communicating with devices other than 3DS systems, or for communicating among multiple CTR systems.\n",0]
,["Pages/Page_55582794.html#PageId_55582796","14.1.1. Security",
"\n14.1.1. Security\nThe library handles encryption and guarantees completeness of transmitted data. Each sent packet is also given a sequence number that is incremented with each send to prevent re-send attacks.\n",0]
,["Pages/Page_55582794.html#PageId_55582797","14.1.2. Packets",
"\n14.1.2. Packets\nPackets transmitted by the IR library include an IR library header, which is used for communication control, and a system communication header, which includes security and other information.\nFigure 14-1. IR Library Packet\nIR Library Header System Communication Header User Data GetPacketSize(dataSize) CalculateBufferSizeToCommunicate(dataSize) dataSize\nGet the size of the user data in a packet after appending header information using the following functions.\nCode 14-1. Functions to Get User Data Size From Data With Header Information Appended\n size_t nn::ir::Communicator::GetPacketSize(size_t dataSize);\nsize_t nn::ir::Communicator::CalculateBufferSizeToCommunicate(size_t dataSize);\nThe user data size is specified in dataSize.\nThe GetPacketSize function calculates the size required to save the packet, and the CalculateBufferSizeToCommunicate function calculates the space required for send and receive buffers.\n",0]
,["Pages/Page_55582794.html#PageId_55582798","14.1.3. Support for Sleep Mode",
"\n14.1.3. Support for Sleep Mode\nWhen transitioning to Sleep Mode, connections are interrupted and any processing is forcibly stopped. Unsent packets and unreceived data are all discarded.\nWhen a connection is interrupted due to Sleep Mode, no request to disconnect is sent to the partner. When sending a disconnect notification to the partner, perform this processing before transitioning to Sleep Mode, and only transition to Sleep Mode when the disconnection is confirmed.\n",0]
,["Pages/Page_55582794.html#PageId_55582799","14.1.4. Communication Range",
"\n14.1.4. Communication Range\nThe following table shows the infrared communication range for two 3DS systems placed with the infrared receivers (on the back of the units) directly facing each other.\nTable 14-1. Communication Range for Infrared Communication\n \t Item\n \t Range\n \t Distance\n \t 0 to 20 cm from the infrared receiver when the lower screen (Touch Screen) is horizontal\n",0]
,["Pages/Page_55582794.html#PageId_55582800","14.2. Initialization",
"\n14.2. Initialization\nThe IR library is initialized by calling the Initialize function of the nn::ir::Communicator class.\nCode 14-2. IR Library Initialization Function\n nn::Result nn::ir::Communicator::Initialize(\n void* pBuf, size_t bufSize,\n size_t receiveBufferDataSize, size_t receiveBufferManagementSize,\n size_t sendBufferDataSize, size_t sendBufferManagementSize);\nSpecify the buffer used by the library to manage transmitted packets, the buffer size in pBuf, and bufSize. The buffer passed to the library must be allocated by the application beforehand. The starting address must be 4096-byte aligned, and it must be a multiple of 4096 bytes. Buffers allocated from device memory cannot be used.\nBuffers allocated from device memory cannot be used. The buffer passed to the library is divided into several areas, and the sizes of each area are specified in receiveBufferDataSize, receiveBufferManagementSize, sendBufferDataSize, and sendBufferManagementSize. For more information about specifying sizes, see 14.2.1. Buffer Passed to the Library.\n",0]
,["Pages/Page_55582794.html#PageId_55582801","14.2.1. Buffer Passed to the Library",
"The communication speed is fixed at 115,200 bps. In 3DS infrared communication, a start bit and an end bit are added to each byte sent. Consequently, the transmission rate for actual data (bps) is the baud rate value multiplied by 0.8, which is 92,160 bps (11,520 bytes/s).\n14.2.1. Buffer Passed to the Library\nIR library transmission processes are implemented with asynchronous functions. The buffer passed to the library during initialization is used mainly for temporary storage of sent packets.\nThe buffer passed to the library is divided into the regions shown below.\nFigure 14-2. Buffer Used by the IR Library\nSend Packet Management Region Send Packet Save Region Receive Packet Management Region Receive Packet Save Region Unused Region pBuf bufSize sendBufferDataSize receiveBufferDataSize receiveBufferManagementSize sendBufferManagementSize Reserved Region GetReservedSize()\n",0]
,["Pages/Page_55582794.html#PageId_55582802","14.2.1.1. Reserved Region",
"The size of each region is calculated as indicated below.\n14.2.1.1. Reserved Region\nThis region is fixed size, and is required for operation of the library.\nYou can get its size with the following function.\nCode 14-3 Function for Getting the Size of the Reserved Region\n size_t nn::ir::Communicator::GetReservedSize();\n",0]
,["Pages/Page_55582794.html#PageId_55582803","14.2.1.2. Send and Receive Packet Management Region",
"\n14.2.1.2. Send and Receive Packet Management Region\nThis region is used for storing management information for transmitted packets.\nIts size is calculated based on the maximum number of packets that can be maintained at any time. For connection processing, specify a size returned by GetManagementSize(1) for both send and receive.\nGet the management information size using the following function.\nCode 14-4. Function to Get the Packet Management Information Size\n size_t nn::ir::Communicator::GetManagementSize(s32 dataNum);\nSpecify the maximum number of packets maintained at any time in dataNum.\n",0]
,["Pages/Page_55582794.html#PageId_55582804","14.2.1.3. Send and Receive Packet Save Region",
"\n14.2.1.3. Send and Receive Packet Save Region\nThis region is used to store sent and received packets. For connection processing, the size must be at least 32 bytes for both send and receive.\nIf the data sizes are variable, specify a size equal to or greater than that calculated using the maximum packet size.\nIf the data sizes are fixed, specify the size of a single data packet multiplied by the maximum number of packets.\nCalculate the packet size from the data size using the following function.\nCode 14-5. Function to Get the Size of a Packet\n size_t nn::ir::Communicator::GetPacketSize(size_t dataSize);\nSpecify the size of the data in dataSize.\n",0]
,["Pages/Page_55582794.html#Anchor_55582804_受信パケット保存領域の注意点","Notes About the Receive Packet Save Region",
"Notes About the Receive Packet Save Region\nDue to noise, packets stored in the received packet storage area could be invalid. Because of this, we recommend allocating a larger area than the actual number of packets that will be received to ensure that normal packets received after such an invalid packet will be saved reliably. For example, one approach would be to allocate the unused region to the receive packet save region after deciding the sizes for the other regions.\nThe following code example sends and receives fixed-size data and maximizes the allocation of the receive packet save region.\nCode 14-6. Code Sample for Calculating Region Sizes\n // Buffer, send/receive data sizes, and number of packets to save.\nstatic u8 buffer[4096] NN_ATRRIBUTE_ALIGN(4096);\nsize_t sendDataSize = 100;\nsize_t sendPacketNum = 10;\nsize_t recvDataSize = 50;\nsize_t recvPacketNum = 20;\n// Calculate required sizes.\nsize_t sendBufferSize =\n nn::ir::Communicator::GetPacketSize(sendDataSize) * sendPacketNum;\nsize_t sendManagementSize =\n nn::ir::Communicator::GetManagementSize(sendPacketNum);\nsize_t receiveBufferSize =\n nn::ir::Communicator::GetPacketSize(recvDataSize) * recvPacketNum;\nsize_t receiveManagementSize =\n nn::ir::Communicator::GetManagementSize(recvPacketNum);\nsize_t reservedSize = nn::ir::Communicator::GetReservedSize();\n// Check whether the total region size is less than the buffer size.\nNN_ASSERT((sendBufferSize + sendManagementSize + receiveBufferSize +\n receiveManagementSize + reservedSize) <= sizeof(buffer));\n// Add an unused region size to the size of the receive packet save region.\nreceiveBufferSize = sizeof(buffer) -\n (sendManagementSize + sendBufferSize +\n receiveManagementSize + reservedSize);\n",0]
,["Pages/Page_55582794.html#PageId_55582805","14.3. Connections",
"\n14.3. Connections\nTo initiate infrared communications between 3DS systems, the systems must authenticate each other as communication devices. The called functions are divided into those for the system waiting for a connection request, and those for the system sending a connection request. The waiting system must call the WaitConnection function, and the sending system must call the RequireConnection function. Both of these functions are asynchronous calls, so control returns before connection processing has completed.\nCode 14-7. Connection Processing Functions\n static nn::Result nn::ir::Communicator::WaitConnection();\nstatic nn::Result nn::ir::Communicator::WaitConnection( nn::fnd::TimeSpan sendReplyDelay);\nstatic nn::Result nn::ir::Communicator::RequireConnection();\nstatic nn::ir::ConnectionStatus nn::ir::Communicator::GetConnectionStatus();\nstatic nn::ir::TryingToConnectStatus nn::ir::Communicator::GetTryingToConnectStatus();\nProcessing is asynchronous, so the GetConnectionStatus function is provided to confirm the overall state of the library and whether connection processing has completed. It returns CONNECTION_STATUS_CONNECTED if connection processing has completed. The GetTryingToConnectStatus function provides processing state details. For other possible return values, see 14.7. Getting the Connection.\nThe following table shows a list of return values for the GetTryingToConnectStatus function.\nTable 14-2. GetTryingToConnectStatus Function Return Values\n \t Return Value\n \t Description\n \t TRYING_TO_CONNECT_STATUS_NONE\n \t Not processing a connection.\n \t TRYING_TO_CONNECT_STATUS_SENDING_REQUEST\n \t Sending a connection request.\n \t TRYING_TO_CONNECT_STATUS_WAITING_REPLY\n \t Waiting for a reply to a connection request.\n \t TRYING_TO_CONNECT_STATUS_WAITING_REQUEST\n \t Waiting for a connection request.\n \t TRYING_TO_CONNECT_STATUS_SENDING_REPLY\n \t Sending a reply to a connection request.\n ",0]
,["Pages/Page_55582794.html#PageId_55582806","14.3.1. Connecting Automatically",
"14.3.1. Connecting Automatically\nWhen it is not clear which of two 3DS systems should receive a connection request, such as when IR communications is requested from the menu on both systems at the same time, use automatic connection.\nWith automatic connection, both systems switch automatically between waiting for a connection and requesting a connection with different timing, in order to connect. As a result, the connection relationship will change based on the combination at the time at which it occurs.\nCode 14-8. Automatic Connection Functions\n static nn::Result nn::ir::Communicator::AutoConnection();\nstatic nn::Result nn::ir::Communicator::AutoConnection(\n nn::fnd::TimeSpan sendReplyDelay,\n nn::fnd::TimeSpan waitRequestMin, nn::fnd::TimeSpan waitRequestMax,\n nn::fnd::TimeSpan waitReplyMin, nn::fnd::TimeSpan waitReplyMax);\nThe following figure shows an example of the operation of automatic connection.\nFigure 14-3. Operation of Automatic Connection\nwaitRequestMin waitRequestMax waitReplyMin waitReplyMax AutoConnection() sendReplyDelay AutoConnection() Send connection reply packet CTR A CTR B Receive connection request packet\nIf called without parameters, values to be used are calculated by the library based on the baud rate set at initialization. Automatic connection may not succeed in some cases, when it is called without specifying parameters, due to other processing by the application. In such cases, specify the parameters while considering the following points.\nsendReplyDelay is the interval between receiving a connection request packet and sending a connection reply packet. The default value is 3 ms. The value must be at least 3 ms, to allow the partner to switch between sending and receiving.\nwaitRequestMin and waitRequestMax are the minimum and maximum times for sending a connection request packet and waiting to receive a connection reply packet. waitRequestMin must be larger than the total of the connection request packet send time, the connection reply packet receive time, and the time for switching between sending and receiving (3 ms).\nwaitReplyMin and waitReplyMax are the minimum and maximum times to wait for a connection request packet and to send a connection reply packet. waitReplyMin must be greater than the total of the time to receive a connection request packet, the time to send a connection reply packet, and the interval for switching between sending and receiving (3 ms).\nThe size of a connection request packet is defined by CONNECTION_REQUEST_PACKET_SIZE (8 bytes), and the size of a connection reply packet is defined by CONNECTION_REPLY_PACKET_SIZE (5 bytes). The time required to send or receive can be calculated from the actual data transmission speed. Packet sizes are defined in bytes. Use care when calculating from transmission speeds, which are in bits.\n",0]
,["Pages/Page_55582794.html#PageId_55582807","14.3.2. Connection Roles",
"\n14.3.2. Connection Roles\nYou can obtain connection roles using the GetConnectionRole function. Operation of the IR library does not differ based on connection role. Use them as the policy that determines the role within infrared communication.\nCode 14-9. Function for Getting a Connection Role\n static nn::ir::ConnectionRole nn::ir::Communicator::GetConnectionRole(void);\nThe following table shows the return values for the GetConnectionRole function.\nTable 14-3. GetConnectionRole Function Return Values\n \t Return Value\n \t Description\n \t CONNECTION_ROLE_NONE\n \t The connection role is not set because connection processing has not started or is in progress.\n \t CONNECTION_ROLE_TO_REQUIRE\n \t Connected after requesting a connection.\n The system has received a connection reply packet after a RequireConnection or AutoConnection function call.\n \t CONNECTION_ROLE_TO_WAIT\n \t Connected after receiving a connection request.\n The system has sent a connection reply packet after a WaitConnection or AutoConnection function call.\n",0]
,["Pages/Page_55582794.html#PageId_55582808","14.4. Confirming the Communication ID",
"\n14.4. Confirming the Communication ID\nTo prevent communication with any other application, each system must confirm the communication ID of the other system after connection processing has completed. Any send or receive-related functions that are called before confirming communication IDs results in an error.\nUse the CreateCommunicationId function to get a communication ID to use for confirmation.\nCode 14-10. Function for Getting a Communication ID\n static bit32 nn::ir::Communicator::CreateCommunicationId(\n bit32 uniqueId, bool isDemo = false);\nSpecify the unique ID allocated by Nintendo for each title for uniqueId. When communicating between different titles, specify the unique ID for either one of them.\nTo prevent infrared communication between the retail version and the downloaded demo version of a title, specify true for isDemo in the demo version. Always set this parameter to false in the retail version, regardless of whether you want to communicate with demo versions.\n Note:\n For test programs and titles that use infrared communication and have not been allocated a unique ID by Nintendo, specify a prototype software code in the range from 0xFF000 to 0xFF3FF for uniqueId. In retail software, you must always specify the unique ID assigned by Nintendo.\nTo confirm communication IDs, one 3DS calls the RequireToConfirmId function and the other calls the WaitToConfirmId function. Both of these functions complete successfully if the communication IDs, communication mode IDs, and passphrases specified by each system match. Send and receive functions can only be used after this point.\nCode 14-11. Functions for Confirming Communication IDs\n static nn::Result nn::ir::Communicator::RequireToConfirmId(\n u8 subId, bit32 communicationId,\n const char passphrase[], size_t passphraseLength);\nstatic nn::Result nn::ir::Communicator::WaitToConfirmId(\n u8 subId, bit32 communicationId,\n const char passphrase[], size_t passphraseLength,\n nn::fnd::TimeSpan timeout);\nstatic bool nn::ir::Communicator::IsConfirmedId();\nUse the communication ID generated by CreateCommunicationId for communicationId.\nWhen an application using infrared communication has multiple scenes, communication between different scenes can be prevented by specifying a communication mode identifier in subId. Specify a different value for each scene.\nThe passphrase specified in passphrase is used as the key for encrypting infrared communications packets. Avoid using strings that are easy to guess. The length of a passphrase must be in the range between IR_PASSPHRASE_LENGTH_MIN and IR_PASSPHRASE_LENGTH_MAX.\nSpecify the length of the passphrase in passphraseLength.\nNote that both the RequireToConfirmId and WaitToConfirmID functions implicitly consume one of the nn::os::Event class instances assigned to the application.\nCommunication IDs must be reconfirmed after a disconnect and reconnection, even if they have been confirmed earlier.\nThe IsConfirmedId function can be used to check whether ID confirmation has already been completed.\n",0]
,["Pages/Page_55582794.html#PageId_55582809","14.5. Transmission",
"\n14.5. Transmission\nData can be sent by infrared communications using the Send function after completing confirmation of communication IDs.\nCode 14-12. Functions for Transmitting Data\n static nn::Result nn::ir::Communicator::Send(\n void *pBuffer, size_t dataSize, size_t bufferSize,\n bool restore = false);\nstatic void nn::ir::Communicator::GetSendEvent(nn::os::Event* pEvent);\nstatic nn::Result nn::ir::Communicator::GetLatestSendErrorResult(bool clear);\nstatic void nn::ir::Communicator::GetSendSizeFreeAndUsed(\n size_t *pSizeFree, s32 *pCountFree,\n size_t *pSizeUsed, s32 *pCountUsed);\nSpecify the send buffer and its size in pBuffer and bufferSize respectively. The send buffer must be at least the size obtained by passing the size of the actual data to be sent to the CalculateBufferSizeToCommunicate function. The start address must also be 4-byte aligned.\nSpecify the data size in dataSize. Data in the range from 0 to 16316 bytes can be sent.\nThe data starting at the beginning of pBuffer and of length dataSize is sent. After data is sent, the buffer contains the encrypted data with headers appended. If the original data is needed after it is sent, specify true for the restore parameter. Note that this consumes more processing time than only sending.\nThe actual transmission is done asynchronously and the Send function returns control to the caller after the packet has been saved in the buffer being used by the library. An event notifies when the data is actually sent, and can be obtained using the GetSendEvent function. The event passed to pEvent is initialized as an automatically resetting event. The Result class instance returned by the GetLatestSendErrorResult function indicates whether a send error occurred. If called with the clear parameter set to true, the error in the library’s internal Result class instance is cleared.\nThe library monitors the state of the buffer, and transmits send packets as quickly as possible through the IR communications module. If the send function is called repeatedly in a short period of time, the library could temporarily store multiple packets in the buffer at the same time. These packets are sent in the order they were saved in the buffer.\nIf the total size of packets saved exceeds the size of the buffer when sending large packets or sending packets repeatedly, the library discards any further packets without saving them. For this reason, we recommend using GetSendSizeFreeAndUsed to check the available space in the send packet management region and the save region before sending a packet. In particular, note that available space in the save region of at least the packet size obtained from the GetPacketSize function is required in order to save the packet.\n",0]
,["Pages/Page_55582794.html#PageId_55582810","14.6. Receipt",
"\n14.6. Receipt\nData can be received by calling the Receive function after completing confirmation of the communications IDs. After the connection process, the library can continue to receive data unless it is maintaining a packet to be sent. So strictly speaking, the Receive function is not a function that performs receipt. It retrieves data that has already been received from the buffer. It is not possible to determine whether received data is valid until it has been retrieved using the Receive function.\nCode 14-13. Functions Using Receive Processes\n static nn::Result nn::ir::Communicator::Receive(\n void* pDst, size_t size, size_t *pReceiveSize,\n s32 *pRemainCount);\nstatic void nn::ir::Communicator::GetReceiveEvent(nn::os::Event* pEvent);\nstatic nn::Result nn::ir::Communicator::GetLatestReceiveErrorResult(\n bool clear);\nstatic nn::Result nn::ir::Communicator::GetNextReceiveDataSize(size_t *pSize);\nstatic nn::Result nn::ir::Communicator::DropNextReceiveData(s32 *pRemainCount);\nstatic void nn::ir::Communicator::GetReceiveSizeFreeAndUsed(\n size_t *pSizeFree, s32 *pCountFree,\n size_t *pSizeUsed, s32 *pCountUsed);\nSpecify the receive buffer and buffer size in pDst and size respectively. The receive buffer must be 4-byte aligned. The data is temporarily saved in encrypted form with appended headers (and so forth) in the buffer, so the buffer must be at least as large as the size calculated by the CalculateBufferSizeToCommunicate function (the size of the actual data to be received) when passed. The required buffer size can be retrieved beforehand using the GetNextReceiveDataSize function.\nOne packet of data is retrieved for each call to the Receive function. The size of the retrieved data is stored in pReceiveSize. When storing the data, the Receive function stores the amount remaining to be retrieved in pRemainCount. To read all of the stored data, call the Receive function repeatedly until 0 (zero) bytes are remaining.\nThe GetReceiveEvent function returns an event containing notification of when received packets were saved in the buffer, so it can be used if data must be retrieved as soon as it has been received. The event passed to pEvent is initialized as an automatically resetting event. The GetLatestReceiveErrorResult function returns an instance of the Result class, indicating whether an error has occurred during receive processing. If called with the clear parameter set to true, the error in the library’s internal Result class instance is cleared.\nIf the GetNextReceiveDataSize function returns a data size that is clearly different from the expected data (and thus the data in the next packet is not needed), one packet’s worth of data can be discarded by using the DropNextReceiveData function.\nIf packets are received more frequently than data is retrieved and the total size of packets to be saved exceeds the size of the buffer, the library discards any further packets without saving them. Use the GetReceiveSizeFreeAndUsed function to determine the available space for the receive packet management region and the save region, and use it to manage receipt.\nIf the current connection is interrupted while received data remains, the remaining data can be received in the interval until the next connection begins.\n",0]
,["Pages/Page_55582794.html#PageId_55582811","14.7. Getting the Connection Status",
"\n14.7. Getting the Connection Status\nUse the GetConnectionStatus function to get the status of the connection. In addition, the GetConnectionStatusEvent function returns an event that indicates when the connection status changed. The event passed to pEvent is initialized as an automatically resetting event.\nCode 14-14. Functions Used to Get the Connection Status\n static void nn::ir::Communicator::GetConnectionStatusEvent(\n nn::os::Event* pEvent);\nstatic nn::ir::ConnectionStatus nn::ir::Communicator::GetConnectionStatus();\nThe following table shows the return values from the GetConnectionStatus function.\nTable 14-4. GetConnectionStatus Return Values\n \t Return Value\n \t Description\n \t CONNECTION_STATUS_STOPPED\n \t The infrared module is stopped.\n \t CONNECTION_STATUS_TRYING_TO_CONNECT\n \t Indicates that a connection is being established.\n \t CONNECTION_STATUS_CONNECTED\n \t A connection has been established.\n \t CONNECTION_STATUS_DISCONNECTING\n \t Indicates that a connection is being disconnected.\n \t CONNECTION_STATUS_FATAL_ERROR\n \t A fault or other fatal error has occurred.\n ",0]
,["Pages/Page_55582794.html#PageId_55582812","14.7.1. Handling Faults",
"14.7.1. Handling Faults\nWhen the connection status is CONNECTION_STATUS_FATAL_ERROR, a fault may have occurred in the infrared communication module. In this state, all functions that return a result except for Finalize always return nn::ir::ResultFatalError. Infrared communication cannot be used in any further processing. Immediately finalize the IR library.\nThis state could indicate a fault in the infrared module, but power-cycling the system may also recover the module. We recommend displaying a message to the user indicating the possibility of a fault and how to handle it.\n",0]
,["Pages/Page_55582794.html#PageId_55582813","14.8. Disconnecting",
"\n14.8. Disconnecting\nTo disconnect infrared communication, call the Disconnect function.\nCode 14-15. Functions Using the Disconnect Processes\n static nn::Result nn::ir::Communicator::Disconnect(void);\nstatic nn::Result nn::ir::Communicator::ClearSendBuffer(void);\nstatic nn::Result nn::ir::Communicator::ClearReceiveBuffer(void);\nThe Disconnect function sends a disconnect request to the communication partner. If a connection is being established, the process is interrupted. Disconnection is handled asynchronously, so control is returned before disconnection processing has completed.\nIf Disconnect is called while some send packets are still unprocessed, the send packets are discarded and the connection is disconnected. If necessary, confirm that all packets have been sent before calling this function. To explicitly discard packets not sent, call the ClearSendBuffer function.\nPackets received before disconnection can be retrieved using the Receive function after disconnecting. Note, however, that they will be discarded when processing the next connection and connection authentication begins. To explicitly discard all received packets, call the ClearReceiveBuffer function.\n",0]
,["Pages/Page_55582794.html#PageId_55582814","14.9. Finalization",
"\n14.9. Finalization\nTo finalize use of the IR library, call the Finalize function.\nCode 14-16. Functions Using the Finalization Processes\n static nn::Result nn::ir::Communicator::Finalize(void);\nIf this function is called before the library is initialized, the nn::ir::ResultNotInitialized function returns an error.\nCONFIDENTIAL\n",0]
,["Pages/Page_55582815.html","15. Differences Between TWL Mode and Actual TWL Systems ",
"15. Differences Between TWL Mode and Actual TWL Systems\nAn application works differently on a 3DS system in TWL mode (DSi-compatible mode) than it does on an actual Nintendo DSi system. This chapter describes those differences. Consider these differences when you are developing applications for systems in the Nintendo DS family that will also run on 3DS systems. (In particular, refer to this information when developing a Nintendo DSiWare service or game that is available on Nintendo eShop.)\n Note:\n For information about how to import a Nintendo DSiWare service or game, see the API Reference page for ctr_makecia.\n",0]
,["Pages/Page_55582815.html#PageId_55582816","15.1. Display-Related Differences",
"\n15.1. Display-Related Differences\n",0]
,["Pages/Page_55582815.html#PageId_55582817","15.1.1. LCD Screens",
"15.1.1. LCD Screens\nBecause the LCD screen layouts differ (see 5.5 Initializing the GX Library), the direction of scanning on the 3DS screens is different from that on the TWL screens. Also note that because emulation is used, the images are rendered with a delay of approximately 1.3 frames.\n",0]
,["Pages/Page_55582815.html#PageId_55582818","15.2. Input-Related Differences",
"\n15.2. Input-Related Differences\n",0]
,["Pages/Page_55582815.html#PageId_55582819","15.2.1. Touch Panel",
"15.2.1. Touch Panel\nNormally, on TWL or NITRO systems, it is difficult for applications to detect touches at the very edge of the screen. But when the application has been started in 1:1 pixel display mode on the 3DS, the SDK (TWL or NITRO) functions might be able to detect touches at the very edges of the application’s screen (a display area that is a subset of the physical screen) because the user has touched the screen outside of the application’s display area.\n",0]
,["Pages/Page_55582815.html#PageId_55582820","15.2.2. Key Input",
"\n15.2.2. Key Input\nWhen the +Control Pad is being emulated by the Circle Pad (see 6.2.1. Digital Buttons and Circle Pad), although the state of the +Control Pad is updated in real time when the Circle Pad is not being moved (when no input is detected), it updates roughly once per frame when the Circle Pad is being moved. For this reason, input from the +Control Pad may not always be reflected accurately when the user is operating the Circle Pad.\nWhen the Circle Pad and the +Control Pad are both being used and the user simultaneously presses Up and Down (or Left and Right) on the +Control Pad, the application is notified of a prohibited operation. The input is treated as Up when Up and Down are pressed simultaneously, and Left when Left and Right are pressed simultaneously. If your application uses such prohibited input to trigger entry to debug mode or some other mode, your application will not operate correctly, because it will never receive the prohibited input.\n",0]
,["Pages/Page_55582815.html#PageId_55582821","15.2.3. Closing the System",
"\n15.2.3. Closing the System\nFor the application, the system state while displaying the HOME Menu is no different from when the system is closed. The PAD_DetectFold function returns TRUE just like it normally does when the system is closed, but the application is not notified of key input or touch panel input.\n",0]
,["Pages/Page_55582815.html#PageId_55582822","15.2.4. Sound Volume",
"\n15.2.4. Sound Volume\nThe system has a slider for sound volume. This allows users to change the volume faster than is physically possible on the Nintendo DSi.\n",0]
,["Pages/Page_55582815.html#PageId_55582823","15.3. OS-Related Differences",
"\n15.3. OS-Related Differences\n",0]
,["Pages/Page_55582815.html#PageId_55582824","15.3.1. Reset and Shutdown",
"15.3.1. Reset and Shutdown\nOn CTR, processing of the OS_RebootSystem function takes much longer than it does on a TWL system.\n",0]
,["Pages/Page_55582815.html#PageId_55582825","15.3.2. Application Jumps",
"\n15.3.2. Application Jumps\nOn CTR, the filename and content of the system menu version are different from TW. If your application incorporates routines that check this information, it might operate incorrectly when running in TWL mode on a CTR system.\n",0]
,["Pages/Page_55582815.html#PageId_55582826","15.4. System Settings-Related Differences",
"\n15.4. System Settings-Related Differences\n",0]
,["Pages/Page_55582815.html#PageId_55582827","15.4.1. Region Codes",
"15.4.1. Region Codes\nOn 3DS, the Australia region is included in the Europe region. Applications intended for the TWL Australia region can also operate in the 3DS Europe region.\nTable 15-1. TWL Application Regions and Corresponding Operable 3DS System Regions\n \t TWL Application Region\n \t Operable 3DS System Regions\n \t JP (Japan)\n \t JP (Japan)\n \t US (United States)\n \t US (United States)\n \t EU (Europe)\n \t EU (Europe)\n \t AU (Australia)\n \t EU (Europe)\n \t EU (Europe) and US (United States)\n \t EU (Europe) or US (United States)\n \t EU (Europe) and AU (Australia)\n \t EU (Europe)\n \t EU (Europe), AU (Australia), and US (United States)\n \t EU (Europe) or US (United States)\n \t CN (China)\n \t CN (China)\n \t KR (Korea)\n \t KR (Korea)\n ",0]
,["Pages/Page_55582815.html#PageId_55582828","15.4.2. Country Setting",
"\n15.4.2. Country Setting\nIf the country setting of the 3DS system is set to a value that would not be available in the region of the TWL application, the value of the country member of the OSOwnerInfoEx structure is set to 254 (OTHER).\n",0]
,["Pages/Page_55582815.html#PageId_55582829","15.4.3. Language Setting",
"\n15.4.3. Language Setting\nIf the language setting of the 3DS system is set to a value that would not be available in the region of the TWL application, the language member of the OSOwnerInfoEx structure is set to either OS_LANGUAGE_JAPANESE for the Japan region or to OS_LANGUAGE_ENGLISH for all other regions.\nCONFIDENTIAL\n",0]
,["Pages/Page_55582830.html","16. Appendix: Process Flows for Using the Circle Pad Pro ",
"16. Appendix: Process Flows for Using the Circle Pad Pro\nStatus indicators are not built into the Circle Pad Pro. It is not possible to determine from the outside whether it is active, whether its battery level is low, or whether it is connected to the CTR system. To ensure ease of use, some mechanism is required for the detection, connection, and redetection processes of the Circle Pad Pro.\n Note:\n Because the C Stick, ZL Button, and ZR Button are included in the SNAKE hardware, the system is treated as having a Circle Pad Pro always attached. The remaining battery life also never decreases.\n Consequently, your application can omit some of the process flows described in this section if you verify the application is running on SNAKE hardware in advance.\nThis chapter provides Nintendo’s recommended process flows. Use them as a reference upon implementation. Yellow backgrounds indicate an example of the message to be displayed for that process.\nRefer to the following when deciding whether to use \"Circle Pad Pro\" or \"C Stick\" in user-facing messages.\n\tDisplay as \"Circle Pad Pro\"\n\tCTR Application \tWhen the Circle Pad Pro is used on CTR and the C Stick on SNAKE in a SNAKE-compatible title\n",0]
,["Pages/Page_55582830.html#PageId_55582831","16.1. Process Flow for Initial Startup",
" \tDisplay as \"C Stick\"\n\tSNAKE-Only Title \tWhen the C Stick is used on SNAKE but the Circle Pad Pro is not used on CTR in a SNAKE-compatible title\n 16.1. Process Flow for Initial Startup\nTo allow the save data to be saved when using the Circle Pad Pro, use the following process flow upon initial startup.\nFigure 16-1. Process Flow for Initial Startup\nStartup Save selection screen (No save data) Select save file Use Circle Pad Pro? Turn on Circle Pad Pro option settings Create Save Data Go to Circle Pad Pro detection process for the usual startup flow Turn off Circle Pad Pro option settings YES NO\n",0]
,["Pages/Page_55582830.html#PageId_55582833","16.2. Process Flow for Normal-Usage Startup",
"\n16.2. Process Flow for Normal-Usage Startup\nAs shown in 16.1 Process Flow for Initial Startup, to allow the save data to be saved using the Circle Pad Pro, use the following process flow upon startup during normal usage.\nParts of the flow that are not necessary on SNAKE are indicated with a dotted red line around a light red background.\nFigure 16-2. Process Flow for Normal-Usage Startup\nCircle Pad Pro detection process Startup Able to detect? YES NO Use Circle Pad Pro? Testing connection... If in standby mode, press either the ZR or ZL Button. Able to detect? (Timer 15 seconds) Circle Pad Pro cannot be recognized. Might not be connected correctly or the battery might have run out. Whether to use Circle Pad Pro and whether to reconnect can be changed from Options. Low battery charge? Circle Pad Pro battery is getting low. Replace the batteries. Whether to use Circle Pad Pro can be changed from Options. Cancel Button pressed Is Circle Pad Pro connected? Circle Pad Pro was removed. Whether to use Circle Pad Pro and whether to reconnect can be changed from Options. Save Data Selection To all in-game scenes Are the Circle Pad Pro settings turned on? Are the Circle Pad Pro settings turned on? Circle Pad Pro was recognized. Turn on the Circle Pad Pro settings. Turn on the Circle Pad Pro option settings Unnecessary on SNAKE\n",0]
,["Pages/Page_55582830.html#PageId_55582834","16.3. Process Flow for Detecting the Circle Pad Pro",
"\n16.3. Process Flow for Detecting the Circle Pad Pro\n Note:\n The following process flow does not apply to SNAKE.\nWe recommend the following process flow for detecting the Circle Pad Pro, except for when it is detected after initial startup. The following figure assumes that the Circle Pad Pro is detected from a thread other than the main thread. To detect explicitly, or to set up an option for connection, see 16.4. Options Screen Process Flows.\nFigure 16-3. Process Flow for Detecting the Circle Pad Pro\nYES NO Circle Pad Pro detection Circle Pad Pro detection loop Wait (1 second) Circle Pad Pro detection process Was the Circle Pad Pro detected? Circle Pad Pro detection completed\n",0]
,["Pages/Page_55582830.html#PageId_55582835","16.4. Options Screen Process Flows",
"\n16.4. Options Screen Process Flows\n",0]
,["Pages/Page_55582830.html#PageId_55582836","16.4.1. Transition to Enabling the Circle Pad Pro",
"When using the Options screen to enable the Circle Pad Pro and transition to connection or reconnection, use the following process flows.\n16.4.1. Transition to Enabling the Circle Pad Pro\nUse the following process flow in the Options screen to transition to enabling the Circle Pad Pro.\nFigure 16-4. Process Flow for Enabling the Circle Pad Pro\nOption Screen Turn Circle Pad Pro settings on (user action) Circle Pad Pro settings were turned on. Check connection? Testing connection... If in standby mode, press either the ZR or ZL Button. Could not connect. Check whether the Circle Pad Pro is attached and whether it still has battery charge remaining. Able to detect? (Timer 15 seconds) YES NO Option Screen Cancel Button pressed Connection confirmed.\n Note:\n On SNAKE, the system is always connected when sampling begins, so the following process flow is unnecessary.\nWhen setting up the option to connect to the Circle Pad Pro, use the following process flow.\nFigure 16-5. Process Flow for Connecting the Circle Pad Pro\nOption Screen Select Connect Circle Pad Pro (user action) Circle Pad Pro connection is being checked. If in standby mode, press either the ZR or ZL Button. Could not connect. Check whether the Circle Pad Pro is attached and whether it still has battery charge remaining. Able to detect? (Timer 15 seconds) YES NO Option Screen Cancel Button pressed Connection confirmed.\n",0]
,["Pages/Page_55582830.html#PageId_55582837","16.4.2. Process Flow for Disconnecting the Circle Pad Pro",
"\n16.4.2. Process Flow for Disconnecting the Circle Pad Pro\nWhen setting up the option to disconnect from the Circle Pad Pro, use the following process flow.\nFigure 16-6. Process Flow for Disconnecting the Circle Pad Pro\nCTR SNAKE Option Screen Turn Circle Pad Pro settings off (user action) Using Circle Pad Pro? Disconnect Circle Pad Pro NO YES Connection with Circle Pad Pro was disconnected. Option Screen Turn Circle Pad Pro settings off (user action) Using Circle Pad Pro? NO YES Circle Pad Pro settings were turned off. Option Screen\n",0]
,["Pages/Page_55582830.html#PageId_55582838","16.5. Process Flow for Using the Circle Pad Pro",
"\n16.5. Process Flow for Using the Circle Pad Pro\n Note:\n The following process flow does not apply to SNAKE.\nWe recommend the following process flow for using the Circle Pad Pro.\nIn the figures below, the process is determined by either setting up the option for Circle Pad Pro detection in the application or by monitoring full-time, before being incorporated into the main thread. The figure on the left shows cases when the option for redetecting the Circle Pad Pro is set up in the application, and the figure on the right shows cases when the Circle Pad Pro is being pulsed for detection full-time. See Figure 16-3 for cases when the Circle Pad Pro is being monitored full-time in the thread other than the main thread.\nFigure 16-7. Process Flow for Circle Pad Pro Detection in Application (left) or Full-Time (right)\nCircle Pad Pro use scenarios Was the Circle Pad Pro disconnected? Main loop Game Processing Using Circle Pad Pro? Circle Pad Pro was removed. Whether to use Circle Pad Pro and whether to reconnect can be changed from Options. Was the Circle Pad Pro detected? Circle Pad Pro battery is getting low. Replace the batteries. Was it detected for the first time after starting a game? Low battery charge? Circle Pad Pro was connected. Was the Circle Pad Pro disconnected? Circle Pad Pro was removed. YES NO\nCONFIDENTIAL\n",0]
,["Pages/Page_70418367.html","12. Applets ",
"12. Applets\nThis chapter describes the libraries that are required in order to use the applets provided by the 3DS system.\nThe library provided by each applet can be used to start the applet from an application and use its features. The system generally allocates the memory required to start applets, but some applets require that the application pass the working memory. In addition, the application effectively stops while applets are running because they use the same CPU as the application after the operations of the called thread are stopped.\n",0]
,["Pages/Page_70418367.html#PageId_55582768","12.1. Library Applets",
"\n12.1. Library Applets\nFeatures often used by applications are provided with 3DS as the following library applets.\n\tSoftware Keyboard Applet \tPhoto Selection Applet \tMii Selection Applet \tSound Selection Applet \tError/EULA Applet \tCircle Pad Pro Calibration Applet \tEC Applet\n Note:\n The Mii Selection applet is provided in the CTR Face Library package.\n",0]
,["Pages/Page_70418367.html#PageId_55582769","12.1.1. Information Common to All Library Applets",
"\n12.1.1. Information Common to All Library Applets\nThe processing required to start and return from a library applet is basically the same as that used to start and return from the HOME Menu. Likewise, while a library applet is executing there are similar restrictions on using devices such as getting key input and rendering, and only the thread that called the library applet will stop it. Therefore, try not to execute unnecessary threads while library applets are executing. When creating threads that will continue to operate even while a library applet is running, note that the library applet creates threads with the priority settings shown in the following table. Set your thread priority so that it does not affect these thread processes.\nTable 12-1. Priorities of Threads Created by Library Applets\n \t Library Applet\n \t Priority\n \t Comments\n \t (Common to all)\n \t 15\n \t Used for notifications such as sleep notifications.\n \t Software Keyboard Applet\n \t 17 to 20\n \t\n \t Photo Selection Applet\n \t 16, 18, 20, 21, 25\n \t\n \t Mii Selection Applet\n \t 17\n \t\n \t Sound Selection Applet\n \t 16, 18\n \t\n \t Error/EULA Applet\n \t 17, 20\n \t\n \t Circle Pad Pro Calibration Applet\n \t 17 to 19\n \t\n \t EC Applet\n \t 17, 22\n \t Used for communication and related functions.\n ",0]
,["Pages/Page_70418367.html#PageId_55582770","12.1.1.1. Recovering From Library Applets",
"The application must support close processing when nn::applet::IsExpectedToCloseApplication returns true after control returns to the application in the same way as it returns to the application when nn::applet::WaitForStarting returns true while calling the function after the HOME Menu starts. However, when the POWER Button is pressed while the library applet is being displayed, the application transitions to a state where it has no rendering rights and at the same time where nn::applet::IsExpectedToProcessPowerButton returns true. If the application responds to the close request in this case, the screen refresh will halt during close processing. Please handle the POWER Button first in your implementation.\n12.1.1.1. Recovering From Library Applets\nWhen the HOME Button, the POWER Button, or the software reset button combination (L + R + START) is pressed while a library applet is starting, the application immediately recovers and the following behavior results.\nTable 12-2. Behavior When Recovering From Library Applets\n \t Button\n \t Behavior\n \t HOME Button\n \t Returns a value as the return code indicating that the HOME Button was pressed. After recovery, nn::applet::IsExpectedToProcessHomeButton returns true.\n \t POWER Button\n \t Returns a value as the return code indicating that the POWER Button was pressed. After recovery, the nn::applet::IsExpectedToProcessPowerButton function returns true.\n \t Software Reset\n \t Returns a value as the return code indicating that there was a software reset.\n ",0]
,["Pages/Page_70418367.html#PageId_55582771","12.1.1.2. Preloading",
"\n12.1.1.2. Preloading\nLibrary applets that support preloading can perform processes such as loading in advance. As a result, you can shorten the time that the screen freezes between the function call that starts the library applet and its display on the screen.\nThe names of the functions for preloading differ for each library applet, but basically they follow the same standards. Functions that begin the preloading process start with Preload. Functions that wait for preloading to complete start with WaitForPreload. And functions that cancel the preloading process start with CancelPreload.\nWhen starting a preloaded library applet, you must wait for preloading to complete before starting. Note also that if you call a function that waits for completing without having first called a function that begins preloading, control never returns. However, this caution applies when both function calls take place on one thread. If the waiting-for-completion thread is different from the thread that begins preloading, control returns even if the order of the calls is reversed. Displaying the HOME Menu using nn::applet::ProcessHomeButton cancels preloading. If you navigate to the HOME Menu between calls to Preload and WaitForPreload, control does not return from WaitForPreload.\nYou cannot preload multiple library applets at the same time. To start a library applet other than one you have preloaded, you must first cancel the preload. Otherwise, after a library applet is started the preload is released, so there is no need to cancel the preload after recovery from a library applet.\n",0]
,["Pages/Page_70418367.html#PageId_55582772","12.1.2. Software Keyboard Applet",
"\n12.1.2. Software Keyboard Applet\nThis library applet is called when an application requires text input from the user, such as for a user name or password. It displays a software keyboard in the lower screen and provides functionality for things such as entering passwords, restricting the number of characters input and which characters can be input, and the ability to filter prohibited words. The upper screen can either be made to darken or to continue displaying the application screen displayed when the software keyboard was started.\nThe nn/swkbd.h header file must be included and the libnn_swkbd library file must be added in order to use this library applet.\nParameters passed when starting the library applet are defined by the nn::swkbd::Parameter data structure. Detailed operational settings are made with the config (nn::swkbd::Config) member of parameters. However, initialization is required before configuration.\nCode 12-1. Initializing Software Keyboard Operational Settings\n void nn::swkbd::InitializeConfig(nn::swkbd::Config* pConfig);\nThe Config structure passed in pConfig is initialized to the default settings. For operational settings that can be made in members of the Config structure, see the Applet Specifications.\nThe application must allocate work memory for this library applet. The size of the work memory required differs depending on the operational settings and can be obtained using the nn::swkbd::GetSharedMemorySize function.\nCode 12-2. Getting the Work Memory Size for the Software Keyboard\n s32 nn::swkbd::GetSharedMemorySize(\n const nn::swkbd::Config* pConfig,\n const void* pInitialStatusData = DELETEME,\n const void* pInitialLearningData = DELETEME);\nPass a pointer to the Config structure used to make operational settings in pConfig.\nIf the operational settings of the software keyboard being used the last time it was run have been saved, you can restore that previous state by passing the start address for that data in pInitialStatusData. If this data does not need to be restored or it was not saved, specify NULL.\nIf training data for predictive text input has been saved with the operational settings of the software keyboard that were used the last time it was run, the training state last in effect can be restored by passing the start address for that data in pInitialLearningData. If this data does not need to be restored or it was not saved, specify NULL.\nThe start address of work memory must be allocated with 4096-byte alignment and its size must be a multiple of 4096 bytes. Furthermore, memory allocated from device memory must not be specified for the work memory.\nAfter parameters have been set and work memory allocated, you can start the software keyboard using the nn::swkbd::StartKeyboardApplet function.\nCode 12-3. Starting the Software Keyboard Applet\n bool nn::swkbd::StartKeyboardApplet(\n nn::applet::AppletWakeupState* pWakeupState,\n nn::swkbd::Parameter* pParameter,\n void* pSharedMemoryAddr,\n size_t sharedMemorySize,\n const wchar_t* pInitialInputText = DELETEME,\n const nn::swkbd::UserWord* pUserWordArray = DELETEME,\n const void* pInitialStatusData = DELETEME,\n const void* pInitialLearningData = DELETEME\n nn::applet::AppTextCheckCallback callback = DELETEME);\nIn pParameter, specify a pointer to the Parameter structure, which has the Config structure used to configure operational settings as one of its members. Information such as the input text string is stored in the structure specified by this argument.\nSpecify the start address and size of work memory in pSharedMemoryAddr and PSharedMemorySize.\nIf a UTF-16LE text string that is not NULL is passed in pInitialInputText, the software keyboard is run with the specified text string set in the input field.\nIn pUserWordArray, specify an array of words to register in the user dictionary.\nSpecify the same value obtained for the work memory size in pInitialStatusData and pInitialLearningData.\nIn callback, specify the callback function to use when the application is checking an input string. When the application does not perform a check due to its operation settings, this argument is ignored.\nStartup fails if the return value of this function is false. Startup succeeds if the return value is true.\nThe software keyboard thread operates at a priority between 17 and 20. So even while the software keyboard is running, attention must be paid to the priority settings of threads that continue to operate.\n",0]
,["Pages/Page_70418367.html#PageId_55582773","12.1.3. Photo Selection Applet",
"\n12.1.3. Photo Selection Applet\nThis library applet is used to select the data for one photo from among those registered in the Nintendo 3DS camera album for use by the application. You can specify extraction conditions such as the capture time and type when starting the applet. You can also filter the data to be listed. Note that the applet can only select photos that are saved on an SD card.\nTo use this library applet, you must include the nn/phtsel.h header file and add the libnn_phtsel library file.\nParameters to be passed when this library applet is started are defined in the nn::phtsel::Parameter structure. Basic operational settings are made in the m_config member (nn::phtsel::Config structure). Detailed settings such as extraction conditions are made in the m_input member (nn::phtsel::PhtselInput structure). The execution result is stored in the m_output member (nn::phtself::PhtselOutput structure). For the available settings and other information, see the sample demo.\nThe application must allocate work memory when the applet background displays images captured by the application. The size required by work memory can be obtained using the nn::phtsel::GetWorkBufferSize function.\nCode 12-4. Getting the Work Memory Size for Photo Selections\n size_t nn::phtsel::GetWorkBufferSize();\nThe start address of work memory must be allocated with 4096-byte alignment and its size must be a multiple of 4096 bytes. Furthermore, memory allocated from device memory must not be specified for the work memory.\nAfter the parameters have been set and the work memory allocated, you can start the photo selection library applet using the nn::phtsel::StartPhtsel function. Call the nn::phtsel::StartPhtselNoCapture function if the applet background does not display images captured by the application.\nCode 12-5. Starting the Photo Selection Library Applet\n nn::applet::AppletWakeupState nn::phtsel::StartPhtsel(\n nn::phtsel::Parameter* pParameter, void* pWorkBuffer);\nnn::applet::AppletWakeupState nn::phtsel::StartPhtselNoCapture(\n nn::phtsel::Parameter* pParameter);\nIn pParameter, specify the pointer to the Parameter structure for which settings were performed. Specify the start address of work memory in pWorkBuffer.\nExecution results are stored in the m_output member of pParameter upon return to the application.\n",0]
,["Pages/Page_70418367.html#PageId_55582774","12.1.4. Mii Selection Applet",
"\n12.1.4. Mii Selection Applet\nThis library applet is called when using Mii characters in an application to select from among registered Mii characters. You can select only one registered Mii or one guest Mii (six are available by default). You can also select whether to display a list of guest Mii characters and whether to display the operating screen in the upper or lower screen.\n Note:\n To use the Mii Selection applet from inside your application, you must use the CTR Face Library (middleware).\n For instructions on using this library, see the CTR Face Library documentation.\n",0]
,["Pages/Page_70418367.html#PageId_55582775","12.1.5. Sound Selection Applet",
"\n12.1.5. Sound Selection Applet\nThis library applet is called when selecting sound data recorded using Nintendo 3DS Sound for a sound to be used, such as an application sound effect. Only one instance of sound data can be selected. This applet cannot be used to record sounds, sort data, delete data, or otherwise manipulate data. Note that the applet can only select sound data that is saved on an SD card.\nTo use this library applet, you must include the header file (nn/voicesel.h) and add the library file (libnn_voicesel).\nThe nn::voicesel::Parameter structure defines the parameters to pass into the library applet when starting it. Use the parameter's config member (nn::voicesel::Config structure) to configure basic operations, and the input member (nn::voicesel::Input structure) to configure advanced features, such as extraction conditions. The results are stored in the output member (nn::voicesel::Output structure). For the available settings and other information, see the sample demo.\nAfter you are finished configuring the parameters, you can start the sound selection library applet by calling nn::voicesel::StartVoiceSel.\nCode 12-6. Starting the Sound Selection Applet\n nn::applet::AppletWakeupState nn::voicesel::StartVoiceSel(\n nn::voicesel::Parameter* pParameter);\nIn pParameter, specify the pointer to the Parameter structure for which settings were performed.\nWhen control returns to the application, pParameter 's output member will store the results of execution.\n",0]
,["Pages/Page_70418367.html#PageId_55582776","12.1.6. Error/EULA Applet",
"\n12.1.6. Error/EULA Applet\nWhen using wireless-based communication features such as StreetPass, you must check the EULA (the licensing agreement related to Nintendo 3DS network services) and gain the consent of the user. If an application that uses these communication features has not confirmed that the user has agreed to the latest EULA and gained the user’s consent, you can use this library applet to display the EULA and get consent. Acceptance of the EULA is required to use communication features, but applications are not required to display the EULA. If the application does not display the EULA, display an error at the time of communication and guide the user to System Settings.\nNot only does this library applet display the EULA, it can also display error messages. As long as infrastructure communication-related libraries (such as AC and FRIENDS) are being used, the correct corresponding error message is displayed when an error code is passed to the applet. You can also display proprietary error messages from the application.\nTo use this library applet, you must include the nn/erreula.h header file and add the libnn_erreula library file.\nParameters to be passed when this library applet is started are defined in the nn::erreula::Parameter structure. Error codes, error messages, and operational settings are made in the config member (nn::erreula::Config structure). Be sure to configure the setting after initializing with the nn::erreula::InitializeConfig function. For more information about parameter settings, refer to the Applet Specifications and sample demos.\nAfter you set the parameters and allocate the work memory, you can start the Error/EULA applet using the nn::erreula::StartErrEulaApplet function.\nCode 12-7. Starting the Error/EULA Applet\n void nn::erreula::StartErrEulaApplet(\n nn::applet::AppletWakeupState* pWakeupState,\n nn::erreula::Parameter* pParameter);\nIn pParameter, specify the pointer to the Parameter structure for which settings were performed.\nIf the EULA display is made by the setting, the agreement sequence of the Network Services Agreement is displayed and the result of agreement or disagreement to the Network Services Agreement is returned to the application.\nAll of the infrastructure communication features associated with the application, as well as StreetPass communication, will return the EULA disagreement error if the user does not agree to the Network Services Agreement in the version that the application requires. NEX login, registration of download tasks, creation of StreetPass box, etc., will all be subject to the agreement. The version of the Network Services Agreement that requires an agreement will automatically be embedded in ROM. Be sure to confirm whether the Network Services Agreement is required with the nn::cfg::IsAgreedEula function, and call back this applet if the agreement is not accepted. Only when the applet is called back in the state of not agreeing to the Network Services Agreement, will “EULA agreement” or “EULA disagreement” be returned correctly.\n",0]
,["Pages/Page_70418367.html#PageId_55582777","12.1.7. Circle Pad Pro Calibration Applet",
"\n12.1.7. Circle Pad Pro Calibration Applet\nThis library applet is used for calibrating the feel of controls on the Right Circle Pad installed in the Circle Pad Pro. Applications supporting the Circle Pad Pro must provide a start scene for this applet so that users can calibrate the feel of controls on the Right Circle Pad.\n Note:\n The C Stick on SNAKE functions like the Right Circle Pad on a permanently connected Circle Pad Pro. If an application running on SNAKE calls the Circle Pad Pro Calibration Applet, a message describing how to calibrate the C Stick is displayed.\nTo use this library applet, you must include the header file (nn/extrapad.h) and add the library file (libnn_extrapad).\nThe parameter passed when the library applet is started is defined by the nn::extrapad::Parameter structure. Operating settings are performed in the config parameter member variables (nn::extrapad::Config structure). Always perform initialization with the nn::extrapad::InitializeConfig function before performing settings for whether to support the HOME Button and software reset.\nWhen parameter setting procedures are complete, you can start the library applet with the nn::extrapad::StartExtraPadApplet function.\nCode 12-8. Starting the Circle Pad Pro Calibration Applet\n void nn::extrapad::StartExtraPadApplet(\n nn::applet::AppletWakeupState* pWakeupState,\n nn::extrapad::Parameter* pParameter);\nIn pParameter, specify the pointer to the Parameter structure for which settings were performed.\n",0]
,["Pages/Page_70418367.html#PageId_55582778","12.1.8. EC Applet",
"\n12.1.8. EC Applet\nThe EC applet is a library applet for purchasing and managing add-on content and service items.\n Note:\n For more information about EC features, see the CTR-SDK API Reference.\n",0]
,["Pages/Page_70418367.html#PageId_71303276","12.2. System Applets",
"\n12.2. System Applets\n",0]
,["Pages/Page_70418367.html#PageId_55582793","12.2.1. Internet Browser Applet",
"A system applet is generally an applet that is started from the HOME Menu, but libraries are provided to start and use the applets from an application. The processing required to start and return from a system applet from an application is basically the same as that used to start and return from the HOME Menu.\n12.2.1. Internet Browser Applet\nThe WEBBRS library lets you start the built-in Internet browser by specifying a URL from an application. The startup method is similar to that of a library applet, but it differs in that closing the Internet browser that was started results in returning to the HOME Menu with the application suspended.\n Warning:\n Depending on which system updates have been applied, there may be systems that do not have the Internet browser installed. For this reason, it is necessary to check whether the Internet browser is installed on the system before starting it.\n Note:\n For more information about the WEBBRS library, see the CTR-SDK API Reference.\n",0]
,["Pages/Page_70418367.html#PageId_68586017","12.2.2. Miiverse Application and Post App",
"\n12.2.2. Miiverse Application and Post App\nThe OLV library enables the use of Miiverse features in an application. This makes it possible to start the Miiverse application or Post app and receive post data from within an application. These are referred to as \"applications\" but are actually included with the system applets.\n Note:\n For more information about the OLV library, see the CTR-SDK API Reference.\n",0]
,["Pages/Page_70418367.html#PageId_70405380","12.2.2.1. Starting an Application From the Miiverse Post Page",
"\n12.2.2.1. Starting an Application From the Miiverse Post Page\nApplications can be started from a post in Miiverse.\nThe application must be configured as follows to enable this feature.\n\tSpecify EnableMiiverseJumpArgs:True in the BSF file. \tSpecify FLAG_APP_STARTABLE flag with the nn::olv::UploadPostDataByPostApp function when posting.\nOperation in the Miiverse Application\nWhen you view a post with the flag above set in the Miiverse application, a Launch button appears in the post. Any user who owns the application can use this button to start it. Users who do not own the application can view the post but cannot start the application.\nFigure 12-1. Starting an Application From the Post Page\nMiiverse Post App Miiverse Post Post App\nCONFIDENTIAL\n",0]
,["Pages/Page_79043477.html","17. Appendix: Testing the Operations of CTR Titles on SNAKE ",
"17. Appendix: Testing the Operations of CTR Titles on SNAKE\nSNAKE has new features, including Super-Stable 3D, an additional input device, and better camera performance. To realize these features, the SNAKE hardware is partially incompatible with CTR. System processes also differ. For more information about SNAKE's added features, see the 3DS Overview.\nCTR titles may work differently on SNAKE, so please test all CTR titles on SNAKE.\nWhen testing your titles, note the following.\n \tPerformance-pursuing scenes \t SNAKE has a higher memory access latency than the CTR, so waiting for memory access could cause some application processes to take longer. Application processing has been found to take as much as around 5% longer in some scenes. If your application has been tuned to the limits on the CTR, there is a chance of processing slowdowns on SNAKE.\nYou can handle this in your application in two ways: lighten the processing burden, or build the application as an extended application that runs three times faster (at 804 MHz) on SNAKE. For more information, see 4.2. Standard and Extended Applications.\n \tLocal communication \tSNAKE processes local communications differently from the CTR, so unexpected behaviors are possible when local communications take place among a mix of the two systems.\nTo verify the operations of local communications, use a mix of CTR and SNAKE systems and test operations with each acting as the host.\n \tStarting and ending the cameras \tThe Super-Stable 3D feature of SNAKE uses input from the cameras, so this feature is disabled when the application uses the cameras.\nNote that on SNAKE, initializing and finalizing the camera library involves the processes to disable and enable the Super-Stable 3D feature, so it takes a little longer to initialize and finalize the library.\n \tHOME Menu \tOn SNAKE, the HOME Menu (system applet) operates in extended mode (where the main clock runs at triple speed). When a standard application (a CTR title) is started, the mode switches to standard mode (CTR-compatible mode).\nStrictly speaking, the application runs in extended mode until nn::applet::Enable is called, at which time the application switches to standard mode. For more information, see 4.2.4. When the Operating Mode Changes.\nNote that when the HOME Button is pressed, the entire system including the suspended application operates in extended mode.\n \tInput interface differences \t\tThe inner camera on SNAKE has a wider angle than the inner camera on CTR systems. \tThe inner and outer cameras on SNAKE have less noise than those on the CTR systems. \tUsing the C Stick on SNAKE has a different feel than the Circle Pad on the Circle Pad Pro. \tThe C Stick on SNAKE and the Circle Pad on the Circle Pad Pro change their state differently upon waking up from Sleep. For more information, see 6.2.7.2. Differences From the Circle Pad Pro.\nCONFIDENTIAL\n",0]
];
for (var x = 0; x < additionalData.length; x++) Search.indexData.push(additionalData[x]);
Search.additionalData = additionalData;
})();
